{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_Liste_Cousinage;

interface


uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, StdCtrls, ExtCtrls, TFlatTabControlUnit, dxCntner, dxTL,
  dxDBGrid, DBCtrls, Db, IBCustomDataSet, IBQuery, dxGrClms,
  u_comp_TFlatTabControl2, TFlatPanelUnit,
  u_comp_TBlueFlatSpeedButton, Menus, Mask, dxDBCtrl,
  dxDBTLCl, dxEditor, dxEdLib, dxDBELib, TFlatButtonUnit,
  TFlatSpeedButtonUnit, dxExEdtr, RVStyle, RVScroll, RichView,
  u_objet_TIntegerList, TFlatSplitterUnit, Buttons, u_comp_TGoodBtn,
  u_comp_TYLanguage, DynamicSkinForm;

type
  TFListeCousinage = class(TSuperForm)
    IBQListeNom: TIBQuery;
    IBQListeNomNOM: TIBStringField;
    dsListeNom: TDataSource;
    pmGrid: TPopupMenu;
    mOuvrir: TMenuItem;
    N2: TMenuItem;
    ExporterenHTML1: TMenuItem;
    IBQListePreNom: TIBQuery;
    IBQListePreNomCLE_FICHE: TIntegerField;
    IBQListePreNomPRENOM: TIBStringField;
    IBQListePreNomDATE_NAISSANCE: TIBStringField;
    IBQListePreNomLIEU_NAISSANCE: TIBStringField;
    IBQListePreNomDATE_DECES: TIBStringField;
    IBQListePreNomLIEU_DECES: TIBStringField;
    IBQListePreNomSEXE: TIntegerField;
    IBQListePreNomNOM_PERE: TIBStringField;
    IBQListePreNomPRENOM_PERE: TIBStringField;
    IBQListePreNomPERE_DATE_NAISSANCE: TIBStringField;
    IBQListePreNomPERE_LIEU_NAISSANCE: TIBStringField;
    IBQListePreNomPERE_CLE_FICHE: TIntegerField;
    IBQListePreNomNOM_MERE: TIBStringField;
    IBQListePreNomPRENOM_MERE: TIBStringField;
    IBQListePreNomMERE_DATE_NAISSANCE: TIBStringField;
    IBQListePreNomMERE_LIEU_NAISSANCE: TIBStringField;
    IBQListePreNomMERE_CLE_FICHE: TIntegerField;
    IBQListePreNomINFOS_SUPP: TStringField;
    DSListePreNom: TDataSource;
    pBorder: TPanel;
    panBtn: TPanel;
    pBottom: TFlatPanel;
    DSCousins: TDataSource;
    IBQCousins: TIBQuery;
    IBQCousinsCLE_FICHE: TIntegerField;
    IBQCousinsNOM: TIBStringField;
    IBQCousinsPRENOM: TIBStringField;
    IBQCousinsDATE_NAISSANCE: TIBStringField;
    IBQCousinsDATE_DECES: TIBStringField;
    IBQCousinsSEXE: TIntegerField;
    IBQCousinsCLE_PERE: TIntegerField;
    IBQCousinsCLE_MERE: TIntegerField;
    Panel2: TPanel;
    panTabs: TPanel;
    PaintBoxOnglet: TPaintBox;
    Panel5: TPanel;
    Panel11: TPanel;
    Panel13: TPanel;
    panTopSpace: TPanel;
    Panel4: TPanel;
    dxDBGCousins: TdxDBGrid;
    dxDBGCousinsColumn4: TdxDBGridImageColumn;
    dxDBGCousinsColumn1: TdxDBGridColumn;
    dxDBGCousinsColumn2: TdxDBGridColumn;
    dxDBGCousinsColumn3: TdxDBGridColumn;
    Panel9: TPanel;
    Panel10: TPanel;
    Panel12: TPanel;
    Panel8: TPanel;
    rbF: TdxCheckEdit;
    rbH: TdxCheckEdit;
    rbTous: TdxCheckEdit;
    Panel14: TPanel;
    FlatSplitter1: TFlatSplitter;
    Panel15: TPanel;
    dxDBGrid1: TdxDBGrid;
    dxDBGCNom: TdxDBGridColumn;
    Panel16: TPanel;
    Panel17: TPanel;
    Panel18: TPanel;
    dxDBGrid2: TdxDBGrid;
    dxDBGridImageColumn1: TdxDBGridImageColumn;
    dxDBGCPrenoms: TdxDBGridColumn;
    dxDBGrid2Column3: TdxDBGridColumn;
    Panel19: TPanel;
    bsfbSelection: TGoodBtn;
    btnFermer: TGoodBtn;
    Panel1: TPanel;
    Panel3: TPanel;
    Panel6: TPanel;
    SaveDialog: TSaveDialog;
    Language: TYLanguage;
    spDynamicSkinForm1: TspDynamicSkinForm;
    procedure IBQListeNomAfterScroll(DataSet: TDataSet);
    procedure SuperFormCreate(Sender: TObject);
    procedure ExporterenHTML1Click(Sender: TObject);
    procedure IBQListePreNomCalcFields(DataSet: TDataSet);
    procedure SuperFormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SuperFormShowFirstTime(Sender: TObject);
    procedure rbTousChange(Sender: TObject);
    procedure rbHChange(Sender: TObject);
    procedure rbFChange(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure bsfbSelectionClick(Sender: TObject);
    procedure pTopMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SuperFormClose(Sender: TObject; var Action: TCloseAction);
    procedure PaintBoxOngletPaint(Sender: TObject);
    procedure PaintBoxOngletMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure SuperFormDestroy(Sender: TObject);
    procedure IBQListePreNomAfterScroll(DataSet: TDataSet);
    procedure Label10MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure IBQCousinsAfterOpen(DataSet: TDataSet);
    procedure pmGridPopup(Sender: TObject);
    procedure SuperFormRefreshControls(Sender: TObject);
    procedure dxDBGCousinsDblClick(Sender: TObject);
  private
    fDialogMode: boolean;
    fFill: boolean;
    //fCanScroll: boolean;

    fNomPrenomIndividuSelected: string;
    fSexeIndividuSelected: integer;

    fIndiCle: TIntegerList;
    fIndiJumpTag: TIntegerList;

    fCanScrollPrenom, fCanScrollNom: boolean;
    procedure SetTabByPositionMouse(x: integer);
    procedure SetNumOngletSelected(index: integer);
    procedure doRefreshPrenoms;
  public
    fNumOngletSelected: integer;
    fTextesOnglets: TStringList;
    fClefIndividuSelected: integer;

    //en entre
    procedure SetIncrustMode;

    //en sortie
    property ClefIndividuSelected: integer read fClefIndividuSelected write fClefIndividuSelected;
    property NomPrenomIndividuSelected: string read fNomPrenomIndividuSelected write fNomPrenomIndividuSelected;
    property SexeIndividuSelected: integer read fSexeIndividuSelected write fSexeIndividuSelected;

    procedure up_InitIndividuPrenom(a_Lettre: string; a_Sexe, a_Mode: integer);
    procedure doRefreshRepertoire;
  end;

implementation

uses u_dm, u_form_main,
  u_form_individu_Saisie_Rapide,
  u_common_func, u_common_var, u_common_const;
{$R *.DFM}

procedure TFListeCousinage.up_InitIndividuPrenom(a_Lettre: string; a_Sexe, a_Mode: integer);
var i_Tab: smallInt;
begin
  i_Tab := POS(a_Lettre, 'ABCDEFGHIJKLMNOPQRSTUVWXYZ');

  SetNumOngletSelected(i_Tab);

  fFill := true;
  try
    case a_Sexe of

      1: begin
          rbTous.checked := false;
          rbH.checked := true;
          rbF.checked := false;
        end;

      2: begin
          rbTous.checked := false;
          rbH.checked := false;
          rbF.checked := true;
        end;
      else
        begin
          rbTous.checked := true;
          rbH.checked := false;
          rbF.checked := false;
        end;
    end;

  finally
    fFill := false;
  end;

  IBQCousins.Params[1].AsInteger := dm.NumDossier;
  doRefreshRepertoire;
end;

procedure TFListeCousinage.doRefreshRepertoire;
var
  debut: string;

begin
  fCanScrollNom := false;
  IBQCousins.Close;

  if fNumOngletSelected > 0
    then debut := copy('ABCDEFGHIJKLMNOPQRSTUVWXYZ', fNumOngletSelected, 1) //nom commenant par
  else debut := ''; //tout le monde


  with IBQListeNom do begin
      DisableControls;
      try
        Close;
        params[0].AsString := debut;
        params[1].AsInteger := dm.NumDossier;
        Open;
      finally
        EnableControls;
        fCanScrollNom := true;
        IBQListeNomAfterScroll(IBQListeNom);

      end;
    end;

  dxDBGrid1.SetFocus;
end;

procedure TFListeCousinage.IBQListeNomAfterScroll(DataSet: TDataSet);
begin
  if fCanScrollNom then
    begin
      doRefreshPrenoms;
    end;
end;

procedure TFListeCousinage.doRefreshPrenoms;
var
  i_sexe: smallint;
  fTryToSelectCleFiche: integer;
begin
  i_Sexe := 0;

  if rbTous.Checked then
    i_sexe := 0
  else if rbH.Checked then
    i_sexe := 1
  else if rbF.Checked then
    i_sexe := 2;


  IBQListePreNom.DisableControls;
  try
    fCanScrollPrenom := false;

    fTryToSelectCleFiche := -1;
    try
      if IBQListePreNom.Active then
        if IBQListePreNom.RecordCount > 0
          then fTryToSelectCleFiche := IBQListePreNom.FieldByName('CLE_FICHE').AsInteger;
    except
    end;

    IBQListePreNom.Close;
    IBQListePreNom.params[0].AsString := IBQListeNomNOM.AsString;
    IBQListePreNom.params[1].AsInteger := dm.NumDossier;
    IBQListePreNom.params[2].AsInteger := 2; //rgEtat.ItemIndex;
    IBQListePreNom.params[3].AsInteger := i_Sexe;
    IBQListePreNom.Open;

    if fTryToSelectCleFiche <> -1 then
      begin
        IBQListePreNom.Locate('CLE_FICHE', fTryToSelectCleFiche, []);
      end;

    dxDBGrid2.ColumnByName('dxDBGCPrenoms').Caption := IBQListeNomNOM.AsString;
  finally
    IBQListePreNom.EnableControls;
    fCanScrollPrenom := true;
  end;

  DoRefreshControls;
end;

procedure TFListeCousinage.ExporterenHTML1Click(Sender: TObject);
var
  SavePlace: TBookmark;
  s_Fichier: string;
begin
  SavePlace := nil;
  s_Fichier := 'Cousins de ' + AssembleString([IBQListeNomNOM.AsString, IBQListePrenomPRENOM.AsString]) + '.HTM';
  SaveDialog.FileName := s_Fichier;
  SaveDialog.InitialDir := _Context.PathDocs;

  if SaveDialog.Execute then
    begin
      IBQCousins.DisableControls;
      try
        SavePlace := IBQCousins.GetBookmark;

        dxDBGCousins.SaveToHTML(SaveDialog.FileName, True);
      finally
        IBQCousins.GotoBookmark(SavePlace);
        IBQCousins.FreeBookmark(SavePlace);

        IBQCousins.EnableControls;

      end;
    end;
end;

procedure TFListeCousinage.IBQListePreNomCalcFields(DataSet: TDataSet);
var s: string;
begin

  s := '';

  if IBQListePreNomLIEU_NAISSANCE.AsString <> '' then
    s := 'N(e)  ' + IBQListePreNomLIEU_NAISSANCE.AsString;

  if IBQListePreNomDATE_DECES.AsString <> '' then
    if Length(s) = 0 then
      s := ' Dcd(e) : ' + IBQListePreNomDATE_DECES.AsString
    else
      s := s + ' - Dcd(e) : ' + IBQListePreNomDATE_DECES.AsString;

  if IBQListePreNomLIEU_DECES.AsString <> '' then
    if Length(s) = 0 then
      s := ' Dcd(e)  ' + IBQListePreNomLIEU_DECES.AsString
    else
      s := s + ' -  ' + IBQListePreNomLIEU_DECES.AsString;

  IBQListePreNomINFOS_SUPP.AsString := s;

end;

procedure TFListeCousinage.SuperFormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = VK_ESCAPE then
    begin
      if fDialogMode then
        begin
          fClefIndividuSelected := -1;
          ModalResult := mrCancel;
          // Close;
        end;
    end;
end;

procedure TFListeCousinage.SetIncrustMode;
begin
  fDialogMode := false;
  BorderStyle := bsNone;


  panBtn.visible := false;
  panTopSpace.visible := false;

  pBorder.BevelOuter := bvNone;
  pBorder.BorderWidth := 0;
  //     pGeneral.BevelOuter := bvNone;
end;


procedure TFListeCousinage.SuperFormShowFirstTime(Sender: TObject);
begin
  if fDialogMode then
    begin
      pBottom.Show;
    end;

  doRefreshControls;
end;


procedure TFListeCousinage.SuperFormCreate(Sender: TObject);
var
  n: integer;
begin
  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  if _Context.Skin then
    begin
      ClientHeight := 462;
      ClientWidth := 689;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;

  SaveDialog.InitialDir := _Context.PathImportExport;

  fTextesOnglets := TStringList.create;

  fTextesOnglets.Add('...');
  for n := 0 to 25 do fTextesOnglets.Add(chr(ord('A') + n));

  SetNumOngletSelected(0);

  fDialogMode := True;
  fClefIndividuSelected := -1;
  fNomPrenomIndividuSelected := '';
  SexeIndividuSelected := -1;

  fFill := false;
  fIndiCle := TIntegerList.create;
  fIndiJumpTag := TIntegerList.create;
end;

procedure TFListeCousinage.rbTousChange(Sender: TObject);
//var SavePlace: TBookmark;
begin
  //     SavePlace := IBQListeNom.GetBookmark;

  if not fFill then
    begin
      fFill := true;
      try
        rbTous.checked := true;
        rbH.checked := false;
        rbF.checked := false;

      finally
        fFill := false;
      end;
      //          doRefreshRepertoire;
      doRefreshPrenoms;
    end;


  //   IBQListeNom.GotoBookmark(SavePlace);
   //  IBQListeNom.FreeBookmark(SavePlace);
end;

procedure TFListeCousinage.rbHChange(Sender: TObject);
//var SavePlace: TBookmark;
begin
  //  SavePlace := IBQListeNom.GetBookmark;
  if not fFill then
    begin
      fFill := true;
      try
        rbTous.checked := false;
        rbH.checked := true;
        rbF.checked := false;

      finally
        fFill := false;
      end;
      //          doRefreshRepertoire;
      doRefreshPrenoms;
    end;
  //   IBQListeNom.GotoBookmark(SavePlace);
   //  IBQListeNom.FreeBookmark(SavePlace);
end;

procedure TFListeCousinage.rbFChange(Sender: TObject);
//var SavePlace: TBookmark;
begin
  //     SavePlace := IBQListeNom.GetBookmark;

  if not fFill then
    begin
      fFill := true;
      try
        rbH.checked := false;
        rbTous.checked := false;
        rbF.checked := true;
      finally
        fFill := false;
      end;
      //          doRefreshRepertoire;
      doRefreshPrenoms;
    end;
  //   IBQListeNom.GotoBookmark(SavePlace);
  //   IBQListeNom.FreeBookmark(SavePlace);
end;

procedure TFListeCousinage.SpeedButton2Click(Sender: TObject);
begin
  ModalResult := mrCancel;
  Close;
end;

procedure TFListeCousinage.bsfbSelectionClick(Sender: TObject);
begin
  fClefIndividuSelected := IBQCousinsCLE_FICHE.AsInteger;

  fNomPrenomIndividuSelected := AssembleString([IBQCousinsNOM.AsString,
    IBQCousinsPRENOM.AsString]);
  SexeIndividuSelected := IBQCousinsSEXE.AsInteger;

  ModalResult := mrOk;
end;


procedure TFListeCousinage.pTopMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFListeCousinage.SuperFormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  IBQCousins.Close;
end;

procedure TFListeCousinage.PaintBoxOngletPaint(Sender: TObject);
begin
  PaintOnglet(PaintBoxOnglet, 27, fNumOngletSelected, 25, 18, clBlack, $00C5E8F3, $008FC6D8, fTextesOnglets);
end;


procedure TFListeCousinage.PaintBoxOngletMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var p: TPoint;
begin
  p := TControl(Sender).ClientToScreen(Point(X, Y));
  p := panTabs.ScreenToClient(p);
  //  p.x := p.x - 3;

  SetTabByPositionMouse(p.x);
end;

procedure TFListeCousinage.SetTabByPositionMouse(x: integer);
var k: integer;
begin
  k := (x div 21);
  if k < 0 then k := 0;
  if k > 26 then k := 26;
  if k <> fNumOngletSelected then
    begin
      SetNumOngletSelected(k);
      doRefreshRepertoire;
    end;
end;

procedure TFListeCousinage.SuperFormDestroy(Sender: TObject);
begin
  fTextesOnglets.Free;
end;

procedure TFListeCousinage.SetNumOngletSelected(index: integer);
begin
  fNumOngletSelected := index;
  PaintBoxOnglet.Refresh;
end;


procedure TFListeCousinage.IBQListePreNomAfterScroll(DataSet: TDataSet);
begin
  if not fCanScrollPrenom then exit;
  IBQCousins.Close;
  IBQCousins.Params[0].AsInteger := IBQListePreNomCLE_FICHE.AsInteger;
  IBQCousins.params[1].AsInteger := dm.NumDossier;
  IBQCousins.Open;
end;

procedure TFListeCousinage.Label10MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFListeCousinage.IBQCousinsAfterOpen(DataSet: TDataSet);
begin
  doRefreshControls;
end;

procedure TFListeCousinage.pmGridPopup(Sender: TObject);
var
  ok: boolean;
begin
  ok := (IBQCousins.Active) and (IBQCousins.RecordCount > 0);
  mOuvrir.Enabled := ok;
  ExporterenHTML1.Enabled := Ok;
end;

procedure TFListeCousinage.SuperFormRefreshControls(Sender: TObject);
begin
  bsfbSelection.Enabled := (IBQCousins.Active) and (IBQCousins.RecordCount > 0);
end;

procedure TFListeCousinage.dxDBGCousinsDblClick(Sender: TObject);
begin
  bsfbSelectionClick(Sender);
end;

end.
