{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_TAG_Gedcom;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, u_comp_TBlueFlatSpeedButton, StdCtrls, ExtCtrls,
  TFlatSpeedButtonUnit, Db, IBCustomDataSet, IBUpdateSQL, IBQuery,
  dxCntner, dxTL, dxDBCtrl, dxDBGrid, TFlatButtonUnit, Buttons,
  u_comp_TGoodBtn, u_comp_TYLanguage, dxExEdtr, DynamicSkinForm;

type
  TFTAGGedcom = class(TSuperForm)
    Query: TIBQuery;
    DataSource: TDataSource;
    pBorder: TPanel;
    Panel7: TPanel;
    Panel4: TPanel;
    lbTitle: TLabel;
    Panel5: TPanel;
    Panel6: TPanel;
    Panel1: TPanel;
    dxDBGrid1: TdxDBGrid;
    btnFermer: TGoodBtn;
    Language: TYLanguage;
    QueryREF_EVE_LIB_COURT: TIBStringField;
    QueryREF_EVE_LIB_LONG: TIBStringField;
    dxDBGrid1Column1: TdxDBGridColumn;
    dxDBGrid1Column2: TdxDBGridColumn;
    btnPrint: TGoodBtn;
    spDynamicSkinForm1: TspDynamicSkinForm;
    procedure SuperFormShowFirstTime(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Label10MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SuperFormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SuperFormCreate(Sender: TObject);
    procedure btnPrintClick(Sender: TObject);
  private
    procedure OpenQuery;
  public

  end;

implementation

uses u_dm, u_common_var, u_form_export_table_2_textfile,
  u_form_Import_textfile_2_table, u_common_func, u_common_const,
  u_form_main;

{$R *.DFM}

{ TFEditRefParticules }

procedure TFTAGGedcom.OpenQuery;
begin
  Query.DisableControls;
  try
    Query.Close;
    Query.Open;
  finally
    Query.EnableControls;
  end;

  doRefreshControls;
end;

procedure TFTAGGedcom.SuperFormShowFirstTime(Sender: TObject);
begin
  OpenQuery;
end;

procedure TFTAGGedcom.SpeedButton1Click(Sender: TObject);
begin
  Close;
end;

procedure TFTAGGedcom.Label10MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFTAGGedcom.SuperFormKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if Key = VK_ESCAPE then ModalResult := mrCancel;
end;

procedure TFTAGGedcom.SuperFormCreate(Sender: TObject);
begin
  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  if _Context.Skin then
    begin
      ClientHeight := 406;
      ClientWidth := 350;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;
end;

procedure TFTAGGedcom.btnPrintClick(Sender: TObject);
begin
  FMain.doPrint(4);
end;

end.

