{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_confirm_add_to_favoris;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, StdCtrls, Buttons, URLLink, GraphicEx, ExtCtrls,
  TFlatSpeedButtonUnit, TFlatPanelUnit, u_comp_TGoodBtn, u_comp_TYLanguage,
  jpeg, DynamicSkinForm;

type
  TFConfirmAddToFavoris = class(TSuperForm)
    pBorder: TPanel;
    Panel2: TPanel;
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    lTitre: TLabel;
    fpBoutons: TFlatPanel;
    btnFermer: TGoodBtn;
    bsfbSelection: TGoodBtn;
    Language: TYLanguage;
    Panel9: TPanel;
    Image2: TImage;
    spDynamicSkinForm1: TspDynamicSkinForm;
    procedure pTopMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SuperFormCreate(Sender: TObject);
    procedure SuperFormShow(Sender: TObject);
    procedure SuperFormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    fNom: string;
    fSexe: Integer;
  public
    property Nom: string read fNom write fNom;
    property Sexe: Integer read fSexe write fSexe;
  end;


implementation

uses u_common_func, u_dm, u_common_const, u_common_var, u_form_main;

{$R *.DFM}

procedure TFConfirmAddToFavoris.pTopMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFConfirmAddToFavoris.SpeedButton1Click(Sender: TObject);
begin
  ModalResult := mrCancel;
  Close;
end;

procedure TFConfirmAddToFavoris.SuperFormCreate(Sender: TObject);
begin

  if _Context.Skin then
    begin
      ClientHeight := 222;
      ClientWidth := 481;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;


  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  fNom := '';
  fSexe := -1;
end;

procedure TFConfirmAddToFavoris.SuperFormShow(Sender: TObject);
begin
  if fSexe = 1 then
    lTitre.Font.Color := _Context.ColorHomme
  else if fSexe = 2 then
    lTitre.Font.Color := _Context.ColorFemme;

  lTitre.Caption := coupechaine(fNom, lTitre);
end;

procedure TFConfirmAddToFavoris.SuperFormKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  case Key of
    _KEY_HELP: dm.ShowHelp(_HELP_FAVORIS);
  end;
end;

end.
