{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                                                     }
{           Philippe Cazaux-Moutou                                      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_list_villes;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, StdCtrls, TFlatPanelUnit, Buttons, ExtCtrls, IBStoredProc,
  u_comp_TBlueFlatSpeedButton, dxCntner, dxTL, dxDBGrid, Db,
  IBCustomDataSet, IBQuery, jpeg, dxEditor, dxExEdtr,
  dxEdLib, dxDBELib, dxDBCtrl, TFlatButtonUnit, TFlatSpeedButtonUnit,
  IBUpdateSQL, ComCtrls, u_objet_TState, dxDBTLCl, dxGrClms,
  u_comp_TGoodBtn, GraphicEx, dxDBEdtr, dxExGrEd, dxExELib,
  u_comp_TYLanguage, Menus, IBTable, DynamicSkinForm;

type
  TMydxDBPopupEdit = class(TdxDBPopupEdit)
  public
    procedure DropDown; override;
  end;

  TFListVilles = class(TSuperForm)
    pBorder: TPanel;
    Panel2: TPanel;
    DSCP: TDataSource;
    IBQCP: TIBQuery;
    Panel10: TPanel;
    Panel13: TPanel;
    panTabs: TPanel;
    PaintBoxOnglet: TPaintBox;
    Panel16: TPanel;
    Panel17: TPanel;
    Panel18: TPanel;
    Panel22: TPanel;
    Panel23: TPanel;
    Panel24: TPanel;
    Panel25: TPanel;
    Panel26: TPanel;
    Notebook: TNotebook;
    dxDBGrid1: TdxDBGrid;
    dxDBCCp: TdxDBGridColumn;
    dxDBInsee: TdxDBGridColumn;
    dxDBGCVille: TdxDBGridColumn;
    Panel6: TPanel;
    Label1: TLabel;
    Label3: TLabel;
    rbStart: TRadioButton;
    rbContent: TRadioButton;
    seVille: TdxEdit;
    seCP: TdxEdit;
    pPays: TPanel;
    pRegion: TPanel;
    pDept: TPanel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    dsPays: TDataSource;
    IBQPays: TIBQuery;
    dsRegion: TDataSource;
    IBQRegion: TIBQuery;
    dsDept: TDataSource;
    IBQDept: TIBQuery;
    IBQPaysRPA_CODE: TIntegerField;
    IBQPaysRPA_LIBELLE: TIBStringField;
    IBQPaysRPA_ABBREVIATION: TIBStringField;
    dbPays: TdxDBGrid;
    dbPaysColumn1: TdxDBGridColumn;
    dbPaysColumn2: TdxDBGridColumn;
    IBUPays: TIBUpdateSQL;
    dbRegion: TdxDBGrid;
    dxDBGridColumn1: TdxDBGridColumn;
    IBQRegionRRG_CODE: TIntegerField;
    IBQRegionRRG_LIBELLE: TIBStringField;
    IBURegion: TIBUpdateSQL;
    dbDept: TdxDBGrid;
    dxDBGridColumn2: TdxDBGridColumn;
    IBUDept: TIBUpdateSQL;
    IBQDeptRDP_CODE: TIntegerField;
    IBQDeptRDP_LIBELLE: TIBStringField;
    IBQDeptRRG_CODE: TIntegerField;
    IBQDeptRDP_PAYS: TIntegerField;
    IBQDeptRDP_TEL: TIBStringField;
    Label16: TLabel;
    PaintBox5: TPaintBox;
    btnAddEvent: TGoodBtn;
    btnDelEvent: TGoodBtn;
    Panel5: TPanel;
    Label2: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label8: TLabel;
    Label10: TLabel;
    dxDBEdit1: TdxDBEdit;
    dxDBEdit2: TdxDBEdit;
    dxDBEdit3: TdxDBEdit;
    dxDBEdit4: TdxDBEdit;
    dxDBEdit5: TdxDBEdit;
    Panel7: TPanel;
    Label9: TLabel;
    btnAddPays: TGoodBtn;
    btnDelPays: TGoodBtn;
    btnAddRegion: TGoodBtn;
    btnDelRegion: TGoodBtn;
    btnAddDept: TGoodBtn;
    btnDelDept: TGoodBtn;
    GoodBtn10: TGoodBtn;
    GoodBtnExport: TGoodBtn;
    btnImportPays: TGoodBtn;
    btnExportPays: TGoodBtn;
    btnImportRegion: TGoodBtn;
    btnExportRegion: TGoodBtn;
    btnImportDepart: TGoodBtn;
    btnExportDepart: TGoodBtn;
    IBQCPVILLE: TIBStringField;
    IBQCPTEL: TIBStringField;
    IBQCPDEPARTEMENT: TIBStringField;
    IBQCPREGION: TIBStringField;
    IBQCPPAYS: TIBStringField;
    IBQCPCODE: TIBStringField;
    IBQCPCLEF: TIntegerField;
    IBQCPCP_PREFIXE: TIBStringField;
    IBQCPCP_DEPT: TIntegerField;
    IBQCPCP_REGION: TIntegerField;
    IBQCPCP_PAYS: TIntegerField;
    IBQCPCP_INSEE: TIBStringField;
    IBQCPCP_HABITANTS: TFloatField;
    IBQCPCP_DENSITE: TFloatField;
    IBQCPCP_DIVERS: TIBStringField;
    IBQRegionRRG_PAYS: TIntegerField;
    pListePays: TPanel;
    Panel8: TPanel;
    Label11: TLabel;
    dxDBPanel: TdxDBGrid;
    dxDBGCLibelle: TdxDBGridColumn;
    dxDBPEPays: TdxDBPopupEdit;
    Panel3: TPanel;
    Image1: TImage;
    Language: TYLanguage;
    Label14: TLabel;
    seInsee: TdxEdit;
    FlatPanel1: TFlatPanel;
    bsfbSelection: TGoodBtn;
    btnFermer: TGoodBtn;
    fbCarte: TFlatButton;
    Panel9: TPanel;
    Panel11: TPanel;
    dxDBGrid2: TdxDBGrid;
    dxDBGrid1Column1: TdxDBGridColumn;
    DSVillesFavoris: TDataSource;
    Panel12: TPanel;
    Image2: TImage;
    Label15: TLabel;
    SaveDialog: TSaveDialog;
    pmVilles: TPopupMenu;
    mFiche: TMenuItem;
    N1: TMenuItem;
    ExporterenHTML1: TMenuItem;
    IBQVillesFavoris: TIBQuery;
    IBQVillesFavorisEV_IND_VILLE: TIBStringField;
    IBQVillesFavorisEV_IND_CP: TIBStringField;
    IBQVillesFavorisEV_IND_DEPT: TIBStringField;
    IBQVillesFavorisEV_IND_REGION: TIBStringField;
    IBQVillesFavorisEV_IND_PAYS: TIBStringField;
    IBQVillesFavorisEV_IND_INSEE: TIBStringField;
    dxDBGrid2Column2: TdxDBGridColumn;
    dxDBGrid2Column3: TdxDBGridColumn;
    dxDBGrid2Column4: TdxDBGridColumn;
    dxDBGrid2Column5: TdxDBGridColumn;
    dxDBGrid2Column6: TdxDBGridColumn;
    N2: TMenuItem;
    mModif: TMenuItem;
    pGeographie: TPanel;
    Label17: TLabel;
    Label18: TLabel;
    dbLong: TdxDBEdit;
    dbLat: TdxDBEdit;
    btnIGN: TFlatButton;
    btnHistoire: TFlatButton;
    IBQCPD_LONGITUDE: TFloatField;
    IBQCPD_LATITUDE: TFloatField;
    Label19: TLabel;
    dxDivers: TdxDBEdit;
    spDynamicSkinForm1: TspDynamicSkinForm;
    procedure SuperFormCreate(Sender: TObject);
    procedure seVilleEnter(Sender: TObject);
    procedure seVilleChange(Sender: TObject);
    procedure seCPChange(Sender: TObject);
    procedure seCPEnter(Sender: TObject);
    procedure rbStartClick(Sender: TObject);
    procedure rbContentClick(Sender: TObject);
    procedure SuperFormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure BlueFlatSpeedButton2Click(Sender: TObject);
    procedure pTopMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btnAddEventClick(Sender: TObject);
    procedure btnDelEventClick(Sender: TObject);
    procedure dxDBGrid1DblClick(Sender: TObject);
    procedure btnImportClick(Sender: TObject);
    procedure btnExportClick(Sender: TObject);
    procedure SuperFormRefreshControls(Sender: TObject);
    procedure PaintBoxOngletPaint(Sender: TObject);
    procedure PaintBoxOngletMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure SuperFormDestroy(Sender: TObject);
    procedure btnAddPaysClick(Sender: TObject);
    procedure IBQPaysNewRecord(DataSet: TDataSet);
    procedure btnDelPaysClick(Sender: TObject);
    procedure btnAddRegionClick(Sender: TObject);
    procedure IBQRegionNewRecord(DataSet: TDataSet);
    procedure btnDelRegionClick(Sender: TObject);
    procedure btnAddDeptClick(Sender: TObject);
    procedure IBQDeptNewRecord(DataSet: TDataSet);
    procedure IBQPaysAfterScroll(DataSet: TDataSet);
    procedure IBQRegionAfterScroll(DataSet: TDataSet);
    procedure btnDelDeptClick(Sender: TObject);
    procedure sbCloseClick(Sender: TObject);
    procedure PaintBox5Paint(Sender: TObject);
    procedure SuperFormShowFirstTime(Sender: TObject);
    procedure SuperFormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure btnExportPaysClick(Sender: TObject);
    procedure btnExportRegionClick(Sender: TObject);
    procedure btnExportDepartClick(Sender: TObject);
    procedure btnImportPaysClick(Sender: TObject);
    procedure btnImportRegionClick(Sender: TObject);
    procedure btnImportDepartClick(Sender: TObject);
    procedure IBQDeptAfterScroll(DataSet: TDataSet);
    procedure dxDBPEPaysInitPopup(Sender: TObject);
    procedure dxDBPanelDblClick(Sender: TObject);
    procedure dxDBPEPaysKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure dxDBPanelKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure fbCarteClick(Sender: TObject);
    procedure seInseeEnter(Sender: TObject);
    procedure seInseeChange(Sender: TObject);
    procedure pmVillesPopup(Sender: TObject);
    procedure mFicheClick(Sender: TObject);
    procedure ExporterenHTML1Click(Sender: TObject);
    procedure mModifClick(Sender: TObject);
    procedure btnIGNClick(Sender: TObject);
    procedure btnHistoireClick(Sender: TObject);
    procedure SuperFormShow(Sender: TObject);
    procedure SuperFormClose(Sender: TObject; var Action: TCloseAction);
  private
    fFill: TState;
    fTextesOnglets: TStringList;
    fOngletID: integer;
    fDialogMode: boolean;
    fCode: string;
    fVille: string;
    fDept: string;
    fPays: string;
    fRegion: string;
    fInsee: string;
    fNumPays: integer;
    fCanSelect: boolean;
    fFirstime: boolean;
    fLongitude: Boolean;

    tmpFieldLong: TFloatField;
    tmpFieldLat: TFloatField;

    procedure doTesteLongitude;
    procedure doActiveOnglet(onglet: integer);
    procedure SetTabByPositionMouse(x: integer);
    procedure doSelectVille;
    procedure doTryToSavePaysRegionDepartement;
    procedure OnBeforeInsertRecordImportDepart(DataSet: TDataSet);
    procedure doRefreshVillesByName;
  public

    //En entre
    property CanSelect: boolean read fCanSelect write fCanSelect;

    //en retour
    property Code: string read fCode write fCode;
    property Ville: string read fVille write fVille;
    property Dept: string read fDept write fDept;
    property Pays: string read fPays write fPays;
    property Region: string read fRegion write fRegion;
    property Insee: string read fInsee write fInsee;
  end;

implementation

uses u_dm, u_form_main, u_form_Ville_Ajout,
  u_common_var, u_form_export_table_2_textfile,
  u_form_Import_textfile_2_table, u_common_func, u_common_const,
  u_Form_Individu_Sur_Favoris, u_form_Modif_Favoris;

{$R *.DFM}

procedure TMydxDBPopupEdit.DropDown;
begin
  inherited;
end;

procedure TFListVilles.SuperFormCreate(Sender: TObject);
begin
  if _Context.Skin then
    begin
      ClientHeight := 490;
      ClientWidth := 703;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;


  fFirstime := True;
  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  fCanSelect := true;
  fOngletID := 0;
  fDialogMode := true;
  fFill := TState.create(false);
  fTextesOnglets := TStringList.create;
  fTextesOnglets.Add('Villes');
  fTextesOnglets.Add('Pays/Dpartements/Rgions');
  fTextesOnglets.Add('Lieux favoris');
  fNumPays := 1;

  doTesteLongitude;
end;

procedure TFListVilles.seVilleEnter(Sender: TObject);
begin
  seCP.Text := '';
  seInsee.Clear;

  with IBQCP do begin
      Close;
      SQL.Clear;
      SQL.ADD('SELECT * FROM PROC_TROUVE_VILLE_PAR_VILLE(:CODE, :MODE) WHERE CP_PAYS = :PAYS');
    end;

  doRefreshControls;
end;

procedure TFListVilles.seVilleChange(Sender: TObject);
begin
  doRefreshVillesByName;
end;

procedure TFListVilles.doRefreshVillesByName;
var i_Mode: smallint;
begin
  if Length(seVille.Text) <= 0 then
    begin
      IBQCP.Close;
      doRefreshControls;
      Exit;
    end;

  Screen.Cursor := crHourglass;
  try
    if rbStart.Checked then i_Mode := 0 else i_Mode := 1;

    IBQCP.DisableControls;
    try
      IBQCP.Close;
      if Copy(seVille.Text, 1, 1) = '*' then
        begin
          IBQCP.SQL.Clear;
          IBQCP.SQL.ADD('SELECT' +
            ' CP_CP AS CODE,' +
            ' CP_VILLE AS VILLE,' +
            ' DEPT.RDP_TEL AS TEL,' +
            ' DEPT.RDP_LIBELLE AS DEPARTEMENT,' +
            ' REGION.RRG_LIBELLE AS REGION,' +
            ' PAYS.RPA_LIBELLE AS PAYS,' +
            ' CP_CODE AS CLEF,' +
            ' CP_PREFIXE,' +
            ' CP_DEPT,' +
            ' CP_REGION,' +
            ' CP_PAYS,' +
            ' CP_INSEE,' +
            ' CP_HABITANTS,' +
            ' CP_DENSITE,' +
            ' CP_DIVERS,' +
            ' CP_LONGITUDE,' +
            ' CP_LATITUDE' +
            ' FROM REF_CP_VILLE VILLE' +
            ' LEFT  JOIN REF_DEPARTEMENTS DEPT' +
            ' ON DEPT.RDP_CODE = VILLE.CP_DEPT' +
            ' LEFT JOIN REF_REGION REGION' +
            ' ON REGION.RRG_CODE = VILLE.CP_REGION' +
            ' LEFT JOIN REF_PAYS PAYS' +
            ' ON PAYS.RPA_CODE = VILLE.CP_PAYS' +
            ' WHERE CP_PAYS = :PAYS');

          IBQCP.Params[0].AsInteger := fNumPays;
        end
      else
        begin
          IBQCP.SQL.Clear;
          IBQCP.SQL.ADD('SELECT * FROM PROC_TROUVE_VILLE_PAR_VILLE(:CODE, :MODE) WHERE CP_PAYS = :PAYS');

          IBQCP.Params[0].AsString := UpperCase(seVille.Text);
          IBQCP.Params[1].AsInteger := i_Mode;
          IBQCP.Params[2].AsInteger := fNumPays;
        end;
      IBQCP.Open;
    finally
      IBQCP.EnableControls;
    end;

  finally
    Screen.Cursor := crArrow;
  end;
  //dxDBGrid1.SetFocus;
  doRefreshControls;
end;

procedure TFListVilles.seCPChange(Sender: TObject);
begin
  if Length(seCP.Text) <= 1 then
    begin
      IBQCP.Close;
      doRefreshControls;
      Exit;
    end;

  if Length(seCP.Text) > 1 then
    with IBQCP do begin
        DisableControls;
        Close;
        Params[0].AsString := seCP.Text;
        Params[1].AsInteger := fNumPays;
        Open;
        EnableControls;
      end;

  doRefreshControls;
end;

procedure TFListVilles.seCPEnter(Sender: TObject);
begin
  seVille.Text := '';
  seInsee.Clear;

  with IBQCP do begin
      Close;
      SQL.Clear;
      SQL.ADD('SELECT * FROM PROC_TROUVE_VILLE_PAR_CP(:CODE) WHERE CP_PAYS = :PAYS');
    end;

  doRefreshControls;
end;

procedure TFListVilles.rbStartClick(Sender: TObject);
begin
  seVilleChange(Sender);
end;

procedure TFListVilles.rbContentClick(Sender: TObject);
begin
  seVilleChange(Sender);
end;

procedure TFListVilles.SuperFormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
    VK_ESCAPE: ModalResult := mrCancel;
    _KEY_HELP: dm.ShowHelp(_ID_VILLES);
  end;
end;

procedure TFListVilles.BlueFlatSpeedButton2Click(Sender: TObject);
begin
  doSelectVille;
end;

procedure TFListVilles.doSelectVille;
begin
  if fCanSelect then
    if Notebook.ActivePage = 'page0' then
      begin
        if (IBQCP.Active) and (IBQCP.RecordCount > 0) then
          begin
            fCode := IBQCPCODE.AsString;
            fVille := IBQCPVille.AsString;
            fDept := IBQCPDepartement.AsString;
            fPays := IBQCPPays.AsString;
            fRegion := IBQCPRegion.AsString;
            fInsee := IBQCPCP_INSEE.AsString;

            if fDialogMode = false then fCode := ''
            else ModalResult := mrOk;
          end;
      end;
  if Notebook.ActivePage = 'page2' then
    begin
      if (IBQVillesFavoris.Active) and (IBQVillesFavoris.RecordCount > 0) then
        begin
          fCode := IBQVillesFavorisEV_IND_CP.AsString;
          fVille := IBQVillesFavorisEV_IND_VILLE.AsString;
          fDept := IBQVillesFavorisEV_IND_DEPT.AsString;
          fPays := IBQVillesFavorisEV_IND_PAYS.AsString;
          fRegion := IBQVillesFavorisEV_IND_REGION.AsString;
          fInsee := IBQVillesFavorisEV_IND_INSEE.AsString;

          if fDialogMode = false then fCode := ''
          else ModalResult := mrOk;
        end;

    end;
end;

procedure TFListVilles.pTopMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFListVilles.btnAddEventClick(Sender: TObject);
var
  aFVilleAjout: TFVilleAjout;
begin
  aFVilleAjout := TFVilleAjout.create(self);
  try
    aFVilleAjout.FormMode := sfmNew;
    if aFVilleAjout.Prepare then
      begin
        if aFVilleAjout.ShowModal = mrOk then
          begin
            IBQPays.Locate('RPA_CODE', aFVilleAjout.CodePays, [loPartialKey]);
            seVille.Text := aFVilleAjout.Ville;
          end;
      end;
  finally
    aFVilleAjout.Free;
  end;
end;

procedure TFListVilles.btnDelEventClick(Sender: TObject);
var
  proc: TIBStoredProc;
begin
  if MyMessageDlg('Confirmez-vous la suppression de cette ville ?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    begin
      proc := TIBStoredProc.Create(Application);
      try
        proc.DataBase := dm.ibd_BASE;
        proc.Transaction := dm.IBTrans_Secondaire;
        proc.StoredProcName := 'PROC_DEL_REF_CP_VILLE';
        proc.Prepare;
        proc.ParamByName('CP_CODE').AsInteger := IBQCPCLEF.AsInteger;
        proc.ExecProc;
        proc.Close;
      finally
        proc.free;
      end;

      doRefreshVillesByName;
    end;
end;

procedure TFListVilles.dxDBGrid1DblClick(Sender: TObject);
var
  aFVilleAjout: TFVilleAjout;
begin
  aFVilleAjout := TFVilleAjout.create(self);
  try
    aFVilleAjout.FormMode := sfmEdit;
    aFVilleAjout.Code := IBQCP.FieldByName('CLEF').AsInteger;

    if aFVilleAjout.Prepare then
      begin
        if aFVilleAjout.ShowModal = mrOk then
          begin
            seVilleEnter(Sender);
            seVille.Text := aFVilleAjout.Ville;
            doRefreshVillesByName;
          end;
      end;
  finally
    aFVilleAjout.Free;
  end;
end;

procedure TFListVilles.btnImportClick(Sender: TObject);
var
  aFImportTextFile2Table: TFImportTextFile2Table;
begin
  aFImportTextFile2Table := TFImportTextFile2Table.create(self);
  try
    aFImportTextFile2Table.TableName := 'REF_CP_VILLE';
    aFImportTextFile2Table.UsePrimaryIndex := true;
    aFImportTextFile2Table.NamePrimaryIndex := 'CP_CODE';
    aFImportTextFile2Table.NameGeneratorPrimaryIndex := 'REF_CP_VILLE';
    aFImportTextFile2Table.ParamsTable.CreateParam(ftString, 'CP_CP', ptInput);
    aFImportTextFile2Table.ParamsTable.CreateParam(ftString, 'CP_PREFIXE', ptInput);
    aFImportTextFile2Table.ParamsTable.CreateParam(ftString, 'CP_VILLE', ptInput);
    aFImportTextFile2Table.ParamsTable.CreateParam(ftString, 'CP_INDIC_TEL', ptInput);
    aFImportTextFile2Table.ParamsTable.CreateParam(ftInteger, 'CP_DEPT', ptInput);
    aFImportTextFile2Table.ParamsTable.CreateParam(ftInteger, 'CP_REGION', ptInput);
    aFImportTextFile2Table.ParamsTable.CreateParam(ftInteger, 'CP_PAYS', ptInput);
    aFImportTextFile2Table.ParamsTable.CreateParam(ftString, 'CP_INSEE', ptInput);
    aFImportTextFile2Table.ParamsTable.CreateParam(ftFloat, 'CP_HABITANTS', ptInput);
    aFImportTextFile2Table.ParamsTable.CreateParam(ftFloat, 'CP_DENSITE', ptInput);
    aFImportTextFile2Table.ParamsTable.CreateParam(ftString, 'CP_DIVERS', ptInput);
    aFImportTextFile2Table.ParamsTable.CreateParam(ftFloat, 'CP_LATITUDE', ptInput);
    aFImportTextFile2Table.ParamsTable.CreateParam(ftFloat, 'CP_LONGITUDE', ptInput);
    aFImportTextFile2Table.ParamsTable.CreateParam(ftInteger, 'CP_MAJ_INSEE', ptInput);

    if aFImportTextFile2Table.ShowModal = mrOk then begin end; //OpenQuery;
  finally
    aFImportTextFile2Table.free;
  end;
end;

procedure TFListVilles.btnExportClick(Sender: TObject);
var
  aFExportTable2TextFile: TFExportTable2TextFile;
begin
  aFExportTable2TextFile := TFExportTable2TextFile.create(self);
  try
    aFExportTable2TextFile.TableName := 'REF_CP_VILLE';
    aFExportTable2TextFile.PropositionFileNameExport := 'Villes.txt';
    aFExportTable2TextFile.ShowModal;
  finally
    aFExportTable2TextFile.Free;
  end;
end;

procedure TFListVilles.SuperFormRefreshControls(Sender: TObject);

begin
  if fFirstime then exit;
     _Agent.doAgent('Hide', '',
    0,
    0);
  bsfbSelection.visible := (IBQCP.Active) and (IBQCP.RecordCount > 0) and fCanSelect;

  btnAddPays.enabled := (IBQPays.Active);
  btnDelPays.enabled := (IBQPays.Active) and (IBQPays.IsEmpty = false);
  btnImportPays.enabled := (IBQPays.Active);
  btnExportPays.enabled := (IBQPays.Active) and (IBQPays.IsEmpty = false);

  btnAddRegion.enabled := (IBQRegion.Active) and (IBQPays.Active) and (IBQPays.IsEmpty = false);
  btnDelRegion.enabled := (IBQRegion.Active) and (IBQRegion.IsEmpty = false);
  btnImportRegion.enabled := (IBQRegion.Active) and (IBQPays.Active) and (IBQPays.IsEmpty = false);
  btnExportRegion.enabled := (IBQRegion.Active) and (IBQRegion.IsEmpty = false);

  btnAddDept.enabled := (IBQDept.Active) and (IBQRegion.Active) and (IBQRegion.IsEmpty = false) and (IBQPays.Active) and (IBQPays.IsEmpty = false);
  btnDelDept.enabled := (IBQDept.Active) and (IBQDept.IsEmpty = false);
  btnImportDepart.enabled := (IBQDept.Active) and (IBQRegion.Active) and (IBQRegion.IsEmpty = false) and (IBQPays.Active) and (IBQPays.IsEmpty = false);
  btnExportDepart.enabled := (IBQDept.Active) and (IBQDept.IsEmpty = false);

  btnDelEvent.Enabled := (IBQCP.IsEmpty = false);
  GoodBtnExport.Enabled := (IBQCP.IsEmpty = false);
  fbCarte.Visible := (IBQCP.IsEmpty = false);
  btnIGN.Visible := ((UpperCase(dxDBPEPays.Text) = 'FRANCE') and (IBQCP.IsEmpty = false)) or
    ((UpperCase(dxDBPEPays.Text) = 'DEPARTEMENT OUTREMER') and (IBQCP.IsEmpty = false)) or
    ((UpperCase(dxDBPEPays.Text) = 'TERRITOIRE OUTREMER') and (IBQCP.IsEmpty = false));

  btnHistoire.Visible := ((UpperCase(dxDBPEPays.Text) = 'FRANCE') and (IBQCP.IsEmpty = false)) or
    ((UpperCase(dxDBPEPays.Text) = 'DEPARTEMENT OUTREMER') and (IBQCP.IsEmpty = false)) or
    ((UpperCase(dxDBPEPays.Text) = 'TERRITOIRE OUTREMER') and (IBQCP.IsEmpty = false));
end;

procedure TFListVilles.PaintBoxOngletPaint(Sender: TObject);
begin
  PaintOnglet(PaintBoxOnglet, 3, fOngletID, 180, 18, clBlack, $00C5E8F3, $008FC6D8, fTextesOnglets);
end;

procedure TFListVilles.PaintBoxOngletMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var p: TPoint;
begin
  p := TControl(Sender).ClientToScreen(Point(X, Y));
  p := panTabs.ScreenToClient(p);
  SetTabByPositionMouse(p.x);
end;

procedure TFListVilles.SetTabByPositionMouse(x: integer);
var k: integer;
begin
  k := (x div 175);
  if k < 0 then k := 0;
  if k > 2 then k := 2;
  doActiveOnglet(k);
end;

procedure TFListVilles.doActiveOnglet(onglet: integer);
begin
  fOngletID := onglet;
  PaintBoxOnglet.Refresh;
  Application.ProcessMessages;
  Notebook.PageIndex := onglet;

  if onglet = 1 then
    bsfbSelection.visible := False
  else if onglet = 0 then
    bsfbSelection.visible := (IBQCP.Active) and (IBQCP.RecordCount > 0) and fCanSelect
  else if onglet = 2 then
    bsfbSelection.visible := (IBQVillesFavoris.Active) and (IBQVillesFavoris.RecordCount > 0) and fCanSelect;

end;

procedure TFListVilles.SuperFormDestroy(Sender: TObject);
begin

  //FreeAndNil(dbLong);

  fFill.free;
  fTextesOnglets.free;

  IBQPays.Close;
  IBQRegion.Close;
  IBQDept.Close;
  IBQVillesFavoris.Close;

  IBQCP.Close;
  //  IBQCP.Free;

  Application.ProcessMessages;
end;

procedure TFListVilles.btnAddPaysClick(Sender: TObject);
begin
  IBQPays.Append;
  dbPays.SetFocus;
  doRefreshControls;
end;

procedure TFListVilles.IBQPaysNewRecord(DataSet: TDataSet);
var
  k: integer;
begin
  //l'ordre insert est dj fait.
  k := dm.uf_GetClefUnique('REF_PAYS');
  IBQPaysRPA_CODE.AsInteger := k;
end;

procedure TFListVilles.btnDelPaysClick(Sender: TObject);
begin
  IBQPays.Delete;
  doRefreshControls;
end;

procedure TFListVilles.btnAddRegionClick(Sender: TObject);

begin
  IBQRegion.Append;
  doRefreshControls;
  dbRegion.SetFocus;
end;

procedure TFListVilles.IBQRegionNewRecord(DataSet: TDataSet);
var
  k: integer;
begin
  //l'ordre insert est dj fait.
  k := dm.uf_GetClefUnique('REF_REGION');
  IBQRegionRRG_CODE.AsInteger := k;
  IBQRegionRRG_Pays.AsInteger := IBQPaysRPA_CODE.AsInteger;
end;

procedure TFListVilles.btnDelRegionClick(Sender: TObject);
begin
  IBQRegion.Delete;
end;

procedure TFListVilles.btnAddDeptClick(Sender: TObject);
begin
  IBQDept.Append;
  doRefreshControls;
  dbDept.SetFocus;
end;

procedure TFListVilles.IBQDeptNewRecord(DataSet: TDataSet);
var
  k: integer;
begin
  //l'ordre insert est dj fait.
  k := dm.uf_GetClefUnique('REF_DEPARTEMENTS');
  IBQDeptRDP_CODE.AsInteger := k;
  IBQDeptRRG_CODE.AsInteger := IBQRegionRRG_CODE.AsInteger;
  IBQDeptRDP_PAYS.AsInteger := IBQPaysRPA_CODE.AsInteger;
end;

procedure TFListVilles.IBQPaysAfterScroll(DataSet: TDataSet);
begin
  fNumPays := IBQPays.FieldByName('RPA_CODE').AsInteger;
  seVille.Text := '';
  seVilleEnter(Self);
  doRefreshControls;
end;

procedure TFListVilles.IBQRegionAfterScroll(DataSet: TDataSet);
begin
  doRefreshControls;
end;

procedure TFListVilles.btnDelDeptClick(Sender: TObject);
begin
  IBQDept.Delete;
  doRefreshControls;
end;

procedure TFListVilles.sbCloseClick(Sender: TObject);
begin
  ModalResult := mrCancel;
  Close;
end;

procedure TFListVilles.PaintBox5Paint(Sender: TObject);
begin
  PaintPointille(Sender);
end;

procedure TFListVilles.SuperFormShowFirstTime(Sender: TObject);

begin
  IBQVillesFavoris.Params[0].AsInteger := dm.NumDossier;
  IBQVillesFavoris.Open;

  IBQPays.Open;
  IBQRegion.Open;
  IBQDept.Open;
  doRefreshControls;

  fFirstime := False;
end;

procedure TFListVilles.SuperFormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if fLongitude then
    begin
      dbLong.DataField := '';
      dbLong.DataSource := nil;

      dbLat.DataField := '';
      dbLat.DataSource := nil;

      IBQCP.Fields.Remove(tmpFieldLong);
      IBQCP.Fields.Remove(tmpFieldLat);
    end;

  doTryToSavePaysRegionDepartement;
end;

procedure TFListVilles.doTryToSavePaysRegionDepartement;
begin
  try
    if (IBQPays.State in [dsEdit, dsInsert]) then IBQPays.Post;
  except
  end;

  try
    if (IBQRegion.State in [dsEdit, dsInsert]) then IBQRegion.Post;
  except;
  end;

  try
    if (IBQDept.State in [dsEdit, dsInsert]) then IBQDept.Post;
  except
  end;

  dm.IBTrans_Secondaire.CommitRetaining;
end;

procedure TFListVilles.btnExportPaysClick(Sender: TObject);
var
  aFExportTable2TextFile: TFExportTable2TextFile;
begin
  aFExportTable2TextFile := TFExportTable2TextFile.create(self);
  try
    aFExportTable2TextFile.TableName := 'REF_PAYS';
    aFExportTable2TextFile.PropositionFileNameExport := 'Pays.txt';
    aFExportTable2TextFile.ShowModal;
  finally
    aFExportTable2TextFile.Free;
  end;
end;

procedure TFListVilles.btnExportRegionClick(Sender: TObject);
var
  rep: word;
  aFExportTable2TextFile: TFExportTable2TextFile;
begin
  rep := MyMessageDlg('Exporter seulement les rgions du pays slectionn ?', mtConfirmation, [mbYes, mbNo, mbCancel], 0);
  if (rep = mrYes) or (rep = mrNo) then
    begin
      aFExportTable2TextFile := TFExportTable2TextFile.create(self);
      try
        aFExportTable2TextFile.TableName := 'REF_REGION';
        aFExportTable2TextFile.PropositionFileNameExport := 'Regions.txt';
        if rep = mrYes then aFExportTable2TextFile.CondSelect := ''; //'(RRG_PAYS=' + Inttostr(IBQPaysRPA_CODE.AsInteger) + ')';
        aFExportTable2TextFile.ShowModal;
      finally
        aFExportTable2TextFile.Free;
      end;
    end;
end;

procedure TFListVilles.btnExportDepartClick(Sender: TObject);
var
  rep: word;
  aFExportTable2TextFile: TFExportTable2TextFile;
begin
  rep := MyMessageDlg('Exporter seulement les dpartements de la rgion slectionne ?', mtConfirmation, [mbYes, mbNo, mbCancel], 0);
  if (rep = mrYes) or (rep = mrNo) then
    begin
      aFExportTable2TextFile := TFExportTable2TextFile.create(self);
      try
        aFExportTable2TextFile.TableName := 'REF_DEPARTEMENTS';
        aFExportTable2TextFile.PropositionFileNameExport := 'Departements.txt';
        if rep = mrYes
          then aFExportTable2TextFile.CondSelect := '(RDP_PAYS=' + Inttostr(IBQPaysRPA_CODE.AsInteger) + ') and (RRG_CODE=' + Inttostr(IBQRegionRRG_CODE.AsInteger) + ')'
        else aFExportTable2TextFile.CondSelect := '';
        // '(RDP_PAYS=' + Inttostr(IBQPaysRPA_CODE.AsInteger) + ')';
        aFExportTable2TextFile.ShowModal;
      finally
        aFExportTable2TextFile.Free;
      end;
    end;
end;


procedure TFListVilles.btnImportPaysClick(Sender: TObject);
var
  aFImportTextFile2Table: TFImportTextFile2Table;
begin
  doTryToSavePaysRegionDepartement;

  aFImportTextFile2Table := TFImportTextFile2Table.create(self);
  try
    aFImportTextFile2Table.TableName := 'REF_PAYS';
    aFImportTextFile2Table.UsePrimaryIndex := true;
    aFImportTextFile2Table.NamePrimaryIndex := 'RPA_CODE';
    aFImportTextFile2Table.NameGeneratorPrimaryIndex := 'REF_PAYS';

    aFImportTextFile2Table.ParamsTable.CreateParam(ftInteger, 'RDP_CODE', ptInput);
    aFImportTextFile2Table.ParamsTable.CreateParam(ftString, 'RDP_LIBELLE', ptInput);
    aFImportTextFile2Table.ParamsTable.CreateParam(ftInteger, 'RRG_CODE', ptInput);
    aFImportTextFile2Table.ParamsTable.CreateParam(ftInteger, 'RDP_PAYS', ptInput);
    aFImportTextFile2Table.ParamsTable.CreateParam(ftString, 'RDP_TEL', ptInput);

    if aFImportTextFile2Table.ShowModal = mrOk then begin end; //OpenQuery;
  finally
    aFImportTextFile2Table.free;
  end;
end;

procedure TFListVilles.btnImportRegionClick(Sender: TObject);
var
  aFImportTextFile2Table: TFImportTextFile2Table;
begin
  doTryToSavePaysRegionDepartement;

  aFImportTextFile2Table := TFImportTextFile2Table.create(self);
  try
    aFImportTextFile2Table.TableName := 'REF_REGION';
    aFImportTextFile2Table.UsePrimaryIndex := true;
    aFImportTextFile2Table.NamePrimaryIndex := 'RRG_CODE';
    aFImportTextFile2Table.NameGeneratorPrimaryIndex := 'REF_REGION';

    aFImportTextFile2Table.ParamsTable.CreateParam(ftInteger, 'RRG_CODE', ptInput);
    aFImportTextFile2Table.ParamsTable.CreateParam(ftString, 'RRG_LIBELLE', ptInput);
    aFImportTextFile2Table.ParamsTable.CreateParam(ftInteger, 'RRG_PAYS', ptInput);

    if aFImportTextFile2Table.ShowModal = mrOk then begin end; //OpenQuery;
  finally
    aFImportTextFile2Table.free;
  end;
end;

procedure TFListVilles.btnImportDepartClick(Sender: TObject);
var
  aFImportTextFile2Table: TFImportTextFile2Table;
begin
  doTryToSavePaysRegionDepartement;

  aFImportTextFile2Table := TFImportTextFile2Table.create(self);
  try
    aFImportTextFile2Table.TableName := 'REF_DEPARTEMENTS';
    aFImportTextFile2Table.UsePrimaryIndex := true;
    aFImportTextFile2Table.NamePrimaryIndex := 'RDP_CODE';
    aFImportTextFile2Table.NameGeneratorPrimaryIndex := 'REF_DEPARTEMENTS';

    aFImportTextFile2Table.ParamsTable.CreateParam(ftInteger, 'RDP_CODE', ptInput);
    aFImportTextFile2Table.ParamsTable.CreateParam(ftString, 'RDP_LIBELLE', ptInput);
    aFImportTextFile2Table.ParamsTable.CreateParam(ftInteger, 'RRG_CODE', ptInput);
    aFImportTextFile2Table.ParamsTable.CreateParam(ftInteger, 'RDP_PAYS', ptInput);
    aFImportTextFile2Table.ParamsTable.CreateParam(ftString, 'RDP_TEL', ptInput);

    aFImportTextFile2Table.InvisibleParamNames.Add('RDP_CODE');
    aFImportTextFile2Table.InvisibleParamNames.Add('RRG_CODE');
    aFImportTextFile2Table.InvisibleParamNames.Add('RDP_PAYS');
    aFImportTextFile2Table.OnBeforeInsertRecord := OnBeforeInsertRecordImportDepart;

    if aFImportTextFile2Table.ShowModal = mrOk then begin end; //OpenQuery;
  finally
    aFImportTextFile2Table.free;
  end;
end;

procedure TFListVilles.OnBeforeInsertRecordImportDepart(DataSet: TDataSet);
begin
  DataSet.FieldByName('RRG_CODE').AsInteger := IBQRegionRRG_CODE.AsInteger;
  DataSet.FieldByName('RDP_PAYS').AsInteger := IBQPaysRPA_CODE.AsInteger;
end;

procedure TFListVilles.IBQDeptAfterScroll(DataSet: TDataSet);
begin
  doRefreshControls;
end;

procedure TFListVilles.dxDBPEPaysInitPopup(Sender: TObject);
begin
  pListePays.Width := 400;
  pListePays.Height := 250;
end;

procedure TFListVilles.dxDBPanelDblClick(Sender: TObject);
begin
  fNumPays := IBQPays.FieldByName('RPA_CODE').AsInteger;

  dxDBInsee.Visible := fNumPays = 1;

  (GetParentForm(dxDBPanel) as TdxPopupEditForm).ClosePopup(True);
end;

procedure TFListVilles.dxDBPEPaysKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = _KEY_OPEN_LIST) then TMydxDBPopupEdit(dxDBPEPays).DropDown;
end;

procedure TFListVilles.dxDBPanelKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (key = VK_ESCAPE) then (GetParentForm(dxDBPanel) as TdxPopupEditForm).ClosePopup(True)
  else
    if (Key = VK_RETURN) then dxDBPanelDblClick(Sender);
end;

procedure TFListVilles.fbCarteClick(Sender: TObject);
var sPays: string;
begin
  if (IBQPaysRPA_LIBELLE.AsString = 'DEPARTEMENT OUTREMER') or
    (IBQPaysRPA_LIBELLE.AsString = 'TERRITOIRE OUTREMER') then
    sPays := IBQDeptRDP_LIBELLE.AsString
  else
    sPays := IBQPaysRPA_LIBELLE.AsString;
  GotoThisURL('http://' + _Context.ChoixCartesInternet + '/pub/agent.dll?qscr=mmfn&plce1=' + IBQCPVILLE.asString + '%2C' + sPays + '&wpst1=1&rtbl=0&regn1=2&cnty1=4&subm=1&fmap=1&tpid=1&dchg=&zz=992108484196');
end;

procedure TFListVilles.seInseeEnter(Sender: TObject);
begin
  seVille.Text := '';
  seCP.Clear;

  with IBQCP do begin
      Close;
      SQL.Clear;
      SQL.ADD('SELECT * FROM PROC_TROUVE_VILLE_PAR_INSEE(:CODE) WHERE CP_PAYS = :PAYS');
    end;

  doRefreshControls;
end;

procedure TFListVilles.seInseeChange(Sender: TObject);
begin
  if Length(seInsee.Text) <= 1 then
    begin
      IBQCP.Close;
      Exit;
    end;

  if Length(seInsee.Text) > 1 then
    with IBQCP do begin
        DisableControls;
        Close;
        Params[0].AsString := seInsee.Text;
        Params[1].AsInteger := fNumPays;
        Open;
        EnableControls;
      end;

  doRefreshControls;
end;

procedure TFListVilles.pmVillesPopup(Sender: TObject);
begin
  mFiche.Enabled := dxDBGrid1.Count > 0;
  ExporterenHTML1.Enabled := dxDBGrid1.Count > 0;
end;

procedure TFListVilles.mFicheClick(Sender: TObject);
var aFIndividusSurFavoris: TFIndividusSurFavoris;
begin
  aFIndividusSurFavoris := TFIndividusSurFavoris.create(self);
  try
    aFIndividusSurFavoris.DoInit(IBQVillesFavorisEV_IND_VILLE.AsString);
    aFIndividusSurFavoris.ShowModal;
  finally
    aFIndividusSurFavoris.Free;
  end;
end;

procedure TFListVilles.ExporterenHTML1Click(Sender: TObject);
var
  SavePlace: TBookmark;
  s_Fichier: string;
begin
  SavePlace := nil;
  s_Fichier := 'Liste des lieux favoris.HTM';
  SaveDialog.FileName := s_Fichier;
  if SaveDialog.Execute then
    begin
      IBQVillesFavoris.DisableControls;
      try
        SavePlace := IBQVillesFavoris.GetBookmark;
        dxDBGrid2.SaveToHTML(s_Fichier, True);
      finally
        IBQVillesFavoris.GotoBookmark(SavePlace);
        IBQVillesFavoris.FreeBookmark(SavePlace);

        IBQVillesFavoris.EnableControls;

      end;
    end;
end;

procedure TFListVilles.mModifClick(Sender: TObject);
var aFModifFavoris: TFModifFavoris;
begin
  aFModifFavoris := TFModifFavoris.create(self);
  try
    aFModifFavoris.DoInit([IBQVillesFavorisEV_IND_CP.AsString,
      IBQVillesFavorisEV_IND_INSEE.AsString,
        IBQVillesFavorisEV_IND_VILLE.AsString,
        IBQVillesFavorisEV_IND_DEPT.AsString,
        IBQVillesFavorisEV_IND_REGION.AsString,
        IBQVillesFavorisEV_IND_PAYS.AsString]);

    if aFModifFavoris.ShowModal = mrOk then
      begin
        IBQVillesFavoris.Close;
        IBQVillesFavoris.Open;
      end;

  finally
    aFModifFavoris.Free;
  end;
end;

procedure TFListVilles.btnIGNClick(Sender: TObject);
begin
  GotoThisURL('http://www.ign.fr/fr/PI/activites/geodesie/commune?COMMUNE=' + IBQCPVILLE.asString);
end;

procedure TFListVilles.btnHistoireClick(Sender: TObject);
begin
  GotoThisURL('http://www.quid.fr/communes.html?mode=query&req=' + IBQCPVILLE.asString + '&secrec=1');
end;

procedure TFListVilles.doTesteLongitude;
var ChpExiste: Boolean;
  i: integer;
  IBTCp: TIBTable;
begin

  IBTCp := TIBTable.Create(nil);
  IBTCp.DataBase := dm.ibd_BASE;
  IBTCp.TableName := 'REF_CP_VILLE';

  IBTCp.Open;
  ChpExiste := False;

  // Je lis dans cette table pour voir si le champ existe
  for i := 0 to IBTCp.FieldDefs.Count - 1 do
    if IBTCp.FieldDefs[i].Name = 'CP_LONGITUDE' then
      begin
        ChpExiste := True;
        fLongitude := True;
        pGeographie.Visible := True;
      end;

  IBTCp.Close;
  IBTCp.Free;

  if ChpExiste then
    // Il existe dans la table, donc je declare le champ
    begin
      tmpFieldLong := TFloatField.Create(nil);

      with tmpFieldLong do
        begin
          FieldName := 'CP_LONGITUDE';
          IBQCP.Open;
          Index := IBQCP.FieldCount;
          IBQCP.Close;
          DataSet := IBQCP;
        end;

      tmpFieldLat := TFloatField.Create(nil);

      with tmpFieldLat do
        begin
          FieldName := 'CP_LATITUDE';
          IBQCP.Open;
          Index := IBQCP.FieldCount;
          IBQCP.Close;
          DataSet := IBQCP;
        end;

      // J affecte le champ au query pour le rendre persistant
      IBQCP.Fields.Add(tmpFieldLong);
      IBQCP.Fields.Add(tmpFieldLat);

      // J affecte le champ a mon dbedi
      dbLong.DataField := 'CP_LONGITUDE';
      dbLat.DataField := 'CP_LATITUDE';

    end;

end;

procedure TFListVilles.SuperFormShow(Sender: TObject);
begin
  _Agent.doAgent('GestureLeft', 'Tapez un nom de ville ou un CP',
    Left + 150,
    Top + 100);
end;

procedure TFListVilles.SuperFormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  _Agent.doAgent('Hide', '',
    0,
    0);
end;

end.
