{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                                                     }
{           Philippe Cazaux-Moutou                                      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_import_gedcom;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, TFlatPanelUnit, u_comp_TBlueFlatSpeedButton, StdCtrls,
  ExtCtrls, TFlatGroupBoxUnit, Buttons, WizardTree,
  u_objet_TImportGedCom, Menus, Grids,
  u_gedcom_type,
  u_objet_TCut, IBXConst,
  u_gedcom_func,
  u_objet_TState, IBCustomDataSet, IBUpdateSQL, Db, IBQuery,
  TFlatGaugeUnit, IBSQL, IBStoredProc, ComCtrls, dxCntner,
  dxEditor, dxExEdtr, dxEdLib, URLLink, TFlatSpeedButtonUnit,
  u_comp_TGoodBtn, dxTL, u_comp_TYLanguage, u_objet_TIntegerList, dxDBedtr,
  jpeg;

type

  TFImportGedcom = class(TSuperForm)
    Panel4: TPanel;
    Panel1: TPanel;
    WizardTree: TWizardTree;
    Panel2: TPanel;
    Notebook: TNotebook;
    FlatGroupBox1: TFlatGroupBox;
    Labelaa: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    rbJeuCarWindows: TRadioButton;
    rbJeuCarMacintosh: TRadioButton;
    rbJeuCarMSDOS: TRadioButton;
    rbJeuCarAnsel: TRadioButton;
    FlatPanel1: TFlatPanel;
    memoJeuxCaractere: TMemo;
    popup_FormatLieux: TPopupMenu;
    popupLieuVille: TMenuItem;
    popup_LieuCode: TMenuItem;
    popup_LieuDept: TMenuItem;
    popup_LieuRegion: TMenuItem;
    popup_LieuPays: TMenuItem;
    popup_LieuSubdivision: TMenuItem;
    popup_LieuIgnorer: TMenuItem;
    N1: TMenuItem;
    btnLieuxCol1: TBlueFlatSpeedButton;
    btnLieuxCol2: TBlueFlatSpeedButton;
    btnLieuxCol3: TBlueFlatSpeedButton;
    btnLieuxCol4: TBlueFlatSpeedButton;
    btnLieuxCol5: TBlueFlatSpeedButton;
    btnLieuxCol6: TBlueFlatSpeedButton;
    btnLieuxCol7: TBlueFlatSpeedButton;
    Label9: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label16: TLabel;
    Label8: TLabel;
    rbDontTouchParticule: TRadioButton;
    rbWorkWithParticule: TRadioButton;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label17: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    lbHeaderSource: TLabel;
    Label30: TLabel;
    lbHeaderNom: TLabel;
    lbHeaderDestination: TLabel;
    lbHeaderCodage: TLabel;
    lbHeaderLangue: TLabel;
    lbHeaderVersion: TLabel;
    lbHeaderCompagnie: TLabel;
    lbHeaderAdresse: TLabel;
    Label29: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    IBSQL: TIBSQL;
    IBQueryEvents: TIBQuery;
    rbClearBdd: TRadioButton;
    rbAddToBdd: TRadioButton;
    IBStoredProc: TIBStoredProc;
    Animate: TAnimate;
    cbSeparateurLieux: TdxPickEdit;
    edPathFileNameGED: TdxEdit;
    Pourcent: TLabel;
    Label33: TLabel;
    lbNdFam: TLabel;
    Label35: TLabel;
    lbNbIndi: TLabel;
    Label7: TLabel;
    URLLink1: TURLLink;
    Label15: TLabel;
    URLLink2: TURLLink;
    Label36: TLabel;
    URLLink3: TURLLink;
    FlatSpeedButton1: TFlatSpeedButton;
    btnSelectDossier: TFlatSpeedButton;
    cbImportImage: TdxCheckEdit;
    cbIgnoreEventIndiVide: TdxCheckEdit;
    Panel5: TPanel;
    Label37: TLabel;
    Panel6: TPanel;
    cbImportEvent: TdxCheckEdit;
    cbImportNotes: TdxCheckEdit;
    cbImportSources: TdxCheckEdit;
    cbImportTemoins: TdxCheckEdit;
    Panel3: TPanel;
    BFSBSelection: TGoodBtn;
    btnPrevious: TGoodBtn;
    btnNext: TGoodBtn;
    Panel7: TPanel;
    theGridLieux: TdxTreeList;
    dxTreeList1Col1: TdxTreeListColumn;
    dxTreeList1Col2: TdxTreeListColumn;
    dxTreeList1Col3: TdxTreeListColumn;
    dxTreeList1Col4: TdxTreeListColumn;
    dxTreeList1Col5: TdxTreeListColumn;
    dxTreeList1Col6: TdxTreeListColumn;
    dxTreeList1Col7: TdxTreeListColumn;
    dxTreeListPreview: TdxTreeListColumn;
    OpenDialog: TOpenDialog;
    Language: TYLanguage;
    QRefTemoins: TIBQuery;
    IBMultimedia: TIBQuery;
    IBMultimediaMULTI_CLEF: TIntegerField;
    IBMultimediaMULTI_INDIVIDU: TIntegerField;
    IBMultimediaMULTI_INFOS: TIBStringField;
    IBMultimediaMULTI_MEDIA: TBlobField;
    IBMultimediaMULTI_DOSSIER: TIntegerField;
    IBMultimediaMULTI_DATE_MODIF: TDateTimeField;
    IBMultimediaMULTI_MEMO: TMemoField;
    IBMultimediaMULTI_STRETCH: TIntegerField;
    IBMultimediaMULTI_IDENTITE: TIntegerField;
    IBMultimediaMULTI_TYPE: TIBStringField;
    IBMultimediaMULTI_REDUITE: TBlobField;
    IBMultimediaMULTI_DEVISE: TBlobField;
    IBMultimediaMULTI_CRI: TBlobField;
    IBMultimediaMULTI_DOCRTF: TBlobField;
    IBMultimediaMULTI_IMAGE_RTF: TIntegerField;
    IBMultimediaMULTI_NUM_ACTE: TIntegerField;
    IBMultimediaMULTI_TYPE_ACTE: TIBStringField;
    IBMultimediaMULTI_SONS_VIDEOS: TBlobField;
    IBMultimediaMULTI_PATH: TIBStringField;
    IBMultimediaMULTI_NOM: TIBStringField;
    IBUMedia: TIBUpdateSQL;
    iVideo: TImage;
    iSons: TImage;
    procedure SuperFormCreate(Sender: TObject);
    procedure WizardTreeChanging(Sender: TObject; NewItemIndex: Integer; var AllowChange: Boolean);
    procedure SuperFormRefreshControls(Sender: TObject);
    procedure btnPreviousClick(Sender: TObject);
    procedure btnNextClick(Sender: TObject);
    procedure BFSBSelectionClick(Sender: TObject);
    procedure SuperFormDestroy(Sender: TObject);
    procedure btnLieuxCol1Click(Sender: TObject);
    procedure popupLieuClick(Sender: TObject);
    procedure rbJeuCarWindowsClick(Sender: TObject);
    procedure rbJeuCarMacintoshClick(Sender: TObject);
    procedure rbJeuCarMSDOSClick(Sender: TObject);
    procedure rbJeuCarAnselClick(Sender: TObject);
    procedure cbSeparateurLieuxChange(Sender: TObject);
    procedure edPathFileNameGEDChange(Sender: TObject);
    procedure bfsbParticulesClick(Sender: TObject);
    procedure rbDontTouchParticuleClick(Sender: TObject);
    procedure WizardTreeChange(Sender: TObject);
    procedure URLLink2Click(Sender: TObject);
    procedure btnSelectDossierClick(Sender: TObject);
    procedure rbClearBddClick(Sender: TObject);
    procedure rbAddToBddClick(Sender: TObject);
    procedure SuperFormShow(Sender: TObject);
    procedure SuperFormHide(Sender: TObject);
  private
    fFill: TState;
    F: Text;

    fListTemoins_REF_RELA_TAG: TStringList;
    fListTemoins_REF_RELA_CODE: TIntegerList;

    //objet de dcryptage du fichier gedcom
    fImportGedCom: TImportGedCom;

    //numro de la page max, dans laquelle peut aller le user
    fMaxNumEtapePossible: integer;

    //le Header est-il dj charg ?
    fIsHeaderLoaded: boolean;

    //les exemples de noms sont-ils dj chargs ?
    fIsQuelquesExeplesDeNomsLoaded: boolean;
    fExempleJeuxCaractere: TStringList;
    fJeuxCaractere: TSetCodageCaracteres;

    //les exemples d'adresses sont-ils chargs
    fIsQuelquesAdressesLoaded: boolean;
    fNumColConfiguring: integer;
    fColumnsLieuxOrder: array[1..7] of byte;
    fExempleLieux: TStringList;


    //le fichier est-il charg ?
    fIsFileLoaded: boolean;

    //bouton "Patienter..." qui clignote
    FontColorWhite: boolean;

    fHeaderSource: string;
    fHeaderNom: string;
    fHeaderDestination: string;
    fHeaderCodage: string;
    fHeaderLangue: string;
    fHeaderVersion: string;
    fHeaderCompagnie: string;
    fHeaderAdresse: string;

    //pour la dcomposition des nom
    fCutName: TCut;

    //pour la dcomposition des adresses
    fCutAddr: TCut;

    //liste des particules possibles
    fParticules: TStringList;

    CutIndi: TCut;
    FileIndi: Text;
    NameFileIndi: string;

    CutEvent: TCut;
    FileEventIndi: Text;
    NameFileEventIndi: string;

    CutDomiIndi: TCut;
    FileDomiIndi: Text;
    NameFileDomiIndi: string;

    CutMediaIndi: TCut;
    FileMediaIndi: Text;
    NameFileMediaIndi: string;

    CutMediaPointeurs: TCut;
    FileMediaPointeurs: Text;
    NameFileMediaPointeurs: string;

    CutEventSourceIndi: TCut;
    FileEventSourceIndi: Text;
    NameEventSourceIndi: string;

    CutFam: TCut;
    NameFileFam: string;

    CutUnion: TCut;
    FileUnion: Text;
    NameFileUnion: string;

    CutEventFam: TCut;
    FileEventFam: Text;
    NameFileEventFam: string;

    CutAsso: TCut;
    FileAsso: Text;
    NameFileAsso: string;

    //divers
    aText: TStringList;

    fNumDossierImport: integer;
    fNomDossierImport: string;

    procedure InitProcess;
    procedure RefreshButtonsLieux;
    procedure DoFillBddWithGedcomFile;
    function CreateIndividu(Indi: TTag_INDIVIDUAL_RECORD): boolean;
    procedure CreateEventsIndividu(Indi: TTag_INDIVIDUAL_RECORD);
    procedure CreateDomicilesIndividu(Indi: TTag_INDIVIDUAL_RECORD);
    procedure CreateMediasIndividu(Indi: TTag_INDIVIDUAL_RECORD);
    function CreateFamille(Fam: TTag_FAM_RECORD): boolean;
    procedure CreateEventsFamille(Fam: TTag_FAM_RECORD);
    procedure CreateAssociationsEventsIndividu(Indi: TTag_INDIVIDUAL_RECORD);
    procedure DecodeNom(aNAME: string; var aNom, aPrenom: string);
    procedure DecodeAdresse(aLINE: string; var aVille, aCP, aDept, aRegion, aPays, aSubd: string);
    procedure doOnProgressEvent(Sender: TObject; Pourcent: integer);
    procedure LoadEventPossibles(aList: TStringList);
    procedure GoToPage(aNumPage: integer);
    procedure doLoadHeader;
    procedure DoLoadQuelquesExemplesDeNoms;
    procedure RefreshExempleJeuCaracteres;
    procedure DoLoadQuelquesAdresses;
    procedure RefreshExempleLieux;
    procedure doImportation;
    procedure doRefreshHeader;
    procedure SaveAssosOfEventFamille(aEvent: TTag_Event_Detail; aFam: TTag_FAM_RECORD);

    procedure RechercheImage;
    procedure AddImageToDatabase(TempPathFileNameJPEG: string);

    procedure CreateSourceEventIndi(aEvent: TTag_Event_Detail; sTable: string);

  public

  end;

var
  FImportGedcom: TFImportGedcom;

implementation

uses
  u_dm, cDateTime, u_form_main,
  u_common_var, u_common_func, u_form_select_dossier, u_common_const;

{$R *.DFM}

const
  _COL_LIEU_IGNORER = 0;

  _COL_LIEU_VILLE = 1;
  _COL_LIEU_CODE = 2;
  _COL_LIEU_DEPT = 3;
  _COL_LIEU_REGION = 4;
  _COL_LIEU_PAYS = 5;
  _COL_LIEU_SUBD = 6;


procedure TFImportGedcom.SuperFormCreate(Sender: TObject);
begin

  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  fNumDossierImport := dm.NumDossier;
  fNomDossierImport := dm.NomDossier;

  fFill := TState.create(false);
  fImportGedCom := TImportGedCom.create;
  fImportGedCom.OnProgress := doOnProgressEvent;

  //jeux de caractre
  fExempleJeuxCaractere := TStringList.create;
  fJeuxCaractere := ccWindows;

  //les lieux
  fExempleLieux := TStringList.create;
  fColumnsLieuxOrder[1] := 1;
  fColumnsLieuxOrder[2] := 2;
  fColumnsLieuxOrder[3] := 3;
  fColumnsLieuxOrder[4] := 4;
  fColumnsLieuxOrder[5] := 5;
  fColumnsLieuxOrder[6] := 6;
  fColumnsLieuxOrder[7] := 0;
  RefreshButtonsLieux;
  RefreshExempleLieux;

  //On se place sur la premire page
  GoToPage(0);

  //on ne peux pas aller sur les pages suivantes, pour l'instant
  fMaxNumEtapePossible := 0;

  //divers
  aText := TStringList.create;
  fCutName := TCut.create;
  fCutAddr := TCut.create;

  //les particules possibles
  fParticules := TStringList.create;
  fParticules.Add('DE ');
  fParticules.Add('VON ');
  fParticules.Add('D''');

  //     TmpIndi := TMyTStringList.create;
  CutIndi := TCut.create;
  CutIndi.ParamSeparator := #9;
  CutIndi.SetTotalStringParams(25);

  //     TmpEvent := TMyTStringList.create;
  CutEvent := TCut.create;
  CutEvent.ParamSeparator := #9;
  CutEvent.SetTotalStringParams(23);

  CutDomiIndi := TCut.create;
  CutDomiIndi.ParamSeparator := #9;
  CutDomiIndi.SetTotalStringParams(18);

  CutMediaIndi := TCut.create;
  CutMediaIndi.ParamSeparator := #9;
  CutMediaIndi.SetTotalStringParams(9);

  CutMediaPointeurs := TCut.create;
  CutMediaPointeurs.ParamSeparator := #9;
  CutMediaPointeurs.SetTotalStringParams(7);

  CutEventSourceIndi := TCut.create;
  CutEventSourceIndi.ParamSeparator := #9;
  CutEventSourceIndi.SetTotalStringParams(11);

  //     TmpFam := TMyTStringList.create;
  CutFam := TCut.create;
  CutFam.ParamSeparator := #9;
  CutFam.SetTotalStringParams(6);

  //     TmpUnion := TMyTStringList.create;
  CutUnion := TCut.create;
  CutUnion.ParamSeparator := #9;
  CutUnion.SetTotalStringParams(7);

  //     TmpEventFam := TMyTStringList.create;
  CutEventFam := TCut.create;
  CutEventFam.ParamSeparator := #9;
  CutEventFam.SetTotalStringParams(18);

  //     TmpAsso := TMyTStringList.create;
  CutAsso := TCut.create;
  CutAsso.ParamSeparator := #9;
  CutAsso.SetTotalStringParams(9);

  fListTemoins_REF_RELA_TAG := TStringList.create;
  fListTemoins_REF_RELA_CODE := TIntegerList.create;

  FontColorWhite := true;
  DoRefreshControls;
end;


procedure TFImportGedcom.SuperFormDestroy(Sender: TObject);
begin
  fImportGedCom.Free;
  fExempleJeuxCaractere.Free;
  fExempleLieux.Free;
  fFill.free;

  //divers
  aText.Free;
  fCutName.free;
  fCutAddr.free;

  //   TmpIndi.free;
  CutIndi.free;

  //    TmpEvent.free;
  CutEvent.free;

  CutDomiIndi.Free;
  CutMediaIndi.Free;
  CutMediaPointeurs.Free;
  CutEventSourceIndi.Free;

  //    TmpFam.free;
  CutFam.free;

  //    TmpUnion.free;
  CutUnion.free;

  //    TmpEventFam.free;
  CutEventFam.free;

  //    TmpAsso.free;
  CutAsso.free;

  fParticules.Free;
  fListTemoins_REF_RELA_TAG.free;
  fListTemoins_REF_RELA_CODE.free;

end;

procedure TFImportGedcom.WizardTreeChanging(Sender: TObject; NewItemIndex: Integer; var AllowChange: Boolean);
begin
  if fFill.value = false then
    begin
      //peut-on changer de page ?
      if NewItemIndex <= fMaxNumEtapePossible then
        begin
          GoToPage(NewItemIndex);
        end
      else
        AllowChange := false;

      DoRefreshControls;
    end;
end;

procedure TFImportGedcom.SuperFormRefreshControls(Sender: TObject);
begin
  //choix du fichier
  if Notebook.PageIndex = 0 then
    begin
      btnPrevious.visible := false;
      btnNext.Caption := 'Suivant >';

    end
  else
    //Header
    if Notebook.PageIndex = 1 then
      begin
        btnPrevious.visible := true;
        btnNext.Caption := 'Suivant >';
        //btnNext.enabled := fMaxNumEtapePossible > 1;
      end
    else
      if NoteBook.PageIndex = NoteBook.Pages.Count - 1 then
        begin
          btnPrevious.visible := true;

          btnNext.Caption := 'Importer';
        end
      else
        begin
          btnPrevious.visible := true;
          btnNext.Caption := 'Suivant >';
        end;

  btnNext.enabled := (fMaxNumEtapePossible > 0) and (fNumDossierImport > 0);

  Label18.enabled := rbWorkWithParticule.checked;
  Label19.enabled := rbWorkWithParticule.checked;
  Label20.enabled := rbWorkWithParticule.checked;
  Label21.enabled := rbWorkWithParticule.checked;

  btnSelectDossier.Caption := '" ' + fNomDossierImport + ' "';

  btnSelectDossier.enabled := rbAddToBdd.checked;
end;

procedure TFImportGedcom.btnPreviousClick(Sender: TObject);
begin
  if NoteBook.PageIndex > 0 then
    begin
      GoToPage(NoteBook.PageIndex - 1);
    end;

  DoRefreshControls;
end;

procedure TFImportGedcom.btnNextClick(Sender: TObject);
begin
  if NoteBook.PageIndex < NoteBook.Pages.Count - 1 then
    begin
      GoToPage(NoteBook.PageIndex + 1);
    end
  else
    begin
      //c'est le lancement de l'import
      doImportation;
    end;

  DoRefreshControls;
end;

procedure TFImportGedcom.BFSBSelectionClick(Sender: TObject);
begin
  _Agent.doAgent('RestPose', '',
    Fmain.Left,
    Fmain.Top);
  OpenDialog.InitialDir := _Context.PathImportExport;

  if OpenDialog.execute then
    begin
      //initialisation de l'objet d'import Gedcom
      InitProcess;

      //on montre le nom du fichier  importer
      edPathFileNameGED.Text := OpenDialog.FileName;

      //On charge le Header
      DoLoadHeader;
    end;

  DoRefreshControls;
end;


procedure TFImportGedcom.btnLieuxCol1Click(Sender: TObject);
var
  p: tpoint;
begin
  fNumColConfiguring := TControl(Sender).tag;

  p.x := 0; p.y := 0;
  p := TControl(Sender).clienttoscreen(p);
  popup_FormatLieux.popup(p.x, p.y + TControl(Sender).height);
end;

procedure TFImportGedcom.popupLieuClick(Sender: TObject);
var
  n: integer;
begin
  fColumnsLieuxOrder[fNumColConfiguring] := TControl(Sender).Tag;

  //si une autre colonne possde le mme tag, alors on la bascule  ignorer
  for n := 0 to 7 do
    if n <> fNumColConfiguring then
      begin
        if fColumnsLieuxOrder[n] = fColumnsLieuxOrder[fNumColConfiguring]
          then fColumnsLieuxOrder[n] := _COL_LIEU_IGNORER;
      end;

  RefreshButtonsLieux;
  RefreshExempleLieux;
end;

procedure TFImportGedcom.RefreshButtonsLieux;
var
  k: integer;
  s: string;
  n: integer;
begin
  for n := 1 to 7 do
    begin
      case fColumnsLieuxOrder[n] of
        _COL_LIEU_VILLE: s := popupLieuVille.caption;
        _COL_LIEU_CODE: s := popup_LieuCode.caption;
        _COL_LIEU_DEPT: s := popup_LieuDept.caption;
        _COL_LIEU_REGION: s := popup_LieuRegion.caption;
        _COL_LIEU_PAYS: s := popup_LieuPays.caption;
        _COL_LIEU_SUBD: s := popup_LieuSubdivision.caption;
        else
          s := ''; //popup_LieuIgnorer.caption;
      end;

      k := pos('&', s); if k <> 0 then delete(s, k, 1);

      case n of
        1: btnLieuxCol1.caption := s;
        2: btnLieuxCol2.caption := s;
        3: btnLieuxCol3.caption := s;
        4: btnLieuxCol4.caption := s;
        5: btnLieuxCol5.caption := s;
        6: btnLieuxCol6.caption := s;
        7: btnLieuxCol7.caption := s;
      end;
    end;
end;

procedure TFImportGedcom.RefreshExempleLieux;
var
  n, k: integer;
  cut: TCut;
  s: string;
begin

  //on clear tout
  for n := 0 to 9 do
    for k := 0 to 7 do theGridLieux.items[n].Values[k] := '';

  Cut := TCut.create;
  try
    if cbSeparateurLieux.Text = '<TAB>'
      then Cut.ParamSeparator := #9
    else Cut.ParamSeparator := cbSeparateurLieux.Text;

    for n := 0 to fExempleLieux.Count - 1 do
      begin
        if n < 10 then
          begin
            //dcoupage de la ligne
            s := fExempleLieux[n];
            Cut.Line := ConvertionChaine(s, fJeuxCaractere);
            Cut.SetParamCountAsInLine;
            Cut.StrToParams;

            for k := 0 to 6 do
              begin
                if k < Cut.Params.count
                  then theGridLieux.items[n].values[k] := Cut.Params[k].AsString;
              end;

            theGridLieux.items[n].values[7] := s;
          end;
      end;
  finally
    Cut.Free;
  end;

end;

procedure TFImportGedcom.rbJeuCarWindowsClick(Sender: TObject);
begin
  if fFill.value = false then
    begin
      fJeuxCaractere := ccWindows;
      RefreshExempleJeuCaracteres;
    end;
end;

procedure TFImportGedcom.RefreshExempleJeuCaracteres;
var
  n: integer;
  s: string;
begin
  fFill.Value := true;
  try
    case fJeuxCaractere of
      ccWindows: rbJeuCarWindows.checked := true;
      ccMacintosh: rbJeuCarMacintosh.checked := true;
      ccDOS: rbJeuCarMSDOS.checked := true;
      ccANSEL: rbJeuCarAnsel.checked := true;
    end;

    memoJeuxCaractere.lines.beginUpdate;
    try
      memoJeuxCaractere.Clear;

      for n := 0 to fExempleJeuxCaractere.count - 1 do
        begin
          s := fExempleJeuxCaractere[n];
          memoJeuxCaractere.lines.add(ConvertionChaine(s, fJeuxCaractere));
          //    memoJeuxCaractere.lines.add(s);
        end;

    finally
      memoJeuxCaractere.lines.EndUpdate;
    end;

  finally
    fFill.value := false;
  end;
end;

procedure TFImportGedcom.rbJeuCarMacintoshClick(Sender: TObject);
begin
  if fFill.value = false then
    begin
      fJeuxCaractere := ccMacintosh;
      RefreshExempleJeuCaracteres;
    end;
end;

procedure TFImportGedcom.rbJeuCarMSDOSClick(Sender: TObject);
begin
  if fFill.value = false then
    begin
      fJeuxCaractere := ccDOS;
      RefreshExempleJeuCaracteres;
    end;
end;

procedure TFImportGedcom.rbJeuCarAnselClick(Sender: TObject);
begin
  if fFill.value = false then
    begin
      fJeuxCaractere := ccANSEL;
      RefreshExempleJeuCaracteres;
    end;
end;

procedure TFImportGedcom.cbSeparateurLieuxChange(Sender: TObject);
begin
  if fFill.Value = false then RefreshExempleLieux;
end;


function TFImportGedcom.CreateFamille(Fam: TTag_FAM_RECORD): boolean;
var
  s: string;
  aSOUR: TTag_SOURCE_CITATION;
  aNOTE: TTag_NOTE_STRUCTURE;
begin
  //UNION_CLE
  CutUnion.Params[0].AsInteger := Fam.Cle;

  //UNION_MARI
  if Fam.CLEF_HUSB = -1
    then CutUnion.Params[1].Clear
  else CutUnion.Params[1].AsInteger := Fam.CLEF_HUSB;

  //UNION_FEMME
  if Fam.CLEF_WIFE = -1
    then CutUnion.Params[2].Clear
  else CutUnion.Params[2].AsInteger := Fam.CLEF_WIFE;

  //KLE_DOSSIER
  CutUnion.Params[3].AsInteger := fNumDossierImport;

  //UNION_TYPE
  CutUnion.Params[4].AsInteger := 0;
  if Fam._TYPU <> nil then
    begin
      CutUnion.Params[4].AsInteger := StrToIntDef(Fam._TYPU.Value, 0);
    end;

  //SOURCE
  CutUnion.Params[5].AsString := '';
  if cbImportSources.checked then
    begin
      aSOUR := fam._SOUR;
      while (aSOUR <> nil) do
        begin
          s := aSOUR.AsLine;
          CutUnion.Params[5].AsString := s;
          aSOUR := TTag_SOURCE_CITATION(aSOUR.PtrNextSameTag);
        end;
    end;

  //COMMENT
  CutUnion.Params[6].AsString := '';
  if cbImportNotes.checked then
    begin
      aNOTE := fam._NOTE;
      while (aNOTE <> nil) do
        begin
          s := aNOTE.AsLine;
          CutUnion.Params[6].AsString := s;
          aNOTE := TTag_NOTE_STRUCTURE(aNOTE.PtrNextSameTag);
        end;
    end;



  if (CutUnion.Params[1].AsString <> '') or (CutUnion.Params[2].AsString <> '') then
    begin
      CutUnion.ParamsToStr;
      Write(FileUnion, CutUnion.Line, #0);
      Flush(FileUnion);

      result := true;
    end
  else
    result := false;

end;

function TFImportGedcom.CreateIndividu(Indi: TTag_INDIVIDUAL_RECORD): boolean;
var
  sex: smallint;
  s: string;
  aNom, aPrenom: string;
  Tmp: string;
  aSOUR: TTag_SOURCE_CITATION;

  aNOTE: TTag_NOTE_STRUCTURE;
const
  _F_CLE_FICHE = 0;
  _F_KLE_DOSSIER = 1;
  _F_CLE_IMPORTATION = 2;
  _F_CLE_PARENTS = 3;
  _F_CLE_PERE = 4;
  _F_CLE_MERE = 5;
  _F_PREFIXE = 6;
  _F_NOM = 7;
  _F_PRENOM = 8;
  _F_SURNOM = 9;
  _F_SUFFIXE = 10;
  _F_SEXE = 11;
  _F_DATE_NAISSANCE = 12;
  _F_ANNEE_NAISSANCE = 13;
  _F_DATE_DECES = 14;
  _F_ANNEE_DECES = 15;
  _F_DECEDE = 16;
  _F_AGE_AU_DECES = 17;
  _F_SOURCE = 18;
  _F_COMMENT = 19;
  _F_FILLIATION = 20;
  _F_NUM_SOSA = 21;
  _F_DATE_MODIF = 22;
  _F_DATE_CREATION = 23;
  _F_MODIF_PAR_QUI = 24;

begin
  Tmp := '';

  //Cration d'un enregistrement dans la table INDIVIDU

  //CLE_FICHE
  CutIndi.Params[_F_CLE_FICHE].AsInteger := indi.cle;

  //KLE_DOSSIER
  CutIndi.Params[_F_KLE_DOSSIER].AsInteger := fNumDossierImport;

  //CLE_IMPORTATION
  CutIndi.Params[_F_CLE_IMPORTATION].AsInteger := indi.cle;

  //CLE_PARENTS
  CutIndi.Params[_F_CLE_PARENTS].Clear;

  //CLE_PERE
  if indi.CLE_PERE = -1
    then CutIndi.Params[_F_CLE_PERE].Clear
  else CutIndi.Params[_F_CLE_PERE].AsInteger := indi.CLE_PERE;

  //CLE_MERE
  if indi.CLE_MERE = -1
    then CutIndi.Params[_F_CLE_MERE].Clear
  else CutIndi.Params[_F_CLE_MERE].AsInteger := indi.CLE_MERE;


  //Nom, prnom        (5/6)
  if indi._NAME <> nil then
    begin
      //Prfixe
      if indi._NAME._NPFX <> nil
        then CutIndi.Params[_F_PREFIXE].AsString := copy(indi._NAME._NPFX.Value, 1, 30)
      else CutIndi.Params[_F_PREFIXE].clear;

      DecodeNom(indi._NAME.Value, aNom, aPrenom);
      //NOM
      CutIndi.Params[_F_NOM].AsString := copy(aNom, 1, 40);
      //PRENOM
      CutIndi.Params[_F_PRENOM].AsString := copy(aPrenom, 1, 60);

      //Surnom
      if indi._NAME._NICK <> nil
        then CutIndi.Params[_F_SURNOM].AsString := copy(indi._NAME._NICK.Value, 1, 120)
      else CutIndi.Params[_F_SURNOM].clear;

      //Suffixe
      if indi._NAME._NSFX <> nil
        then CutIndi.Params[_F_SUFFIXE].AsString := copy(indi._NAME._NSFX.Value, 1, 30)
      else CutIndi.Params[_F_SUFFIXE].clear;
    end
  else
    begin
      //Prfixe
      CutIndi.Params[_F_PREFIXE].clear;
      //NOM
      CutIndi.Params[_F_NOM].clear;
      //PRENOM
      CutIndi.Params[_F_PRENOM].clear;
      //Surnon
      CutIndi.Params[_F_SURNOM].clear;
      //Suffixe
      CutIndi.Params[_F_SUFFIXE].clear;
    end;

  //Sexe
  sex := 0;
  if indi._SEX <> nil then
    begin
      s := ansiUpperCase(indi._SEX.Value);
      if s = 'M' then sex := 1 else if s = 'F' then sex := 2;
    end;
  CutIndi.Params[_F_SEXE].AsInteger := sex;

  //DATE_NAISSANCE
  CutIndi.Params[_F_DATE_NAISSANCE].clear;

  //ANNEE_NAISSANCE
  CutIndi.Params[_F_ANNEE_NAISSANCE].clear;

  //DATE_DECES
  CutIndi.Params[_F_DATE_DECES].clear;

  //ANNEE_DECES
  CutIndi.Params[_F_ANNEE_DECES].clear;

  //DECEDE
  CutIndi.Params[_F_DECEDE].clear;

  //AGE_AU_DECES
  CutIndi.Params[_F_AGE_AU_DECES].clear;

  //SOURCE
  CutIndi.Params[_F_SOURCE].AsString := '';
  if cbImportSources.checked then
    begin
      aSOUR := indi._SOUR;
      while (aSOUR <> nil) do
        begin

          s := aSOUR.AsLine;
          CutIndi.Params[_F_SOURCE].AsString := s;

          aSOUR := TTag_SOURCE_CITATION(aSOUR.PtrNextSameTag);
        end;
    end;

  //COMMENT
  CutIndi.Params[_F_COMMENT].AsString := '';
  if cbImportNotes.checked then
    begin
      aNOTE := indi._NOTE;
      while (aNOTE <> nil) do
        begin
          s := aNOTE.AsLine;
          //               s := indi._NOTE.Value;
          //               for p := 0 to indi._NOTE.Memo.count - 1 do s := s + #13#10 + indi._NOTE.Memo[p];
          CutIndi.Params[_F_COMMENT].AsString := s;
          aNOTE := TTag_NOTE_STRUCTURE(aNOTE.PtrNextSameTag);
        end;
    end;

  //FILLIATION
  CutIndi.Params[_F_FILLIATION].clear;
  if indi._FILA <> nil then
    begin
      s := indi._FILA.Value;
      if s <> '' then CutIndi.Params[_F_FILLIATION].AsString := s;
    end;

  //NUM_SOSA
  CutIndi.Params[_F_NUM_SOSA].clear;

  //DATE_MODIF
  CutIndi.Params[_F_DATE_MODIF].clear;

  //DATE_CREATION
  CutIndi.Params[_F_DATE_CREATION].clear;

  //Modifi par qui ?
  CutIndi.Params[_F_MODIF_PAR_QUI].AsString := 'Unknown';

  CutIndi.ParamsToStr;

  Write(FileIndi, CutIndi.Line, #0);
  Flush(FileIndi);


  result := true;
end;

procedure TFImportGedcom.CreateEventsIndividu(Indi: TTag_INDIVIDUAL_RECORD);

  procedure SaveEvent(aEvent: TTag_Event_Detail);
  var
    s: string;
    cle: integer;
    aVille, aCP, aDept, aRegion, aPays, aSubd, sActe: string;
    aLieuDit: string;
  begin
    while aEvent <> nil do
      begin
        Cle := dm.uf_GetClefUnique('EVENEMENTS_IND');

        if Cle <> -1 then
          begin
            aEvent.Cle := Cle;


            //EV_IND_CLEF
            CutEvent.Params[0].AsInteger := Cle;

            //EV_IND_KLE_FICHE
            CutEvent.Params[1].AsInteger := indi.cle;

            //EV_IND_KLE_DOSSIER
            CutEvent.Params[2].AsInteger := fNumDossierImport;

            //EV_IND_TYPE
            CutEvent.Params[3].AsString := copy(aEvent.Caption, 1, 7);

            //DATE_WRITEN, DATE_YEAR, DATE, TIME
            CutEvent.Params[4].AsString := '';
            CutEvent.Params[5].AsString := '';
            CutEvent.Params[6].AsString := '';
            CutEvent.Params[22].AsString := '';

            if aEvent._DATE <> nil then
              begin
                if _GDate.DecodeGedcomDate(aEvent._Date.Value) then
                  begin
                    CutEvent.Params[4].AsString := copy(_GDate.EncodeHumanDate, 1, 100);
                    if _GDate.KnowYear then CutEvent.Params[5].AsInteger := _GDate.GDate.Year1;
                    if _GDate.KnowDate then CutEvent.Params[6].AsString := FormatDateTime('d/m/yyyy', _GDate.GDate.DateTime1);
                  end;

              end;

            if aEvent._TIME <> nil then
              begin
                //showmessage(copy(aEvent._TIME.Value, 1, 8));
                CutEvent.Params[22].AsString := copy(aEvent._TIME.Value, 1, 5);
              end;

            //EV_IND_ADRESSE, CP, VILLE, DEPT, PAYS
            if aEvent._PLAC <> nil then
              begin
                DecodeAdresse(aEvent._PLAC.value, aVille, aCP, aDept, aRegion, aPays, aSubd);

                CutEvent.Params[7].AsString := ''; //le lieu dit
                CutEvent.Params[8].AsString := trim(copy(aCP, 1, 10));
                CutEvent.Params[9].AsString := trim(copy(aVille, 1, 30));
                CutEvent.Params[10].AsString := trim(copy(aDept, 1, 30));
                CutEvent.Params[11].AsString := trim(copy(aPays, 1, 30));
                CutEvent.Params[17].AsString := trim(copy(aRegion, 1, 50));
                CutEvent.Params[18].AsString := trim(copy(aSubd, 1, 50));
              end
            else
              begin
                CutEvent.Params[7].AsString := '';
                CutEvent.Params[8].AsString := '';
                CutEvent.Params[9].AsString := '';
                CutEvent.Params[10].AsString := '';
                CutEvent.Params[11].AsString := '';
                CutEvent.Params[17].AsString := '';
                CutEvent.Params[18].AsString := '';
              end;

            if aEvent._LIEU <> nil then
              begin
                aLieuDit := trim(copy(aEvent._LIEU.Value, 1, 50));
                CutEvent.Params[7].AsString := aLieuDit;
              end;

            //Cause
            if aEvent._CAUS <> nil then
              begin
                CutEvent.Params[12].AsString := copy(aEvent._CAUS.Value, 1, 90);
              end
            else
              begin
                CutEvent.Params[12].AsString := '';
              end;

            //Source
            CutEvent.Params[13].AsString := '';
            if cbImportSources.checked then
              begin
                if aEvent._SOUR <> nil then
                  begin
                    s_ABBR := '';
                    s_TEXT := '';
                    s_TITL := '';
                    s_REPO := '';
                    s_AUTH := '';
                    s_PUBL := '';

                    s := aEvent._SOUR.AsLine;
                    CreateSourceEventIndi(aEvent, 'I');

                  end;
              end;

            //Commentaires
            CutEvent.Params[14].AsString := '';
            if cbImportNotes.checked then
              begin
                if aEvent._NOTE <> nil then
                  begin
                    s := aEvent._NOTE.AsLine;
                    CutEvent.Params[14].AsString := s;
                  end;
              end;

            //EV_IND_TYPE_ANNEE
            CutEvent.Params[15].AsInteger := 0;

            //Description
            CutEvent.Params[16].AsString := copy(aEvent.Value, 1, 90);
            {
            if aEvent._XINSEE <> nil then
              begin
                CutEvent.Params[20].AsString := copy(aEvent._XINSEE.Value, 1, 6);
              end;
            }

            if aEvent._XORD <> nil then
              begin
                CutEvent.Params[21].AsInteger := StrToInt(aEvent._XORD.Value);
              end;

            CutEvent.Params[19].AsInteger := 0;
            {
            sActe := '';
            if aEvent._XACTE <> nil then
              begin
                sActe := Copy(aEvent._XACTE.Value, 1, 1);
                if StrToInt(sActe) = 1 then CutEvent.Params[19].AsInteger := StrToInt(sActe);
              end;
             }

            CutEvent.ParamsToStr;

            Write(FileEventIndi, CutEvent.Line, #0);
            Flush(FileEventIndi);
          end;

        //on cherche le suivant...
        aEvent := TTag_Event_Detail(aEvent.PtrNextSameTag);
      end;
  end;

begin
  if Indi.Cle <> -1 then
    begin
      //INDIVIDUAL_EVENT_STRUCTURE
      SaveEvent(Indi._BIRT);
      SaveEvent(Indi._DIPL);
      SaveEvent(Indi._CHR);
      SaveEvent(Indi._DEAT);
      SaveEvent(Indi._BURI);
      SaveEvent(Indi._CREM);
      SaveEvent(Indi._ADOP);
      SaveEvent(Indi._BAPM);
      SaveEvent(Indi._BARM);
      SaveEvent(Indi._BASM);
      SaveEvent(Indi._BLES);
      SaveEvent(Indi._CHRA);
      SaveEvent(Indi._CONF);
      SaveEvent(Indi._FCOM);
      SaveEvent(Indi._ORDN);
      SaveEvent(Indi._NATU);
      SaveEvent(Indi._EMIG);
      SaveEvent(Indi._IMMI);
      SaveEvent(Indi._CENS);
      SaveEvent(Indi._PROB);
      SaveEvent(Indi._WILL);
      SaveEvent(Indi._GRAD);
      SaveEvent(Indi._RETI);
      SaveEvent(Indi._EVEN); //23
      SaveEvent(Indi._BRIT);

      //INDIVIDUAL_ATTRIBUTE_STRUCTURE
      SaveEvent(Indi._CAST);
      SaveEvent(Indi._DSCR);
      SaveEvent(Indi._EDUC);
      SaveEvent(Indi._IDNO);
      SaveEvent(Indi._NATI);
      SaveEvent(Indi._NCHI);
      SaveEvent(Indi._NMR);
      SaveEvent(Indi._OCCU);
      SaveEvent(Indi._PROP);
      SaveEvent(Indi._RELI);
      SaveEvent(Indi._RESI);
      SaveEvent(Indi._SSN);
      SaveEvent(Indi._TITL); //13

      //LDS_INDIVIDUAL_ORDINANCE
      SaveEvent(Indi._BAPL);
      SaveEvent(Indi._CONL);
      SaveEvent(Indi._ENDL);
      SaveEvent(Indi._SLGC); //4

      //Autres Tag (de Heredis...)
      SaveEvent(Indi._PURC);
      SaveEvent(Indi._ALIV);
      SaveEvent(Indi._MILI);
      SaveEvent(Indi._SALE);
      SaveEvent(Indi._TRIP); //5
      SaveEvent(Indi._INHU);


    end;
end;

procedure TFImportGedcom.CreateAssociationsEventsIndividu(Indi: TTag_INDIVIDUAL_RECORD);

  procedure SaveAsso(aEvent: TTag_Event_Detail);
  var
    s: string;
    CleAsso, k: integer;
    aAsso: TTag_ASSOCIATION_STRUCTURE;
    indi_asso: TIndi;
  begin
    while aEvent <> nil do
      begin
        //on sauvegarde les associations en relation avec cet vnement
        aAsso := aEvent._ASSO;
        while aAsso <> nil do
          begin
            indi_asso := fImportGedCom.GetIndividuByID(aAsso.ID);
            if indi_asso <> nil then
              begin
                //rcupration d'une cl pour le nouveau record
                CleAsso := dm.uf_GetClefUnique('T_ASSOCIATIONS');

                if CleAsso <> -1 then
                  begin
                    //ASSOC_CLEF
                    CutAsso.Params[0].AsInteger := CleAsso;

                    //ASSOC_KLE_IND
                    CutAsso.Params[1].AsInteger := Indi.Cle;

                    //ASSOC_KLE_ASSOCIE
                    CutAsso.Params[2].AsInteger := indi_asso.Cle;

                    //ASSOC_KLE_DOSSIER
                    CutAsso.Params[3].AsInteger := fNumDossierImport;

                    //ASSOC_NOTES
                    CutAsso.Params[4].AsString := '';
                    if cbImportNotes.checked then
                      begin
                        if aAsso._NOTE <> nil then
                          begin
                            s := aAsso._NOTE.AsLine;
                            //                                        s := aAsso._NOTE.Value;
                            //                                        for p := 0 to aAsso._NOTE.Memo.count - 1 do s := s + #13#10 + aAsso._NOTE.Memo[p];
                            CutAsso.Params[4].AsString := s;
                          end;
                      end;

                    //ASSOC_SOURCES
                    CutAsso.Params[5].AsString := '';
                    if cbImportNotes.checked then
                      begin
                        if aAsso._SOUR <> nil then
                          begin
                            s := aAsso._SOUR.AsLine;
                            //                                        s := aAsso._SOUR.Value;
                            //								for p := 0 to aAsso._SOUR.Memo.count - 1 do s := s + #13#10 + aAsso._SOUR.Memo[p];
                            CutAsso.Params[5].AsString := s;
                          end;
                      end;

                    //ASSOC_TYPE
                    CutAsso.Params[6].AsString := '0';
                    if aAsso._RELA <> nil then
                      begin
                        // CutAsso.Params[6].AsInteger := StrToIntDef(aAsso._RELA.Value, 0);
                         //							fListTemoins_REF_RELA_TAG.Clear;
                         //							fListTemoins_REF_RELA_CODE.Clear;
                        s := AnsiUpperCase(aAsso._RELA.Value);
                        k := fListTemoins_REF_RELA_TAG.IndexOf(s);
                        if k <> -1 then
                          begin
                            CutAsso.Params[6].AsInteger := fListTemoins_REF_RELA_CODE[k];

                            //Attention, pour le cas GODPARENT
                            if s = 'GODPARENT' then
                              begin
                                if _Context.Langue = 'FRA' then
                                  begin
                                    if indi_asso.SEXE <> '' then
                                      begin
                                        if indi_asso.SEXE = 'M' then
                                          begin
                                            CutAsso.Params[6].AsInteger := 1;
                                          end
                                        else
                                          if indi_asso.SEXE = 'F' then
                                            begin
                                              CutAsso.Params[6].AsInteger := 2;
                                            end;
                                      end;
                                  end;
                              end;
                          end;
                      end;

                    //ASSOC_EVENEMENT
                    CutAsso.Params[7].AsInteger := aEvent.Cle; //la cle de l'event

                    //ASSOC_TABLE
                    CutAsso.Params[8].AsString := 'I';

                    CutAsso.ParamsToStr;

                    Write(FileAsso, CutAsso.Line, #0);
                    Flush(FileAsso);
                  end;
              end;

            //le suivant
            aAsso := TTag_ASSOCIATION_STRUCTURE(aAsso.PtrNextSameTag);
          end;
        //on cherche le suivant...
        aEvent := TTag_Event_Detail(aEvent.PtrNextSameTag);
      end;
  end;

begin
  if Indi.Cle <> -1 then
    begin
      //INDIVIDUAL_EVENT_STRUCTURE
      SaveAsso(Indi._BIRT);
      SaveAsso(Indi._CHR);
      SaveAsso(Indi._DEAT);
      SaveAsso(Indi._BURI);
      SaveAsso(Indi._CREM);
      SaveAsso(Indi._ADOP);
      SaveAsso(Indi._BAPM);
      SaveAsso(Indi._BARM);
      SaveAsso(Indi._BASM);
      SaveAsso(Indi._BLES);
      SaveAsso(Indi._CHRA);
      SaveAsso(Indi._CONF);
      SaveAsso(Indi._FCOM);
      SaveAsso(Indi._ORDN);
      SaveAsso(Indi._NATU);
      SaveAsso(Indi._EMIG);
      SaveAsso(Indi._IMMI);
      SaveAsso(Indi._CENS);
      SaveAsso(Indi._PROB);
      SaveAsso(Indi._WILL);
      SaveAsso(Indi._GRAD);
      SaveAsso(Indi._RETI);
      SaveAsso(Indi._EVEN); //23
      SaveAsso(Indi._BRIT);

      //INDIVIDUAL_ATTRIBUTE_STRUCTURE
      SaveAsso(Indi._CAST);
      SaveAsso(Indi._DSCR);
      SaveAsso(Indi._EDUC);
      SaveAsso(Indi._IDNO);
      SaveAsso(Indi._NATI);
      SaveAsso(Indi._NCHI);
      SaveAsso(Indi._NMR);
      SaveAsso(Indi._OCCU);
      SaveAsso(Indi._PROP);
      SaveAsso(Indi._RELI);
      SaveAsso(Indi._RESI);
      SaveAsso(Indi._SSN);
      SaveAsso(Indi._TITL); //13

      //LDS_INDIVIDUAL_ORDINANCE
      SaveAsso(Indi._BAPL);
      SaveAsso(Indi._CONL);
      SaveAsso(Indi._ENDL);
      SaveAsso(Indi._SLGC); //4

      //Autres Tag (de Heredis...)
      SaveAsso(Indi._PURC);
      SaveAsso(Indi._ALIV);
      SaveAsso(Indi._MILI);
      SaveAsso(Indi._SALE);
      SaveAsso(Indi._TRIP); //5
      SaveAsso(Indi._INHU);
    end;
end;

procedure TFImportGedcom.DecodeNom(aNAME: string; var aNom, aPrenom: string);
var
  s, ps: string;
  n, w: integer;
begin
  aNom := '';
  aPrenom := '';
  fCutName.ParamSeparator := '/';
  fCutName.Line := aName;
  fCutName.SetParamCountAsInLine;
  fCutName.StrToParams;

  if fCutName.Params.count >= 1 then aPrenom := fCutName.Params[0].AsString;
  if fCutName.Params.count >= 2 then aNom := fCutName.Params[1].AsString;

  if rbWorkWithParticule.checked then
    begin
      //on gre la particule
      if aNom <> '' then
        begin
          s := ansiUpperCase(aNom);

          for n := 0 to fParticules.count - 1 do
            begin
              w := length(fParticules[n]);
              if copy(s, 1, w) = fParticules[n] then
                begin
                  //on a trouv un nom  particule
                  ps := trim(copy(aNom, 1, w));

                  delete(aNom, 1, w);
                  aNom := aNom + ' (' + ps + ')';

                  break;
                end;
            end;
        end;
    end;
end;

procedure TFImportGedcom.DecodeAdresse(aLINE: string; var aVille, aCP, aDept, aRegion, aPays, aSubd: string);
var
  n: integer;
begin
  aCP := '';
  aVille := '';
  aDept := '';
  aRegion := '';
  aPays := '';
  aSubd := '';

  //	if fColumnsLieuxOrder
//     WriteLn(F, ConvertionToChaine('2 FORM Ville , Code Lieu , Dpartement , Rgion , Pays, Subdivision', fJeuxCaractere));

  if cbSeparateurLieux.Text = '<TAB>'
    then fCutName.ParamSeparator := #9
  else fCutName.ParamSeparator := cbSeparateurLieux.Text;

  fCutName.Line := aLINE;
  fCutName.SetParamCountAsInLine;
  fCutName.StrToParams;

  for n := 1 to 7 do
    begin
      case fColumnsLieuxOrder[n] of

        _COL_LIEU_VILLE: if fCutName.Params.count >= n then aVille := fCutName.Params[n - 1].AsString;
        _COL_LIEU_CODE: if fCutName.Params.count >= n then aCP := fCutName.Params[n - 1].AsString;
        _COL_LIEU_DEPT: if fCutName.Params.count >= n then aDept := fCutName.Params[n - 1].AsString;
        _COL_LIEU_REGION: if fCutName.Params.count >= n then aRegion := fCutName.Params[n - 1].AsString;
        _COL_LIEU_PAYS: if fCutName.Params.count >= n then aPays := fCutName.Params[n - 1].AsString;
        _COL_LIEU_SUBD: if fCutName.Params.count >= n then aSubd := fCutName.Params[n - 1].AsString;
      end;
    end;
end;

procedure TFImportGedcom.edPathFileNameGEDChange(Sender: TObject);
begin
  //   btnNext.Enabled := Length(edPathFileNameGED.Text) > 0;
end;

procedure TFImportGedcom.InitProcess;
begin
  //Initialisation de l'objet d'importation
  fImportGedCom.Clear;

  //Etape maximal possible
  fMaxNumEtapePossible := 0;

  //jeux de caractre
  fExempleJeuxCaractere.Clear;

  fIsHeaderLoaded := false;
  fIsQuelquesExeplesDeNomsLoaded := false;
  fIsQuelquesAdressesLoaded := false;
  fIsFileLoaded := false;

  fHeaderNom := '';
  fHeaderDestination := '';
  fHeaderCodage := '';
  fHeaderLangue := '';
  fHeaderVersion := '';
  fHeaderCompagnie := '';
  fHeaderAdresse := '';

end;

procedure TFImportGedcom.bfsbParticulesClick(Sender: TObject);
//var     aFParametres: TFParametres;
begin
  {
       aFParametres := TFParametres.create(self);
       try
            aFParametres.ShowModal;
       finally
            aFParametres.Free;
       end;
       }
end;

procedure TFImportGedcom.rbDontTouchParticuleClick(Sender: TObject);
begin
  DoRefreshControls;
end;

procedure TFImportGedcom.doLoadHeader;
var
  suite: boolean;
  s: string;
  n: integer;
  ok: boolean;
  Content: TStringList;
  CutPlac: TCut;
begin
  //on initialise la faon de lire les villes
  for n := 1 to 7 do fColumnsLieuxOrder[n] := _COL_LIEU_IGNORER;

  Content := TStringList.create;
  try
    fIsHeaderLoaded := false;
    fHeaderSource := '';
    fHeaderNom := '';
    fHeaderDestination := '';
    fHeaderCodage := '';
    fHeaderLangue := '';
    fHeaderVersion := '';
    fHeaderCompagnie := '';
    fHeaderAdresse := '';

    fImportGedCom.LoadFromFileJustTheHeader(edPathFileNameGED.text, Content);
    suite := fImportGedCom.DecodageGedcom(fImportGedCom.GedcomStructureOfHeader, Content, fJeuxCaractere);

    if (suite) and (fImportGedCom.GedcomStructureOfHeader._HEAD <> nil) then
      begin
        fIsHeaderLoaded := true;

        //remplissage des infos du Header
        if fImportGedCom.GedcomStructureOfHeader._HEAD._SOUR <> nil then
          begin
            s := fImportGedCom.GedcomStructureOfHeader._HEAD._SOUR.Value;
            if fImportGedCom.GedcomStructureOfHeader._HEAD._SOUR._VERS <> nil then
              begin
                s := u_gedcom_func.AssembleString([s, fImportGedCom.GedcomStructureOfHeader._HEAD._SOUR._VERS.Value], ' ');
              end;

            fHeaderSource := s;

            if fImportGedCom.GedcomStructureOfHeader._HEAD._SOUR._NAME <> nil then
              begin
                fHeaderNom := fImportGedCom.GedcomStructureOfHeader._HEAD._SOUR._NAME.value;
              end;

            if fImportGedCom.GedcomStructureOfHeader._HEAD._SOUR._CORP <> nil then
              begin
                fHeaderCompagnie := fImportGedCom.GedcomStructureOfHeader._HEAD._SOUR._CORP.value;

                if fImportGedCom.GedcomStructureOfHeader._HEAD._SOUR._CORP._ADDR <> nil then
                  begin
                    fHeaderAdresse := fImportGedCom.GedcomStructureOfHeader._HEAD._SOUR._CORP._ADDR.value;
                  end;
              end;

          end;

        if fImportGedCom.GedcomStructureOfHeader._HEAD._DEST <> nil then
          begin
            fHeaderDestination := fImportGedCom.GedcomStructureOfHeader._HEAD._DEST.value;
          end;

        if fImportGedCom.GedcomStructureOfHeader._HEAD._CHAR <> nil then
          begin
            fHeaderCodage := fImportGedCom.GedcomStructureOfHeader._HEAD._CHAR.value;

            fHeaderCodage := AnsiUpperCase(fHeaderCodage);

            if fHeaderCodage = 'ANSI' then
              begin
                fJeuxCaractere := ccWindows;
                rbJeuCarWindows.checked := true;
              end
            else
              if fHeaderCodage = 'MACINTOSH' then
                begin
                  fJeuxCaractere := ccMacintosh;
                  rbJeuCarMacintosh.checked := true;
                end
              else
                if fHeaderCodage = 'IBMPC' then
                  begin
                    fJeuxCaractere := ccDOS;
                    rbJeuCarMSDOS.checked := true;
                  end
                else
                  if fHeaderCodage = 'ANSEL' then
                    begin
                      fJeuxCaractere := ccANSEL;
                      rbJeuCarAnsel.checked := true;
                    end;

            if fImportGedCom.GedcomStructureOfHeader._HEAD._LANG <> nil then
              begin
                fHeaderLangue := fImportGedCom.GedcomStructureOfHeader._HEAD._LANG.value;
              end;

            if fImportGedCom.GedcomStructureOfHeader._HEAD._GEDC <> nil then
              begin
                if fImportGedCom.GedcomStructureOfHeader._HEAD._GEDC._VERS <> nil then
                  begin
                    fHeaderVersion := fImportGedCom.GedcomStructureOfHeader._HEAD._GEDC._VERS.value;
                  end;
              end;

            //ordre des villes
            if fImportGedCom.GedcomStructureOfHeader._HEAD._PLAC <> nil then
              begin
                if fImportGedCom.GedcomStructureOfHeader._HEAD._PLAC._FORM <> nil then
                  begin
                    s := trim(fImportGedCom.GedcomStructureOfHeader._HEAD._PLAC._FORM.value);

                    CutPlac := TCut.create;
                    try
                      CutPlac.Line := ConvertionChaine(s, fJeuxCaractere);
                      CutPlac.ParamSeparator := ',';
                      CutPlac.SetParamCountAsInLine;
                      if CutPlac.StrToParams then
                        begin
                          for n := 0 to CutPlac.Params.Count - 1 do
                            begin
                              if n < 7 then
                                begin
                                  s := trim(CutPlac.Params[n].AsString);
                                  if (s = 'Ville') or (s = 'Town') then fColumnsLieuxOrder[n + 1] := _COL_LIEU_VILLE
                                  else
                                    if (s = 'Code Lieu') or
                                      (s = 'Area code') or
                                      (s = 'Area Code') then fColumnsLieuxOrder[n + 1] := _COL_LIEU_CODE
                                    else
                                      if (s = 'Dpartement') or (s = 'County') then fColumnsLieuxOrder[n + 1] := _COL_LIEU_DEPT
                                      else
                                        if (s = 'Rgion') or (s = 'Region') then fColumnsLieuxOrder[n + 1] := _COL_LIEU_REGION
                                        else
                                          if (s = 'Pays') or (s = 'Country') then fColumnsLieuxOrder[n + 1] := _COL_LIEU_PAYS
                                          else
                                            if (s = 'Subdivision') or (s = 'Subdivision') then fColumnsLieuxOrder[n + 1] := _COL_LIEU_SUBD
                                            else
                                              fColumnsLieuxOrder[n + 1] := _COL_LIEU_IGNORER;
                                end;
                            end;
                        end;
                    finally
                      CutPlac.Free;
                    end;
                  end;
              end;
            //On peux passer  l'tape suivante
            fMaxNumEtapePossible := 1000;

            //On passe  la page suivante
            GoToPage(1);
          end
        else
          begin
            MyMessageDlg('Impossible de lire ce fichier !', mtWarning, [mbOK], 0);
          end;

        DoRefreshHeader;
        DoRefreshControls;
      end;

  finally
    Content.Free;
  end;

  //on regarde si on a trouv les villes
  ok := false;
  for n := 1 to 7 do if fColumnsLieuxOrder[n] <> _COL_LIEU_IGNORER then ok := true;
  if Ok = false then
    begin
      //on met un codage
      fColumnsLieuxOrder[1] := 1;
      fColumnsLieuxOrder[2] := 2;
      fColumnsLieuxOrder[3] := 3;
      fColumnsLieuxOrder[4] := 4;
      fColumnsLieuxOrder[5] := 5;
      fColumnsLieuxOrder[6] := 6;
      fColumnsLieuxOrder[7] := 0;
    end;

  RefreshButtonsLieux;
  RefreshExempleLieux;
end;

procedure TFImportGedcom.GoToPage(aNumPage: integer);
begin
  fFill.Value := true;
  try
    Notebook.PageIndex := aNumPage;
    WizardTree.ItemIndex := aNumPage;
  finally
    fFill.Value := false;
  end;

  case NoteBook.PageIndex of

    //on est maintenant sur les header
    1: begin
        if fIsHeaderLoaded = false then DoLoadHeader;
        DoRefreshHeader;
      end;
    //on est maintenant sur les exemples
    2: begin
        if fIsQuelquesExeplesDeNomsLoaded = false then DoLoadQuelquesExemplesDeNoms;
      end;

    //on est maintenant sur la config des adresses
    4: begin
        if fIsQuelquesAdressesLoaded = false then DoLoadQuelquesAdresses;
      end;

  end;


  DoRefreshControls;
end;


procedure TFImportGedcom.WizardTreeChange(Sender: TObject);
begin
  WizardTree.Refresh;
end;


procedure TFImportGedcom.CreateEventsFamille(Fam: TTag_FAM_RECORD);

  procedure SaveEvent(aEvent: TTag_Event_Detail);
  var
    s: string;
    cle: integer;
    aVille, aCP, aDept, aRegion, aPays, aSubd: string;
    aLieuDit: string;
  begin
    while aEvent <> nil do
      begin
        Cle := dm.uf_GetClefUnique('EVENEMENTS_FAM');

        if Cle <> -1 then
          begin
            aEvent.Cle := Cle;

            //EV_FAM_CLEF
            CutEventFam.Params[0].AsInteger := Cle;

            //EV_KLE_KLE_FICHE
            CutEventFam.Params[1].AsInteger := Fam.cle;

            //EV_FAM_KLE_DOSSIER
            CutEventFam.Params[2].AsInteger := fNumDossierImport;

            //EV_FAM_TYPE
            CutEventFam.Params[3].AsString := copy(aEvent.Caption, 1, 7);

            //DATE_WRITEN, DATE_YEAR, DATE
            CutEventFam.Params[4].AsString := '';
            CutEventFam.Params[5].AsString := '';
            CutEventFam.Params[6].AsString := '';

            if aEvent._DATE <> nil then
              begin
                if _GDate.DecodeGedcomDate(aEvent._Date.Value) then
                  begin
                    CutEventFam.Params[4].AsString := copy(_GDate.EncodeHumanDate, 1, 100);
                    if _GDate.KnowYear then CutEventFam.Params[5].AsInteger := _GDate.GDate.Year1;
                    if _GDate.KnowDate then CutEventFam.Params[6].AsString := FormatDateTime('d/m/yyyy', _GDate.GDate.DateTime1);
                  end;
              end;

            //EV_IND_ADRESSE, CP, VILLE, DEPT, PAYS
            if aEvent._PLAC <> nil then
              begin
                DecodeAdresse(aEvent._PLAC.value, aVille, aCP, aDept, aRegion, aPays, aSubd);

                CutEventFam.Params[7].AsString := ''; //aEvent._PLAC.value;
                CutEventFam.Params[8].AsString := trim(copy(aCP, 1, 10));
                CutEventFam.Params[9].AsString := trim(copy(aVille, 1, 30));
                CutEventFam.Params[10].AsString := trim(copy(aDept, 1, 30));
                CutEventFam.Params[11].AsString := trim(copy(aPays, 1, 30));
                CutEventFam.Params[14].AsString := trim(copy(aRegion, 1, 50));
                CutEventFam.Params[15].AsString := trim(copy(aSubd, 1, 50));

              end
            else
              begin
                CutEventFam.Params[7].AsString := '';
                CutEventFam.Params[8].AsString := '';
                CutEventFam.Params[9].AsString := '';
                CutEventFam.Params[10].AsString := '';
                CutEventFam.Params[11].AsString := '';
                CutEventFam.Params[14].AsString := copy(aRegion, 1, 50);
                CutEventFam.Params[15].AsString := copy(aSubd, 1, 50);
              end;

            if aEvent._LIEU <> nil then
              begin
                aLieuDit := trim(copy(aEvent._LIEU.Value, 1, 50));
                CutEventFam.Params[7].AsString := aLieuDit;
              end;

            //Source
            CutEventFam.Params[12].AsString := '';
            if cbImportSources.checked then
              begin
                if aEvent._SOUR <> nil then
                  begin
                    s_ABBR := '';
                    s_TEXT := '';
                    s_TITL := '';
                    s_REPO := '';
                    s_AUTH := '';
                    s_PUBL := '';

                    s := aEvent._SOUR.AsLine;
                    //CutEventFam.Params[12].AsString := s;

                    CreateSourceEventIndi(aEvent, 'F');
                  end
              end;

            //Commentaires
            CutEventFam.Params[13].AsString := '';
            if cbImportNotes.checked then
              begin
                if aEvent._NOTE <> nil then
                  begin
                    s := aEvent._NOTE.AsLine;
                    //    s := aEvent._NOTE.Value;
                     //   for p := 0 to aEvent._NOTE.Memo.count - 1 do s := s + #13#10 + aEvent._NOTE.Memo[p];
                    CutEventFam.Params[13].AsString := s;
                  end;
              end;

            CutEventFam.ParamsToStr;
            Write(FileEventFam, CutEventFam.Line, #0);
            Flush(FileEventFam);

            if cbImportTemoins.checked then
              begin
                SaveAssosOfEventFamille(aEvent, Fam);
              end;
          end;

        //on cherche le suivant...
        aEvent := TTag_Event_Detail(aEvent.PtrNextSameTag);
      end;
  end;

begin
  if Fam.Cle <> -1 then
    begin
      SaveEvent(Fam._ANUL);
      SaveEvent(Fam._CENS);
      SaveEvent(Fam._DIV);
      SaveEvent(Fam._DIVF);
      SaveEvent(Fam._ENGA);
      SaveEvent(Fam._MARR);
      SaveEvent(Fam._MARB);
      SaveEvent(Fam._MARC);
      SaveEvent(Fam._MARL);
      SaveEvent(Fam._MARS);
      SaveEvent(Fam._EVEN);
    end;
end;

procedure TFImportGedcom.SaveAssosOfEventFamille(aEvent: TTag_Event_Detail; aFam: TTag_FAM_RECORD);
var
  s: string;
  CleAsso, p, k: integer;
  //          aCP, aVille, aDept, aPays: string;
  //          aTag: TTag;
  aAsso: TTag_ASSOCIATION_STRUCTURE;
  indi_asso: TIndi;
begin
  //on sauvegarde les associations en relation avec cet vnement
  aAsso := aEvent._ASSO;
  while aAsso <> nil do
    begin
      indi_asso := fImportGedCom.GetIndividuByID(aAsso.ID);
      if indi_asso <> nil then
        begin
          //rcupration d'une cl pour le nouveau record
          CleAsso := dm.uf_GetClefUnique('T_ASSOCIATIONS');

          if CleAsso <> -1 then
            begin
              //ASSOC_CLEF
              CutAsso.Params[0].AsInteger := CleAsso;

              //ASSOC_KLE_IND
              CutAsso.Params[1].AsInteger := aEvent.Cle; //aFam.Cle;

              //ASSOC_KLE_ASSOCIE
              CutAsso.Params[2].AsInteger := indi_asso.Cle;

              //ASSOC_KLE_DOSSIER
              CutAsso.Params[3].AsInteger := fNumDossierImport;

              //ASSOC_NOTES
              CutAsso.Params[4].AsString := '';
              if cbImportNotes.checked then
                begin
                  if aAsso._NOTE <> nil then
                    begin
                      s := aAsso._NOTE.AsLine;
                      //                              s := aAsso._NOTE.Value;
                        //                            for p := 0 to aAsso._NOTE.Memo.count - 1 do s := s + #13#10 + aAsso._NOTE.Memo[p];
                      CutAsso.Params[4].AsString := s;
                    end;
                end;

              //ASSOC_SOURCES
              CutAsso.Params[5].AsString := '';
              if cbImportNotes.checked then
                begin
                  if aAsso._SOUR <> nil then
                    begin
                      s := aAsso._SOUR.Value;
                      for p := 0 to aAsso._SOUR.Memo.count - 1 do s := s + #13#10 + aAsso._SOUR.Memo[p];
                      CutAsso.Params[5].AsString := s;
                    end;
                end;

              //ASSOC_TYPE
              CutAsso.Params[6].AsString := '0';
              if aAsso._RELA <> nil then
                begin
                  CutAsso.Params[6].AsInteger := StrToIntDef(aAsso._RELA.Value, 0);

                  s := AnsiUpperCase(aAsso._RELA.Value);
                  k := fListTemoins_REF_RELA_TAG.IndexOf(s);
                  if k <> -1 then
                    begin
                      CutAsso.Params[6].AsInteger := fListTemoins_REF_RELA_CODE[k];
                    end;
                end;

              //ASSOC_EVENEMENT
              CutAsso.Params[7].AsInteger := aEvent.Cle; //la cle de l'event

              //ASSOC_TABLE
              CutAsso.Params[8].AsString := 'U';

              CutAsso.ParamsToStr;

              Write(FileAsso, CutAsso.Line, #0);
              Flush(FileAsso);
            end;
        end;

      //le suivant
      aAsso := TTag_ASSOCIATION_STRUCTURE(aAsso.PtrNextSameTag);
    end;
end;

procedure TFImportGedcom.LoadEventPossibles(aList: TStringList);
var
  n: integer;
begin
  aList.clear;
  try
    try
      IBQueryEvents.close;
      IBQueryEvents.Open;
      IBQueryEvents.last;
      IBQueryEvents.first;
      for n := 0 to IBQueryEvents.RecordCount - 1 do
        begin
          aList.Add(IBQueryEvents.FieldByName('REF_EVE_LIB_COURT').AsString);
          IBQueryEvents.Next;
        end;

    except
    end;
  finally
    IBQueryEvents.Close;
  end;

end;

procedure TFImportGedcom.doImportation;
var
  suite: boolean;
  StartTime, Duree: TDateTime;
begin
  if rbClearBdd.checked then
    begin
      fNumDossierImport := dm.NumDossier;
      fNomDossierImport := dm.NomDossier;
    end;

  btnNext.font.color := clWhite;
  Application.ProcessMessages;

  if rbClearBdd.checked then
    begin
      suite := false;
      if MyMessageDlg('Confirmez-vous le remplacement du dossier courant ?', mtWarning, [mbYes, mbNo], 0) = mrYes then
        begin
          btnNext.Caption := 'Patienter ...';
          btnNext.Refresh;
          Application.ProcessMessages;

          try
            try
              screen.cursor := crHourGlass;
              Animate.CommonAVI := aviEmptyRecycle;
              Animate.Visible := true;
              Animate.Active := true;

              dm.DoClearDossier;
              dm.IBT_BASE.CommitRetaining;
              dm.IBTrans_Secondaire.CommitRetaining;

              suite := true;
            finally
              Animate.Active := false;
              Animate.Visible := false;
              screen.cursor := crDefault;
            end;
          except
          end;

          Application.ProcessMessages;
        end
    end
  else
    suite := true;

  if suite then
    begin
      btnNext.Caption := 'Patienter ...';
      btnNext.Refresh;
      btnPrevious.visible := false;
      Application.ProcessMessages;

      screen.cursor := crHourGlass;
      Animate.CommonAVI := aviCopyFiles;
      Animate.Visible := true;
      Animate.Active := true;
      try

        //dbut de l'heure
        StartTime := Now;

        //on charge et decrypte tout le fichier gedcom
        fListTemoins_REF_RELA_TAG.Clear;
        fListTemoins_REF_RELA_CODE.Clear;

        QRefTemoins.Close;
        try
          try
            QRefTemoins.ParamByName('LANGUE').AsString := _Context.Langue;
            QRefTemoins.Open;
            while (not QRefTemoins.eof) do
              begin
                fListTemoins_REF_RELA_TAG.Add(AnsiUpperCase(QRefTemoins.FieldByName('REF_RELA_TAG').AsString));
                fListTemoins_REF_RELA_CODE.Add(QRefTemoins.FieldByName('REF_RELA_CODE').AsInteger);
                QRefTemoins.Next;
              end;

          except
          end;
        finally
          QRefTemoins.Close;
        end;

        //on balance tout dans la base de donne
        DoFillBddWithGedcomFile;

        Duree := Now - StartTime;

      finally
        Animate.Active := false;
        Animate.Visible := false;
        screen.cursor := crDefault;
      end;

      //on indique que tout s'est pass

      _Agent.doAgent('Congratulate', 'C''est termin',
        Fmain.Left + 260,
        Fmain.Top + 340);

      MyMessageDlg('L''importation a t effectue avec succs, en ' + inttostr(Hour(Duree)) + 'h, ' + inttostr(Minute(Duree)) + 'min, ' + inttostr(Second(Duree)) + 'sec.', mtInformation, [mbOK], 0);

      //On change le dossier en cours, si il est diffrent du dossier d'importation
      if fNumDossierImport <> dm.NumDossier then
        begin
          dm.doSaveLastFicheActiveOfDossier;
          dm.doOpenDossier(fNumDossierImport);

          _Context.LastNumDossier := dm.NumDossier;
          _Context.ShouldSave := True;
        end;

      //on rafraichis les favoris
      dm.LoadFavoris(FMain.menu_Favoris);

      FMain.doRefreshControls;

      //on va direct dans le rpertoire
      AutoFreeOnClose := true;
      DoSendMessage(Owner, 'OPEN_REPERTOIRE_AFTER_IMPORT');
      Close;
    end
  else
    DoRefreshControls;
end;


procedure TFImportGedcom.DoLoadQuelquesExemplesDeNoms;
begin
  fIsQuelquesExeplesDeNomsLoaded := false;

  if fImportGedCom.LoadFromFileQuelquesExemplesDeNoms(edPathFileNameGED.text, fExempleJeuxCaractere) then
    begin
      fIsQuelquesExeplesDeNomsLoaded := true;
      RefreshExempleJeuCaracteres;
      //On peux passer  toutes les tapes suivante
      fMaxNumEtapePossible := 1000;

    end;
end;

procedure TFImportGedcom.DoLoadQuelquesAdresses;
begin
  fIsQuelquesAdressesLoaded := false;

  if fImportGedCom.LoadFromFileQuelquesAdresses(edPathFileNameGED.text, fExempleLieux) then
    begin
      fIsQuelquesAdressesLoaded := true;
      RefreshExempleLieux;
      fMaxNumEtapePossible := 1000;
    end;
end;

procedure TFImportGedcom.doOnProgressEvent(Sender: TObject; Pourcent: integer);
begin
  lbNdFam.Caption := inttostr(fImportGedCom.ListFam.Count);
  lbNbIndi.Caption := inttostr(fImportGedCom.ListIndi.Count);
  Application.ProcessMessages;
end;

procedure TFImportGedcom.DoRefreshHeader;
begin
  lbHeaderSource.caption := ConvertionChaine(fHeaderSource, fJeuxCaractere);
  lbHeaderNom.caption := ConvertionChaine(fHeaderNom, fJeuxCaractere);
  lbHeaderDestination.caption := ConvertionChaine(fHeaderDestination, fJeuxCaractere);
  lbHeaderCodage.caption := ConvertionChaine(fHeaderCodage, fJeuxCaractere);
  lbHeaderLangue.caption := ConvertionChaine(fHeaderLangue, fJeuxCaractere);
  lbHeaderVersion.caption := ConvertionChaine(fHeaderVersion, fJeuxCaractere);
  lbHeaderCompagnie.caption := ConvertionChaine(fHeaderCompagnie, fJeuxCaractere);
  lbHeaderAdresse.caption := ConvertionChaine(fHeaderAdresse, fJeuxCaractere);
end;

procedure TFImportGedcom.DoFillBddWithGedcomFile;
var
  indi, indi_husb, indi_wife: TIndi;
  fam: TFam;

  TagFam: TTag_FAM_RECORD;
  TagIndi: TTag_INDIVIDUAL_RECORD;

  TotRec: integer;
  NumRec: integer;
  DelimInput: TIBInputDelimitedFile;

  TmpLine: string;
  Block: TStringList;
  aGedcomBlock: TGedComStructure;

  n, k: integer;
  trouve: boolean;

  aSOUR: TSour;
  aNOTE: TNote;
  aREPO: TRepo;

  procedure ReadNextBlock;
  var
    S: string;
    Stop: boolean;
  begin
    if TmpLine <> '' then
      begin
        Block.Clear;
        Block.Add(TmpLine);
        TmpLine := '';
      end;

    Stop := EOF(F);
    if Stop then Block.Clear;

    while (not Stop) do
      begin
        //on lit une ligne
        ReadLn(F, S);
        if copy(S, 1, 2) = '0 ' then
          begin
            if Block.Count = 0 then Block.Add(S)
            else
              begin
                TmpLine := S;
                Stop := true;
              end;
          end
        else
          Block.Add(S);

        if Stop = false then Stop := EOF(F);
      end;
  end;

begin
  NumRec := 0;

  NameFileIndi := TempPath + 'tmpindi.txt';
  NameFileEventIndi := TempPath + 'tmpeventindi.txt';
  NameFileDomiIndi := TempPath + 'tmpdomiindi.txt';
  NameFileMediaIndi := TempPath + 'tmpmediaindi.txt';
  NameFileMediaPointeurs := TempPath + 'tmpmediaPointeurs.txt';
  NameEventSourceIndi := TempPath + 'tmpsourevent.txt';
  NameFileFam := TempPath + 'tmpfam.txt';
  NameFileUnion := TempPath + 'tmpunion.txt';
  NameFileEventFam := TempPath + 'tmpeventfam.txt';
  NameFileAsso := TempPath + 'tmpasso.txt';

  //on rcupre les vnements possibles
  LoadEventPossibles(fImportGedCom.EventsPossible);

  fIsFileLoaded := false;
  fImportGedCom.PathFileName := edPathFileNameGED.text;

  fImportGedCom.PrepareIndividusAndFamilles;

  lbNdFam.Caption := inttostr(fImportGedCom.ListFam.Count);
  lbNbIndi.Caption := inttostr(fImportGedCom.ListIndi.Count);

  Block := TStringList.create;

  //on connait le nombre d'individus et de famille
  TotRec := fImportGedCom.ListIndi.Count + fImportGedCom.ListFam.Count + 9;

  AssignFile(FileIndi, NameFileIndi);
  AssignFile(FileEventIndi, NameFileEventIndi);
  AssignFile(FileDomiIndi, NameFileDomiIndi);
  AssignFile(FileMediaIndi, NameFileMediaIndi);
  AssignFile(FileMediaPointeurs, NameFileMediaPointeurs);
  AssignFile(FileEventSourceIndi, NameEventSourceIndi);
  AssignFile(FileEventFam, NameFileEventFam);
  AssignFile(FileUnion, NameFileUnion);
  AssignFile(FileAsso, NameFileAsso);
  try
    Rewrite(FileIndi);
    Rewrite(FileEventIndi);
    Rewrite(FileDomiIndi);
    Rewrite(FileMediaIndi);
    Rewrite(FileMediaPointeurs);
    Rewrite(FileEventSourceIndi);
    Rewrite(FileEventFam);
    Rewrite(FileUnion);
    Rewrite(FileAsso);

    AssignFile(F, edPathFileNameGED.Text);

    try
      //################################
      //ici, on lit et dcode tous les blocs notes, source et repo
      Reset(F);
      repeat
        ReadNextBlock;
        if Block.Count <> 0 then
          begin
            trouve := false;

            //on cherche l'objet dans les sources
            for n := 0 to fImportGedCom.ListSour.Count - 1 do
              if TSour(fImportGedCom.ListSour[n]).FirstLine = Block[0] then
                begin
                  //On dcode ce block
                  aSOUR := TSour(fImportGedCom.ListSour[n]);

                  aSOUR.GedcomBlock.PtrObjetImportGedcom := fImportGedCom;
                  aSOUR.GedcomBlock.AfterCreate(nil);
                  aSOUR.GedcomBlock.Level := -1;

                  //on dcode
                  if fImportGedCom.DecodageGedcom(aSOUR.GedcomBlock, Block, fJeuxCaractere) then
                    begin

                    end;

                  trouve := true;
                end;

            if trouve = false then
              begin
                //on cherche l'objet dans les notes
                for n := 0 to fImportGedCom.ListNote.Count - 1 do
                  if TSour(fImportGedCom.ListNote[n]).FirstLine = Block[0] then
                    begin
                      //On dcode ce block
                      aNOTE := TNote(fImportGedCom.ListNote[n]);

                      aNOTE.GedcomBlock.PtrObjetImportGedcom := fImportGedCom;
                      aNOTE.GedcomBlock.AfterCreate(nil);
                      aNOTE.GedcomBlock.Level := -1;

                      //on dcode
                      if fImportGedCom.DecodageGedcom(aNOTE.GedcomBlock, Block, fJeuxCaractere) then
                        begin

                        end;

                      trouve := true;
                    end;
              end;

            if trouve = false then
              begin
                //on cherche l'objet dans les repo
                for n := 0 to fImportGedCom.ListRepo.Count - 1 do
                  if TRepo(fImportGedCom.ListRepo[n]).FirstLine = Block[0] then
                    begin
                      //On dcode ce block
                      aREPO := TRepo(fImportGedCom.ListRepo[n]);

                      aREPO.GedcomBlock.PtrObjetImportGedcom := fImportGedCom;
                      aREPO.GedcomBlock.AfterCreate(nil);
                      aREPO.GedcomBlock.Level := -1;

                      //on dcode
                      if fImportGedCom.DecodageGedcom(aREPO.GedcomBlock, Block, fJeuxCaractere) then
                        begin

                        end;

                      //trouve := true;
                    end;
              end;


          end;

      until Block.Count = 0;

      //on lit les familles une par une
      Reset(F);
      repeat
        ReadNextBlock;
        if Block.Count <> 0 then
          begin
            aGedcomBlock := TGedcomStructure.create;
            try
              aGedcomBlock.PtrObjetImportGedcom := fImportGedCom;
              aGedcomBlock.AfterCreate(nil);
              aGedcomBlock.Level := -1;

              //on dcode
              if fImportGedCom.DecodageGedcom(aGedcomBlock, Block, fJeuxCaractere) then
                begin
                  if aGedcomBlock._FAM <> nil then
                    begin
                      TagFam := TTag_FAM_RECORD(aGedcomBlock._FAM);
                      Fam := fImportGedCom.GetFamilleByID(TagFam.ID);

                      TagFam.CLE := Fam.CLE;

                      //le mari
                      if TagFam._HUSB <> nil then
                        begin
                          //on recherche l'individu qui porte cet ID
                          indi_husb := fImportGedCom.GetIndividuByID(TagFam._HUSB.ID);
                          if indi_husb <> nil then
                            begin
                              fam.CLEF_HUSB := indi_husb.Cle;
                              TagFam.CLEF_HUSB := Fam.CLEF_HUSB;
                            end;
                        end;

                      //la femme
                      if TagFam._WIFE <> nil then
                        begin
                          //on recherche l'individu qui porte cet ID
                          indi_wife := fImportGedCom.GetIndividuByID(TagFam._WIFE.ID);
                          if indi_wife <> nil then
                            begin
                              fam.CLEF_WIFE := indi_wife.Cle;
                              TagFam.CLEF_WIFE := Fam.CLEF_WIFE;
                            end;
                        end;

                      //Cration de l'enregistrement pour cette famille
                      if CreateFamille(TagFam) then
                        begin
                          CreateEventsFamille(TagFam);
                        end;

                      {
                          if cbImportTemoins.checked then
                          begin
                       CreateAssociationsEventsFamilles(TagFam);
                          end;
                           }

                      inc(NumRec); Pourcent.Caption := inttostr((NumRec * 100) div (TotRec)) + ' %';
                      Application.ProcessMessages;
                    end;
                end;

            finally
              aGedcomBlock.Free;
            end;
          end;

      until Block.Count = 0;

      //on lit les individus
      TmpLine := '';
      Reset(F);
      repeat
        ReadNextBlock;
        if Block.Count <> 0 then
          begin
            aGedcomBlock := TGedcomStructure.create;
            try
              aGedcomBlock.PtrObjetImportGedcom := fImportGedCom;
              aGedcomBlock.AfterCreate(nil);
              aGedcomBlock.Level := -1;

              //on dcode
              if fImportGedCom.DecodageGedcom(aGedcomBlock, Block, fJeuxCaractere) then
                begin
                  if aGedcomBlock._INDI <> nil then
                    begin
                      TagIndi := TTag_INDIVIDUAL_RECORD(aGedcomBlock._INDI);
                      Indi := fImportGedCom.GetIndividuByID(TagIndi.ID);

                      TagIndi.Cle := Indi.Cle;

                      if TagIndi._FAMC <> nil then
                        begin
                          //on recherche la cl de cette famille
                          fam := fImportGedCom.GetFamilleByID(TagIndi._FAMC.ID);
                          if fam <> nil then
                            begin
                              //les famille "parents" de cet individu sont :
                              indi.CLE_PARENTS := fam.CLE;
                              TagIndi.CLE_PARENTS := fam.CLE;

                              //le pre est
                              indi.CLE_PERE := fam.CLEF_HUSB;
                              TagIndi.CLE_PERE := fam.CLEF_HUSB;

                              //la mre est
                              indi.CLE_MERE := fam.CLEF_WIFE;
                              TagIndi.CLE_MERE := fam.CLEF_WIFE;
                            end;
                        end;

                      CreateIndividu(TagIndi);
                      CreateEventsIndividu(TagIndi);
                      CreateDomicilesIndividu(TagIndi);
                      if cbImportImage.Checked then CreateMediasIndividu(TagIndi);

                      if cbImportTemoins.checked then
                        begin
                          CreateAssociationsEventsIndividu(TagIndi);
                        end;

                      inc(NumRec); Pourcent.Caption := inttostr((NumRec * 100) div (TotRec)) + ' %';
                      Application.ProcessMessages;
                    end;
                end;
            finally
              aGedcomBlock.Free;
            end;
          end;

      until Block.Count = 0;


    finally
      CloseFile(F);

    end;

  finally
    CloseFile(FileIndi);
    CloseFile(FileEventIndi);
    CloseFile(FileDomiIndi);
    CloseFile(FileMediaIndi);
    CloseFile(FileMediaPointeurs);
    CloseFile(FileEventSourceIndi);
    CloseFile(FileEventFam);
    CloseFile(FileUnion);
    CloseFile(FileAsso);
  end;

  Block.Free;

  IBSQL.Close;
  IBSQL.SQL.clear;
  IBSQL.SQL.Add('insert into INDIVIDU values');
  IBSQL.SQL.Add('(:CLE_FICHE,:KLE_DOSSIER,:CLE_IMPORTATION,:CLE_PARENTS,:CLE_PERE,:CLE_MERE,:PREFIXE,');
  IBSQL.SQL.Add(':NOM,:PRENOM,:SURNOM,:SUFFIXE,:SEXE,:DATE_NAISSANCE,:ANNEE_NAISSANCE,:DATE_DECES,');
  IBSQL.SQL.Add(':ANNEE_DECES,:DECEDE,:AGE_AU_DECES,:SOURCE,:COMMENT,:FILLIATION,:NUM_SOSA,');
  IBSQL.SQL.Add(':DATE_MODIF,:DATE_CREATION,:MODIF_PAR_QUI, :INDI_TRIE_NOM)');

  DelimInput := TIBInputDelimitedFile.Create;
  try
    DelimInput.Filename := NameFileIndi;
    DelimInput.ColDelimiter := #9;
    DelimInput.RowDelimiter := #0;
    DelimInput.ReadBlanksAsNull := true;

    IBSQL.BatchInput(DelimInput);
  finally
    DelimInput.Free;
  end;

  inc(NumRec); Pourcent.Caption := inttostr((NumRec * 100) div (TotRec)) + ' %';
  Application.ProcessMessages;
  dm.IBT_BASE.CommitRetaining;
  //dm.IBTrans_Secondaire.CommitRetaining;

  //domiciles
  IBSQL.Close;
  IBSQL.SQL.clear;
  IBSQL.SQL.Add('insert into ADRESSES_IND values');
  IBSQL.SQL.Add('(:ADR_CLEF,:ADR_TYPE,:ADR_KLE_DOSSIER,:ADR_KLE_IND,:ADR_ADRESSE,:ADR_CP,:ADR_VILLE,:ADR_DEPT,:ADR_REGION,:ADR_PAYS,:ADR_TEL,:ADR_MAIL,:ADR_DATE_WRITEN,:ADR_DATE_YEAR_1,:ADR_DATE_YEAR_2,:ADR_DATE_1,:ADR_DATE_2, :ADR_INSEE)');

  DelimInput := TIBInputDelimitedFile.Create;
  try
    DelimInput.Filename := NameFileDomiIndi;
    DelimInput.ColDelimiter := #9;
    DelimInput.RowDelimiter := #0;
    DelimInput.ReadBlanksAsNull := true;

    IBSQL.BatchInput(DelimInput);
  finally
    DelimInput.Free;
  end;
  inc(NumRec); Pourcent.Caption := inttostr((NumRec * 100) div (TotRec)) + ' %';
  Application.ProcessMessages;
  dm.IBT_BASE.CommitRetaining;
  //  dm.IBTrans_Secondaire.CommitRetaining;

  //-- Gestion des Images -------------------------------------------------------------------------------
  if cbImportImage.Checked then
    begin
      //Le medias
      IBSQL.Close;
      IBSQL.SQL.clear;
      IBSQL.SQL.Add('INSERT INTO MULTIMEDIA ( ' +
        'MULTI_CLEF, ' +
        'MULTI_INFOS, ' +
        'MULTI_DOSSIER, ' +
        'MULTI_INDIVIDU, ' +
        'MULTI_PATH, ' +
        'MULTI_TYPE, ' +
        'MULTI_IDENTITE, ' +
        'MULTI_IMAGE_RTF, ' +
        'MULTI_NUM_ACTE)' +
        'VALUES ( ' +
        ':MULTI_CLEF, ' +
        ':MULTI_INFOS, ' +
        ':MULTI_DOSSIER, ' +
        ':MULTI_INDIVIDU, ' +
        ':MULTI_PATH, ' +
        ':MULTI_TYPE, ' +
        ':MULTI_IDENTITE, ' +
        ':MULTI_IMAGE_RTF, ' +
        ':MULTI_NUM_ACTE)');

      DelimInput := TIBInputDelimitedFile.Create;
      try
        DelimInput.Filename := NameFileMediaIndi;
        DelimInput.ColDelimiter := #9;
        DelimInput.RowDelimiter := #0;
        DelimInput.ReadBlanksAsNull := true;

        IBSQL.BatchInput(DelimInput);
      finally
        DelimInput.Free;
      end;
      inc(NumRec); Pourcent.Caption := inttostr((NumRec * 100) div (TotRec)) + ' %';
      Application.ProcessMessages;
      dm.IBT_BASE.CommitRetaining;


      //Les pointeurs -----------------------------------------------------------------------------------
      IBSQL.Close;
      IBSQL.SQL.clear;
      IBSQL.SQL.Add('INSERT INTO MEDIA_POINTEURS ( ' +
        'MP_CLEF, ' +
        'MP_MEDIA, ' +
        'MP_POINTE_SUR, ' +
        'MP_TABLE, ' +
        'MP_IDENTITE, ' +
        'MP_KLE_DOSSIER, ' +
        'MP_CLE_INDIVIDU)' +
        'VALUES ( ' +
        ':MP_CLEF, ' +
        ':MP_MEDIA, ' +
        ':MP_POINTE_SUR, ' +
        ':MP_TABLE, ' +
        ':MP_IDENTITE, ' +
        ':MP_KLE_DOSSIER, ' +
        ':MP_KLE_INDIVIDU)');

      DelimInput := TIBInputDelimitedFile.Create;
      try
        DelimInput.Filename := NameFileMediaPointeurs;
        DelimInput.ColDelimiter := #9;
        DelimInput.RowDelimiter := #0;
        DelimInput.ReadBlanksAsNull := true;

        IBSQL.BatchInput(DelimInput);
      finally
        DelimInput.Free;
      end;
      inc(NumRec); Pourcent.Caption := inttostr((NumRec * 100) div (TotRec)) + ' %';
      Application.ProcessMessages;
      dm.IBT_BASE.CommitRetaining;

    end;
  // ----------------------------------------------------------------------------------------------------

  if (cbImportEvent.checked) then
    begin
      IBSQL.Close;
      IBSQL.SQL.clear;
      IBSQL.SQL.Add('insert into EVENEMENTS_IND values');
      IBSQL.SQL.Add('(:EV_IND_CLEF, :EV_IND_KLE_FICHE, :EV_IND_KLE_DOSSIER, :EV_IND_TYPE,');
      IBSQL.SQL.Add(':EV_IND_DATE_WRITEN, :EV_IND_DATE_YEAR, :EV_IND_DATE, :EV_IND_ADRESSE,');
      IBSQL.SQL.Add(':EV_IND_CP, :EV_IND_VILLE, :EV_IND_DEPT, :EV_IND_PAYS, :EV_IND_CAUSE,');
      IBSQL.SQL.Add(':EV_IND_SOURCE, :EV_IND_COMMENT, :EV_IND_TYPEANNEE, :EV_IND_DESCRIPTION,:EV_IND_REGION,');
      IBSQL.SQL.Add(':EV_IND_SUBD, :EV_IND_ACTE, :EV_IND_INSEE, :EV_IND_ORDRE, :EV_IND_HEURE)');
      //PCM

      DelimInput := TIBInputDelimitedFile.Create;
      try
        DelimInput.Filename := NameFileEventIndi;
        DelimInput.ColDelimiter := #9;
        DelimInput.RowDelimiter := #0;
        DelimInput.ReadBlanksAsNull := true;

        IBSQL.BatchInput(DelimInput);
      finally
        DelimInput.Free;
      end;
      Application.ProcessMessages;
      dm.IBT_BASE.CommitRetaining;
    end;
  inc(NumRec); Pourcent.Caption := inttostr((NumRec * 100) div (TotRec)) + ' %';
  Application.ProcessMessages;

  if (cbImportEvent.checked) then
    begin
      IBSQL.Close;
      IBSQL.SQL.clear;
      IBSQL.SQL.Add('INSERT INTO SOURCES_RECORD( ' +
        'ID, ' +
        'DATA_ID, ' +
        'ABR, ' +
        'TEXTE, ' +
        'TITL, ' +
        'DATA_EVEN, ' +
        'AUTH, ' +
        'CHANGE_DATE, ' +
        'PUBL, ' +
        'TYPE_TABLE, ' +
        'KLE_DOSSIER )' +
        'VALUES ( ' +
        ':ID, ' +
        ':DATA_ID, ' +
        ':ABR, ' +
        ':TEXTE, ' +
        ':TITL, ' +
        ':REPO, ' +
        ':AUTH, ' +
        ':CHANGE_DATE, ' +
        ':PUBL, ' +
        ':TYPE_TABLE, ' +
        ':KLE_DOSSIER )');

      DelimInput := TIBInputDelimitedFile.Create;
      try
        DelimInput.Filename := NameEventSourceIndi;
        DelimInput.ColDelimiter := #9;
        DelimInput.RowDelimiter := #0;
        DelimInput.ReadBlanksAsNull := true;

        IBSQL.BatchInput(DelimInput);
      finally
        DelimInput.Free;
      end;
    end;
  inc(NumRec); Pourcent.Caption := inttostr((NumRec * 100) div (TotRec)) + ' %';
  Application.ProcessMessages;
  dm.IBT_BASE.CommitRetaining;


  IBSQL.Close;
  IBSQL.SQL.clear;
  IBSQL.SQL.Add('insert into EVENEMENTS_FAM values');
  IBSQL.SQL.Add('(:EV_FAM_CLEF, :EV_FAM_KLE_FAMILLE, :EV_FAM_KLE_DOSSIER,:EV_FAM_TYPE,');
  IBSQL.SQL.Add(':EV_FAM_DATE_WRITEN, :EV_FAM_DATE_YEAR, :EV_FAM_DATE,:EV_FAM_ADRESSE,');
  IBSQL.SQL.Add(':EV_FAM_CP, :EV_FAM_VILLE, :EV_FAM_DEPT, :EV_FAM_PAYS,');
  IBSQL.SQL.Add(':EV_FAM_SOURCE, :EV_FAM_COMMENT,:EV_FAM_REGION,:EV_FAM_SUBD, 0,');
  IBSQL.SQL.Add(':EV_FAM_INSEE, :EV_FAM_ORDRE)');
  //PCM

  DelimInput := TIBInputDelimitedFile.Create;
  try
    DelimInput.Filename := NameFileEventFam;
    DelimInput.ColDelimiter := #9;
    DelimInput.RowDelimiter := #0;
    DelimInput.ReadBlanksAsNull := true;

    IBSQL.BatchInput(DelimInput);
  finally
    DelimInput.Free;
  end;
  inc(NumRec); Pourcent.Caption := inttostr((NumRec * 100) div (TotRec)) + ' %';
  Application.ProcessMessages;
  dm.IBT_BASE.CommitRetaining;


  IBSQL.Close;
  IBSQL.SQL.clear;
  IBSQL.SQL.Add('insert into T_UNION values');
  IBSQL.SQL.Add(' ( :UNION_CLE, :UNION_MARI, :UNION_FEMME, :KLE_DOSSIER, :UNION_TYPE, :SOURCE, :COMMENT)');

  DelimInput := TIBInputDelimitedFile.Create;
  try
    DelimInput.Filename := NameFileUnion;
    DelimInput.ColDelimiter := #9;
    DelimInput.RowDelimiter := #0;
    DelimInput.ReadBlanksAsNull := true;

    IBSQL.BatchInput(DelimInput);
  finally
    DelimInput.Free;
  end;
  inc(NumRec); Pourcent.Caption := inttostr((NumRec * 100) div (TotRec)) + ' %';
  Application.ProcessMessages;
  dm.IBT_BASE.CommitRetaining;

  if (cbImportTemoins.checked) then
    begin
      IBSQL.Close;
      IBSQL.SQL.clear;
      IBSQL.SQL.Add('insert into T_ASSOCIATIONS values');
      IBSQL.SQL.Add(' (:ASSOC_CLEF,:ASSOC_KLE_IND,:ASSOC_KLE_ASSOCIE,:ASSOC_KLE_DOSSIER,:ASSOC_NOTES,:ASSOC_SOURCES,:ASSOC_TYPE,:ASSOC_EVENEMENT,:ASSOC_TABLE)');


      DelimInput := TIBInputDelimitedFile.Create;
      try
        DelimInput.Filename := NameFileAsso;
        DelimInput.ColDelimiter := #9;
        DelimInput.RowDelimiter := #0;
        DelimInput.ReadBlanksAsNull := true;

        IBSQL.BatchInput(DelimInput);
      finally
        DelimInput.Free;
      end;
      Application.ProcessMessages;
      dm.IBT_BASE.CommitRetaining;
    end;
  inc(NumRec); Pourcent.Caption := inttostr((NumRec * 100) div (TotRec)) + ' %';
  Application.ProcessMessages;

  inc(NumRec); Pourcent.Caption := inttostr((NumRec * 100) div (TotRec)) + ' %';
  Application.ProcessMessages;

  //Appel proc_after_import
  try
    IBStoredProc.Close;
    IBStoredProc.StoredProcName := 'PROC_AFTER_IMPORT';

    IBStoredProc.Prepare;
    IBStoredProc.Params[0].AsInteger := fNumDossierImport;

    //if cbAfterImport.checked then
    //  IBStoredProc.Params[1].AsInteger := 1
    //else
    IBStoredProc.Params[1].AsInteger := 0;

    IBStoredProc.ExecProc;
  finally
    IBStoredProc.Close;
  end;
  inc(NumRec); Pourcent.Caption := inttostr((NumRec * 100) div (TotRec)) + ' %';
  Application.ProcessMessages;
  dm.IBT_BASE.CommitRetaining;

  //Appel
  if cbIgnoreEventIndiVide.checked then
    begin
      try
        IBStoredProc.Close;
        IBStoredProc.StoredProcName := 'PROC_PURGE_EVE_INDIVIDUS';
        IBStoredProc.Prepare;
        IBStoredProc.Params[0].AsInteger := fNumDossierImport;
        IBStoredProc.ExecProc;
      finally
        IBStoredProc.Close;
      end;
      Application.ProcessMessages;
      dm.IBT_BASE.CommitRetaining;
    end;
  inc(NumRec); Pourcent.Caption := inttostr((NumRec * 100) div (TotRec)) + ' %';
  Application.ProcessMessages;

  RechercheImage;

  Pourcent.Caption := '100 %';
  Application.ProcessMessages;

  //Suppression des fichiers temporaires
  {
  NameFileDomiIndi := TempPath + 'tmpdomiindi.txt';
  NameFileMediaIndi := TempPath + 'tmpmediaindi.txt';
  NameFileMediaPointeurs := TempPath + 'tmpmediaPointeurs.txt';
  NameEventSourceIndi := TempPath + 'tmpsourevent.txt';
  }
  try
    deleteFile(NameFileIndi);
  except
  end;
  try
    deleteFile(NameFileDomiIndi);
  except
  end;
  try
    deleteFile(NameFileMediaIndi);
  except
  end;
  try
    deleteFile(NameFileMediaPointeurs);
  except
  end;
  try
    deleteFile(NameEventSourceIndi);
  except
  end;
  try
    deleteFile(NameFileEventIndi);
  except
  end;
  try
    deleteFile(NameFileFam);
  except
  end;
  try
    deleteFile(NameFileUnion);
  except
  end;
  try
    deleteFile(NameFileEventFam);
  except
  end;
  try
    deleteFile(NameFileAsso);
  except
  end;
end;

procedure TFImportGedcom.URLLink2Click(Sender: TObject);
begin
  GotoThisURL('www.gedx.com');
end;

procedure TFImportGedcom.btnSelectDossierClick(Sender: TObject);
var
  aFSelectDossier: TFSelectDossier;
begin
  aFSelectDossier := TFSelectDossier.create(self);
  try
    aFSelectDossier.CanDeleteCurrentDossier := false;
    aFSelectDossier.ActiveNewDossierIfSelect := false;

    if aFSelectDossier.ShowModal = mrOk then
      begin
        fNumDossierImport := aFSelectDossier.CleDossier;
        fNomDossierImport := aFSelectDossier.NomDossier;
      end;

  finally
    aFSelectDossier.free;
  end;

  doRefreshControls;
end;

procedure TFImportGedcom.rbClearBddClick(Sender: TObject);
begin
  doRefreshControls;
end;

procedure TFImportGedcom.rbAddToBddClick(Sender: TObject);
begin
  doRefreshControls;
end;


// Importation des adresse de l individu ----------------------------------------------------------------

procedure TFImportGedcom.CreateDomicilesIndividu(Indi: TTag_INDIVIDUAL_RECORD);
var
  s, add1: string;
  cle, p: integer;
  TagDomi: TTag_DOMICILE;
begin
  if (Indi._ADDR <> nil) and (Indi.Cle <> -1) then
    begin
      TagDomi := Indi._ADDR;
      while TagDomi <> nil do
        begin
          Cle := dm.uf_GetClefUnique('ADRESSES_IND');

          if Cle <> -1 then
            begin
              TagDomi.Cle := Cle;

              //ADR_CLEF
              CutDomiIndi.Params[0].AsInteger := Cle;

              //ADR_TYPE
              CutDomiIndi.Params[1].AsInteger := 1;

              //ADR_KLE_DOSSIER
              CutDomiIndi.Params[2].AsInteger := fNumDossierImport;

              //ADR_KLE_IND
              CutDomiIndi.Params[3].AsInteger := indi.cle;

              //ADR_ADRESSE
              CutDomiIndi.Params[4].AsString := '';

              //                  s := copy(TagDomi._ADDR.Value, 1, 160);

              if TagDomi._ADR1 <> nil
                then
                begin
                  add1 := copy(TagDomi._ADR1.Value, 1, 160);
                  CutDomiIndi.Params[4].AsString := add1;
                end
              else CutDomiIndi.Params[4].AsString := '';

              if TagDomi._ADR2 <> nil
                then CutDomiIndi.Params[4].AsString := add1 + #13#10 + copy(TagDomi._ADR2.Value, 1, 160);
              //else CutDomiIndi.Params[4].AsString := '';

              //ADR_CP
              if TagDomi._POST <> nil
                then CutDomiIndi.Params[5].AsString := copy(TagDomi._POST.Value, 1, 10)
              else CutDomiIndi.Params[5].AsString := '';

              //ADR_VILLE
              if TagDomi._CITY <> nil
                then CutDomiIndi.Params[6].AsString := copy(TagDomi._CITY.Value, 1, 40)
              else CutDomiIndi.Params[6].AsString := '';

              //ADR_DEPT
              if TagDomi._STAT <> nil
                then CutDomiIndi.Params[7].AsString := copy(TagDomi._STAT.Value, 1, 40)
              else CutDomiIndi.Params[7].AsString := '';

              //ADR_REGION
              if TagDomi._REG <> nil
                then CutDomiIndi.Params[8].AsString := copy(TagDomi._REG.Value, 1, 40)
              else CutDomiIndi.Params[8].AsString := '';

              //ADR_PAYS
              if TagDomi._CTRY <> nil
                then CutDomiIndi.Params[9].AsString := copy(TagDomi._CTRY.Value, 1, 40)
              else CutDomiIndi.Params[9].AsString := '';

              //ADR_TEL
              CutDomiIndi.Params[10].AsString := '';
              if TagDomi._TEL <> nil then
                begin
                  s := TagDomi._TEL.Value;
                  for p := 0 to TagDomi._TEL.Memo.count - 1 do s := s + #13#10 + TagDomi._TEL.Memo[p];
                  CutDomiIndi.Params[10].AsString := s;
                end;

              //ADR_MAIL
              if TagDomi._MAIL <> nil
                then CutDomiIndi.Params[11].AsString := copy(TagDomi._MAIL.Value, 1, 250)
              else CutDomiIndi.Params[11].AsString := '';

              //DATE_WRITEN, DATE_YEAR_1, DATE_YEAR_2, DATE_1, DATE_2
              CutDomiIndi.Params[12].AsString := '';
              CutDomiIndi.Params[13].AsString := '';
              CutDomiIndi.Params[14].AsString := '';
              CutDomiIndi.Params[15].AsString := '';
              CutDomiIndi.Params[16].AsString := '';


              if TagDomi._DATE <> nil then
                begin
                  if _GDate.DecodeGedcomDate(TagDomi._Date.Value) then
                    begin
                      CutDomiIndi.Params[12].AsString := copy(_GDate.EncodeHumanDate, 1, 100);

                      //Soit la date n'est pas une priode
                      if (_GDate.GDate.UseDate2 = false) then
                        begin
                          //l'anne
                          if (_GDate.KnowYear) then CutDomiIndi.Params[13].AsInteger := _GDate.GDate.Year1;

                          //la date entire
                          if (_GDate.KnowDate) then CutDomiIndi.Params[15].AsString := FormatDateTime('d/m/yyyy', _GDate.GDate.DateTime1);
                        end
                      else
                        //soit la date est une priode
                        if (_GDate.GDate.UseDate1) and (_GDate.GDate.UseDate2) then
                          begin
                            //Date1
                            if (_GDate.GDate.UseDate1) and (_GDate.GDate.ValidDateTime1) then CutDomiIndi.Params[15].AsString := FormatDateTime('d/m/yyyy', _GDate.GDate.DateTime1);
                            //Anne 1
                            if (_GDate.GDate.UseDate1) and (_GDate.GDate.Year1 <> -1) then CutDomiIndi.Params[13].AsInteger := _GDate.GDate.Year1;

                            //Date2
                            if (_GDate.GDate.UseDate2) and (_GDate.GDate.ValidDateTime2) then CutDomiIndi.Params[16].AsString := FormatDateTime('d/m/yyyy', _GDate.GDate.DateTime2);
                            //Anne 2
                            if (_GDate.GDate.UseDate2) and (_GDate.GDate.Year2 <> -1) then CutDomiIndi.Params[14].AsInteger := _GDate.GDate.Year2;
                          end;
                    end;
                end;

              CutDomiIndi.ParamsToStr;

              Write(FileDomiIndi, CutDomiIndi.Line, #0);
              Flush(FileDomiIndi);
            end;

          //on cherche le suivant...
          TagDomi := TTag_DOMICILE(TagDomi.PtrNextSameTag);
        end;
    end;
end;

procedure TFImportGedcom.CreateMediasIndividu(Indi: TTag_INDIVIDUAL_RECORD);
var
  s, sIdent: string;
  cle, ClePointeur, m: integer;
  TagMedia: TTag_MEDIA;
begin
  if (Indi._PICT <> nil) and (Indi.Cle <> -1) then
    begin
      TagMedia := Indi._PICT;
      while TagMedia <> nil do
        begin
          s := copy(TagMedia._PATH.Value, 1, 160);
          if FileExists(s) then
            begin
              Cle := dm.uf_GetClefUnique('MULTIMEDIA');

              if Cle <> -1 then
                begin
                  TagMedia.Cle := Cle;

                  //MULTI_CLEF
                  CutMediaIndi.Params[0].AsInteger := Cle;

                  //MULTI_DOSSIER
                  CutMediaIndi.Params[2].AsInteger := fNumDossierImport;

                  //MULTI_INDIVIDUS
                  CutMediaIndi.Params[3].AsInteger := indi.cle;

                  if TagMedia._PATH <> nil
                    then
                    begin
                      s := copy(TagMedia._PATH.Value, 1, 160);
                      CutMediaIndi.Params[4].AsString := s;
                    end
                  else CutMediaIndi.Params[4].AsString := '';

                  if TagMedia._XTYPE <> nil
                    then
                    begin
                      s := copy(TagMedia._XTYPE.Value, 1, 1);
                      CutMediaIndi.Params[5].AsString := s;
                    end
                  else CutMediaIndi.Params[5].AsString := '';

                  if TagMedia._XIDEN <> nil
                    then
                    begin
                      s := copy(TagMedia._XIDEN.Value, 1, 1);
                      sIdent := s;
                      CutMediaIndi.Params[6].AsInteger := StrToInt(s);
                    end
                  else CutMediaIndi.Params[6].AsInteger := 0;

                  if TagMedia._XMODE <> nil
                    then
                    begin
                      s := copy(TagMedia._XMODE.Value, 1, 1);
                      m := StrToInt(s);
                      CutMediaIndi.Params[7].AsInteger := StrToInt(s);
                    end
                  else CutMediaIndi.Params[7].AsInteger := 0;

                  if TagMedia._XACTE <> nil
                    then
                    begin
                      s := copy(TagMedia._XACTE.Value, 1, 8);
                      m := StrToInt(s);
                      CutMediaIndi.Params[8].AsInteger := 0; // StrToInt(s);
                    end
                  else CutMediaIndi.Params[8].AsInteger := 0;

                  //MULTI_INFOS
                  if m = 0 then
                    CutMediaIndi.Params[1].AsString := 'Image importe le : ' + DateToStr(Date) + '  ' + TimeToStr(Time)
                  else if m = 1 then
                    CutMediaIndi.Params[1].AsString := 'Texte import le : ' + DateToStr(Date) + '  ' + TimeToStr(Time)
                  else if m = 2 then
                    CutMediaIndi.Params[1].AsString := 'Son import le : ' + DateToStr(Date) + '  ' + TimeToStr(Time)
                  else if m = 3 then
                    CutMediaIndi.Params[1].AsString := 'Vido importe le : ' + DateToStr(Date) + '  ' + TimeToStr(Time);

                  CutMediaIndi.ParamsToStr;

                  Write(FileMediaIndi, CutMediaIndi.Line, #0);
                  Flush(FileMediaIndi);


                  //-- Les pointeurs --------------------------------------------------------------------
                  {
                  IBSQL.SQL.Add('INSERT INTO MEDIA_POINTEURS ( ' +
                    'MP_CLEF, ' +
                    'MP_MEDIA, ' +
                    'MP_POINTE_SUR, ' +
                    'MP_TABLE, ' +
                    'MP_IDENTITE, '+
                    'MP_KLE_DOSSIER)' +
                    'VALUES ( ' +
                    ':MP_CLEF, ' +
                    ':MP_MEDIA, ' +
                    ':MP_POINTE_SUR, ' +
                    ':MP_TABLE, ' +
                    ':MP_IDENTITE, '+
                    ':MP_KLE_DOSSIER)');
                  }
                  ClePointeur := dm.uf_GetClefUnique('MEDIA_POINTEURS');
                  CutMediaPointeurs.Params[0].AsInteger := ClePointeur;
                  CutMediaPointeurs.Params[1].AsInteger := Cle;
                  CutMediaPointeurs.Params[2].AsInteger := indi.cle;
                  CutMediaPointeurs.Params[3].AsString := 'I';
                  CutMediaPointeurs.Params[4].AsInteger := StrToInt(sIdent);
                  CutMediaPointeurs.Params[5].AsInteger := fNumDossierImport;
                  CutMediaPointeurs.Params[6].AsInteger := indi.cle;

                  CutMediaPointeurs.ParamsToStr;

                  Write(FileMediaPointeurs, CutMediaPointeurs.Line, #0);
                  Flush(FileMediaPointeurs);
                end;
            end;
          //on cherche le suivant...
          TagMedia := TTag_MEDIA(TagMedia.PtrNextSameTag);

        end;
    end;
end;

procedure TFImportGedcom.RechercheImage;
var
  TempPathFileNameJPEG: string;
  MS: TMemoryStream;
begin

  IBMultimedia.Close;
  IBMultimedia.Params[0].AsInteger := fNumDossierImport;
  IBMultimedia.Open;
  IBMultimedia.First;

  while (not IBMultimedia.EOF) do
    begin
      if FileExists(IBMultimedia.FieldByName('MULTI_PATH').AsString) then
        begin
          if IBMultimediaMULTI_IMAGE_RTF.AsInteger = 2 then
            begin
              //Edition d'un record
              IBMultimedia.Edit;

              MS := TMemoryStream.Create;
              iSons.Picture.Graphic.SaveToStream(MS);
              MS.Position := 0;
              TBlobField(IBMultimediaMULTI_REDUITE).LoadFromStream(MS);
              FreeAndNil(MS);

              IBMultimedia.Post;

            end
          else if IBMultimediaMULTI_IMAGE_RTF.AsInteger = 3 then
            begin
              //Edition d'un record
              IBMultimedia.Edit;

              MS := TMemoryStream.Create;
              iVideo.Picture.Graphic.SaveToStream(MS);
              MS.Position := 0;
              TBlobField(IBMultimediaMULTI_REDUITE).LoadFromStream(MS);
              FreeAndNil(MS);

              IBMultimedia.Post;

            end
          else if IBMultimediaMULTI_IMAGE_RTF.AsInteger = 0 then
            begin
              if ConvertionImageToJPeg(IBMultimedia.FieldByName('MULTI_PATH').AsString, TempPathFileNameJPEG, _Context.TauxCompressionJPeg) then
                begin
                  //Edition d'un record
                  IBMultimedia.Edit;

                  //On ajoute l'image dans la base
                  AddImageToDatabase(TempPathFileNameJPEG);
                end;
            end;
        end;
      IBMultimedia.Next;
    end;

  //IBMultimedia.Post;
  IBMultimedia.Close;
  dm.IBT_BASE.CommitRetaining;

end;

procedure TFImportGedcom.AddImageToDatabase(TempPathFileNameJPEG: string);
var
  ImageField: TField;
  Picture: TPicture;
  imageForVignette: TImage;
  MS: TMemoryStream;
begin
  begin

    IBMultimedia.FieldByName('MULTI_DATE_MODIF').AsDateTime := Now;

    ImageField := IBMultimediaMULTI_MEDIA;
    if ImageField <> nil then
      begin
        //DBGraphic.Visible := true;
        // TydxDBGraphicEdit(DBGraphic).AutoSize := true;
         //On ajoute l'image JPeg dans le blob
        Picture := TPicture.Create;
        try
          Picture.LoadFromFile(TempPathFileNameJPEG);
          SaveGraphicToBlobField(Picture.Graphic, ImageField);

        finally
          Picture.Free;
        end;

        {- Creation de la vignette -------------------------------------------------------------------}
        MS := TMemoryStream.Create;
        imageForVignette := TImage.Create(Self);

        imageForVignette.Width := 90;
        imageForVignette.Height := 106;

        try
          MakeVignette(TempPathFileNameJPEG, TempPathFileNameJPEG, imageForVignette, MS);
          MS.Position := 0;
          TBlobField(IBMultimediaMULTI_REDUITE).LoadFromStream(MS);

        finally
          FreeAndNil(imageForVignette);
          FreeAndNil(MS);
        end;

        try
          IBMultimedia.Post;
        except
        end;

        {---------------------------------------------------------------------------------------------}
      end;

  end;
end;

procedure TFImportGedcom.CreateSourceEventIndi(aEvent: TTag_Event_Detail; sTable: string);
var s_ABBR,
  s_TEXT,
    s_TITL,
    s_REPO,
    s_AUTH,
    s_PUBL: string;

  cle: integer;
begin

  s_ABBR := Get_ABBR;
  s_TEXT := Get_TEXT;
  s_TITL := Get_TITL;
  s_REPO := Get_REPO;
  s_AUTH := Get_AUTH;
  s_PUBL := Get_PUBL;

  if (Length(s_ABBR) > 0) or
    (Length(s_TEXT) > 0) or
    (Length(s_TITL) > 0) or
    (Length(s_REPO) > 0) or
    (Length(s_PUBL) > 0) or
    (Length(s_AUTH) > 0) then
    begin
      Cle := dm.uf_GetClefUnique('SOURCES_RECORD');

      if Cle <> -1 then
        begin
          {
          IBSQL.SQL.Add('INSERT INTO SOURCES_RECORD( ' +
          'ID, ' +
          'DATA_ID, ' +
          'ABR, ' +
          'TEXTE, ' +
          'TITL, ' +
          'DATA_EVEN, ' +
          'AUTH, ' +
          'CHANGE_DATE, ' +
          'PUBL, ' +
          'TYPE_TABLE, ' +
          'KLE_DOSSIER )' +
          'VALUES ( ' +
          ':ID, ' +
          ':DATA_ID, ' +
          ':ABR, ' +
          ':TEXTE, ' +
          ':TITL, ' +
          ':REPO, ' +
          ':AUTH, ' +
          ':CHANGE_DATE, ' +
          ':PUBL, ' +
          ':TYPE_TABLE, ' +
          ':KLE_DOSSIER )');
          }
          CutEventSourceIndi.Params[0].AsInteger := Cle;
          CutEventSourceIndi.Params[1].AsInteger := aEvent.cle;
          CutEventSourceIndi.Params[2].AsString := Copy(s_ABBR, 1, 60);
          CutEventSourceIndi.Params[3].AsString := s_TEXT;
          CutEventSourceIndi.Params[4].AsString := s_TITL;
          CutEventSourceIndi.Params[5].AsString := Copy(s_REPO, 1, 90);
          CutEventSourceIndi.Params[6].AsString := s_AUTH;
          CutEventSourceIndi.Params[7].AsDateTime := NOW;
          CutEventSourceIndi.Params[8].AsString := s_PUBL;
          CutEventSourceIndi.Params[9].AsString := sTable; //Copy(Get_EVEN,1,1);
          CutEventSourceIndi.Params[10].AsInteger := fNumDossierImport;

          if sTable = 'I' then
            CutEvent.Params[13].AsString := s_TEXT + #10#13 + 'Voir le dtail...'
          else
            CutEventFam.Params[12].AsString := s_TEXT + #10#13 + 'Voir le dtail...';

          CutEventSourceIndi.ParamsToStr;

          Write(FileEventSourceIndi, CutEventSourceIndi.Line, #0);
          Flush(FileEventSourceIndi);

        end;
    end;
end;

procedure TFImportGedcom.SuperFormShow(Sender: TObject);
begin
  _Agent.doAgent('GestureLeft', 'Cliquez sur le bouton',
    Fmain.Left + 260,
    Fmain.Top + 340);
end;

procedure TFImportGedcom.SuperFormHide(Sender: TObject);
begin
  _Agent.doAgent('Hide', '',
    0,
    0);
  OpenDialog.InitialDir := _Context.PathImportExport;
end;

end.

