{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_common_graph_type;

interface

uses
  extctrls,
  Windows;

type
  //coordonnes d'un point dans l'espace
  TPoint3D = record
    x: single;
    y: single;
    z: single;
  end;

  TFloatPoint = record
    x: single;
    y: single;
  end;

  TFloatRectangle = record
    P1: TFloatPoint;
    P2: TFloatPoint;
    P3: TFloatPoint;
    P4: TFloatPoint;
  end;

  TFloatRect = record
    Left: single;
    Top: single;
    Right: single;
    Bottom: single;
  end;

  TIntRectangle = record
    P1: TPoint;
    P2: TPoint;
    P3: TPoint;
    P4: TPoint;
  end;

  TMyPanel = class(TPanel)

  public
    property Canvas;
  end;

  TMouseMode = (mmMoveOrSelect, mmZoomMore, mmZoomLess);

  TMouseMoveOnChantierEvent = procedure(Sender: TObject; X, Y: single) of object;

  TEventApplyVue = procedure(Sender: TObject; Name: string) of object;



implementation

uses
  SysUtils;



end.
