{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_common_graph_var;

interface

uses
  Classes,
  Forms,
  u_common_graph_const,
  u_objet_graph_TChantier,
  u_objet_graph_TViewer,
  u_objet_TMulot;


var
  //Le chantier
  _Chantier: TChantier;

  //Objet de gestion de l'affichage du chantier, dans le PaintBox
  _Viewer: TViewer;

  //Chemin dans lequel sont stocks les chantiers
  _PathChantiers: string; //  X:\chemin_de_TotalRecol.exe\Data\

  //Context du logiciel, de faon  retrouver la mme chose entre 2 excutions de ce soft
//     _Context: TContext;

  //Un mulot, pour faire du BeginUpdate/EndUpdate du pointeur de souris
  _Mulot: TMulot;


implementation

uses
  SysUtils;

initialization

  _PathChantiers := ExtractFilePath(application.ExeName) + _RELPATH_CHANTIERS;

  _Viewer := nil;
  _Chantier := nil;
  //    _Context := TContext.create;
  _Mulot := TMulot.create;


finalization

  //    _Context.Free;
  _Mulot.Free;

end.
