{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_objet_graph_TPlot;

interface

type
  TPlot = class
  private
    fYV: integer;
    fXV: integer;
    fYC: single;
    fXC: single;
    fYM: integer;
    fXM: integer;
    fYI: single;
    fXI: single;
    //    fYP: integer;
    //    fXP: integer;

  public
    //coordonnes dans le chantier
    property XC: single read fXC write fXC;
    property YC: single read fYC write fYC;

    //coordonnes dans le viewer
    property XV: integer read fXV write fXV;
    property YV: integer read fYV write fYV;

    //coordonnes dans la miniature
    property XM: integer read fXM write fXM;
    property YM: integer read fYM write fYM;

    //coordonnes pour l'impression (pour la roue)
    property XI: single read fXI write fXI;
    property YI: single read fYI write fYI;


    //coordonnes sur le papier
 //   property XP: integer read fXP write fXP;
 //   property YP: integer read fYP write fYP;

    procedure CoordChantier_2_CoordViewer(coef: single);
    procedure CoordChantier_2_CoordMiniature(coef: single);
    //          procedure CoordChantier_2_CoordPapier(coef: single);
  end;


implementation

{ TPlot }

procedure TPlot.CoordChantier_2_CoordMiniature(coef: single);
begin
  fXM := round(coef * fXC);
  fYM := round(coef * fYC);
end;

procedure TPlot.CoordChantier_2_CoordViewer(coef: single);
begin
  fXV := round(coef * fXC);
  fYV := round(coef * fYC);
end;

{
procedure TPlot.CoordChantier_2_CoordPapier(coef: single);
begin
     fXP := round(coef * fXC);
     fYP := round(coef * fYC);
end;
 }


end.
