{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_Modale;

interface

uses
     Windows, CompSuperForm, Forms, u_comp_TBlueFlatSpeedButton, TFlatPanelUnit,
     StdCtrls, Controls, Buttons, Classes, ExtCtrls, Messages,
     TFlatSpeedButtonUnit;

type
     TFModale = class(TSuperForm)
          pBorder: TPanel;
          pGeneral: TPanel;
          pTop: TPanel;
          sbClose: TSpeedButton;
          lTitre: TLabel;
          pGlobal: TPanel;
          fpBoutons: TFlatPanel;
          pBottom: TPanel;
          panDock: TPanel;
          bsfbSelection: TFlatSpeedButton;
          btnFermer: TFlatSpeedButton;

          procedure SuperFormCreate(Sender: TObject);
          procedure sbCloseClick(Sender: TObject);
          procedure pTopMouseDown(Sender: TObject; Button: TMouseButton;
               Shift: TShiftState; X, Y: Integer);
          procedure SuperFormClose(Sender: TObject; var Action: TCloseAction);
     private
          fDialogMode: boolean;

          procedure up_Boutons(a_Mode: Boolean);
          procedure SetDialogMode(const Value: boolean);
     public
          property DialogMode: boolean read fDialogMode write SetDialogMode;
     end;

implementation

{$R *.DFM}

procedure TFModale.SuperFormCreate(Sender: TObject);
{
Initialisation de la fenetre
}

begin
     up_Boutons(False);
end;

procedure TFModale.SuperFormClose(Sender: TObject;
     var Action: TCloseAction);
begin
     //
end;

procedure TFModale.SetDialogMode(const Value: boolean);
begin
     fDialogMode := Value;
     //     panBtnDialog.visible := Value;
end;

procedure TFModale.sbCloseClick(Sender: TObject);
begin
     ModalResult := mrCancel;
     Close;
end;

procedure TFModale.pTopMouseDown(Sender: TObject;
     Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
     ReleaseCapture;
     TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFModale.up_Boutons(a_Mode: Boolean);
begin
     //
end;

end.

