{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_individu_connector;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, ExtCtrls, Db, IBCustomDataSet, IBQuery, dxCntner, dxTL,
  dxDBCtrl, dxDBGrid, IBUpdateSQL, StdCtrls, dxEditor, dxExEdtr, dxEdLib,
  GraphicEx, u_comp_TGoodBtn, u_comp_TNakedSpeedButton, dxDBEdtr,
  dxDBELib, dxDBTLCl, dxGrClms, u_objet_TIntegerList, u_objet_TGedcomDate,
  TFlatSplitterUnit, u_comp_TYLanguage;

type
  TMydxDBPopupEdit = class(TdxDBPopupEdit)
  public
    procedure DropDown; override;
  end;

  TMydxInplaceDropDownEdit = class(TdxInplaceDropDownEdit)
  public
    procedure DropDown; override;
  end;

  TFIndividuConnector = class(TSuperForm)
    QListIndi: TIBQuery;
    DataSourceListIndi: TDataSource;
    IBQAscendant: TIBQuery;
    Query: TIBQuery;
    Panel4: TPanel;
    Panel5: TPanel;
    panFamille: TPanel;
    cbAskConfirm: TCheckBox;
    Panel6: TPanel;
    Panel7: TPanel;
    Panel8: TPanel;
    Panel9: TPanel;
    rbIndiCreateFrom: TRadioButton;
    dsDate: TdxDateEdit;
    rbAllIndi: TRadioButton;
    Label37: TLabel;
    ApanGP_Paternel: TPanel;
    Panel3: TPanel;
    pan56565: TPanel;
    ApanGM_Paternel: TPanel;
    Panel13: TPanel;
    ApanGP_Maternel: TPanel;
    Panel15: TPanel;
    ApanGM_Maternel: TPanel;
    Panel17: TPanel;
    pan676976: TPanel;
    pan978987: TPanel;
    pan7868: TPanel;
    ApanPere: TPanel;
    Panel19: TPanel;
    ApanMere: TPanel;
    Panel21: TPanel;
    pan67675: TPanel;
    pan898989: TPanel;
    ApanIndividuCentral: TPanel;
    panIndi: TPanel;
    Label2: TLabel;
    pb: TPaintBox;
    panLienGPP: TNakedSpeedButton;
    panLienGMP: TNakedSpeedButton;
    panLienGPM: TNakedSpeedButton;
    panLienGMM: TNakedSpeedButton;
    panLienP: TNakedSpeedButton;
    panLienM: TNakedSpeedButton;
    rbIndiPatronyme: TRadioButton;
    IBQPatronymes: TIBQuery;
    IBQPatronymesNOM: TIBStringField;
    DSPatronymes: TDataSource;
    pPatronymes: TPanel;
    Panel22: TPanel;
    Label7: TLabel;
    dxDBGrid1: TdxDBGrid;
    dxDBGridColumn1: TdxDBGridColumn;
    dxPopupPatronyme: TdxPopupEdit;
    gridListIndi: TdxDBGrid;
    gridListIndiNOM: TdxDBGridMaskColumn;
    gridListIndiPRENOM: TdxDBGridMaskColumn;
    gridListIndiSEXE: TdxDBGridImageColumn;
    QListIndiCLE_FICHE: TIntegerField;
    QListIndiPREFIXE: TIBStringField;
    QListIndiNOM: TIBStringField;
    QListIndiPRENOM: TIBStringField;
    QListIndi_DETAIL: TStringField;
    lbGPP: TLabel;
    panGP_Paternel: TPaintBox;
    panGM_Paternel: TPaintBox;
    panGP_Maternel: TPaintBox;
    panGM_Maternel: TPaintBox;
    panPere: TPaintBox;
    panMere: TPaintBox;
    panIndividuCentral: TPaintBox;
    lbGMP: TLabel;
    lbGPM: TLabel;
    lbGMM: TLabel;
    lbP: TLabel;
    lbM: TLabel;
    lbIndi: TLabel;
    ApanEnfants: TPanel;
    Panel2: TPanel;
    Panel10: TPanel;
    lbEnfants: TListBox;
    panLienEnfant: TNakedSpeedButton;
    QListIndiDATE_NAISSANCE: TIBStringField;
    FlatSplitter1: TFlatSplitter;
    QListIndiSEXE: TIntegerField;
    QListIndiANNEE_NAISSANCE: TIntegerField;
    QListIndiANNEE_DECES: TIntegerField;
    Language: TYLanguage;
    procedure panIndividuCentralDragOver(Sender, Source: TObject; X,
      Y: Integer; State: TDragState; var Accept: Boolean);
    procedure panIndividuCentralDragDrop(Sender, Source: TObject; X,
      Y: Integer);
    procedure SuperFormCreate(Sender: TObject);
    procedure panGP_PaternelMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure panPereDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure panPereDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure panMereDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure panMereDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure panGP_PaternelDragOver(Sender, Source: TObject; X,
      Y: Integer; State: TDragState; var Accept: Boolean);
    procedure panGP_PaternelDragDrop(Sender, Source: TObject; X,
      Y: Integer);
    procedure panGM_PaternelDragOver(Sender, Source: TObject; X,
      Y: Integer; State: TDragState; var Accept: Boolean);
    procedure panGM_PaternelDragDrop(Sender, Source: TObject; X,
      Y: Integer);
    procedure panGP_MaternelDragOver(Sender, Source: TObject; X,
      Y: Integer; State: TDragState; var Accept: Boolean);
    procedure panGP_MaternelDragDrop(Sender, Source: TObject; X,
      Y: Integer);
    procedure panGM_MaternelDragOver(Sender, Source: TObject; X,
      Y: Integer; State: TDragState; var Accept: Boolean);
    procedure panGM_MaternelDragDrop(Sender, Source: TObject; X,
      Y: Integer);
    procedure pbPaint(Sender: TObject);
    procedure panFamilleResize(Sender: TObject);
    procedure panLienPClick(Sender: TObject);
    procedure panLienMClick(Sender: TObject);
    procedure panLienGPPClick(Sender: TObject);
    procedure panLienGMPClick(Sender: TObject);
    procedure panLienGPMClick(Sender: TObject);
    procedure panLienGMMClick(Sender: TObject);
    procedure dxPopupPatronymeInitPopup(Sender: TObject);
    procedure QListIndiCalcFields(DataSet: TDataSet);
    procedure dxDBGrid1DblClick(Sender: TObject);
    procedure dsDateEnter(Sender: TObject);
    procedure dxPopupPatronymeEnter(Sender: TObject);
    procedure rbAllIndiClick(Sender: TObject);
    procedure rbIndiCreateFromClick(Sender: TObject);
    procedure rbIndiPatronymeEnter(Sender: TObject);
    procedure dsDateChange(Sender: TObject);
    procedure SuperFormRefreshControls(Sender: TObject);
    procedure lbEnfantsClick(Sender: TObject);
    procedure SuperFormDestroy(Sender: TObject);
    procedure gridListIndiStartDrag(Sender: TObject;
      var DragObject: TDragObject);
    procedure lbEnfantsDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure lbEnfantsDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure panLienEnfantClick(Sender: TObject);
    procedure dxPopupPatronymeKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure dxDBGrid1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SuperFormShowFirstTime(Sender: TObject);
    procedure rbIndiPatronymeClick(Sender: TObject);
  private
    TagFromGrid: integer;
    fCleIndiCentral: integer;
    fSexeIndiCentral: integer;
    fTagEnfants: TIntegerList;
    fDNEnfants: TStringList;

    fSexeFromGrid: integer;
    fDateNaissanceFromGrid: string;
    fGDateFromGrid: TGedcomDate;

    DNINDI, DNP, DNM, DNGPP, DNGMP, DNGPM, DNGMM: string;

    procedure Fixe_Pere(aClePere, aCleIndi: integer);
    procedure Fixe_Mere(aCleMere, aCleIndi: integer);
    procedure DeleteLienMere(aCleIndi: integer);
    procedure DeleteLienPere(aCleIndi: integer);
    procedure MakeDisposition;
    function LoadRepertoire: boolean;
    function Confirmation: boolean;
    function ConfirmationDelete: boolean;
    procedure Fixe_Enfant(aCle_Enfant, aCleIndi: integer);
    procedure DeleteLienEnfant(aCleIndi: integer);
  public
    //en entre
    function Prepare: boolean;

    //utilisation pour les favoris
    procedure doRefreshPeopleArroundIndividu(Cle: integer);
    property CleIndiCentral: integer read fCleIndiCentral write fCleIndiCentral;
  end;

implementation

uses u_dm, u_common_func, u_common_var, u_common_const, u_form_main;

{$R *.DFM}

{ TSuperForm2 }

function TFIndividuConnector.Prepare: boolean;
begin
  result := LoadRepertoire;
  if result then doRefreshPeopleArroundIndividu(dm.FicheActive);
end;


function TFIndividuConnector.LoadRepertoire: boolean;
begin
  //     try
            //Chargement de la liste des individus
  QListIndi.Close;

  if rbAllIndi.checked then
    begin
      QListIndi.SQL.Clear;
      QListIndi.SQL.Add('select CLE_FICHE,PREFIXE, NOM, PRENOM, SEXE, DATE_NAISSANCE, ANNEE_NAISSANCE, ANNEE_DECES from INDIVIDU where (KLE_DOSSIER=:KLE_DOSSIER) ORDER BY NOM,PRENOM');
    end
  else
    if rbIndiCreateFrom.checked then
      begin
        QListIndi.SQL.Clear;
        QListIndi.SQL.Add('select CLE_FICHE,PREFIXE, NOM, PRENOM, SEXE, DATE_NAISSANCE, ANNEE_NAISSANCE, ANNEE_DECES from INDIVIDU where (KLE_DOSSIER=:KLE_DOSSIER) and (DATE_CREATION>=:DATE_CREATION) ORDER BY NOM,PRENOM');
        QListIndi.ParamByName('DATE_CREATION').AsDateTime := dsDate.Date;
      end
    else
      begin
        QListIndi.SQL.Clear;
        QListIndi.SQL.Add('select CLE_FICHE,PREFIXE, NOM, PRENOM, SEXE, DATE_NAISSANCE, ANNEE_NAISSANCE, ANNEE_DECES from INDIVIDU where (KLE_DOSSIER=:KLE_DOSSIER) and (NOM=''' + dxPopupPatronyme.Text + ''') ORDER BY NOM,PRENOM');
      end;

  QListIndi.ParamByName('KLE_DOSSIER').AsInteger := dm.NumDossier;
  QListIndi.Open;
  gridListIndi.Enabled := QListIndi.IsEmpty = false;

  result := true;
  // except
//  result := false
  // end;
end;



procedure TFIndividuConnector.panIndividuCentralDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
begin
  Accept := (Source = gridListIndi) or
    (source = panPere) or
    (source = panMere) or
    (source = panGP_Paternel) or
    (source = panGM_Paternel) or
    (source = panGP_Maternel) or
    (source = panGM_Maternel) or
    ((source = lbEnfants) and (lbEnfants.items.count > 0));
end;

procedure TFIndividuConnector.panIndividuCentralDragDrop(Sender, Source: TObject; X, Y: Integer);
var
  k: integer;
begin
  //soit changement d'individu central
  if (source = gridListIndi) then
    begin
      k := TagFromGrid;
      if k <> fCleIndiCentral then
        begin
          fCleIndiCentral := k;
          dm.FicheActive := k;
          doRefreshPeopleArroundIndividu(k);
        end;
    end
  else
    if (source = panPere) or
      (source = panMere) or
      (source = panGP_Paternel) or
      (source = panGM_Paternel) or
      (source = panGP_Maternel) or
      (source = panGM_Maternel)
      then
      begin
        fCleIndiCentral := TPanel(source).Tag;
        dm.FicheActive := TPanel(source).Tag;
        doRefreshPeopleArroundIndividu(fCleIndiCentral);
      end
    else
      if (source = lbEnfants) then
        begin
          if (lbEnfants.ItemIndex >= 0) and (lbEnfants.ItemIndex < fTagEnfants.Count) then
            begin
              fCleIndiCentral := fTagEnfants[lbEnfants.ItemIndex];
              dm.FicheActive := fTagEnfants[lbEnfants.ItemIndex];
              doRefreshPeopleArroundIndividu(fCleIndiCentral);
            end;
        end;
end;

procedure TFIndividuConnector.SuperFormCreate(Sender: TObject);
begin
  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  //     sdxPanelText := 'Posez un entte';

  fTagEnfants := TIntegerList.create;
  fDNEnfants := TStringList.create;
  fCleIndiCentral := -1;

  panIndividuCentral.Tag := -1;
  panPere.Tag := -1;
  panMere.Tag := -1;
  panGP_Paternel.Tag := -1;
  panGM_Paternel.Tag := -1;
  panGP_Maternel.Tag := -1;
  panGM_Maternel.Tag := -1;

  panLienP.visible := false;
  panLienM.visible := false;
  panLienGPP.visible := false;
  panLienGMP.visible := false;
  panLienGPM.visible := false;
  panLienGMM.visible := false;

  fGDateFromGrid := TGedcomDate.create;
  fGDateFromGrid.AssignTokens;

  //     panEnfants.Tag := -1;
end;

procedure TFIndividuConnector.doRefreshPeopleArroundIndividu(Cle: integer);
var
  n: integer;
  i_Count: SmallInt;
  i_Niveau: SmallInt;
  fInfos, fInfosLine, s: string;
  //     s_Nom, s_Hint: string;
begin
  //     btnHomme.visible := false;
  //     btnFemme.visible := false;

  fTagEnfants.Clear;
  fDNEnfants.Clear;
  lbIndi.Caption := '';
  lbP.Caption := '';
  lbM.Caption := '';
  lbGPP.Caption := '';
  lbGMP.Caption := '';
  lbGPM.Caption := '';
  lbGMM.Caption := '';
  lbEnfants.Items.Clear;
  //     panEnfants.Caption := '';


  panIndividuCentral.Tag := -1;
  panPere.Tag := -1;
  panMere.Tag := -1;
  panGP_Paternel.Tag := -1;
  panGM_Paternel.Tag := -1;
  panGP_Maternel.Tag := -1;
  panGM_Maternel.Tag := -1;
  //     panEnfants.Tag := -1;


  panIndividuCentral.Cursor := crDefault;
  panPere.Cursor := crDefault;
  panMere.Cursor := crDefault;
  panGP_Paternel.Cursor := crDefault;
  panGM_Paternel.Cursor := crDefault;
  panGP_Maternel.Cursor := crDefault;
  panGM_Maternel.Cursor := crDefault;
  lbEnfants.Cursor := crDefault;


  panLienP.visible := false;
  panLienM.visible := false;
  panLienGPP.visible := false;
  panLienGMP.visible := false;
  panLienGPM.visible := false;
  panLienGMM.visible := false;



  {
       btnFemme.Visible := False;
       btnHomme.Visible := False;

       btnPere.Enabled := False;
       btnMere.Enabled := False;
       btnGrandPere_Paternel.Enabled := False;
       btnGrandMere_Paternel.Enabled := False;
       btnGrandPere_Maternel.Enabled := False;
       btnGrandMere_Maternel.Enabled := False;
       btnOnclesTantes.Enabled := False;
       btnFreresSoeurs.Enabled := False;
       btnFils.Enabled := False;
       btnFilles.Enabled := False;
       btnCousinsCousines.Enabled := False;
       btnConjoints.Enabled := False;

       //branchement des grand-parents paternel
       btnGrandPere_Paternel.Tag := -1;
       btnGrandMere_Paternel.Tag := -1;
       btnGrandPere_Paternel.Hint := '';
       btnGrandMere_Paternel.Hint := '';

       //branchement des grands-parents maternels
       btnGrandPere_Maternel.Tag := -1;
       btnGrandMere_Maternel.Tag := -1;
       btnGrandPere_Maternel.Hint := '';
       btnGrandMere_Maternel.Hint := '';

       //Le pre
       btnPere.Tag := -1;

       //La mre
       btnMere.Tag := -1;

       popup_OnclesTantes.Items.Clear;
       popup_FreresSoeurs.Items.Clear;
       popup_Fils.Items.Clear;
       popup_Filles.Items.Clear;
       popup_CousinsCousines.Items.Clear;
       popup_Conjoints.Items.Clear;

       rv.Clear;
       fIndiNom.Clear;
       fIndiPrenom.Clear;
       fIndiSexe.Clear;
       fIndiDateNaissance.Clear;
       fIndiDateDeces.Clear;
       fIndiSosa.Clear;
       fIndiNiveau.Clear;
       fIndiCle.Clear;
       fIndiJumpTag.Clear;
  }
  IBQAscendant.DisableControls;
  try

    IBQAscendant.Close;
    //passage des parametres ---
    IBQAscendant.Params[0].AsInteger := Cle; //Cle de l'individu
    IBQAscendant.Params[1].AsInteger := dm.NumDossier;
    IBQAscendant.Params[2].AsInteger := _Context.MaxIndPourNaviguer;
    IBQAscendant.Open;

    //{oblig de faire ca pour compter les enregs ---
    IBQAscendant.Last;
    //{----------------------------------------------

    i_Count := IBQAscendant.RecordCount;

    //si rien , on sort -------
    if i_Count <= 0 then
      begin
        IBQAscendant.close;
        exit;
      end;

    IBQAscendant.First;

    {
    Panel3.Caption := ' ' + AssembleString([
         FieldByName('NOM').AsString,
              FieldByName('PRENOM').AsString]);
              }

    for n := 1 to i_Count do
      begin
        fInfos := ' ' + IBQAscendant.FieldByName('NOM').AsString + #13#10 +
          ' ' + IBQAscendant.FieldByName('PRENOM').AsString;
        s := trim(IBQAscendant.FieldByName('DATE_NAISSANCE').AsString);
        if s <> '' then fInfos := fInfos + #13#10 + ' ' + s;
        s := trim(IBQAscendant.FieldByName('DATE_DECES').AsString);
        if s <> '' then fInfos := fInfos + #13#10 + ' +' + s;


        fInfosLine := AssembleString([IBQAscendant.FieldByName('NOM').AsString, IBQAscendant.FieldByName('PRENOM').AsString]);
        s := trim(IBQAscendant.FieldByName('DATE_NAISSANCE').AsString);
        if s <> '' then fInfosLine := fInfosLine + ' ' + s;
        s := trim(IBQAscendant.FieldByName('DATE_DECES').AsString);
        if s <> '' then fInfosLine := fInfosLine + ' +' + s;



        {
              //on fabrique la chaine de caracteres -------
              s_Nom := AssembleString([
                   IBQAscendant.FieldByName('NOM').AsString,
                        IBQAscendant.FieldByName('PRENOM').AsString,
                        IBQAscendant.FieldByName('DATE_NAISSANCE').AsString,
                        IBQAscendant.FieldByName('DATE_DECES').AsString]);

              s_Hint := AssembleString([
                   IBQAscendant.FieldByName('NOM').AsString,
                        IBQAscendant.FieldByName('PRENOM').AsString]) + Char(10) + Char(13) +
                   ' ' + IBQAscendant.FieldByName('DATE_NAISSANCE').AsString + Char(10) + Char(13) +
                   '+ ' + IBQAscendant.FieldByName('DATE_DECES').AsString;
         }
              //On recupere le niveau de parente ----------
        i_Niveau := IBQAscendant.FieldByName('NIVEAU').AsInteger;

        {
        fIndiNom.Add(FieldByName('NOM').AsString);
        fIndiPrenom.Add(FieldByName('PRENOM').AsString);
        fIndiSexe.Add(FieldByName('SEXE').AsInteger);
        fIndiDateNaissance.Add(FieldByName('DATE_NAISSANCE').AsString);
        fIndiDateDeces.Add(FieldByName('DATE_DECES').AsString);
        fIndiSosa.Add(FieldByName('SOSA').AsInteger);
        fIndiNiveau.Add(i_Niveau);
        fIndiCle.Add(FieldByName('CLE_FICHE').AsInteger);
        fIndiJumpTag.Add(-1);
         }
        case i_Niveau of



          0: // Lui Meme
            begin
              lbIndi.Caption := fInfos;
              panIndividuCentral.Tag := IBQAscendant.FieldByName('CLE_FICHE').AsInteger;
              panIndividuCentral.Cursor := crHandPoint;
              DNINDI := IBQAscendant.FieldByName('DATE_NAISSANCE').AsString;
              fSexeIndiCentral := IBQAscendant.FieldByName('SEXE').AsInteger;

              if IBQAscendant.FieldByName('SEXE').AsInteger = 1 then panIndi.color := $00FFCC99
              else
                if IBQAscendant.FieldByName('SEXE').AsInteger = 2 then panIndi.color := $0099CCFF;
            end;

          1: // Parents
            begin
              case IBQAscendant.FieldByName('SOSA').AsInteger of
                2: // Pere
                  begin
                    lbP.Caption := fInfos;
                    panPere.Tag := IBQAscendant.FieldByName('CLE_FICHE').AsInteger;
                    panPere.Cursor := crHandPoint;
                    panLienP.visible := true;
                    DNP := IBQAscendant.FieldByName('DATE_NAISSANCE').AsString;
                    {
                    btnPere.Tag := FieldByName('CLE_FICHE').AsInteger;
                    btnPere.Hint := s_Hint;
                    btnPere.Enabled := True;
                    }
                  end;
                3: // Mere
                  begin
                    lbM.Caption := fInfos;
                    panMere.Tag := IBQAscendant.FieldByName('CLE_FICHE').AsInteger;
                    panMere.Cursor := crHandPoint;
                    panLienM.visible := true;
                    DNM := IBQAscendant.FieldByName('DATE_NAISSANCE').AsString;
                    {
                    btnMere.Tag := FieldByName('CLE_FICHE').AsInteger;
                    btnMere.Hint := s_Hint;
                    btnMere.Enabled := True;
                    }
                  end;
              end;
            end;

          2: // Grands parents
            begin
              case IBQAscendant.FieldByName('SOSA').AsInteger of
                4: // GP Paternel
                  begin
                    lbGPP.Caption := fInfos;
                    panGP_Paternel.Tag := IBQAscendant.FieldByName('CLE_FICHE').AsInteger;
                    panGP_Paternel.Cursor := crHandPoint;
                    panLienGPP.visible := true;
                    DNGPP := IBQAscendant.FieldByName('DATE_NAISSANCE').AsString;
                    {
                         btnGrandPere_Paternel.Tag := FieldByName('CLE_FICHE').AsInteger;
                         btnGrandPere_Paternel.Hint := s_Hint;
                         btnGrandPere_Paternel.Enabled := True;
                         }

                  end;
                5: // GM Paternelle
                  begin
                    lbGMP.Caption := fInfos;
                    panGM_Paternel.Tag := IBQAscendant.FieldByName('CLE_FICHE').AsInteger;
                    panGM_Paternel.Cursor := crHandPoint;
                    panLienGMP.visible := true;
                    DNGMP := IBQAscendant.FieldByName('DATE_NAISSANCE').AsString;
                    {
                         btnGrandMere_Paternel.Tag := FieldByName('CLE_FICHE').AsInteger;
                         btnGrandMere_Paternel.Hint := s_Hint;
                         btnGrandMere_Paternel.Enabled := True;
                         }
                  end;
                6: // GP Maternel
                  begin
                    lbGPM.Caption := fInfos;
                    panGP_Maternel.Tag := IBQAscendant.FieldByName('CLE_FICHE').AsInteger;
                    panGP_Maternel.Cursor := crHandPoint;
                    panLienGPM.visible := true;
                    DNGPM := IBQAscendant.FieldByName('DATE_NAISSANCE').AsString;
                    {
                         btnGrandPere_Maternel.Tag := FieldByName('CLE_FICHE').AsInteger;
                         btnGrandPere_Maternel.Hint := s_Hint;
                         btnGrandPere_Maternel.Enabled := True;
                         }
                  end;
                7: // GM Maternelle
                  begin
                    lbGMM.Caption := fInfos;
                    panGM_Maternel.Tag := IBQAscendant.FieldByName('CLE_FICHE').AsInteger;
                    panGM_Maternel.Cursor := crHandPoint;
                    panLienGMM.visible := true;
                    DNGMM := IBQAscendant.FieldByName('DATE_NAISSANCE').AsString;
                    {
                         btnGrandMere_Maternel.Tag := FieldByName('CLE_FICHE').AsInteger;
                         btnGrandMere_Maternel.Hint := s_Hint;
                         btnGrandMere_Maternel.Enabled := True;
                         }
                  end;
              end;
            end;
          {
           3: // Oncles et tantes
                begin
                     btnOnclesTantes.Enabled := True;
                     NewItem := TMenuItem.create(self);
                     popup_OnclesTantes.Items.Add(NewItem);
                     NewItem.Tag := FieldByName('CLE_FICHE').AsInteger;
                     NewItem.Caption := s_Nom;
                     NewItem.Onclick := OnSelectIndividu;

                     if FieldByName('SEXE').AsInteger = 1 then
                          NewItem.ImageIndex := 1
                     else
                          NewItem.ImageIndex := 0;

                end;

           4: // Freres et soeurs
                begin
                     btnFreresSoeurs.Enabled := True;
                     NewItem := TMenuItem.create(self);
                     popup_FreresSoeurs.Items.Add(NewItem);
                     NewItem.Tag := FieldByName('CLE_FICHE').AsInteger;
                     NewItem.Caption := s_Nom;
                     NewItem.Onclick := OnSelectIndividu;

                     if FieldByName('SEXE').AsInteger = 1 then
                          NewItem.ImageIndex := 1
                     else
                          NewItem.ImageIndex := 0;

                end;
           }


          5: // Enfants
            begin
              lbEnfants.items.Add(fInfosLine);
              fTagEnfants.Add(IBQAscendant.FieldByName('CLE_FICHE').AsInteger);
              fDNEnfants.Add(IBQAscendant.FieldByName('DATE_NAISSANCE').AsString);
              lbEnfants.Cursor := crHandPoint;
              {
                  if FieldByName('SEXE').AsInteger = 1 then
                       // Fils
                  begin
                       btnFils.Enabled := True;
                       NewItem := TMenuItem.create(self);
                       popup_Fils.Items.Add(NewItem);
                       NewItem.Tag := FieldByName('CLE_FICHE').AsInteger;
                       NewItem.Caption := s_Nom;
                       NewItem.Onclick := OnSelectIndividu;
                       NewItem.ImageIndex := 1
                  end
                  else
                       // Filles
                  begin
                       btnFilles.Enabled := True;
                       NewItem := TMenuItem.create(self);
                       popup_Filles.Items.Add(NewItem);
                       NewItem.Tag := FieldByName('CLE_FICHE').AsInteger;
                       NewItem.Caption := s_Nom;
                       NewItem.Onclick := OnSelectIndividu;
                       NewItem.ImageIndex := 0;
                  end;
                  }

            end;



          {
          6: // Cousins Cousines
               begin
                    btnCousinsCousines.Enabled := True;
                    NewItem := TMenuItem.create(self);
                    popup_CousinsCousines.Items.Add(NewItem);
                    NewItem.Tag := FieldByName('CLE_FICHE').AsInteger;
                    NewItem.Caption := s_Nom;
                    NewItem.Onclick := OnSelectIndividu;

                    if FieldByName('SEXE').AsInteger = 1 then
                         NewItem.ImageIndex := 1
                    else
                         NewItem.ImageIndex := 0;
               end;

          7: // Conjoints
               begin
                    btnConjoints.Enabled := True;
                    NewItem := TMenuItem.create(self);
                    popup_Conjoints.Items.Add(NewItem);
                    NewItem.Tag := FieldByName('CLE_FICHE').AsInteger;
                    NewItem.Caption := s_Nom;
                    NewItem.Onclick := OnSelectIndividu;

                    if FieldByName('SEXE').AsInteger = 1 then
                         NewItem.ImageIndex := 1
                    else
                         NewItem.ImageIndex := 0;
               end;
          }
        end;

        IBQAscendant.next;
      end;

  finally
    IBQAscendant.EnableControls;
    IBQAscendant.Close;
  end;

  doRefreshControls;
end;


procedure TFIndividuConnector.panGP_PaternelMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if TPanel(Sender).Tag <> -1 then TPanel(Sender).BeginDrag(false);
end;

procedure TFIndividuConnector.panPereDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
var
  r, i: boolean;
begin
  Accept := false;

  if (Source = gridListIndi) and (panIndividuCentral.Tag <> -1) and (fSexeFromGrid = 1) then
    begin
      if _Context.CoherenceActive then
        begin
          r := EcartDatesD1D2SuperieurOuEgalA(fDateNaissanceFromGrid, DNINDI, trunc(_Context.AgeMiniNaissanceEnfantHommes * 365.25), i);
          if i or r then
            begin
              r := EcartDatesD1D2InferieurOuEgalA(fDateNaissanceFromGrid, DNINDI, trunc(_Context.AgeMaxiNaissanceEnfantHommes * 365.25), i);
              if i then Accept := true;
              if i then Accept := true else Accept := r;
            end;
        end
      else
        begin
          r := DateInOrder(fDateNaissanceFromGrid, DNINDI, true, i);
          if i then Accept := true;
          if i then Accept := true else Accept := r;
        end;
    end;
end;

procedure TFIndividuConnector.panPereDragDrop(Sender, Source: TObject; X, Y: Integer);
begin
  if Confirmation then
    begin
      Fixe_Pere(TagFromGrid, panIndividuCentral.Tag);
      doRefreshPeopleArroundIndividu(panIndividuCentral.Tag);
    end;
end;



procedure TFIndividuConnector.Fixe_Pere(aClePere, aCleIndi: integer);
begin
  try
    try
      Query.Close;
      Query.SQL.Clear;
      Query.SQL.Add('update individu set CLE_PERE=:CLE_PERE where (CLE_FICHE=:CLE_FICHE)');
      Query.ParamByName('CLE_FICHE').AsInteger := aCleIndi;
      Query.ParamByName('CLE_PERE').AsInteger := aClePere;
      Query.ExecSQL;
    finally
      Query.Close;
    end;
    dm.IBT_BASE.CommitRetaining;
  except
    dm.IBT_BASE.RollBackRetaining;
  end;
end;



procedure TFIndividuConnector.panMereDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
var
  r, i: boolean;
begin
  Accept := false;
  if (Source = gridListIndi) and (panIndividuCentral.Tag <> -1) and (fSexeFromGrid = 2) then
    begin
      if _Context.CoherenceActive then
        begin
          r := EcartDatesD1D2SuperieurOuEgalA(fDateNaissanceFromGrid, DNINDI, trunc(_Context.AgeMiniNaissanceEnfantFemmes * 365.25), i);
          if i or r then
            begin
              r := EcartDatesD1D2InferieurOuEgalA(fDateNaissanceFromGrid, DNINDI, trunc(_Context.AgeMaxiNaissanceEnfantFemmes * 365.25), i);
              if i then Accept := true;
              if i then Accept := true else Accept := r;
            end;
        end
      else
        begin
          r := DateInOrder(fDateNaissanceFromGrid, DNINDI, true, i);
          if i then Accept := true;
          if i then Accept := true else Accept := r;
        end;
    end;
end;

procedure TFIndividuConnector.panMereDragDrop(Sender, Source: TObject; X, Y: Integer);
begin
  if Confirmation then
    begin
      Fixe_Mere(TagFromGrid, panIndividuCentral.Tag);
      doRefreshPeopleArroundIndividu(panIndividuCentral.Tag);
    end;
end;


procedure TFIndividuConnector.Fixe_Mere(aCleMere, aCleIndi: integer);
begin
  try
    try
      Query.Close;
      Query.SQL.Clear;
      Query.SQL.Add('update individu set CLE_MERE=:CLE_MERE where (CLE_FICHE=:CLE_FICHE)');
      Query.ParamByName('CLE_FICHE').AsInteger := aCleIndi;
      Query.ParamByName('CLE_MERE').AsInteger := aCleMere;
      Query.ExecSQL;
    finally
      Query.Close;
    end;
    dm.IBT_BASE.CommitRetaining;
  except
    dm.IBT_BASE.RollBackRetaining;
  end;
end;


procedure TFIndividuConnector.panGP_PaternelDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
var
  r, i: boolean;
begin
  Accept := false;

  if (Source = gridListIndi) and (panPere.Tag <> -1) and (fSexeFromGrid = 1) then
    begin
      if _Context.CoherenceActive then
        begin
          r := EcartDatesD1D2SuperieurOuEgalA(fDateNaissanceFromGrid, DNP, trunc(_Context.AgeMiniNaissanceEnfantHommes * 365.25), i);
          if i or r then
            begin
              r := EcartDatesD1D2InferieurOuEgalA(fDateNaissanceFromGrid, DNP, trunc(_Context.AgeMaxiNaissanceEnfantHommes * 365.25), i);
              if i then Accept := true;
              if i then Accept := true else Accept := r;
            end;
        end
      else
        begin
          r := DateInOrder(fDateNaissanceFromGrid, DNP, true, i);
          if i then Accept := true;
          if i then Accept := true else Accept := r;
        end;
    end;
end;

procedure TFIndividuConnector.panGP_PaternelDragDrop(Sender, Source: TObject; X, Y: Integer);
begin
  if Confirmation then
    begin
      Fixe_Pere(TagFromGrid, panPere.Tag);
      doRefreshPeopleArroundIndividu(panIndividuCentral.Tag);
    end;
end;


procedure TFIndividuConnector.panGM_PaternelDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
var
  r, i: boolean;
begin
  Accept := false;

  if (Source = gridListIndi) and (panPere.Tag <> -1) and (fSexeFromGrid = 2) then
    begin
      if _Context.CoherenceActive then
        begin
          r := EcartDatesD1D2SuperieurOuEgalA(fDateNaissanceFromGrid, DNP, trunc(_Context.AgeMiniNaissanceEnfantFemmes * 365.25), i);
          if i or r then
            begin
              r := EcartDatesD1D2InferieurOuEgalA(fDateNaissanceFromGrid, DNP, trunc(_Context.AgeMaxiNaissanceEnfantFemmes * 365.25), i);
              if i then Accept := true;
              if i then Accept := true else Accept := r;
            end;
        end
      else
        begin
          r := DateInOrder(fDateNaissanceFromGrid, DNP, true, i);
          if i then Accept := true;
          if i then Accept := true else Accept := r;
        end;
    end;
end;


procedure TFIndividuConnector.panGM_PaternelDragDrop(Sender, Source: TObject; X, Y: Integer);
begin
  if Confirmation then
    begin
      Fixe_Mere(TagFromGrid, panPere.Tag);
      doRefreshPeopleArroundIndividu(panIndividuCentral.Tag);
    end;
end;


procedure TFIndividuConnector.panGP_MaternelDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
var
  r, i: boolean;
begin
  Accept := false;

  if (Source = gridListIndi) and (panMere.Tag <> -1) and (fSexeFromGrid = 1) then
    begin
      if _Context.CoherenceActive then
        begin
          r := EcartDatesD1D2SuperieurOuEgalA(fDateNaissanceFromGrid, DNM, trunc(_Context.AgeMiniNaissanceEnfantHommes * 365.25), i);
          if i or r then
            begin
              r := EcartDatesD1D2InferieurOuEgalA(fDateNaissanceFromGrid, DNM, trunc(_Context.AgeMaxiNaissanceEnfantHommes * 365.25), i);
              if i then Accept := true;
              if i then Accept := true else Accept := r;
            end;
        end
      else
        begin
          r := DateInOrder(fDateNaissanceFromGrid, DNM, true, i);
          if i then Accept := true;
          if i then Accept := true else Accept := r;
        end;
    end;
end;

procedure TFIndividuConnector.panGP_MaternelDragDrop(Sender, Source: TObject; X, Y: Integer);
begin
  Fixe_Pere(QListIndi.FieldByName('CLE_FICHE').AsInteger, panMere.Tag);
  doRefreshPeopleArroundIndividu(panIndividuCentral.Tag);
end;




procedure TFIndividuConnector.panGM_MaternelDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
var
  r, i: boolean;
begin
  Accept := false;

  if (Source = gridListIndi) and (panMere.Tag <> -1) and (fSexeFromGrid = 2) then
    begin
      if _Context.CoherenceActive then
        begin
          r := EcartDatesD1D2SuperieurOuEgalA(fDateNaissanceFromGrid, DNM, trunc(_Context.AgeMiniNaissanceEnfantFemmes * 365.25), i);
          if i or r then
            begin
              r := EcartDatesD1D2InferieurOuEgalA(fDateNaissanceFromGrid, DNM, trunc(_Context.AgeMaxiNaissanceEnfantFemmes * 365.25), i);
              if i then Accept := true;
              if i then Accept := true else Accept := r;
            end;
        end
      else
        begin
          r := DateInOrder(fDateNaissanceFromGrid, DNM, true, i);
          if i then Accept := true;
          if i then Accept := true else Accept := r;
        end;
    end;
end;


procedure TFIndividuConnector.panGM_MaternelDragDrop(Sender, Source: TObject; X, Y: Integer);
begin
  if Confirmation then
    begin
      Fixe_Mere(TagFromGrid, panMere.Tag);
      doRefreshPeopleArroundIndividu(panIndividuCentral.Tag);
    end;
end;


procedure TFIndividuConnector.DeleteLienPere(aCleIndi: integer);
begin
  try
    try
      Query.Close;
      Query.SQL.Clear;
      Query.SQL.Add('update individu set CLE_PERE=NULL where (CLE_FICHE=:CLE_FICHE)');
      Query.ParamByName('CLE_FICHE').AsInteger := aCleIndi;
      Query.ExecSQL;
    finally
      Query.Close;
    end;
    dm.IBT_BASE.CommitRetaining;
  except
    dm.IBT_BASE.RollBackRetaining;
  end;
end;


procedure TFIndividuConnector.DeleteLienMere(aCleIndi: integer);
begin
  try
    try
      Query.Close;
      Query.SQL.Clear;
      Query.SQL.Add('update individu set CLE_MERE=NULL where (CLE_FICHE=:CLE_FICHE)');
      Query.ParamByName('CLE_FICHE').AsInteger := aCleIndi;
      Query.ExecSQL;
    finally
      Query.Close;
    end;
    dm.IBT_BASE.CommitRetaining;
  except
    dm.IBT_BASE.RollBackRetaining;
  end;
end;


procedure TFIndividuConnector.MakeDisposition;
const
  _left = 8;
  _sep = 4;
  _middle = 16;
var
  w: integer;
begin
  w := (panFamille.Width - _left - _sep - _middle - _sep - _left) div 4;

  ApanGP_Paternel.width := w;
  ApanGM_Paternel.width := w;
  ApanGP_Maternel.width := w;
  ApanGM_Maternel.width := w;
  ApanPere.width := w;
  ApanMere.width := w;
  ApanIndividuCentral.width := w * 2;

  ApanGP_Paternel.left := _left;
  ApanGM_Paternel.left := _left + w + _sep;
  ApanGP_Maternel.left := panFamille.Width - 1 - _left - w - _sep - w;
  ApanGM_Maternel.left := panFamille.Width - 1 - _left - w;

  ApanPere.left := ApanGP_Paternel.left + (((ApanGM_Paternel.Left + ApanGM_Paternel.Width - ApanGP_Paternel.left) - w) div 2);
  ApanMere.left := ApanGP_Maternel.Left + (((ApanGM_Maternel.Left + ApanGM_Maternel.Width - ApanGP_Maternel.left) - w) div 2);

  ApanIndividuCentral.left := ApanGP_Paternel.left + (((ApanGM_Maternel.Left + ApanGM_Maternel.Width - ApanGP_Paternel.left) - (w * 2)) div 2);

  panLienGPP.left := ApanPere.Left + ((ApanGP_Paternel.Left + ApanGP_Paternel.Width - ApanPere.Left - panLienGPP.width) div 2);
  panLienGMP.left := ApanGM_Paternel.Left + ((ApanPere.Left + ApanPere.Width - ApanGM_Paternel.Left - panLienGMP.width) div 2);
  panLienGPM.left := ApanMere.Left + ((ApanGP_Maternel.Left + ApanGP_Maternel.Width - ApanMere.Left - panLienGPM.width) div 2);
  panLienGMM.left := ApanGM_Maternel.Left + ((ApanMere.Left + ApanMere.Width - ApanGM_Maternel.Left - panLienGMM.width) div 2);
  panLienP.left := ApanIndividuCentral.Left + ((ApanPere.Left + ApanPere.Width - ApanIndividuCentral.Left - panLienP.width) div 2);
  panLienM.left := ApanMere.Left + ((ApanIndividuCentral.Left + ApanIndividuCentral.Width - ApanMere.Left - panLienM.width) div 2);

  ApanEnfants.Left := ApanPere.Left;
  ApanEnfants.Width := (ApanMere.Left + ApanMere.Width - ApanPere.Left);

  panLienEnfant.Left := ApanEnfants.Left + ApanEnfants.Width - panLienEnfant.Width;

  pb.Refresh;
end;


procedure TFIndividuConnector.pbPaint(Sender: TObject);
var
  x, y: integer;

  procedure PanToPb(aPan: TPanel; xp, yp: integer; var x, y: integer);
  var
    P: TPoint;
  begin
    P := pb.ScreenToClient(aPan.ClientToScreen(point(xp, yp)));
    x := p.x;
    y := p.y;
  end;

begin
  pb.Canvas.Pen.Color := clBlack;


  PanToPb(ApanGP_Paternel, (ApanGP_Paternel.Width div 2), ApanGP_Paternel.Height, x, y);
  pb.Canvas.MoveTo(x, y);
  PanToPb(ApanPere, (ApanPere.Width div 2), 0, x, y);
  pb.Canvas.LineTo(x, y);


  PanToPb(ApanGM_Paternel, (ApanGM_Paternel.Width div 2), ApanGM_Paternel.Height, x, y);
  pb.Canvas.MoveTo(x, y);
  PanToPb(ApanPere, (ApanPere.Width div 2), 0, x, y);
  pb.Canvas.LineTo(x, y);


  PanToPb(ApanGP_Maternel, (ApanGP_Maternel.Width div 2), ApanGP_Maternel.Height, x, y);
  pb.Canvas.MoveTo(x, y);
  PanToPb(ApanMere, (ApanMere.Width div 2), 0, x, y);
  pb.Canvas.LineTo(x, y);


  PanToPb(ApanGM_Maternel, (ApanGM_Maternel.Width div 2), ApanGM_Maternel.Height, x, y);
  pb.Canvas.MoveTo(x, y);
  PanToPb(ApanMere, (ApanMere.Width div 2), 0, x, y);
  pb.Canvas.LineTo(x, y);


  PanToPb(ApanPere, (ApanPere.Width div 2), ApanPere.Height, x, y);
  pb.Canvas.MoveTo(x, y);
  PanToPb(ApanIndividuCentral, (ApanIndividuCentral.Width div 2), 0, x, y);
  pb.Canvas.LineTo(x, y);


  PanToPb(ApanMere, (ApanMere.Width div 2), ApanMere.Height, x, y);
  pb.Canvas.MoveTo(x, y);
  PanToPb(ApanIndividuCentral, (ApanIndividuCentral.Width div 2), 0, x, y);
  pb.Canvas.LineTo(x, y);


  PanToPb(ApanIndividuCentral, (ApanIndividuCentral.Width div 2), ApanIndividuCentral.Height, x, y);
  pb.Canvas.MoveTo(x, y);
  PanToPb(ApanEnfants, (ApanEnfants.Width div 2), 0, x, y);
  pb.Canvas.LineTo(x, y);

  PanToPb(ApanIndividuCentral, (ApanIndividuCentral.Width div 2), ApanIndividuCentral.Height, x, y);
  pb.Canvas.MoveTo(x, y);
  PanToPb(ApanEnfants, (ApanEnfants.Width div 2), 0, x, y);
  pb.Canvas.LineTo(x - 20, y);

  PanToPb(ApanIndividuCentral, (ApanIndividuCentral.Width div 2), ApanIndividuCentral.Height, x, y);
  pb.Canvas.MoveTo(x, y);
  PanToPb(ApanEnfants, (ApanEnfants.Width div 2), 0, x, y);
  pb.Canvas.LineTo(x + 20, y);

end;

procedure TFIndividuConnector.panFamilleResize(Sender: TObject);
begin
  MakeDisposition;
end;

procedure TFIndividuConnector.panLienPClick(Sender: TObject);
begin
  if ConfirmationDelete then
    begin
      DeleteLienPere(panIndividuCentral.Tag);
      doRefreshPeopleArroundIndividu(panIndividuCentral.Tag);
    end;
end;

procedure TFIndividuConnector.panLienMClick(Sender: TObject);
begin
  if ConfirmationDelete then
    begin
      DeleteLienMere(panIndividuCentral.Tag);
      doRefreshPeopleArroundIndividu(panIndividuCentral.Tag);
    end;
end;

procedure TFIndividuConnector.panLienGPPClick(Sender: TObject);
begin
  if ConfirmationDelete then
    begin
      DeleteLienPere(panPere.Tag);
      doRefreshPeopleArroundIndividu(panIndividuCentral.Tag);
    end;
end;

function TFIndividuConnector.Confirmation: boolean;
begin
  if cbAskConfirm.checked then
    begin
      result := MyMessageDlg('Confirmez-vous l' + #39 + 'ajout de ce lien familliale ?', mtConfirmation, [mbYes, mbNo], 0) = mrYes;
    end
  else
    result := true;
end;


function TFIndividuConnector.ConfirmationDelete: boolean;
begin
  if cbAskConfirm.checked then
    begin
      result := MyMessageDlg('Confirmez-vous la suppression de ce lien familliale ?', mtConfirmation, [mbYes, mbNo], 0) = mrYes;
    end
  else
    result := true;
end;

procedure TFIndividuConnector.panLienGMPClick(Sender: TObject);
begin
  if ConfirmationDelete then
    begin
      DeleteLienMere(panPere.Tag);
      doRefreshPeopleArroundIndividu(panIndividuCentral.Tag);
    end;
end;

procedure TFIndividuConnector.panLienGPMClick(Sender: TObject);
begin
  if ConfirmationDelete then
    begin
      DeleteLienPere(panMere.Tag);
      doRefreshPeopleArroundIndividu(panIndividuCentral.Tag);
    end;
end;

procedure TFIndividuConnector.panLienGMMClick(Sender: TObject);
begin
  if ConfirmationDelete then
    begin
      DeleteLienMere(panMere.Tag);
      doRefreshPeopleArroundIndividu(panIndividuCentral.Tag);
    end;
end;

procedure TFIndividuConnector.dxPopupPatronymeInitPopup(Sender: TObject);
begin
  pPatronymes.Width := 400;
  pPatronymes.Height := 250;

  IBQPatronymes.Close;
  IBQPatronymes.Params[0].AsInteger := dm.NumDossier;
  IBQPatronymes.Open;
end;

procedure TFIndividuConnector.QListIndiCalcFields(DataSet: TDataSet);
var
  s: string;
begin
  s := '';
  if QListIndiANNEE_NAISSANCE.IsNull = false then
    begin
      s := ' ' + QListIndiANNEE_NAISSANCE.AsString;
    end;

  if QListIndiANNEE_DECES.IsNull = false then
    begin
      if s <> '' then s := s + #13#10;
      s := s + '+ ' + QListIndiANNEE_DECES.AsString;
    end;

  QListIndi_DETAIL.AsString := s;
end;

procedure TFIndividuConnector.dxDBGrid1DblClick(Sender: TObject);
begin
  dxPopupPatronyme.Text := IBQPatronymesNOM.AsString;
  (GetParentForm(dxDBGrid1) as TdxPopupEditForm).ClosePopup(True);
  LoadRepertoire;
end;

procedure TFIndividuConnector.dsDateEnter(Sender: TObject);
begin
  rbIndiCreateFrom.Checked := true;
  LoadRepertoire;
end;

procedure TFIndividuConnector.dxPopupPatronymeEnter(Sender: TObject);
begin
  rbIndiPatronyme.Checked := true;
  LoadRepertoire;
end;

procedure TFIndividuConnector.rbAllIndiClick(Sender: TObject);
begin
  doRefreshControls;
  LoadRepertoire;
end;

procedure TFIndividuConnector.rbIndiCreateFromClick(Sender: TObject);
begin
  doRefreshControls;
  LoadRepertoire;
  TMydxInplaceDropDownEdit(dsDate).DropDown;
end;

procedure TFIndividuConnector.rbIndiPatronymeEnter(Sender: TObject);
begin
  LoadRepertoire;
end;

procedure TFIndividuConnector.dsDateChange(Sender: TObject);
begin
  LoadRepertoire;
end;

procedure TFIndividuConnector.SuperFormRefreshControls(Sender: TObject);
begin
  panLienEnfant.visible := (lbEnfants.ItemIndex <> -1);

  dsDate.enabled := rbIndiCreateFrom.checked;
  dxPopupPatronyme.enabled := rbIndiPatronyme.checked;

  application.processmessages;
  application.processmessages;
end;

procedure TFIndividuConnector.lbEnfantsClick(Sender: TObject);
begin
  doRefreshControls;
end;

procedure TFIndividuConnector.SuperFormDestroy(Sender: TObject);
begin
  //sdxPanelText := Fmain.lEnteteColonne.Caption;

  fTagEnfants.Free;
  fDNEnfants.Free;
  fGDateFromGrid.Free;
end;

procedure TFIndividuConnector.gridListIndiStartDrag(Sender: TObject;
  var DragObject: TDragObject);
begin
  TagFromGrid := QListIndi.FieldByName('CLE_FICHE').AsInteger;
  fSexeFromGrid := QListIndi.FieldByName('SEXE').AsInteger;
  fDateNaissanceFromGrid := QListIndi.FieldByName('DATE_NAISSANCE').AsString;
end;

procedure TFIndividuConnector.lbEnfantsDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
var
  r, i: boolean;
begin
  Accept := false;

  if (Source = gridListIndi) and (panIndividuCentral.Tag <> -1) then
    begin
      if _Context.CoherenceActive then
        begin
          if fSexeIndiCentral = 1 then
            begin
              r := EcartDatesD1D2SuperieurOuEgalA(DNINDI, fDateNaissanceFromGrid, trunc(_Context.AgeMiniNaissanceEnfantHommes * 365.25), i);
              if i or r then
                begin
                  r := EcartDatesD1D2InferieurOuEgalA(DNINDI, fDateNaissanceFromGrid, trunc(_Context.AgeMaxiNaissanceEnfantHommes * 365.25), i);
                  if i then Accept := true;
                  if i then Accept := true else Accept := r;
                end;
            end
          else
            begin
              r := EcartDatesD1D2SuperieurOuEgalA(DNINDI, fDateNaissanceFromGrid, trunc(_Context.AgeMiniNaissanceEnfantFemmes * 365.25), i);
              if i or r then
                begin
                  r := EcartDatesD1D2InferieurOuEgalA(DNINDI, fDateNaissanceFromGrid, trunc(_Context.AgeMaxiNaissanceEnfantFemmes * 365.25), i);
                  if i then Accept := true;
                  if i then Accept := true else Accept := r;
                end;
            end;
        end
      else
        begin
          r := DateInOrder(DNINDI, fDateNaissanceFromGrid, true, i);
          if i then Accept := true;
          if i then Accept := true else Accept := r;
        end;
    end;
end;



procedure TFIndividuConnector.lbEnfantsDragDrop(Sender, Source: TObject; X, Y: Integer);
begin
  if Confirmation then
    begin
      Fixe_Enfant(TagFromGrid, panIndividuCentral.Tag);
      doRefreshPeopleArroundIndividu(panIndividuCentral.Tag);
    end;
end;

procedure TFIndividuConnector.Fixe_Enfant(aCle_Enfant, aCleIndi: integer);
var
  sexe: integer;
begin
  try
    //On recherche le sexe du parent
    try
      Query.Close;
      Query.SQL.Clear;
      Query.SQL.Add('select sexe from individu where CLE_FICHE=' + inttostr(aCleIndi));
      Query.Open;
      Query.Last;
      Query.First;
      if Query.RecordCount = 1 then
        begin
          sexe := Query.FieldByName('SEXE').AsInteger;
          if (sexe = 1) or (sexe = 2) then
            begin
              //maj
              Query.Close;
              Query.SQL.Clear;
              if sexe = 1
                then Query.SQL.Add('update individu set CLE_PERE=' + inttostr(aCleIndi) + ' where CLE_FICHE=' + inttostr(aCle_Enfant))
              else Query.SQL.Add('update individu set CLE_MERE=' + inttostr(aCleIndi) + ' where CLE_FICHE=' + inttostr(aCle_Enfant));
              Query.ExecSQL;
            end
          else
            MyMessageDlg('Le sexe du parent est inconnu.', mtWarning, [mbOK], 0);
        end;
    finally
      Query.Close;
    end;
    dm.IBT_BASE.CommitRetaining;
  except
    dm.IBT_BASE.RollBackRetaining;
  end;
end;



procedure TFIndividuConnector.panLienEnfantClick(Sender: TObject);
begin
  if ConfirmationDelete then
    begin
      DeleteLienEnfant(panIndividuCentral.Tag);
      doRefreshPeopleArroundIndividu(panIndividuCentral.Tag);
    end;
end;


procedure TFIndividuConnector.DeleteLienEnfant(aCleIndi: integer);
var
  sexe: integer;
  aCle_Enfant: integer;
begin
  if lbEnfants.ItemIndex <> -1 then
    begin
      try
        aCle_Enfant := fTagEnfants[lbEnfants.ItemIndex];

        //On recherche le sexe du parent
        try
          Query.Close;
          Query.SQL.Clear;
          Query.SQL.Add('select sexe from individu where CLE_FICHE=' + inttostr(aCleIndi));
          Query.Open;
          Query.Last;
          Query.First;
          if Query.RecordCount = 1 then
            begin
              sexe := Query.FieldByName('SEXE').AsInteger;
              if (sexe = 1) or (sexe = 2) then
                begin
                  //maj
                  Query.Close;
                  Query.SQL.Clear;
                  if sexe = 1
                    then Query.SQL.Add('update individu set CLE_PERE=Null where CLE_FICHE=' + inttostr(aCle_Enfant))
                  else Query.SQL.Add('update individu set CLE_MERE=Null where CLE_FICHE=' + inttostr(aCle_Enfant));
                  Query.ExecSQL;
                end
              else
                MyMessageDlg('Le sexe du parent est inconnu.', mtWarning, [mbOK], 0);
            end;
        finally
          Query.Close;
        end;
        dm.IBT_BASE.CommitRetaining;
      except
        dm.IBT_BASE.RollBackRetaining;
      end;
    end;
end;

procedure TFIndividuConnector.dxPopupPatronymeKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if (Key = _KEY_OPEN_LIST) then TMydxDBPopupEdit(dxPopupPatronyme).DropDown;
end;

{ TMydxDBPopupEdit }

procedure TMydxDBPopupEdit.DropDown;
begin
  inherited;
end;

procedure TFIndividuConnector.dxDBGrid1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if (key = VK_ESCAPE) then (GetParentForm(dxDBGrid1) as TdxPopupEditForm).ClosePopup(True)
  else
    if (Key = VK_RETURN) then dxDBGrid1DblClick(Sender);
end;

procedure TFIndividuConnector.SuperFormShowFirstTime(Sender: TObject);
begin
  doRefreshControls;
end;

procedure TFIndividuConnector.rbIndiPatronymeClick(Sender: TObject);
begin
  doRefreshControls;
  LoadRepertoire;
  TMydxDBPopupEdit(dxPopupPatronyme).DropDown;
end;

{ TMydxInplaceDropDownEdit }

procedure TMydxInplaceDropDownEdit.DropDown;
begin
  inherited;
end;

end.
