{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_individu_observations;

interface

uses
  Windows, CompSuperForm, Classes, Controls, StdCtrls, forms,
  dxCntner, dxEditor, dxExEdtr, dxEdLib, dxDBELib, ExtCtrls, URLLink, Db,
  u_comp_TYLanguage, TFlatSplitterUnit;

type
  TFIndividuObservations = class(TSuperForm)
    Panel10: TPanel;
    Panel13: TPanel;
    DataSource: TDataSource;
    lNom: TLabel;
    Label8: TLabel;
    Language: TYLanguage;
    Panel1: TPanel;
    memo: TdxDBMemo;
    Panel2: TPanel;
    dxDBMemo1: TdxDBMemo;
    Panel3: TPanel;
    Panel4: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    FlatSplitter1: TFlatSplitter;
    procedure SuperFormRefreshControls(Sender: TObject);
    procedure SuperFormCreate(Sender: TObject);

  private
    fFormIndividu: TForm;
    procedure SetFormIndividu(const Value: TForm);
  public
    property FormIndividu: TForm read fFormIndividu write SetFormIndividu;

    procedure doInitialize;
    function doOpenQuerys: boolean;
  end;

implementation

uses u_form_individu, u_dm, u_common_func, u_common_const, u_common_var;

{$R *.DFM}

procedure TFIndividuObservations.doInitialize;
begin

end;

function TFIndividuObservations.doOpenQuerys: boolean;
begin
  result := true;
end;

procedure TFIndividuObservations.SetFormIndividu(const Value: TForm);
begin
  fFormIndividu := Value;
  DataSource.DataSet := TFIndividu(fFormIndividu).QueryIndividu;
end;



procedure TFIndividuObservations.SuperFormRefreshControls(Sender: TObject);
begin
  DataSource.AutoEdit := (TFIndividu(fFormindividu).CleFiche <> -1) and (TFIndividu(fFormindividu).DialogMode = false);
end;

procedure TFIndividuObservations.SuperFormCreate(Sender: TObject);
begin
  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;
end;

end.
