{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_individu_par_prenom;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, StdCtrls, ExtCtrls, TFlatTabControlUnit, dxCntner, dxTL,
  dxDBGrid, DBCtrls, Db, IBCustomDataSet, IBQuery, dxGrClms,
  u_comp_TFlatTabControl2, TFlatPanelUnit,
  u_comp_TBlueFlatSpeedButton, Menus, Mask, dxDBCtrl,
  dxDBTLCl, dxEditor, dxEdLib, dxDBELib, TFlatButtonUnit,
  TFlatSpeedButtonUnit, dxExEdtr, RVStyle, RVScroll, RichView,
  u_objet_TIntegerList, TFlatSplitterUnit, Buttons, OleCtrls, SHDocVw,
  u_comp_TGoodBtn, u_comp_TYLanguage, DynamicSkinForm;

type
  TFIndividuPrenom = class(TSuperForm)
    IBQListeNom: TIBQuery;
    IBQListeNomNOM: TIBStringField;
    dsListeNom: TDataSource;
    pmGrid: TPopupMenu;
    Envoirplusdanslagrille: TMenuItem;
    N1: TMenuItem;
    mOuvrir: TMenuItem;
    mOuvrirFiche: TMenuItem;
    N2: TMenuItem;
    ExporterenHTML1: TMenuItem;
    IBQListePreNom: TIBQuery;
    IBQListePreNomCLE_FICHE: TIntegerField;
    IBQListePreNomPRENOM: TIBStringField;
    IBQListePreNomDATE_NAISSANCE: TIBStringField;
    IBQListePreNomLIEU_NAISSANCE: TIBStringField;
    IBQListePreNomDATE_DECES: TIBStringField;
    IBQListePreNomLIEU_DECES: TIBStringField;
    IBQListePreNomSEXE: TIntegerField;
    IBQListePreNomNOM_PERE: TIBStringField;
    IBQListePreNomPRENOM_PERE: TIBStringField;
    IBQListePreNomPERE_DATE_NAISSANCE: TIBStringField;
    IBQListePreNomPERE_LIEU_NAISSANCE: TIBStringField;
    IBQListePreNomPERE_CLE_FICHE: TIntegerField;
    IBQListePreNomNOM_MERE: TIBStringField;
    IBQListePreNomPRENOM_MERE: TIBStringField;
    IBQListePreNomMERE_DATE_NAISSANCE: TIBStringField;
    IBQListePreNomMERE_LIEU_NAISSANCE: TIBStringField;
    IBQListePreNomMERE_CLE_FICHE: TIntegerField;
    IBQListePreNomINFOS_SUPP: TStringField;
    DSListePreNom: TDataSource;
    pBorder: TPanel;
    panBtn: TPanel;
    pBottom: TFlatPanel;
    panTopSpace: TPanel;
    Panel1: TPanel;
    RVStyle: TRVStyle;
    Panel2: TPanel;
    panTabs: TPanel;
    PaintBoxOnglet: TPaintBox;
    Panel5: TPanel;
    Panel11: TPanel;
    Panel13: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel6: TPanel;
    Panel7: TPanel;
    panDock: TPanel;
    Panel8: TPanel;
    rbF: TdxCheckEdit;
    rbH: TdxCheckEdit;
    rbTous: TdxCheckEdit;
    Panel9: TPanel;
    rv: TRichView;
    Panel10: TPanel;
    bsfbSelection: TGoodBtn;
    btnFermer: TGoodBtn;
    bfsbCreation: TGoodBtn;
    dxDBGrid2: TdxDBGrid;
    dxDBGridImageColumn1: TdxDBGridImageColumn;
    dxDBGCPrenoms: TdxDBGridColumn;
    dxDBGrid2Column3: TdxDBGridColumn;
    dxDBGrid1: TdxDBGrid;
    dxDBGCNom: TdxDBGridColumn;
    FlatSplitter1: TFlatSplitter;
    lbParPrenom: TLabel;
    Panel14: TPanel;
    Panel15: TPanel;
    Panel16: TPanel;
    SaveDialog: TSaveDialog;
    Language: TYLanguage;
    spDynamicSkinForm1: TspDynamicSkinForm;
    procedure IBQListeNomAfterScroll(DataSet: TDataSet);
    procedure dxDBGrid2DblClick(Sender: TObject);
    procedure IBQListePreNomAfterScroll(DataSet: TDataSet);
    procedure pmGridPopup(Sender: TObject);
    procedure SuperFormCreate(Sender: TObject);
    procedure ExporterenHTML1Click(Sender: TObject);
    procedure EnvoirplusdanslagrilleClick(Sender: TObject);
    procedure IBQListePreNomCalcFields(DataSet: TDataSet);
    procedure SuperFormShowFirstTime(Sender: TObject);
    procedure rbTousChange(Sender: TObject);
    procedure rbHChange(Sender: TObject);
    procedure rbFChange(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure bsfbSelectionClick(Sender: TObject);
    procedure pTopMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure bfsbCreationClick(Sender: TObject);
    procedure mOuvrirFicheClick(Sender: TObject);
    procedure rvJump(Sender: TObject; id: Integer);
    procedure PaintBoxOngletMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure PaintBoxOngletPaint(Sender: TObject);
    procedure SuperFormDestroy(Sender: TObject);
    procedure Label10MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SuperFormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SuperFormRefreshControls(Sender: TObject);
  private
    fNumOngletSelected: integer;
    fTextesOnglets: TStringList;

    fDialogMode: boolean;
    fFill: boolean;
    fClefIndividuSelected: integer;
    fNomPrenomIndividuSelected: string;
    fSexeIndividuSelected: integer;
    fSexe: integer;
    fNom: string;

    fIndiCle: TIntegerList;
    fIndiJumpTag: TIntegerList;

    fCanScrollPrenom, fCanScrollNom: boolean;
    fDecesIndividuSelected: string;
    fNaissanceIndividuSelected: string;
    fModeSosa: boolean;
    procedure doTellToOpenIndividuAndClose;
    procedure doFillBottomInfos;
    procedure doSelect;
    procedure SetTabByPositionMouse(x: integer);
    procedure SetNumOngletSelected(index: integer);
    procedure doRefreshPrenoms;

  public
    //en entre
    procedure SetIncrustMode;

    //en sortie
    property ClefIndividuSelected: integer read fClefIndividuSelected write fClefIndividuSelected;
    property NomPrenomIndividuSelected: string read fNomPrenomIndividuSelected write fNomPrenomIndividuSelected;
    property SexeIndividuSelected: integer read fSexeIndividuSelected write fSexeIndividuSelected;
    property NaissanceIndividuSelected: string read fNaissanceIndividuSelected write fNaissanceIndividuSelected;
    property DecesIndividuSelected: string read fDecesIndividuSelected write fDecesIndividuSelected;
    property Sexe: integer read fSexe write fSexe;
    property NomIndi: string read fNom write fNom;

    //en lecture
    property DialogMode: boolean read fDialogMode;
    property ModeSosa: boolean read fModeSosa write fModeSosa;

    procedure up_InitIndividuPrenom(a_Lettre, a_Type: string; a_Sexe, a_Mode: integer);
    procedure doRefreshRepertoire;

    function GetCleFicheSelected: integer;
    function GetNomFicheSelected: string;
  end;

implementation

uses u_dm, u_form_main, u_form_individu, u_form_individu_Saisie_Rapide,
  u_common_func, u_common_var, u_common_const;
{$R *.DFM}

procedure TFIndividuPrenom.up_InitIndividuPrenom(a_Lettre, a_Type: string; a_Sexe, a_Mode: integer);
var i_Tab: smallInt;
begin

  if a_Type = 'SOSA' then
    begin
      bsfbSelection.Caption := 'Renumrotez';
      //Label10.Caption := 'Renumrotation SOSA';
      ExporterenHTML1.Visible := false;
      mOuvrir.Visible := false;
      N2.Visible := false;
    end;

  i_Tab := POS(a_Lettre, 'ABCDEFGHIJKLMNOPQRSTUVWXYZ') - 1;

  fSexe := a_Sexe;

  SetNumOngletSelected(i_Tab);

  fFill := true;
  try
    case a_Sexe of

      1: begin
          rbTous.checked := false;
          rbH.checked := true;
          rbF.checked := false;
        end;

      2: begin
          rbTous.checked := false;
          rbH.checked := false;
          rbF.checked := true;
        end;
      else
        begin
          rbTous.checked := true;
          rbH.checked := false;
          rbF.checked := false;
        end;
    end;

  finally
    fFill := false;
  end;

  doRefreshRepertoire;
end;

procedure TFIndividuPrenom.doRefreshRepertoire;
var
  debut: string;
begin
  fCanScrollNom := false;

  if fNumOngletSelected >= 0
    then debut := copy('ABCDEFGHIJKLMNOPQRSTUVWXYZ', fNumOngletSelected + 1, 1) //nom commenant par
  else debut := ''; //tout le monde

  with IBQListeNom do begin
      DisableControls;
      try
        Close;
        params[0].AsString := debut;
        params[1].AsInteger := dm.NumDossier;
        Open;

        if sexe = 1 then
          IBQListeNom.Locate('NOM', NomIndi, [loPartialKey]);

      finally
        EnableControls;
        fCanScrollNom := true;
        IBQListeNomAfterScroll(IBQListeNom);
      end;
    end;

  doRefreshControls;
end;

procedure TFIndividuPrenom.IBQListeNomAfterScroll(DataSet: TDataSet);
begin
  if fCanScrollNom then
    begin
      doRefreshPrenoms;
    end;
end;

procedure TFIndividuPrenom.doRefreshPrenoms;
var i_sexe: smallint;
  fTryToSelectCleFiche: integer;
begin
  i_Sexe := 0;

  if rbTous.Checked then
    i_sexe := 0
  else if rbH.Checked then
    i_sexe := 1
  else if rbF.Checked then
    i_sexe := 2;

  IBQListePreNom.DisableControls;
  try
    fCanScrollPrenom := false;

    fTryToSelectCleFiche := -1;
    try
      if IBQListePreNom.Active then
        if IBQListePreNom.RecordCount > 0
          then fTryToSelectCleFiche := IBQListePreNom.FieldByName('CLE_FICHE').AsInteger;
    except
    end;

    IBQListePreNom.Close;
    IBQListePreNom.params[0].AsString := IBQListeNomNOM.AsString;
    IBQListePreNom.params[1].AsInteger := dm.NumDossier;
    IBQListePreNom.params[2].AsInteger := 2; //rgEtat.ItemIndex;
    IBQListePreNom.params[3].AsInteger := i_Sexe;
    IBQListePreNom.Open;

    if fTryToSelectCleFiche <> -1 then
      begin
        IBQListePreNom.Locate('CLE_FICHE', fTryToSelectCleFiche, []);
      end;

    dxDBGrid2.ColumnByName('dxDBGCPrenoms').Caption := IBQListeNomNOM.AsString;
  finally
    IBQListePreNom.EnableControls;
    fCanScrollPrenom := true;
    IBQListePreNomAfterScroll(IBQListePreNom);
  end;

  DoRefreshControls;
end;

procedure TFIndividuPrenom.ExporterenHTML1Click(Sender: TObject);
var
  b: boolean;
  SavePlace: TBookmark;
begin
  SavePlace := nil;

  if SaveDialog.Execute then
    begin
      b := fCanScrollPrenom;
      fCanScrollPrenom := false;
      try
        IBQListePreNom.DisableControls;
        try
          SavePlace := IBQListePreNom.GetBookmark;
          dxDBGrid2.SaveToHTML(SaveDialog.FileName, True);
        finally
          IBQListePreNom.GotoBookmark(SavePlace);
          IBQListePreNom.FreeBookmark(SavePlace);
          IBQListePreNom.EnableControls;
        end;
      finally
        fCanScrollPrenom := b;
      end;
    end;
end;

procedure TFIndividuPrenom.EnvoirplusdanslagrilleClick(Sender: TObject);
begin
  Envoirplusdanslagrille.Checked := not Envoirplusdanslagrille.Checked;

  if Envoirplusdanslagrille.Checked then
    dxDBGrid2.Options := dxDBGrid2.Options + [egoPreview]
  else
    dxDBGrid2.Options := dxDBGrid2.Options - [egoPreview];

end;

procedure TFIndividuPrenom.IBQListePreNomCalcFields(DataSet: TDataSet);
var s: string;
begin

  s := '';

  if IBQListePreNomLIEU_NAISSANCE.AsString <> '' then
    s := 'N(e)  ' + IBQListePreNomLIEU_NAISSANCE.AsString;

  if IBQListePreNomDATE_DECES.AsString <> '' then
    if Length(s) = 0 then
      s := ' Dcd(e) : ' + IBQListePreNomDATE_DECES.AsString
    else
      s := s + ' - Dcd(e) : ' + IBQListePreNomDATE_DECES.AsString;

  if IBQListePreNomLIEU_DECES.AsString <> '' then
    if Length(s) = 0 then
      s := ' Dcd(e)  ' + IBQListePreNomLIEU_DECES.AsString
    else
      s := s + ' -  ' + IBQListePreNomLIEU_DECES.AsString;

  IBQListePreNomINFOS_SUPP.AsString := s;

end;

procedure TFIndividuPrenom.SetIncrustMode;
begin
  fDialogMode := false;
  BorderStyle := bsNone;

  panBtn.visible := false;
  panTopSpace.visible := false;

  pBorder.BevelOuter := bvNone;
  pBorder.BorderWidth := 0;
end;


procedure TFIndividuPrenom.SuperFormShowFirstTime(Sender: TObject);
begin
  bfsbCreation.visible := not fModeSosa;

  lbParPrenom.visible := fDialogMode;
  if fDialogMode then
    begin
      panel1.BorderWidth := 5;
      pBottom.Show;
    end;
end;

procedure TFIndividuPrenom.dxDBGrid2DblClick(Sender: TObject);
begin
  doSelect;
end;


procedure TFIndividuPrenom.doTellToOpenIndividuAndClose;
begin
  dm.FicheActive := IBQListePreNomCLE_FICHE.AsInteger;

  AutoFreeOnClose := true;
  DoSendMessage(Owner, 'OPEN_FICHE_INDIVIDU_FROM_LISTE_PAR_PRENOM');
  Close;
end;

procedure TFIndividuPrenom.IBQListePreNomAfterScroll(DataSet: TDataSet);
begin
  if fCanScrollPrenom then
    begin
      doFillBottomInfos;

      if IBQListePreNomSEXE.AsInteger = 1 then
        panel9.Color := _Context.ColorHomme
      else
        panel9.Color := _Context.ColorFemme;

    end;
end;

procedure TFIndividuPrenom.pmGridPopup(Sender: TObject);
begin
  if (IBQListePreNom.active) and (IBQListePreNom.IsEmpty = false) then
    begin
      Envoirplusdanslagrille.enabled := true;
      ExporterenHTML1.enabled := true;
      mOuvrir.enabled := true;
      mOuvrirFiche.enabled := true;
    end
  else
    begin
      Envoirplusdanslagrille.enabled := false;
      ExporterenHTML1.enabled := false;
      mOuvrir.enabled := false;
      mOuvrirFiche.enabled := false;
    end;
end;

procedure TFIndividuPrenom.SuperFormCreate(Sender: TObject);
var
  n: integer;
begin
  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  if _Context.Skin then
    begin
      ClientHeight := 473;
      ClientWidth := 615;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;

  fModeSosa := false;
  SaveDialog.InitialDir := _Context.PathImportExport;

  fTextesOnglets := TStringList.create;
  for n := 0 to 25 do fTextesOnglets.Add(chr(ord('A') + n));

  SetNumOngletSelected(0);

  fDialogMode := True;
  fClefIndividuSelected := -1;
  fNomPrenomIndividuSelected := '';
  SexeIndividuSelected := -1;
  fDecesIndividuSelected := '';
  fNaissanceIndividuSelected := '';

  fFill := false;
  fIndiCle := TIntegerList.create;
  fIndiJumpTag := TIntegerList.create;
end;

procedure TFIndividuPrenom.rbTousChange(Sender: TObject);
//var SavePlace: TBookmark;
begin
  //     SavePlace := IBQListeNom.GetBookmark;

  if not fFill then
    begin
      fFill := true;
      try
        rbTous.checked := true;
        rbH.checked := false;
        rbF.checked := false;

      finally
        fFill := false;
      end;

      doRefreshPrenoms;
      //          doRefreshRepertoire;
    end;


  //    IBQListeNom.GotoBookmark(SavePlace);
   //   IBQListeNom.FreeBookmark(SavePlace);
end;

procedure TFIndividuPrenom.rbHChange(Sender: TObject);
//var SavePlace: TBookmark;
begin
  //   SavePlace := IBQListeNom.GetBookmark;
  if not fFill then
    begin
      fFill := true;
      try
        rbTous.checked := false;
        rbH.checked := true;
        rbF.checked := false;

      finally
        fFill := false;
      end;
      doRefreshPrenoms;
      //          doRefreshRepertoire;
    end;
  //   IBQListeNom.GotoBookmark(SavePlace);
   //  IBQListeNom.FreeBookmark(SavePlace);
end;

procedure TFIndividuPrenom.rbFChange(Sender: TObject);
//var SavePlace: TBookmark;
begin
  //   SavePlace := IBQListeNom.GetBookmark;

  if not fFill then
    begin
      fFill := true;
      try
        rbH.checked := false;
        rbTous.checked := false;
        rbF.checked := true;
      finally
        fFill := false;
      end;
      doRefreshPrenoms;
      //          doRefreshRepertoire;
    end;
  //   IBQListeNom.GotoBookmark(SavePlace);
   //  IBQListeNom.FreeBookmark(SavePlace);
end;

procedure TFIndividuPrenom.SpeedButton2Click(Sender: TObject);
begin
  ModalResult := mrCancel;
  Close;
end;

procedure TFIndividuPrenom.bsfbSelectionClick(Sender: TObject);
begin
  doSelect;
end;

procedure TFIndividuPrenom.doSelect;
begin
  fClefIndividuSelected := IBQListePreNomCLE_FICHE.AsInteger;
  fNomPrenomIndividuSelected := AssembleString([IBQListeNom.FieldByName('NOM').AsString,
    IBQListePreNomPRENOM.AsString]);
  SexeIndividuSelected := IBQListePreNomSEXE.AsInteger;

  fNaissanceIndividuSelected := IBQListePreNomDATE_NAISSANCE.AsString;
  fDecesIndividuSelected := IBQListePreNomDATE_DECES.AsString;

  if fDialogMode = false
    then doTellToOpenIndividuAndClose
  else ModalResult := mrOk;
end;

procedure TFIndividuPrenom.doFillBottomInfos;
const
  crlf: string = chr(13) + chr(10);
var
  JumpTag: integer;
  s, s2, s3: string;
  sexe: integer;
begin
  rv.Clear;
  rv.FirstJumpNo := 0;
  JumpTag := 0;
  fIndiJumpTag.Clear;
  fIndiCle.Clear;

  sexe := IBQListePreNomSEXE.AsInteger;

  //le nom
  s := trim(AssembleString([IBQListeNomNOM.AsString, IBQListePreNomPRENOM.AsString]));
  if s <> '' then
    begin
      case sexe of
        1: RVStyle.TextStyles.Items[2].Color := _Context.ColorHomme;
        2: RVStyle.TextStyles.Items[2].Color := _Context.ColorFemme;
        else
          RVStyle.TextStyles.Items[2].Color := clBlack;
      end;

      rv.Add(s, rvsSubheading);
      rv.AddTextFromNewLine(' ', rvsNormal);
    end;

  //N(e) le ?
  s := trim(IBQListePreNomDATE_NAISSANCE.AsString);
  if s <> '' then
    begin
      //selon le sexe :
      case sexe of
        1: s3 := 'N le';
        2: s3 := 'Ne le';
        else
          s3 := 'N(e) le';
      end;

      s := '                 ' + s3 + ' ' + s;

      // ?
      s2 := trim(IBQListePreNomLIEU_NAISSANCE.AsString);
      if s2 <> '' then s := s + '   ' + '' + ' ' + s2;

      rv.Add(s, rvsNormal);
      rv.AddTextFromNewLine(' ', rvsNormal);
    end;
  rv.AddTextFromNewLine(' ', rvsNormal);


  //le pre
  s := trim(AssembleString([IBQListePreNomNOM_PERE.AsString, IBQListePreNomPRENOM_PERE.AsString]));
  if s <> '' then
    begin
      RVStyle.TextStyles.Items[4].Color := _Context.ColorHomme;
      rv.Add('son pre : ', rvsNormal);
      rv.Add(s, rvsJump1);
      fIndiJumpTag.Add(JumpTag);
      fIndiCle.Add(IBQListePreNomPERE_CLE_FICHE.AsInteger);
      inc(JumpTag);

      rv.AddTextFromNewLine(' ', rvsNormal);


      s2 := '';
      try
        s2 := trim(IBQListePreNomPERE_DATE_NAISSANCE.AsString);
      except
      end;


      s3 := '';
      try
        s3 := trim(IBQListePreNomPERE_LIEU_NAISSANCE.AsString);
      except
      end;

      s := '';
      if s2 <> '' then
        begin
          s := 'N le ' + s2 + '   ';
        end;

      if s3 <> '' then
        begin
          s := s + ' ' + s3;
        end;

      if s <> '' then
        begin
          rv.Add('                 ' + s, rvsNormal);
        end;
      rv.AddTextFromNewLine(' ', rvsNormal);
    end;

  //la mre
  s := trim(AssembleString([IBQListePreNomNOM_MERE.AsString, IBQListePreNomPRENOM_MERE.AsString]));
  if s <> '' then
    begin
      RVStyle.TextStyles.Items[5].Color := _Context.ColorFemme;
      rv.Add('sa mre  : ', rvsNormal);
      rv.Add(s, rvsJump2);
      fIndiJumpTag.Add(JumpTag);
      fIndiCle.Add(IBQListePreNomMERE_CLE_FICHE.AsInteger);

      //inc(JumpTag);

      rv.AddTextFromNewLine(' ', rvsNormal);


      s2 := '';
      try
        s2 := trim(IBQListePreNomMERE_DATE_NAISSANCE.AsString);
      except
      end;


      s3 := '';
      try
        s3 := trim(IBQListePreNomMERE_LIEU_NAISSANCE.AsString);
      except
      end;

      s := '';
      if s2 <> '' then
        begin
          s := 'Ne le ' + s2 + '   ';
        end;

      if s3 <> '' then
        begin
          s := s + ' ' + s3;
        end;

      if s <> '' then
        begin
          rv.Add('                 ' + s, rvsNormal);
        end;
    end;

  rv.format;
  rv.Paint;
end;

procedure TFIndividuPrenom.pTopMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFIndividuPrenom.bfsbCreationClick(Sender: TObject);
var
  aFIndividuSaisieRapide: TFIndividuSaisieRapide;
begin

  aFIndividuSaisieRapide := TFIndividuSaisieRapide.create(self);
  aFIndividuSaisieRapide.Sexe := Sexe;
  try
    if aFIndividuSaisieRapide.ShowModal = mrOk then
      begin
        // dm.up_RenumSosa(TFIndividuSaisieRapide.ClefIndividuSelected);
      end;
  finally

    up_InitIndividuPrenom(Copy(aFIndividuSaisieRapide.NomFiche, 1, 1), '', aFIndividuSaisieRapide.Sexe, 2);
    IBQListeNom.Locate('NOM', aFIndividuSaisieRapide.NomFiche, [loPartialKey]);

    aFIndividuSaisieRapide.Free;

  end;

end;

procedure TFIndividuPrenom.mOuvrirFicheClick(Sender: TObject);
begin
  OpenFicheIndividuInBox(IBQListePreNomCLE_FICHE.AsInteger);
end;

procedure TFIndividuPrenom.rvJump(Sender: TObject; id: Integer);
var
  k: integer;
begin
  k := fIndiJumpTag.IndexOf(id);
  if k <> -1 then
    begin
      dm.FicheActive := fIndiCle[k];

      AutoFreeOnClose := true;
      DoSendMessage(Owner, 'OPEN_FICHE_INDIVIDU_FROM_LISTE_PAR_PRENOM');
      Close;
    end;
end;

function TFIndividuPrenom.GetCleFicheSelected: integer;
begin
  if IBQListePreNom.RecordCount > 0
    then result := IBQListePreNomCLE_FICHE.AsInteger
  else result := -1;
end;


function TFIndividuPrenom.GetNomFicheSelected: string;
begin
  if IBQListePreNom.RecordCount > 0
    then result := AssembleString([IBQListeNomNOM.AsString, IBQListePreNomPRENOM.AsString])
  else result := '';
end;

procedure TFIndividuPrenom.PaintBoxOngletMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var p: TPoint;
begin
  p := TControl(Sender).ClientToScreen(Point(X, Y));
  p := panTabs.ScreenToClient(p);
  //  p.x := p.x - 3;

  SetTabByPositionMouse(p.x);
end;

procedure TFIndividuPrenom.SetTabByPositionMouse(x: integer);
var k: integer;
begin
  k := (x div 21);
  if k < 0 then k := 0;
  if k > 25 then k := 25;
  if k <> fNumOngletSelected then
    begin
      SetNumOngletSelected(k);
      doRefreshRepertoire;
    end;
end;

procedure TFIndividuPrenom.PaintBoxOngletPaint(Sender: TObject);
begin
  PaintOnglet(PaintBoxOnglet, 26, fNumOngletSelected, 25, 18, clBlack, $00C5E8F3, $008FC6D8, fTextesOnglets);
end;

procedure TFIndividuPrenom.SetNumOngletSelected(index: integer);
begin
  fNumOngletSelected := index;
  PaintBoxOnglet.Refresh;
end;


procedure TFIndividuPrenom.SuperFormDestroy(Sender: TObject);
begin
  fTextesOnglets.free;
end;

procedure TFIndividuPrenom.Label10MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFIndividuPrenom.SuperFormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
    VK_ESCAPE: ModalResult := mrCancel;
    _KEY_HELP: dm.ShowHelp(_ID_RECHERCHER);
  end;
end;

procedure TFIndividuPrenom.SuperFormRefreshControls(Sender: TObject);
begin
  bsfbSelection.enabled := (IBQListeNom.Active) and (IBQListeNom.IsEmpty = false);
end;

end.
