{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{           1     ,01/01/2002 ,Philippe Cazaux-Moutou  ,                 }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_No_Dossier;

interface

uses
  Windows, Messages, CompSuperForm, Classes, Controls, ExtCtrls, Sysutils,
  TFlatSpeedButtonUnit, StdCtrls, OleCtrls, SHDocVw, Forms,
  u_comp_TGoodBtn, u_comp_TYLanguage;

type
  TFNoDossier = class(TSuperForm)
    Label14: TLabel;
    Label13: TLabel;
    FlatSpeedButton1: TGoodBtn;
    Language: TYLanguage;
    procedure FlatSpeedButton1Click(Sender: TObject);
    procedure SuperFormShowFirstTime(Sender: TObject);
    procedure SuperFormCreate(Sender: TObject);
  private

  public

  end;

var
  FNoDossier: TFNoDossier;

implementation

uses u_dm, u_form_select_dossier, u_common_const, u_common_var;

{$R *.DFM}

procedure TFNoDossier.FlatSpeedButton1Click(Sender: TObject);
var
  aFSelectDossier: TFSelectDossier;
begin
  aFSelectDossier := TFSelectDossier.create(self);
  try
    aFSelectDossier.ShowModal;
    //          dm.up_Comptage(0);
  finally
    aFSelectDossier.Free;
  end;
end;

procedure TFNoDossier.SuperFormShowFirstTime(Sender: TObject);
var
  Flags: OLEVariant;
begin
  Flags := 0;
  //     WebBrowser1.Navigate(WideString('file://' + extractFilePath(Application.exeName) + 'help/Un_Dossier.htm'), Flags, Flags, Flags, Flags);

end;

procedure TFNoDossier.SuperFormCreate(Sender: TObject);
begin
  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;
end;

end.
