{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                                                     }
{           Philippe Cazaux-Moutou                                      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}
unit u_form_main;

interface

uses
  Forms, Windows, CompSuperForm, Menus, TFlatSpeedButtonUnit, URLLink, Controls,
  dxBar, MaxInstance, TFlatHintUnit, StdCtrls, GraphicEx, ExtCtrls, Graphics,
  Classes, u_comp_TYLanguage, u_comp_TNakedSpeedButton, dxCntner, dxEditor, dxExEdtr,
  dxEdLib, dxGrDate, SysUtils, Messages, jpeg, Tabs, Buttons, Dialogs, dxDBCtrl,
  u_dm, ShellApi, IniFiles, Registry,
  u_form_navigation,
  u_form_individu,
  u_form_list_report,
  u_form_rechercher,
  u_form_anniversaires,
  u_form_list_villes,
  u_form_repertoire,
  u_form_arbre,
  u_form_import_gedcom,
  u_form_export_gedcom,
  u_form_graph_paintbox,
  u_form_graph_miniature,
  u_objet_TGraphArbre,
  u_objet_TGraphRoue,
  u_form_export_geneanet,
  u_form_graph_config_hierarchie,
  u_form_graph_config_roue,
  u_form_postit,
  u_form_No_Dossier,
  u_form_edit_ref_particules,
  u_form_edit_ref_prefixes,
  u_form_edit_ref_religions,
  u_form_edit_ref_token_date,
  u_form_edit_raccourcis,
  u_form_individu_connector,
  u_form_select_database,
  u_Form_Restore,
  u_Form_WEB,
  u_form_OpenSources,
  u_form_language,
  u_comp_TBlueFlatSpeedButton,
  u_form_individu_par_prenom, ImgList, dxPSGlbl, dxPSUtl, dxPSEngn,
  dxPrnPg, dxBkgnd, dxWrap, dxPrnDev, dxPSGraphicLnk, dxPSdxOCLnk,
  dxPSCore, dxPSdxTLLnk, dxPSdxDBCtrlLnk, dxPSdxDBGrLnk, dxPgsDlg,
  dxPSImgLnk, u_comp_TInfoVersion, DynamicSkinForm, SkinData, spTrayIcon,
  SkinMenus, SkinCtrls, SkinHint, OleCtrls, AgentObjects_TLB;

type
  TFMain = class(TSuperForm)

    (* Les decos -------------------------------------------*)
    Image1: TImage;
    Panel7: TPanel;
    panGauche: TPanel;
    Panel11: TPanel;
    Panel3: TPanel;
    Panel6: TPanel;
    Panel1: TPanel;
    Panel5: TPanel;
    panDock: TPanel;
    Panel8: TPanel;
    Panel9: TPanel;
    Panel10: TPanel;
    URLLink3: TURLLink;
    panDockOptions: TPanel;
    panOptions: TPanel;
    Panel2: TPanel;
    Panel4: TPanel;
    Panel13: TPanel;
    Panel14: TPanel;
    Panel15: TPanel;
    Panel16: TPanel;
    Panel18: TPanel;
    Image24: TImage;
    Image25: TImage;
    Panel12: TPanel;
    Image20: TImage;
    Panel19: TPanel;
    Panel20: TPanel;
    Panel21: TPanel;
    Panel22: TPanel;
    Panel23: TPanel;
    Panel24: TPanel;
    Panel25: TPanel;
    lIndividus: TLabel;
    lImportExport: TLabel;
    lRepertoire: TURLLink;
    lFiche: TURLLink;
    lArbre: TURLLink;
    lAnniversaire: TURLLink;
    lListePrenom: TURLLink;
    lImport: TURLLink;
    lExport: TURLLink;
    lGeneanet: TURLLink;
    lImpAsc: TURLLink;
    lImpArbre: TURLLink;
    it1: TImage;
    it2: TImage;
    it3: TImage;
    it4: TImage;
    it5: TImage;
    it6: TImage;
    it7: TImage;
    it8: TImage;
    it9: TImage;
    it12: TImage;
    it10: TImage;
    lImpressions: TLabel;
    it11: TImage;
    lImpRoue: TURLLink;
    Image26: TImage;
    lDossier: TURLLink;
    lbNomDossier: TLabel;
    Panel17: TPanel;
    Image19: TImage;
    bfsbRecherche: TNakedSpeedButton;
    bfsbQuitter: TNakedSpeedButton;
    lDivers: TLabel;
    lVilles: TURLLink;
    lPref: TURLLink;
    it16: TImage;
    it18: TImage;
    Image3: TImage;
    Image4: TImage;
    URLBlockNotes: TURLLink;
    panMiniature: TPanel;
    panDockMiniature: TPanel;
    lLiensFamilliaux: TURLLink;
    MaxInstance1: TMaxInstance;
    Language: TYLanguage;
    dxBarManager: TdxBarManager;
    Dossiers1: TdxBarButton;
    Informations1: TdxBarButton;
    Blocnotes2: TdxBarButton;
    Quitter1: TdxBarButton;
    Fichier1: TdxBarSubItem;
    Rpertoire1: TdxBarButton;
    Listeparprnom1: TdxBarButton;
    FicheIndividu1: TdxBarButton;
    mSaisierapide: TdxBarButton;
    Rechercher2: TdxBarButton;
    Recherchededoublons: TdxBarButton;
    mNouveaux: TdxBarButton;
    mListeUnions: TdxBarButton;
    mCousinage: TdxBarButton;
    Arbre2: TdxBarButton;
    Anniversaires1: TdxBarButton;
    option_RenumerotationSOSA: TdxBarButton;
    Connector1: TdxBarButton;
    menu_Individu: TdxBarSubItem;
    MenuFavoris_Add: TdxBarButton;
    menu_Favoris: TdxBarSubItem;
    ImporterauformatGEDCOM1: TdxBarButton;
    ExporterauformatGEDCOM1: TdxBarButton;
    ExporterauformatGeneaNet1: TdxBarButton;
    ExportImages: TdxBarButton;
    menu_ImportExport: TdxBarSubItem;
    Arbredascendance1: TdxBarButton;
    Rouedascendance1: TdxBarButton;
    Documents1: TdxBarButton;
    menu_Impressions: TdxBarSubItem;
    Prfrences2: TdxBarButton;
    Langage1: TdxBarButton;
    Raccourissaisie1: TdxBarButton;
    Prfixes1: TdxBarButton;
    Religions1: TdxBarButton;
    Particules1: TdxBarButton;
    Motsclefsutilissdanslesdates1: TdxBarButton;
    VillesCodes1: TdxBarButton;
    Emplacementdelabasededonne1: TdxBarButton;
    mOptimise: TdxBarButton;
    menu_Configuration: TdxBarSubItem;
    Commentamarche1: TdxBarButton;
    Documentation1: TdxBarButton;
    menu_go_web_ancestrologie: TdxBarButton;
    Aide1: TdxBarSubItem;
    iBars4: TImage;
    dxBarButton1: TdxBarButton;
    dxBBLieuxFavoris: TdxBarButton;
    Partenaires: TdxBarButton;
    dxbDelFavoris: TdxBarButton;
    mOpenSource: TdxBarButton;
    mAddon: TdxBarSubItem;
    lExit: TLabel;
    lEnteteColonne: TLabel;
    mDLLLoad: TdxBarButton;
    mNaissVilles: TdxBarButton;
    mDecesVilles: TdxBarButton;
    mCalendrier: TdxBarButton;
    mOrphelins: TdxBarButton;
    mSansVilles: TdxBarButton;
    mPosthume: TdxBarButton;
    mVerif: TdxBarButton;
    msInfos: TdxBarButton;
    mMajInsee: TdxBarButton;
    mInseeCP: TdxBarButton;
    dxComponentPrinter1: TdxComponentPrinter;
    dxPLRepertoire: TdxDBGridReportLink;
    dxPLArbre: TdxOrgChartReportLink;
    dxPLVillesFavorites: TdxDBGridReportLink;
    dxPLUnions: TdxDBGridReportLink;
    dxPrintStyleManager: TdxPrintStyleManager;
    dxPrintStyleManagerStyle: TBasedxPrintStyle;
    mTagGedcom: TdxBarButton;
    dxPTags: TdxDBGridReportLink;
    mMaj: TdxBarButton;
    InfoVersion: TInfoVersion;
    dxbDoublonsVille: TdxBarButton;
    dxpNaissances: TdxDBGridReportLink;
    mBiblioSources: TdxBarButton;
    mBiblioMedias: TdxBarButton;
    dxSkins: TdxBarButton;
    spSkinData1: TspSkinData;
    OD: TOpenDialog;
    spStoredSkin1: TspStoredSkin;
    spDynamicSkinForm1: TspDynamicSkinForm;
    spTrayIcon1: TspTrayIcon;
    spSkinHint: TspSkinHint;
    sxMListeDiffusion: TdxBarButton;
    Timer: TTimer;


    (* les proc et fonctions ---------------------------------*)
    procedure OpenModuleClick(Sender: TObject);

    procedure lDossierClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure lAnniversaireClick(Sender: TObject);
    procedure SuperFormDestroy(Sender: TObject);
    procedure SuperFormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure SuperFormReceiveMessage(sender: TObject; theMessage: string);
    procedure lRechercherClick(Sender: TObject);
    procedure lVillesClick(Sender: TObject);
    procedure lPrefClick(Sender: TObject);
    procedure menu_go_web_ancestrologieClick(Sender: TObject);
    procedure option_RenumerotationSOSAClick(Sender: TObject);
    procedure mSaisierapideClick(Sender: TObject);
    procedure mListeUnionsClick(Sender: TObject);
    procedure mCousinageClick(Sender: TObject);
    procedure SuperFormRefreshControls(Sender: TObject);
    procedure MenuFavoris_AddClick(Sender: TObject);
    procedure IInformationsClick(Sender: TObject);
    procedure URLBlockNotesClick(Sender: TObject);
    procedure Particules1Click(Sender: TObject);
    procedure Prfixes1Click(Sender: TObject);
    procedure Religions1Click(Sender: TObject);
    procedure Raccourissaisie1Click(Sender: TObject);
    procedure RecherchededoublonsClick(Sender: TObject);
    procedure SuperFormFirstActivate(Sender: TObject);
    procedure SuperFormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Motsclefsutilissdanslesdates1Click(Sender: TObject);
    procedure Quitter1Click(Sender: TObject);
    procedure ExportImagesClick(Sender: TObject);
    procedure MaxInstance1TooMany(Sender: TObject);
    procedure mNouveauxClick(Sender: TObject);
    procedure Commentamarche1Click(Sender: TObject);
    procedure Documentation1Click(Sender: TObject);
    procedure Fichier1PaintBar(Sender: TObject; Canvas: TCanvas;
      const R: TRect);
    procedure dxBarButton1Click(Sender: TObject);
    procedure dxBBLieuxFavorisClick(Sender: TObject);
    procedure dxbDelFavorisClick(Sender: TObject);
    procedure mNaissVillesClick(Sender: TObject);
    procedure mDecesVillesClick(Sender: TObject);
    procedure mCalendrierClick(Sender: TObject);
    procedure mOrphelinsClick(Sender: TObject);
    procedure mSansVillesClick(Sender: TObject);
    procedure mPosthumeClick(Sender: TObject);
    procedure mVerifClick(Sender: TObject);
    procedure msInfosClick(Sender: TObject);
    procedure mMajInseeClick(Sender: TObject);
    procedure mInseeCPClick(Sender: TObject);
    procedure mTagGedcomClick(Sender: TObject);
    procedure mMajClick(Sender: TObject);
    procedure dxbDoublonsVilleClick(Sender: TObject);
    procedure mBiblioSourcesClick(Sender: TObject);
    procedure mBiblioMediasClick(Sender: TObject);
    procedure dxSkinsClick(Sender: TObject);
    procedure menu_ConfigurationPopup(Sender: TObject);
    procedure sxMListeDiffusionClick(Sender: TObject);
    procedure SuperFormClose(Sender: TObject; var Action: TCloseAction);
    procedure TimerTimer(Sender: TObject);

  private
    //  aFListVilles: TFListVilles;
    aFArbre: TFArbre;
    aFExportGedcom: TFExportGedcom;
    aFImportGedcom: TFImportGedcom;

    aFListReport: TFListReport;
    aFRepertoire: TFRepertoire;
    aFIndividuPrenom: TFIndividuPrenom;
    aFNoDossier: TFNoDossier;
    aFExportGeneanet: TFExportGeneanet;

    //graph
    aFGraphPaintBox: TFGraphPaintBox;
    aFGraphMiniature: TFGraphMiniature;

    aFEditRefParticules: TFEditRefParticules;
    aFEditRefPrefixes: TFEditRefPrefixes;
    aFEditRefReligions: TFEditRefreligions;
    aFEditRaccourcis: TFEditRaccourcis;
    aFIndividuConnector: TFIndividuConnector;
    aFSelectDatabase: TFSelectDatabase;
    aFEditRefTokenDate: TFEditRefTokenDate;
    aFRestoreDatabase: TFRestore;
    aFWeb: TFWeb;
    aFOpenSources: TFOpenSources;
    aFLanguage: TFLanguage;

    //module actif en ce moment
    fIDModuleActif: integer;

    //le prcdent module actif
    fLastIDModuleActif: integer;

    fModeMenu: integer;
    MustKillApplication: boolean;
    fDemarrageIsFinish: boolean;

    bFirsTime: boolean;

    procedure OnClickDll(sender: TObject);
    procedure doPrepareJusteAfterOpenDatabase;
    procedure ShowIndividuRecents;
    procedure DoInitAddon;

  public

    aFIndividu: TFIndividu;
    aFPostit: TFPostit;
    aGraphArbre: TGraphArbre;
    aGraphRoue: TGraphRoue;
    aFConfigHierarchie: TFGraphConfigHierarchie;
    aFConfigRoue: TFGraphConfigRoue;

    property IDModuleActif: integer read fIDModuleActif write fIDModuleActif;
    property DemarrageIsFinish: boolean read fDemarrageIsFinish;

    function CloseModuleActif: boolean;
    procedure OpenModule(ID: integer);

    procedure RefreshFavoris;
    procedure OnClickOnFavoris(sender: TObject);

    procedure RefreshMenuFavoris_Add(canAccess: boolean);
    procedure RefreshMenuFavoris_Individus(canAccess: boolean);
    procedure FirstUse;
    procedure BeforeGoHelp;
    procedure doTranslate;
    procedure doPrint(iVal: Integer);
  end;

var
  FMain: TFMain;

implementation

uses
  dxDBGrid,
  u_common_const,
  u_common_var,
  u_Form_Infos,
  u_form_individu_Saisie_Rapide,
  u_form_select_dossier,
  u_common_func,
  u_Form_Liste_Unions,
  u_form_Liste_Cousinage,
  u_rm,
  u_form_confirm_add_to_favoris,
  u_form_edit_context,
  u_Form_Liste_Doublons,
  u_Form_Liste_Nouveaux_Indi,
  u_form_Ville_Favoris,
  u_Form_Liste_Naiss_Ville,
  u_Form_Liste_Deces_Ville,
  u_form_calendriers,
  u_Form_About,
  u_Form_Orphelins,
  u_Form_SansVilles,
  u_Form_Posthumes, u_Form_Verif_Event, u_Form_InverseInsee,
  u_form_TAG_Gedcom, u_Form_Maj_Internet, u_form_list_villes_Doublons,
  u_form_Biblio_Documents,
  u_Form_Bibliotheque_Multimedia;

{$R *.DFM}


procedure TFMain.FormCreate(Sender: TObject);
var
  iCaptionHeight: integer;
  FIniFile: TIniFile;
  fReg: TRegistry;
  sr: TSearchRec;
  FileAttrs: Integer;

begin

  if not FileExists('C:\Program Files\Borland\InterBase\UDF\DLL_Majuscules.dll') then
    if FileExists(ExtractFilePath(Application.EXEName) + 'DLL_Majuscules.dll') then
      CopyFile(Pchar(ExtractFilePath(Application.EXEName) + 'DLL_Majuscules.dll'), PChar('C:\Program Files\Borland\InterBase\UDF\DLL_Majuscules.dll'), False);

  doInitAgent(_Context.UseAgent);

  if (_Context.Skin) and not (DirExists(ExtractFilePath(Application.ExeName) + 'Skins')) then
    _Context.Skin := False;

  if _Context.Skin then
    begin
      if FileExists(_Context.SkinDefault) then
        begin
          spSkinData1.ClearSkin;
          spSkinData1.LoadFromFile(_Context.SkinDefault);
          ClientHeight := 542;
          ClientWidth := 788;
        end
    end
  else
    begin
      spSkinData1.ClearSkin;
      spSkinData1.ClearAll;
    end;

  Enabled := False;
  bFirsTime := True;
  doTranslate;
  Application.ShowHint := _Context.CanSeeHint;

  iCaptionHeight := GetSystemMetrics(SM_CYCAPTION);

  if iCaptionHeight > 22 then
    Height := Height + (iCaptionHeight - 22);

  fDemarrageIsFinish := false;
  MustKillApplication := false;
  MaxInstance1.GetSem;

  DoInitAddon;

  Application.ProcessMessages;

  if MustKillApplication = false then
    begin

      Application.ProcessMessages;

      aFPostit := nil;
      fModeMenu := _SHOW_MENU_PRINCIPAL;
      Application.ProcessMessages;

      fIDModuleActif := -1;
      fLastIDModuleActif := -1;
      _FormNavigation := TFNavigation.create(self);
      sdxPanelText := lEnteteColonne.Caption;
      sdxGrTitleConfirm := 'Confirmation';
      sdxGrDeleteRecordQuestion := 'Supprimer l''enregistrement ?';
      sdxDeleteMultipleRecordsQuestion := 'Supprimer tous ces enregistrements ?';
      sdxGridDatePopupToday := 'Aujourd''hui';
      sdxGridDatePopupClear := 'Effacer';

    end;

  Application.ProcessMessages;

  if not _Context.IsPhilippe then
    rm := Trm.Create(Self);

  if FileExists(ExtractFilePath(Application.ExeName) + 'update.ini') then
    begin
      FIniFile := TIniFile.Create(ExtractFilePath(Application.ExeName) + 'Update.ini');
      FIniFile.WriteString('UPDATE', 'NoMineur', InfoVersion.NoMineur);
      FIniFile.WriteString('UPDATE', 'Build', InfoVersion.NoConstruction);
      FIniFile.WriteString('UPDATE', 'Date', DateTimeToStr(Now));
      FIniFile.WriteString('UPDATE', 'Nom', Application.Title);
      FIniFile.WriteString('UPDATE', 'Version', InfoVersion.Version);
      FIniFile.WriteString('UPDATE', 'Taille', '');

      if FindFirst(Application.ExeName, FileAttrs, sr) = 0 then

        begin
          // ShowMessage(Format('%n',[sr.Size]));
          FIniFile.WriteString('UPDATE', 'Taille', IntToStr(sr.Size));
          FindClose(sr);
        end;
      FIniFile.Free;

    end;

  // ici on vire la clef de l ancienne version -------------
  fReg := TRegIniFile.create;
  try
    fReg.RootKey := HKEY_CURRENT_USER;
    if fReg.OpenKey('\SOFTWARE\Ancestro2001', False) then
      fReg.DeleteKey('\SOFTWARE\Ancestro2001');
  finally
    fReg.Free;
  end;

  //  bFirsTime := False;

end;

procedure TFMain.OpenModuleClick(Sender: TObject);
begin
  Screen.Cursor := crArrow;
  Application.ProcessMessages;

  if (fIDModuleActif <> TComponent(sender).Tag) then
    begin
      if CloseModuleActif then OpenModule(TComponent(sender).Tag);
    end;
end;

procedure TFMain.OpenModule(ID: integer);

begin
  FMain.Caption := Application.Title;
  case ID of

    _ID_NO_DOSSIER:
      begin
        // fLastIDModuleActif := fIDModuleActif;

        aFNoDossier := TFNoDossier.create(self);
        aFNoDossier.ShowIncrust(panDock);

        fIDModuleActif := ID;
        RefreshMenuFavoris_Add(false);
        RefreshMenuFavoris_Individus(false);
      end;
    _ID_INDIVIDU:
      begin
        //    fLastIDModuleActif := fIDModuleActif;
        aFIndividu := TFIndividu.create(self);
        aFIndividu.DialogMode := false;
        aFIndividu.LocateOnFirstIndividuDossierIfNotFind := true;
        aFIndividu.ProposeToCreateNewIndividuIfNotFind := true;

        //                    aFIndividu.CleFiche := dm.FicheActive;
        //                    aFIndividu.SetIncrustMode;
        aFIndividu.ShowIncrust(panDock);
        Application.ProcessMessages;

        aFIndividu.doOpenFiche(dm.FicheActive);

        fIDModuleActif := ID;
        RefreshMenuFavoris_Add(true);
        RefreshMenuFavoris_Individus(true);
      end;

    _ID_CONNECTOR:
      begin
        aFIndividuConnector := TFIndividuConnector.create(self);
        if aFIndividuConnector.Prepare then
          begin
            fIDModuleActif := ID;
            aFIndividuConnector.ShowIncrust(panDock);
          end
        else aFIndividuConnector.free;
        RefreshMenuFavoris_Add(false);
        RefreshMenuFavoris_Individus(true);
      end;


    _ID_INDIVIDU_PAR_PRENOM:
      begin
        //    fLastIDModuleActif := fIDModuleActif;
        aFIndividuPrenom := TFIndividuPrenom.create(self);
        aFIndividuPrenom.SetIncrustMode;
        aFIndividuPrenom.up_InitIndividuPrenom('A', '', 0, 2);
        aFIndividuPrenom.ShowIncrust(panDock);
        fIDModuleActif := ID;

        RefreshMenuFavoris_Add(true);
        RefreshMenuFavoris_Individus(true);
      end;
    _ID_REPERTOIRE:
      begin
        //    fLastIDModuleActif := fIDModuleActif;
        aFRepertoire := TFRepertoire.create(self);
        //                    aFRepertoire.up_InitRepertoire('A', 0, 2);
        aFRepertoire.InitRepertoireWithFicheActive;
        aFRepertoire.ShowIncrust(panDock);

        fIDModuleActif := ID;

        RefreshMenuFavoris_Add(true);
        RefreshMenuFavoris_Individus(true);
      end;
    _ID_ARBRE:
      begin
        //    fLastIDModuleActif := fIDModuleActif;
        aFArbre := TFArbre.create(self);
        aFArbre.Init_Arbre;
        aFArbre.ShowIncrust(panDock);
        fIDModuleActif := ID;

        RefreshMenuFavoris_Add(true);
        RefreshMenuFavoris_Individus(true);
      end;
    _ID_IMPORTATION_GEDCOM:
      begin
        //    fLastIDModuleActif := fIDModuleActif;
        aFImportGedcom := TFImportGedcom.create(self);
        aFImportGedcom.ShowIncrust(panDock);
        fIDModuleActif := ID;

        RefreshMenuFavoris_Add(false);
        RefreshMenuFavoris_Individus(false);
      end;
    _ID_EXPORTATION_GEDCOM:
      begin
        RefreshMenuFavoris_Add(false);
        RefreshMenuFavoris_Individus(false);

        //   fLastIDModuleActif := fIDModuleActif;
        aFExportGedcom := TFExportGedcom.create(self);
        aFExportGedcom.ShowIncrust(panDock);
        fIDModuleActif := ID;

        RefreshMenuFavoris_Add(false);
        RefreshMenuFavoris_Individus(true);
      end;

    _ID_PRINT_ARBRE:
      begin
        panMiniature.Visible := true;
        //la miniature
        aFGraphMiniature := TFGraphMiniature.create(self);

        aFGraphMiniature.ShowIncrust(panDockMiniature);
        Application.ProcessMessages;

        //le paintbox
        aFGraphPaintBox := TFGraphPaintBox.create(self);
        aFGraphPaintBox.GraphMiniature := aFGraphMiniature;


        //la boite de configuration du graph
        aFConfigHierarchie := TFGraphConfigHierarchie.create(self);
        aFConfigHierarchie.GraphPaintBox := aFGraphPaintBox;

        aFGraphPaintBox.PtrLabelZoom := aFConfigHierarchie.lbZoom;
        aFGraphPaintBox.PtrTrackBar := aFConfigHierarchie.TrackBar;
        aFGraphPaintBox.ShowIncrust(panDock);
        Application.ProcessMessages;

        //le module graphique
        aGraphArbre := TGraphArbre.create;

        aFConfigHierarchie.PtrGraph := aGraphArbre;

        aGraphArbre.CleIndiDepart := dm.FicheActive;
        aGraphArbre.NbGeneration := _Context.ArbreShowNbGeneration;
        //                    aGraphArbre.Canvas := aFGraphPaintBox.PaintBox.Canvas;
        aGraphArbre.Load;
        Application.ProcessMessages;

        //On branche tout a
        aFGraphPaintBox.PlugGraph(aGraphArbre);
        Application.ProcessMessages;

        aFGraphPaintBox.sbDesc.Visible := True;
        aFGraphPaintBox.edNbGeneration.IntValue := aGraphArbre.NbGeneration;
        //                    fNbGenIsModified := false;
        aFGraphPaintBox.btnRefresh.enabled := false;


        fModeMenu := _SHOW_MENU_GRAPH;
        fIDModuleActif := ID;
        Application.ProcessMessages;

        RefreshMenuFavoris_Add(false);
        RefreshMenuFavoris_Individus(true);

        doRefreshControls;

        aFConfigHierarchie.Show;
        Application.ProcessMessages;

      end;

    _ID_PRINT_ROUE:
      begin
        panMiniature.Visible := true;
        //la miniature
        aFGraphMiniature := TFGraphMiniature.create(self);
        aFGraphMiniature.ShowIncrust(panDockMiniature);
        Application.ProcessMessages;

        //le paintbox
        aFGraphPaintBox := TFGraphPaintBox.create(self);
        aFGraphPaintBox.GraphMiniature := aFGraphMiniature;

        //la boite de configuration du graph
        aFConfigRoue := TFGraphConfigRoue.create(self);
        aFConfigRoue.GraphPaintBox := aFGraphPaintBox;
        aFGraphPaintBox.sbDesc.Visible := False;

        aFGraphPaintBox.PtrLabelZoom := aFConfigRoue.lbZoom;
        aFGraphPaintBox.PtrTrackBar := aFConfigRoue.TrackBar;
        aFGraphPaintBox.ShowIncrust(panDock);
        Application.ProcessMessages;

        //le module graphique
        aGraphRoue := TGraphRoue.create;

        aFConfigRoue.PtrGraph := aGraphRoue;

        aGraphRoue.CleIndiDepart := dm.FicheActive;
        aGraphRoue.NbGeneration := _Context.RoueShowNbGeneration;
        aGraphRoue.Canvas := aFGraphPaintBox.PaintBox.Canvas;
        aGraphRoue.Load;
        Application.ProcessMessages;

        //On branche tout a
        aFGraphPaintBox.PlugGraph(aGraphRoue);
        Application.ProcessMessages;

        aFGraphPaintBox.edNbGeneration.IntValue := aGraphRoue.NbGeneration;
        aFGraphPaintBox.btnRefresh.enabled := false;

        fModeMenu := _SHOW_MENU_GRAPH;
        fIDModuleActif := ID;
        Application.ProcessMessages;

        RefreshMenuFavoris_Add(false);
        RefreshMenuFavoris_Individus(true);

        doRefreshControls;

        aFConfigRoue.Show;
        Application.ProcessMessages;
      end;

    _ID_EXPORTATION_GENEANET:
      begin
        aFExportGeneanet := TFExportGeneanet.create(self);
        aFExportGeneanet.ShowIncrust(panDock);
        Application.ProcessMessages;
        aFExportGeneanet.doPrepare;
        fIDModuleActif := ID;

        RefreshMenuFavoris_Add(false);
        RefreshMenuFavoris_Individus(false);
      end;

    _ID_PRINT:
      begin
        aFListReport := TFListReport.create(self);
        aFListReport.ShowIncrust(panDock);
        fIDModuleActif := ID;

        RefreshMenuFavoris_Add(false);
        RefreshMenuFavoris_Individus(true);
      end;

    _ID_EMPLACEMENT_BDD:
      begin
        aFSelectDatabase := TFSelectDatabase.create(self);
        aFSelectDatabase.ShowIncrust(panDock);

        RefreshMenuFavoris_Add(false);
        RefreshMenuFavoris_Individus(false);
        fIDModuleActif := ID;
      end;

    _ID_RESTORE_BDD:
      begin
        aFRestoreDatabase := TFRestore.create(self);
        aFRestoreDatabase.ShowIncrust(panDock);
        fIDModuleActif := ID;

        RefreshMenuFavoris_Add(false);
        RefreshMenuFavoris_Individus(false);
      end;

    _ID_WEB:
      begin
        aFWeb := TFWeb.create(self);
        aFWeb.ShowIncrust(panDock);
        aFWeb.WebBrowser1.Navigate(WideString('http://www.ancestrologie.com'));
        fIDModuleActif := ID;

        RefreshMenuFavoris_Add(false);
        RefreshMenuFavoris_Individus(true);
      end;

    _ID_PARTENAIRES:
      begin
        aFWeb := TFWeb.create(self);
        aFWeb.ShowIncrust(panDock);
        aFWeb.WebBrowser1.Navigate(WideString('file://' + _Path_Appli + _REL_PATH_GOODIES + _FileNamePartenaires));
        fIDModuleActif := ID;

        RefreshMenuFavoris_Add(false);
        RefreshMenuFavoris_Individus(true);
      end;

    _ID_OPENSOURCES:
      begin
        aFOpenSources := TFOpenSources.create(self);
        aFOpenSources.ShowIncrust(panDock);
        fIDModuleActif := ID;

        RefreshMenuFavoris_Add(false);
        RefreshMenuFavoris_Individus(true);

      end;

    _ID_LANGUAGE:
      begin
        aFLanguage := TFLanguage.create(self);
        aFLanguage.ShowIncrust(panDock);
        fIDModuleActif := ID;

        RefreshMenuFavoris_Add(false);
        RefreshMenuFavoris_Individus(false);
      end;

  end;

  doRefreshControls;
end;

function TFMain.CloseModuleActif: boolean;
begin
  result := true;

  case fIDModuleActif of
    _ID_NO_DOSSIER:
      begin
        fLastIDModuleActif := fIDModuleActif;
        aFNoDossier.HideIncrust;
        aFNoDossier.Free;
        aFNoDossier := nil;
      end;
    _ID_INDIVIDU:
      begin
        if aFIndividu.VerifyCanCloseFiche then
          begin
            fLastIDModuleActif := fIDModuleActif;
            aFIndividu.HideIncrust;
            aFIndividu.free;
            aFIndividu := nil;

            option_RenumerotationSOSA.enabled := true;
          end
        else
          result := false;
      end;
    _ID_CONNECTOR:
      begin
        fLastIDModuleActif := fIDModuleActif;
        aFIndividuConnector.HideIncrust;
        aFIndividuConnector.Free;
        aFIndividuConnector := nil;
      end;
    _ID_INDIVIDU_PAR_PRENOM:
      begin
        fLastIDModuleActif := fIDModuleActif;
        aFIndividuPrenom.HideIncrust;
        aFIndividuPrenom.Free;
        aFIndividuPrenom := nil;
      end;
    _ID_REPERTOIRE:
      begin
        fLastIDModuleActif := fIDModuleActif;
        aFRepertoire.HideIncrust;
        aFRepertoire.free;
        aFRepertoire := nil;
      end;
    _ID_ARBRE:
      begin
        fLastIDModuleActif := fIDModuleActif;
        aFArbre.HideIncrust;
        aFArbre.free;
        aFArbre := nil;
      end;
    _ID_IMPORTATION_GEDCOM:
      begin
        fLastIDModuleActif := fIDModuleActif;
        aFImportGedcom.HideIncrust;
        aFImportGedcom.free;
        aFImportGedcom := nil;
      end;
    _ID_EXPORTATION_GEDCOM:
      begin
        fLastIDModuleActif := fIDModuleActif;
        aFExportGedcom.HideIncrust;
        aFExportGedcom.free;
        aFExportGedcom := nil;
      end;

    _ID_PRINT_ARBRE:
      begin
        fLastIDModuleActif := fIDModuleActif;
        aFGraphPaintBox.UnplugGraph;

        //destruction de la miniature
        aFGraphPaintBox.HideIncrust;
        aFGraphPaintBox.free;
        aFGraphMiniature.free;

        //la boite de configuration du graph
        aFConfigHierarchie.free;

        //le module graphique
        aGraphArbre.free;

        fModeMenu := _SHOW_MENU_PRINCIPAL;
        doRefreshControls;
        Application.ProcessMessages;
        panMiniature.Visible := false;
      end;

    _ID_PRINT_ROUE:
      begin

        fLastIDModuleActif := fIDModuleActif;
        aFGraphPaintBox.UnplugGraph;

        //destruction de la miniature
        aFGraphPaintBox.HideIncrust;
        aFGraphPaintBox.free;
        aFGraphMiniature.free;

        //la boite de configuration du graph
        aFConfigRoue.free;

        //le module graphique
        aGraphRoue.free;

        fModeMenu := _SHOW_MENU_PRINCIPAL;
        doRefreshControls;
        Application.ProcessMessages;
        panMiniature.Visible := false;

      end;

    _ID_EXPORTATION_GENEANET:
      begin
        fLastIDModuleActif := fIDModuleActif;
        aFExportGeneanet.HideIncrust;
        aFExportGeneanet.free;
        aFExportGeneanet := nil;
      end;

    _ID_PRINT:
      begin
        fLastIDModuleActif := fIDModuleActif;
        aFListReport.HideIncrust;
        aFListReport.free;
        aFListReport := nil;
      end;

    _ID_EMPLACEMENT_BDD:
      begin
        fLastIDModuleActif := fIDModuleActif;
        aFSelectDatabase.HideIncrust;
        aFSelectDatabase.free;
        aFSelectDatabase := nil;
      end;

    _ID_RESTORE_BDD:
      begin
        fLastIDModuleActif := fIDModuleActif;
        aFRestoreDatabase.HideIncrust;
        aFRestoreDatabase.free;
        aFRestoreDatabase := nil;
      end;

    _ID_WEB:
      if _Context.ShowWeb then
        begin
          fLastIDModuleActif := fIDModuleActif;
          aFWeb.HideIncrust;
          aFWeb.free;
          aFWeb := nil;
        end;

    _ID_PARTENAIRES:
      begin
        fLastIDModuleActif := fIDModuleActif;
        aFWeb.HideIncrust;
        aFWeb.free;
        aFWeb := nil;
      end;

    _ID_OPENSOURCES:
      begin
        fLastIDModuleActif := fIDModuleActif;
        aFOpenSources.HideIncrust;
        aFOpenSources.free;
        aFOpenSources := nil;
      end;

    _ID_LANGUAGE:
      begin
        fLastIDModuleActif := fIDModuleActif;
        aFLanguage.HideIncrust;
        aFLanguage.free;
        aFLanguage := nil;
      end;

  end;

  //doRefreshControls;

  RefreshMenuFavoris_Add(false);
  RefreshMenuFavoris_Individus(false);

  if result then fIDModuleActif := -1;

  doRefreshControls;
end;

(* Ouverture des fenetres modales ----------------------------------------------*)

procedure TFMain.lDossierClick(Sender: TObject);
var
  suite: boolean;
  aFSelectDossier: TFSelectDossier;
begin
  //Si on se trouve dans la fiche individu, alors on demande de sauvegarder si la fiche est modifies
  if fIDModuleActif = _ID_INDIVIDU
    then suite := aFIndividu.VerifyCanCloseFiche
  else suite := true;

  if suite then
    begin
      //On commit avant de jouer avec les dossiers
      dm.IBT_BASE.CommitRetaining;

      aFSelectDossier := TFSelectDossier.create(self);
      try
        if aFSelectDossier.ShowModal = mrOk then
          begin
            Application.ProcessMessages;

            if CloseModuleActif then OpenModule(_ID_INDIVIDU);

            Application.ProcessMessages;
          end;
      finally
        aFSelectDossier.Free;
      end;

      doRefreshControls;
    end;
end;

procedure TFMain.lAnniversaireClick(Sender: TObject);
var
  aFAnniversaires: TFAnniversaires;
begin
  aFAnniversaires := TFAnniversaires.create(self);
  try
    aFAnniversaires.ShowModal;
  finally
    aFAnniversaires.Free;
  end;
end;

procedure TFMain.SuperFormDestroy(Sender: TObject);
begin
  Application.ProcessMessages;
  //if not _Context.IsPhilippe then rm.free;

  if aFPostit <> nil then aFPostit.free;

  _FormNavigation.Free;
  _FormNavigation := nil;

  Application.ProcessMessages;

  rm.Free;
  rm := nil;

  Application.ProcessMessages;
end;

procedure TFMain.SuperFormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := false;

  if MustKillApplication = false then
    begin
      if _Context.ShowExit then
        begin
          if MyMessageDlg(lExit.Caption, mtConfirmation, [mbYes, mbNo], 0) = mrYes then
            begin
              if CloseModuleActif then
                begin
                  Hide;
                  CanClose := True;
                  dm.doCloseDatabase;
                end;
            end
          else
            begin
              CanClose := false;
              exit;
            end;
        end
      else
        if CloseModuleActif then
          begin
            Hide;
            CanClose := true;
            dm.doCloseDatabase;
          end;
    end;
end;

procedure TFMain.SuperFormReceiveMessage(sender: TObject; theMessage: string);
var
  k: integer;
begin
  if theMessage = 'OPEN_FICHE_INDIVIDU_FROM_REPERTOIRE' then
    begin
      //le rpertoire se dtruit tout seul
      OpenModule(_ID_INDIVIDU);
    end
  else
    if theMessage = 'OPEN_FICHE_INDIVIDU_FROM_ARBRE' then
      begin
        //le rpertoire se dtruit tout seul
        OpenModule(_ID_INDIVIDU);
      end
    else
      if theMessage = 'OPEN_FICHE_INDIVIDU_FROM_LISTE_COUSINAGE' then
        begin
          //la liste cousinage se dtruit toute seule
          //soit la fiche individu est dj active
          if fIDModuleActif = _ID_INDIVIDU then
            begin
              k := dm.FicheActive;
              if aFIndividu.VerifyCanCloseFiche then
                begin
                  aFIndividu.doOpenFiche(k);
                end;
            end
          else
            //soit c'est un autre module qui est ouvert.
            begin
              if CloseModuleActif then OpenModule(_ID_INDIVIDU);
            end;
        end
      else
        if theMessage = 'OPEN_FICHE_INDIVIDU_FROM_LISTE_DOUBLONS' then
          begin
            //la liste union se dtruit toute seule
                 //soit la fiche individu est dj active
            if fIDModuleActif = _ID_INDIVIDU then
              begin
                k := dm.FicheActive;
                if aFIndividu.VerifyCanCloseFiche then
                  begin
                    aFIndividu.doOpenFiche(k);
                  end;
              end
            else
              //soit c'est un autre module qui est ouvert.
              begin
                if CloseModuleActif then OpenModule(_ID_INDIVIDU);
              end;
          end
        else
          if theMessage = 'OPEN_FICHE_INDIVIDU_FROM_LISTE_DOUBLONS' then
            begin
              //la liste union se dtruit toute seule
                   //soit la fiche individu est dj active
              if fIDModuleActif = _ID_INDIVIDU then
                begin
                  k := dm.FicheActive;
                  if aFIndividu.VerifyCanCloseFiche then
                    begin
                      aFIndividu.doOpenFiche(k);
                    end;
                end
              else
                //soit c'est un autre module qui est ouvert.
                begin
                  if CloseModuleActif then OpenModule(_ID_INDIVIDU);
                end;
            end
          else
            if theMessage = 'OPEN_FICHE_INDIVIDU_FROM_LISTE_PAR_PRENOM' then
              //la liste par prnom se dtruit toute seule
              begin
                //soit la fiche individu est dj active
                if fIDModuleActif = _ID_INDIVIDU then
                  begin
                    k := dm.FicheActive;
                    if aFIndividu.VerifyCanCloseFiche then
                      begin
                        aFIndividu.doOpenFiche(k);
                      end;
                  end
                else
                  //soit c'est un autre module qui est ouvert.
                  //il est responsable, dans ce cas, de sa propre destruction
                  begin
                    OpenModule(_ID_INDIVIDU);
                  end;
              end
            else
              if theMessage = 'OPEN_REPERTOIRE_FROM_DOSSIER' then
                //le dossier se dtruit tout seul
                begin
                  //soit le rpertoire en ouvert
                  if fIDModuleActif = _ID_REPERTOIRE then
                    begin
                      aFRepertoire.CloseAllQuerys;
                      aFRepertoire.up_InitRepertoire('A', 0, 2);
                    end
                  else
                    //soit c'est un autre module qui est ouvert.
                    //il est responsable, dans ce cas, de sa propre destruction
                    begin
                      if CloseModuleActif then OpenModule(_ID_REPERTOIRE);
                    end;
                end
              else
                if theMessage = 'OPEN_REPERTOIRE_AFTER_IMPORT' then
                  begin
                    OpenModule(_ID_REPERTOIRE);
                  end
                else
                  if theMessage = 'OPEN_IMPORT_GEDCOM_FROM_FICHE_INDIVIDU' then
                    begin
                      OpenModule(_ID_IMPORTATION_GEDCOM);
                    end
                  else
                    if theMessage = 'DO_AFTER_SELECT_DATABASE' then
                      begin
                        fIDModuleActif := -1;
                        doPrepareJusteAfterOpenDatabase;
                      end
                    else
                      if theMessage = 'DO_USE_ANCESTRO_FROM_OMED' then
                        begin
                          fIDModuleActif := -1;
                          if dm.ibd_BASE.Connected = false then FirstUse
                          else OpenModule(_ID_INDIVIDU);
                        end
                      else
                        if theMessage = 'DO_CLOSE_ANCESTRO_FROM_OMED' then
                          begin
                            {
                             fIDModuleActif := -1;
                             if dm.ibd_BASE.Connected = false then FirstUse
                             else OpenModule(_ID_INDIVIDU);
                             }
                            Close;
                          end;

  doRefreshControls;
end;

procedure TFMain.lRechercherClick(Sender: TObject);
var
  aFRechercher: TFRechercher;
begin
  aFRechercher := TFRechercher.create(self);
  try
    if aFRechercher.ShowModal = mrOk then
      begin
        //Selon le module
        case fIDModuleActif of

          _ID_INDIVIDU:
            begin
              if aFIndividu.VerifyCanCloseFiche then
                begin
                  aFIndividu.doOpenFiche(aFRechercher.CleFicheSelected);
                end;
            end;

          _ID_REPERTOIRE:
            begin
              //On ferme le rpertoire, et on montre la fiche individu
              if CloseModuleActif then
                begin
                  dm.FicheActive := aFRechercher.CleFicheSelected;
                  OpenModule(_ID_INDIVIDU);
                end;
            end;

          _ID_ARBRE:
            begin
              dm.FicheActive := aFRechercher.CleFicheSelected;
              aFArbre.Init_Arbre;
            end;

          _ID_PRINT_ARBRE, _ID_PRINT_ROUE: aFGraphPaintBox.doSelectOtherIndividu(aFRechercher.CleFicheSelected);

        end;
      end;
  finally
    aFRechercher.Free;
  end;
end;

procedure TFMain.lVillesClick(Sender: TObject);
var
  aFListVilles: TFListVilles;
begin
  aFListVilles := TFListVilles.create(self);
  try
    aFListVilles.CanSelect := false;
    aFListVilles.ShowModal;
    Application.ProcessMessages;
  finally
    aFListVilles.Free;
  end;
end;

procedure TFMain.lPrefClick(Sender: TObject);
var
  aFEditContext: TFEditContext;
begin
  aFEditContext := TFEditContext.create(self);
  try
    if aFEditContext.ShowModal = mrOk then
      begin
        //La fiche individu est-elle active ?
        if fIDModuleActif = _ID_INDIVIDU then
          begin
            //on rafraichit les cohrences
            aFIndividu.LoadCoherenceDates;
            aFIndividu.CoherenceDate.Test;
            aFIndividu.aFIndividuIdentite.SetColorFromContext;
            aFIndividu.DoRefreshControls;

            aFIndividu.aFIndividuIdentite.IBQEve.Close;
            aFIndividu.aFIndividuIdentite.IBQEve.Open;
          end;
      end;
  finally
    aFEditContext.Free;
  end;

  if not _Context.Skin then
    spSkinData1.ClearSkin
  else
    if spSkinData1.Empty then
      begin
        Application.ProcessMessages;
        //DisableAlign;
        Hide;
        spSkinData1.ClearSkin;

        if FileExists(_Context.SkinDefault) then
          spSkinData1.LoadFromFile(_Context.SkinDefault)
        else
          spSkinData1.LoadFromFile(ExtractFilePath(Application.ExeName) + 'Skins\corona!\SkIN.INI');

        ClientHeight := 542;
        ClientWidth := 788;
        Show;
        // EnableAlign;
      end;

end;

procedure TFMain.option_RenumerotationSOSAClick(Sender: TObject);
var
  aFIndividuPrenom: TFIndividuPrenom;
  aFConfirmAddToFavoris: TFConfirmAddToFavoris;
  sSosa: string;
begin

  //Cration de la boite de recherche d'un individu par le prnom
  aFIndividuPrenom := TFIndividuPrenom.create(self);
  try
    aFIndividuPrenom.Position := poMainFormCenter;
    aFIndividuPrenom.ModeSosa := true;

    aFIndividuPrenom.up_InitIndividuPrenom('A', 'SOSA', 0, 2);

    if aFIndividuPrenom.ShowModal = mrOk then
      begin
        if MyMessageDlg('Confirmez-vous le lancement de la renumrotation SOSA ?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
          begin
            _FOccupe.doActive;
            try
              dm.up_RenumSosa(aFIndividuPrenom.ClefIndividuSelected);
            finally
              _FOccupe.doDesactive;
            end;

            aFConfirmAddToFavoris := TFConfirmAddToFavoris.create(self);
            try
              aFConfirmAddToFavoris.lTitre.Caption := aFIndividuPrenom.NomPrenomIndividuSelected;
              //'L''individu ayant le plus grand N SOSA';
              if aFConfirmAddToFavoris.ShowModal = mrOk then
                begin
                  if CloseModuleActif then
                    begin
                      dm.FicheActive := aFIndividuPrenom.ClefIndividuSelected;
                      dm.AddToFavoris(aFIndividuPrenom.ClefIndividuSelected);
                      dm.AddToFavoris(dm.doRecupMaxSosa(sSosa));
                      dm.LoadFavoris(menu_favoris);
                      OpenModule(_ID_INDIVIDU);

                      //                              dm.up_Comptage(0);
                    end;
                end;
            finally
              aFConfirmAddToFavoris.Free;
            end;
          end;
      end;
  finally
    aFIndividuPrenom.Free;
  end;
end;

procedure TFMain.mSaisierapideClick(Sender: TObject);
var
  aFIndividuSaisieRapide: TFIndividuSaisieRapide;
begin

  //Cration de la boite de recherche d'un individu par le prnom
  aFIndividuSaisieRapide := TFIndividuSaisieRapide.create(self);
  try
    aFIndividuSaisieRapide.ShowModal;

    if fIDModuleActif = _ID_REPERTOIRE then
      if aFIndividuSaisieRapide.IndividuHaveBeenCreated
        then aFRepertoire.doRefreshRepertoire;

    { TODO : rafraichir le rep sur le bon individu }

  finally
    aFIndividuSaisieRapide.Free;
  end;
end;

procedure TFMain.mListeUnionsClick(Sender: TObject);
var
  aFListeUnions: TFListeUnions;
begin
  aFListeUnions := TFListeUnions.create(self);
  try
    if aFListeUnions.ShowModal = mrOk then
      begin
        //Selon le module
        case fIDModuleActif of

          _ID_INDIVIDU:
            begin
              if aFIndividu.VerifyCanCloseFiche then
                begin
                  aFIndividu.doOpenFiche(aFListeUnions.CleFicheSelected);
                end;
            end;

          _ID_REPERTOIRE:
            begin
              //On ferme le rpertoire, et on montre la fiche individu
              if CloseModuleActif then
                begin
                  dm.FicheActive := aFListeUnions.CleFicheSelected;
                  OpenModule(_ID_INDIVIDU);
                end;
            end;

          _ID_ARBRE:
            begin
              dm.FicheActive := aFListeUnions.CleFicheSelected;
              aFArbre.Init_Arbre;
            end;


          _ID_PRINT_ARBRE, _ID_PRINT_ROUE: aFGraphPaintBox.doSelectOtherIndividu(aFListeUnions.CleFicheSelected);

        end;
      end;
  finally
    aFListeUnions.Free;
  end;
end;

procedure TFMain.mCousinageClick(Sender: TObject);
var
  aFListeCousinage: TFListeCousinage;
begin
  aFListeCousinage := TFListeCousinage.create(self);
  try
    if aFListeCousinage.ShowModal = mrOk then
      begin
        //Selon le module
        case fIDModuleActif of

          _ID_INDIVIDU:
            begin
              if aFIndividu.VerifyCanCloseFiche then
                begin
                  aFIndividu.doOpenFiche(aFListeCousinage.fClefIndividuSelected);
                end;
            end;

          _ID_REPERTOIRE:
            begin
              //On ferme le rpertoire, et on montre la fiche individu
              if CloseModuleActif then
                begin
                  dm.FicheActive := aFListeCousinage.fClefIndividuSelected;
                  OpenModule(_ID_INDIVIDU);
                end;
            end;

          _ID_ARBRE:
            begin
              dm.FicheActive := aFListeCousinage.fClefIndividuSelected;
              aFArbre.Init_Arbre;
            end;


          _ID_PRINT_ARBRE, _ID_PRINT_ROUE: aFGraphPaintBox.doSelectOtherIndividu(aFListeCousinage.fClefIndividuSelected);

        end;
      end;
  finally
    aFListeCousinage.Free;
  end;
end;

procedure TFMain.SuperFormRefreshControls(Sender: TObject);
var
  dbc: boolean;
  S: TStringList;
  iCount: integer;
begin
  if bFirsTime then Exit;
  s := TStringList.Create;
  iCount := LoadStringListWithFichier(_Path_Appli + _REL_PATH_PLUGINS + '*.dll', s);
  FreeAndNil(s);

  dbc := dm.ibd_BASE.Connected and fDemarrageIsFinish;

  //Dossier
  if (dbc) and (dm.NumDossier > 0) then
    begin
      lbNomDossier.Caption := dm.NomDossier;
    end
  else
    begin
      lbNomDossier.Caption := '';
      lbNomDossier.Hint := '';
    end;


  bfsbRecherche.enabled := (dbc) and ((dm.NumDossier > 0)
    and (fIDModuleActif in [
    _ID_REPERTOIRE,
      _ID_ARBRE,
      _ID_INDIVIDU,
      _ID_PRINT_ARBRE,
      _ID_PRINT_ROUE]));

  Rechercher2.enabled := bfsbRecherche.enabled;

  Informations1.enabled := (dbc) and (dm.NumDossier > 0);
  Blocnotes2.enabled := (dbc) and (dm.NumDossier > 0);
  mOptimise.enabled := (dbc) and (dm.NumDossier > 0);
  lDossier.enabled := (dbc); //and (dm.NumDossier > 0);
  lIndividus.enabled := (dbc) and (dm.NumDossier > 0);
  lRepertoire.enabled := (dbc) and (dm.NumDossier > 0);
  lFiche.enabled := (dbc) and (dm.NumDossier > 0);
  lLiensFamilliaux.enabled := (dbc) and (dm.NumDossier > 0);
  lArbre.enabled := (dbc) and (dm.NumDossier > 0);
  lAnniversaire.enabled := (dbc) and (dm.NumDossier > 0);
  lListePrenom.enabled := (dbc) and (dm.NumDossier > 0);
  lImportExport.enabled := (dbc) and (dm.NumDossier > 0);
  lImport.enabled := (dbc) and (dm.NumDossier > 0);
  lExport.enabled := (dbc) and (dm.NumDossier > 0);
  lGeneanet.enabled := (dbc) and (dm.NumDossier > 0);
  lImpressions.enabled := (dbc) and (dm.NumDossier > 0);

  lImpArbre.enabled := (dbc) and (dm.NumDossier > 0) and (not _Context.IsPhilippe);
  lImpRoue.enabled := (dbc) and (dm.NumDossier > 0) and (not _Context.IsPhilippe);
  Arbredascendance1.enabled := (dbc) and (dm.NumDossier > 0) and (not _Context.IsPhilippe);
  Rouedascendance1.enabled := (dbc) and (dm.NumDossier > 0) and (not _Context.IsPhilippe);

  lImpAsc.enabled := (dbc) and (dm.NumDossier > 0);
  URLBlockNotes.enabled := (dbc) and (dm.NumDossier > 0);
  lDivers.enabled := (dbc) and (dm.NumDossier > 0);
  lVilles.enabled := (dbc) and (dm.NumDossier > 0);
  lPref.enabled := (dbc) and (dm.NumDossier > 0);
  Dossiers1.enabled := (dbc); // and (dm.NumDossier > 0);
  menu_Individu.enabled := (dbc) and (dm.NumDossier > 0);
  menu_Favoris.enabled := (dbc) and (dm.NumDossier > 0);
  menu_ImportExport.enabled := (dbc) and (dm.NumDossier > 0);
  menu_Impressions.enabled := (dbc) and (dm.NumDossier > 0);
  mAddon.enabled := (dbc) and (dm.NumDossier > 0) and (iCount > 2);
  Prfrences2.enabled := (dbc) and (dm.NumDossier > 0);
  Raccourissaisie1.enabled := (dbc) and (dm.NumDossier > 0);
  Raccourissaisie1.enabled := (dbc) and (dm.NumDossier > 0);
  Prfixes1.enabled := (dbc) and (dm.NumDossier > 0);
  Religions1.enabled := (dbc) and (dm.NumDossier > 0);
  Particules1.enabled := (dbc) and (dm.NumDossier > 0);
  Motsclefsutilissdanslesdates1.enabled := (dbc) and (dm.NumDossier > 0);
  VillesCodes1.enabled := (dbc) and (dm.NumDossier > 0);

  Application.ProcessMessages;
  Application.ProcessMessages;

end;

procedure TFMain.RefreshFavoris;
begin
  //on rcupre tous les favoris
  dm.LoadFavoris(menu_Favoris);
end;

procedure TFMain.OnClickOnFavoris(sender: TObject);
var
  cle: integer;
  nom: string;
  sexe: integer;
  k: integer;
begin
  cle := TMenuItem(sender).Tag;
  nom := TMenuItem(sender).Caption;
  if TMenuItem(sender).ImageIndex = 39 then sexe := 1
  else
    if TMenuItem(sender).ImageIndex = 38 then sexe := 2
    else
      sexe := 0;

  k := pos('&', nom);
  if k > 0 then delete(nom, k, 1);

  //sur quel module somme-nous ?
  case fIDModuleActif of

    _ID_INDIVIDU:
      begin
        if aFIndividu.VerifyCanCloseFiche then
          begin
            aFIndividu.doOpenFiche(cle);
          end;
      end;
    _ID_INDIVIDU_PAR_PRENOM:
      begin
        if CloseModuleActif then
          begin
            dm.FicheActive := cle;
            OpenModule(_ID_INDIVIDU);
          end;
      end;
    _ID_REPERTOIRE:
      begin
        if CloseModuleActif then
          begin
            dm.FicheActive := cle;
            OpenModule(_ID_INDIVIDU);
          end;
      end;
    _ID_ARBRE:
      begin
        dm.FicheActive := cle;
        aFArbre.Init_Arbre;
      end;
    _ID_CONNECTOR:
      begin
        aFIndividuConnector.CleIndiCentral := cle;
        dm.FicheActive := cle;
        aFIndividuConnector.doRefreshPeopleArroundIndividu(cle);
      end;
    _ID_IMPORTATION_GEDCOM:
      begin
        //                    aFImportGedcom := nil;
      end;
    _ID_EXPORTATION_GEDCOM:
      begin
        if sexe <> 0 then
          if aFExportGedcom.CanSetCleFicheFromFavoris then
            begin
              aFExportGedcom.CleIndiDepart := cle;
              aFExportGedcom.NameIndiDepart := nom;
              aFExportGedcom.SexeIndiDepart := sexe;

              aFExportGedcom.DoRefreshControls;
            end;
      end;

    _ID_PRINT_ARBRE:
      begin
        aGraphArbre.CleIndiDepart := Cle;
        aFGraphPaintBox.RefreshTout;
        aFGraphPaintBox.btnRefresh.enabled := false;
        dm.FicheActive := Cle;
      end;

    _ID_PRINT_ROUE:
      begin
        aGraphRoue.CleIndiDepart := Cle;
        aFGraphPaintBox.RefreshTout;
        aFGraphPaintBox.btnRefresh.enabled := false;
        dm.FicheActive := Cle;
      end;

    _ID_PRINT:
      begin
        dm.FicheActive := Cle;
        aFListReport.doRefreshReport;
      end;
  end;
end;

procedure TFMain.MenuFavoris_AddClick(Sender: TObject);
var
  cle: integer;
  nom: string;
  Sexe: Integer;
  aFConfirmAddToFavoris: TFConfirmAddToFavoris;
begin
  Application.ProcessMessages;
  cle := -1;
  nom := '';
  Sexe := -1;

  //sur quel module somme-nous ?
  case fIDModuleActif of

    _ID_INDIVIDU:
      begin
        cle := aFIndividu.CleFiche;
        nom := aFIndividu.GetNomIndividu;
        Sexe := aFIndividu.QueryIndividuSEXE.AsInteger;
      end;
    _ID_INDIVIDU_PAR_PRENOM:
      begin
        cle := aFIndividuPrenom.GetCleFicheSelected;
        nom := aFIndividuPrenom.GetNomFicheSelected;
        Sexe := -1;
      end;
    _ID_REPERTOIRE:
      begin
        cle := aFRepertoire.GetCleFicheSelected;
        nom := aFRepertoire.GetNomFicheSelected;
        Sexe := aFRepertoire.IBQListeNomSEXE.AsInteger;
      end;
    _ID_ARBRE:
      begin
        cle := aFArbre.GetCleFicheSelected;
        nom := aFArbre.GetNomFicheSelected;
        Sexe := -1;
      end;
  end;

  if cle <> -1 then
    begin
      aFConfirmAddToFavoris := TFConfirmAddToFavoris.create(self);
      try
        aFConfirmAddToFavoris.Nom := nom;
        aFConfirmAddToFavoris.Sexe := Sexe;

        //aFConfirmAddToFavoris.lTitre.Caption := coupechaine(nom,aFConfirmAddToFavoris.lTitre);
        if aFConfirmAddToFavoris.ShowModal = mrOk then
          begin
            //on ajoute la clef aux favoris
            dm.AddToFavoris(cle);

            //rafraichissement des favoris
            dm.LoadFavoris(menu_Favoris);
          end;
      finally
        aFConfirmAddToFavoris.Free;
      end;
    end;
end;

procedure TFMain.RefreshMenuFavoris_Add(canAccess: boolean);
begin
  MenuFavoris_Add.enabled := canAccess;
end;

procedure TFMain.RefreshMenuFavoris_Individus(canAccess: boolean);
//var
 //    n: integer;
begin
  {YU
   for n := menu_Favoris.count - 1 downto 0 do
   begin
    if menu_Favoris.items[n].tag >= 0 then menu_Favoris[n].Enabled := canAccess;
   end;
   }
end;

procedure TFMain.IInformationsClick(Sender: TObject);
var
  aFInfos: TFInfos;
begin
  aFInfos := TFInfos.create(self);
  try
    aFInfos.ShowStats;
    aFInfos.ShowModal;
  finally
    aFInfos.Free;
  end;
end;

procedure TFMain.URLBlockNotesClick(Sender: TObject);
begin
  if aFPostit = nil then aFPostit := TFPostit.create(self);

  if aFPostit.visible = false then
    begin
      aFPostit.Show;
      if aFPostit.doOpenQuery = false then aFPostit.Close;
    end;
end;

procedure TFMain.Particules1Click(Sender: TObject);
begin
  aFEditRefParticules := TFEditRefParticules.create(self);
  try
    aFEditRefParticules.ShowModal;
  finally
    aFEditRefParticules.Free;
  end;
end;

procedure TFMain.Prfixes1Click(Sender: TObject);
begin
  aFEditRefPrefixes := TFEditRefPrefixes.create(self);
  try
    aFEditRefPrefixes.ShowModal;
  finally
    aFEditRefPrefixes.free;
  end;
end;

procedure TFMain.Religions1Click(Sender: TObject);
begin
  aFEditRefReligions := TFEditRefReligions.create(self);
  try
    aFEditRefReligions.ShowModal;
  finally
    aFEditRefReligions.Free;
  end;
end;

procedure TFMain.Raccourissaisie1Click(Sender: TObject);
begin
  aFEditRaccourcis := TFEditRaccourcis.create(self);
  try
    aFEditRaccourcis.ShowModal;
    dm.LoadRaccourcis;
  finally
    aFEditRaccourcis.Free;
  end;
end;

procedure TFMain.RecherchededoublonsClick(Sender: TObject);
var aFListeDoublons: TFListeDoublons;
begin
  aFListeDoublons := TFListeDoublons.create(self);
  try
    aFListeDoublons.ShowModal;
  finally
    aFListeDoublons.Free;
  end;
end;

procedure TFMain.SuperFormFirstActivate(Sender: TObject);
begin
  if MustKillApplication = false then
    begin
      FirstUse;
    end;

  fDemarrageIsFinish := true;
  doRefreshControls;
  Enabled := True;

  bFirsTime := False;
  dm.doCLoseAbout;

  _Agent.doAgent('Announce', 'Bonjour, je suis l pour vous aider.' +
    ' Si vous ne voulez pas de moi, allez dans les prfrences et dcochez mon option....', 0, 0);
end;

procedure TFMain.FirstUse;
begin

  //Ouverture de la base de donne
  dm.doOpenDatabase;

  //La base est-elle ouverte ?
  if dm.ibd_BASE.Connected = false then
    begin
      OpenModule(_ID_EMPLACEMENT_BDD);
    end
  else
    doPrepareJusteAfterOpenDatabase;

end;

procedure TFMain.doPrepareJusteAfterOpenDatabase;
begin
  _Context.ActiveFenetreDossier := False;

  Application.ProcessMessages;

  if dm.NumDossier = -1 then
    OpenModule(_ID_NO_DOSSIER)
  else
    begin
      if _Context.ActiveFenetreDossier then
        lDossierClick(Self)
      else
        begin
          OpenModule(_ID_INDIVIDU);
          if _Context.ShowNew then
            begin
              if dm.doNouveaux > 0 then ShowIndividuRecents;
            end;
        end;

      Application.ProcessMessages;

      RefreshFavoris;
      Application.ProcessMessages;

      doRefreshControls;
      Application.ProcessMessages;

    end;

  lbNomDossier.Caption := dm.NomDossier;
end;

procedure TFMain.SuperFormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = _KEY_HELP then BeforeGoHelp;
end;

procedure TFMain.Motsclefsutilissdanslesdates1Click(Sender: TObject);
begin
  aFEditRefTokenDate := TFEditRefTokenDate.create(self);
  try
    aFEditRefTokenDate.ShowModal;
    dm.LoadMotClefDate;
  finally
    aFEditRefTokenDate.Free;
  end;
end;

procedure TFMain.Quitter1Click(Sender: TObject);
begin
  Close;
end;

procedure TFMain.ExportImagesClick(Sender: TObject);
begin
  dm.doExportImages;
end;

procedure TFMain.MaxInstance1TooMany(Sender: TObject);
begin
  MustKillApplication := true;
end;

procedure TFMain.menu_go_web_ancestrologieClick(Sender: TObject);
begin
  if _Context.ShowWeb then
    OpenModuleClick(Sender)
  else
    GotoThisURL(dm.GetUrlSite);
end;

procedure TFMain.mNouveauxClick(Sender: TObject);
begin
  ShowIndividuRecents;
end;

procedure TFMain.ShowIndividuRecents;
var
  aFListeNouveauxIndi: TFListeNouveauxIndi;
begin
  aFListeNouveauxIndi := TFListeNouveauxIndi.create(self);
  try
    if aFListeNouveauxIndi.ShowModal = mrOk then
      begin
        //Selon le module
        case fIDModuleActif of

          _ID_INDIVIDU:
            begin
              if aFIndividu.VerifyCanCloseFiche then
                begin
                  aFIndividu.doOpenFiche(aFListeNouveauxIndi.CleFicheSelected);
                end;
            end;

          _ID_REPERTOIRE:
            begin
              //On ferme le rpertoire, et on montre la fiche individu
              if CloseModuleActif then
                begin
                  dm.FicheActive := aFListeNouveauxIndi.CleFicheSelected;
                  OpenModule(_ID_INDIVIDU);
                end;
            end;

          _ID_ARBRE:
            begin
              dm.FicheActive := aFListeNouveauxIndi.CleFicheSelected;
              aFArbre.Init_Arbre;
            end;

          _ID_PRINT_ARBRE, _ID_PRINT_ROUE: aFGraphPaintBox.doSelectOtherIndividu(aFListeNouveauxIndi.CleFicheSelected);

        end;
      end;
  finally
    aFListeNouveauxIndi.Free;
  end;

end;

procedure TFMain.Commentamarche1Click(Sender: TObject);
begin
  BeforeGoHelp;
end;

procedure TFMain.BeforeGoHelp;
var
  fIDHelp: integer;
begin
  case fIDModuleActif of
    _ID_INDIVIDU: begin
        case aFIndividu.OngletFormIncrusted of

          _ONGLET_IDENTITE: fIDHelp := _HELP_INDI_IDENTITE;
          _ONGLET_SES_CONJOINTS: fIDHelp := _HELP_INDI_UNIONS;
          _ONGLET_ARBRE: fIDHelp := _HELP_INDI_ARBRE;
          _ONGLET_PHOTOS_DOCS: fIDHelp := _HELP_INDI_PHOTO_DOC;
          _ONGLET_OBSERVATIONS: fIDHelp := _HELP_INDI_INFOS;
          _ONGLET_DOMICILES: fIDHelp := _HELP_INDI_DOMICILES;
          else if aFIndividu.panNobody.Visible then fIDHelp := _HELP_INDI_START else fIDHelp := -1;
        end;
      end;
    else
      fIDHelp := fIDModuleActif;
  end;
  if fIDHelp <> -1 then dm.ShowHelp(fIDHelp);
end;

procedure TFMain.Documentation1Click(Sender: TObject);
begin
  dm.ShowHelp(_HELP_BIEVENUE);
end;

procedure TFMain.doTranslate;
begin
  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;
  Caption := Application.Title
end;

procedure TFMain.Fichier1PaintBar(Sender: TObject; Canvas: TCanvas; const R: TRect);
var
  SR, BR: TRect;
begin
  DrawVerticalGradient(Canvas, R, 0, 0, 0, 0, 0, 205);
  SR := R;
  with iBars4.Picture.Bitmap do
    begin
      TransparentColor := clBlack;
      BR := Rect(0, 0, Width, Height);
    end;
  with SR do
    begin
      Left := (Left + Right - BR.Right) div 2;
      Right := Left + BR.Right;
      Top := Bottom - BR.Bottom;
    end;
  if SR.Top > 0 then
    with Canvas do
      begin
        Brush.Style := bsClear;
        BrushCopy(SR, iBars4.Picture.Bitmap, BR, clBlack);
        Brush.Style := bsSolid;
      end;
end;


procedure TFMain.dxBBLieuxFavorisClick(Sender: TObject);
var
  aFVillesFavoris: TFVillesFavoris;
begin
  aFVillesFavoris := TFVillesFavoris.create(self);
  try
    dxPLVillesFavorites.Component := aFVillesFavoris.dxDBGrid1;
    aFVillesFavoris.ShowModal
  finally
    aFVillesFavoris.Free;
  end;
end;

procedure TFMain.mDecesVillesClick(Sender: TObject);
var
  aFDecesParVille: TFDecesParVille;
begin
  aFDecesParVille := TFDecesParVille.create(self);
  try
    if aFDecesParVille.ShowModal = mrOk then
      begin
        //Selon le module
        case fIDModuleActif of

          _ID_INDIVIDU:
            begin
              if aFIndividu.VerifyCanCloseFiche then
                begin
                  aFIndividu.doOpenFiche(aFDecesParVille.CleFicheSelected);
                end;
            end;

          _ID_REPERTOIRE:
            begin
              //On ferme le rpertoire, et on montre la fiche individu
              if CloseModuleActif then
                begin
                  dm.FicheActive := aFDecesParVille.CleFicheSelected;
                  OpenModule(_ID_INDIVIDU);
                end;
            end;

          _ID_ARBRE:
            begin
              dm.FicheActive := aFDecesParVille.CleFicheSelected;
              aFArbre.Init_Arbre;
            end;


          _ID_PRINT_ARBRE, _ID_PRINT_ROUE: aFGraphPaintBox.doSelectOtherIndividu(aFDecesParVille.CleFicheSelected);

        end;
      end;
  finally
    aFDecesParVille.Free;
  end;
end;

procedure TFMain.mNaissVillesClick(Sender: TObject);
var
  aFNaissanceParVille: TFNaissanceParVille;
begin
  aFNaissanceParVille := TFNaissanceParVille.create(self);
  try
    if aFNaissanceParVille.ShowModal = mrOk then
      begin
        //Selon le module
        case fIDModuleActif of

          _ID_INDIVIDU:
            begin
              if aFIndividu.VerifyCanCloseFiche then
                begin
                  aFIndividu.doOpenFiche(aFNaissanceParVille.CleFicheSelected);
                end;
            end;

          _ID_REPERTOIRE:
            begin
              //On ferme le rpertoire, et on montre la fiche individu
              if CloseModuleActif then
                begin
                  dm.FicheActive := aFNaissanceParVille.CleFicheSelected;
                  OpenModule(_ID_INDIVIDU);
                end;
            end;

          _ID_ARBRE:
            begin
              dm.FicheActive := aFNaissanceParVille.CleFicheSelected;
              aFArbre.Init_Arbre;
            end;


          _ID_PRINT_ARBRE, _ID_PRINT_ROUE: aFGraphPaintBox.doSelectOtherIndividu(aFNaissanceParVille.CleFicheSelected);

        end;
      end;
  finally
    aFNaissanceParVille.Free;
  end;
end;

procedure TFMain.dxbDelFavorisClick(Sender: TObject);
begin
  if MyMessageDlg('Confirmez-vous la suppression des liens vers vos individus favoris ?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    begin
      dm.DelFavoris;
    end;
end;

// -- About ---------------------------------------------------------------------------------------------

procedure TFMain.dxBarButton1Click(Sender: TObject);
var
  aFAbout: TFAbout;
begin
  aFAbout := TFAbout.create(self);
  try
    aFAbout.ShowModal;
  finally
    aFAbout.Free;
  end;
end;


procedure TFMain.mCalendrierClick(Sender: TObject);
var
  aFCalendriers: TFCalendriers;
begin
  aFCalendriers := TFCalendriers.create(self);
  try
    aFCalendriers.CanSelect := false;
    aFCalendriers.ShowModal;
  finally
    aFCalendriers.Free;
  end;
end;

procedure TFMain.mOrphelinsClick(Sender: TObject);
var
  aFOrphelins: TFOrphelins;
begin
  aFOrphelins := TFOrphelins.create(self);
  try
    if aFOrphelins.ShowModal = mrOk then
      begin
        //Selon le module
        case fIDModuleActif of

          _ID_INDIVIDU:
            begin
              if aFIndividu.VerifyCanCloseFiche then
                begin
                  aFIndividu.doOpenFiche(aFOrphelins.CleFicheSelected);
                end;
            end;

          _ID_REPERTOIRE:
            begin
              //On ferme le rpertoire, et on montre la fiche individu
              if CloseModuleActif then
                begin
                  dm.FicheActive := aFOrphelins.CleFicheSelected;
                  OpenModule(_ID_INDIVIDU);
                end;
            end;

          _ID_ARBRE:
            begin
              dm.FicheActive := aFOrphelins.CleFicheSelected;
              aFArbre.Init_Arbre;
            end;


          _ID_PRINT_ARBRE, _ID_PRINT_ROUE: aFGraphPaintBox.doSelectOtherIndividu(aFOrphelins.CleFicheSelected);

        end;
      end;
  finally
    aFOrphelins.Free;
  end;
end;

procedure TFMain.mSansVillesClick(Sender: TObject);
var
  aFSansVilles: TFSansVilles;
begin
  aFSansVilles := TFSansVilles.create(self);
  try
    if aFSansVilles.ShowModal = mrOk then
      begin
        //Selon le module
        case fIDModuleActif of

          _ID_INDIVIDU:
            begin
              if aFIndividu.VerifyCanCloseFiche then
                begin
                  aFIndividu.doOpenFiche(aFSansVilles.CleFicheSelected);
                end;
            end;

          _ID_REPERTOIRE:
            begin
              //On ferme le rpertoire, et on montre la fiche individu
              if CloseModuleActif then
                begin
                  dm.FicheActive := aFSansVilles.CleFicheSelected;
                  OpenModule(_ID_INDIVIDU);
                end;
            end;

          _ID_ARBRE:
            begin
              dm.FicheActive := aFSansVilles.CleFicheSelected;
              aFArbre.Init_Arbre;
            end;


          _ID_PRINT_ARBRE, _ID_PRINT_ROUE: aFGraphPaintBox.doSelectOtherIndividu(aFSansVilles.CleFicheSelected);

        end;
      end;
  finally
    aFSansVilles.Free;
  end;
end;

procedure TFMain.mPosthumeClick(Sender: TObject);
var
  aFPosthumes: TFPosthumes;
begin
  aFPosthumes := TFPosthumes.create(self);
  try
    if aFPosthumes.ShowModal = mrOk then
      begin
        //Selon le module
        case fIDModuleActif of

          _ID_INDIVIDU:
            begin
              if aFIndividu.VerifyCanCloseFiche then
                begin
                  aFIndividu.doOpenFiche(aFPosthumes.CleFicheSelected);
                end;
            end;

          _ID_REPERTOIRE:
            begin
              //On ferme le rpertoire, et on montre la fiche individu
              if CloseModuleActif then
                begin
                  dm.FicheActive := aFPosthumes.CleFicheSelected;
                  OpenModule(_ID_INDIVIDU);
                end;
            end;

          _ID_ARBRE:
            begin
              dm.FicheActive := aFPosthumes.CleFicheSelected;
              aFArbre.Init_Arbre;
            end;


          _ID_PRINT_ARBRE, _ID_PRINT_ROUE: aFGraphPaintBox.doSelectOtherIndividu(aFPosthumes.CleFicheSelected);

        end;
      end;
  finally
    aFPosthumes.Free;
  end;
end;

procedure TFMain.mVerifClick(Sender: TObject);
var aFVerifEvent: TFVerifEvent;
begin
  aFVerifEvent := TFVerifEvent.create(self);
  try
    aFVerifEvent.ShowModal;
  finally
    aFVerifEvent.Free;
  end;
end;

// -- Gestion des PlugIns -------------------------------------------------------------------------------
type
  TinitTitre = function: Pchar;

procedure TFMain.DoInitAddon;
var HAddOn: LongWord;
  i: integer;
  S: TStringList;
  //MonItem: TdxBarButton;
  AskTitle: string;
  Menu: TdxBarButton;
  Link: TdxBarItemLink;
  NbIcon: hicon;
  Icon: TIcon;
  mot: word;
  nIco: Integer;
begin

  mAddon.ItemLinks.Clear;
  //Scanne le repertoire et met les chemins dans une TStringList
  s := TStringList.Create;
  LoadStringListWithFichier(_Path_Appli + _REL_PATH_PLUGINS + '*.dll', s);
  Application.ProcessMessages;

  with dxBarManager do
    begin
      LockUpdate := True;

      for i := 0 to S.Count - 1 do
        begin
          HAddOn := LoadLibrary(PChar(_Path_Appli + _REL_PATH_PLUGINS + S.Strings[i]));
          if HAddOn <> 0 then
            begin

              AskTitle := TinitTitre(GetProcAddress(HAddOn, 'InitTitreDll'));

              Menu := TdxBarButton.Create(dxBarManager);
              Menu.Caption := AskTitle;
              Menu.OnClick := OnClickDll;
              //Menu.ImageIndex := 59;
              Menu.Description := S.Strings[i];

              Link := mAddon.ItemLinks.Add;
              Link.Item := Menu;

              if upperCase(S.Strings[i]) = 'DLLSTATISTIQUES.DLL' then
                Link.BeginGroup := True;

              NbIcon := ExtractIcon(HINSTANCE, Pchar(_Path_Appli + _REL_PATH_PLUGINS + S.Strings[i]), UINT(-1)); //ExtractIcon(0, PChar(S.Strings[i]), $FFFFFFFF);

              if NbIcon = 0 then
                begin
                  Menu.ImageIndex := 59;
                end
              else
                begin
                  // On recupere l icone de la dll
                  Icon := TIcon.Create;
                  Icon.Handle := ExtractIcon(Mot, Pchar(_Path_Appli + _REL_PATH_PLUGINS + S.Strings[i]), 0);

                  nIco := dm.ImageListMenu.AddIcon(Icon);

                  if nIco = -1 then
                    Menu.ImageIndex := 59
                  else
                    Menu.ImageIndex := nIco;

                  Icon.Free;
                end;
            end
          else
            ShowMessage('Erreur pendant le chargement de la dll : ' + _Path_Appli + _REL_PATH_PLUGINS + S.Strings[i]);

          FreeLibrary(HAddOn);
          Application.ProcessMessages;
        end;
      LockUpdate := False;
    end;

  FreeAndNil(s);
end;

type
  tProcedure = procedure(sBase: pChar);

procedure TFMain.OnClickDll(sender: TObject);
// Ici on ouvre la fonction principale de la dll ----------
var
  HAddOn: LongWord;
  sToken: string;
begin
  Application.ProcessMessages;

  sToken := (sender as TdxBarButton).Description;
  HAddOn := LoadLibrary(pchar(_Path_Appli + _REL_PATH_PLUGINS + (sender as TdxBarButton).Description));
  if HAddOn <> 0 then
    begin
      tProcedure(GetProcAddress(HAddOn, 'InitStartDll'))(pChar(_Context.PathFileNameBdd));

      FreeLibrary(HAddOn);
      Application.ProcessMessages;
    end;
end;
// -- Fin de gestion des PlugIns ------------------------------------------------------------------------

procedure TFMain.msInfosClick(Sender: TObject);
begin
  Screen.Cursor := crHourGlass;
  shellexecute(application.handle, nil, pchar('MSINFO32.EXE'), nil, nil, SW_SHOWNORMAL);
  Screen.Cursor := crDefault;
end;

procedure TFMain.mMajInseeClick(Sender: TObject);
begin
  dm.doMajInsee;
end;

procedure TFMain.mInseeCPClick(Sender: TObject);
var aFInverseInsee: TFInverseInsee;
begin
  aFInverseInsee := TFInverseInsee.create(self);
  try
    aFInverseInsee.ShowModal;
  finally
    aFInverseInsee.Free;
  end;
end;

procedure TFMain.doPrint(iVal: Integer);

begin

  //showmessage(dxComponentPrinter1.ReportLink[iVal].Caption);
  case iVal of
    0:
      begin
        dxPLRepertoire.Component := aFRepertoire.dxDBGridNom;
        dxComponentPrinter1.CurrentLink := dxPLRepertoire;
      end;
    1:
      begin
        dxPLArbre.Component := aFIndividu.aFIndividuArbre.oc;
        dxComponentPrinter1.CurrentLink := dxPLArbre;
      end;
    2: dxComponentPrinter1.CurrentLink := dxPLVillesFavorites;
    3: dxComponentPrinter1.CurrentLink := dxPLUnions;
    4: dxComponentPrinter1.CurrentLink := dxPTags;
    5: dxComponentPrinter1.CurrentLink := dxpNaissances;
  end;

  dxComponentPrinter1.Preview(True, nil);
end;

procedure TFMain.mTagGedcomClick(Sender: TObject);
var aFTAGGedcom: TFTAGGedcom;
begin
  aFTAGGedcom := TFTAGGedcom.create(self);
  try
    aFTAGGedcom.ShowModal;
  finally
    aFTAGGedcom.Free;
  end;
end;

procedure TFMain.mMajClick(Sender: TObject);
var aFMajInternet: TFMajInternet;
begin
  aFMajInternet := TFMajInternet.create(self);
  try
    aFMajInternet.ShowModal;
  finally
    aFMajInternet.Free;
  end;
end;

procedure TFMain.dxbDoublonsVilleClick(Sender: TObject);
var aFListeVillesDoublons: TFListeVillesDoublons;
begin
  aFListeVillesDoublons := TFListeVillesDoublons.create(self);
  try
    aFListeVillesDoublons.ShowModal;
  finally
    aFListeVillesDoublons.Free;
  end;
end;

procedure TFMain.mBiblioSourcesClick(Sender: TObject);
var aFBiblio_Documents: TFBiblio_Documents;
begin
  aFBiblio_Documents := TFBiblio_Documents.create(self);
  try
    aFBiblio_Documents.ShowModal;
  finally
    aFBiblio_Documents.Free;
  end;
end;

procedure TFMain.mBiblioMediasClick(Sender: TObject);
var aFBibliothequeMultimedia: TFBibliothequeMultimedia;
begin
  aFBibliothequeMultimedia := TFBibliothequeMultimedia.create(self);
  try
    aFBibliothequeMultimedia.ShowModal;
  finally
    aFBibliothequeMultimedia.Free;
  end;
end;

procedure TFMain.dxSkinsClick(Sender: TObject);
begin
  Application.ProcessMessages;

  od.InitialDir := ExtractFilePath(Application.ExeName) + 'Skins';

  if OD.Execute then
    begin
      spSkinData1.LoadFromFile(OD.FileName);
      ClientHeight := 542;
      ClientWidth := 788;
      _Context.SkinDefault := OD.FileName;
      _Context.Save;
    end;
end;

procedure TFMain.menu_ConfigurationPopup(Sender: TObject);
begin
  dxSkins.Enabled := _Context.Skin;
end;

procedure TFMain.sxMListeDiffusionClick(Sender: TObject);
begin
  GotoThisURL(dm.GeturlListeDiffusion);
end;


procedure TFMain.SuperFormClose(Sender: TObject; var Action: TCloseAction);
begin
  _Agent.doAgent('Hide', '', 0, 0);
end;

procedure TFMain.TimerTimer(Sender: TObject);
begin
  if _Agent.bAgentShow then
    _Agent.doAgent('Hide', '', 0, 0);

  Timer.Enabled := False;
end;

end.

