program Ancestrologie;

uses
  Forms,
  u_common_const in '..\Main\u_common_const.pas',
  u_common_var in '..\Main\u_common_var.pas',
  u_dm in '..\Main\u_dm.pas' {dm: TDataModule},
  u_form_rechercher in '..\Individus\u_form_rechercher.pas' {FRechercher},
  u_form_list_report in '..\Editions\u_form_list_report.pas' {FListReport},
  u_objet_TState in '..\Divers\u_objet_TState.pas',
  u_form_list_villes in '..\Divers\u_form_list_villes.pas' {FListVilles},
  u_form_navigation in '..\Arbre\u_form_navigation.pas' {FNavigation},
  u_form_export_gedcom in '..\Gedcom\u_form_export_gedcom.pas' {FExportGedcom},
  u_form_Union_events_sources in '..\Unions\u_form_Union_events_sources.pas' {FUnionEventsSources},
  u_form_Union_events_details in '..\Unions\u_form_Union_events_details.pas' {FUnionEventsDetails},
  u_form_Union_events_temoins in '..\Unions\u_form_Union_events_temoins.pas' {FUnionEventsTemoins},
  u_form_import_gedcom in '..\Gedcom\u_form_import_gedcom.pas' {FImportGedcom},
  u_objet_TImportGedCom in '..\Gedcom\u_objet_TImportGedCom.pas',
  u_gedcom_type in '..\Gedcom\u_gedcom_type.pas',
  u_form_Liste_Cousinage in '..\Divers\u_form_Liste_Cousinage.pas' {FListeCousinage},
  u_gedcom_func in '..\Gedcom\u_gedcom_func.pas',
  u_form_anniversaires in '..\Divers\u_form_anniversaires.pas' {FAnniversaires},
  u_objet_TGedcomDate in '..\Gedcom\u_objet_TGedcomDate.pas',
  u_form_main in '..\Main\u_form_main.pas' {FMain},
  u_form_select_dossier in '..\Divers\u_form_select_dossier.pas' {FSelectDossier},
  u_form_individu_Affecte_Enfant in '..\Individus\u_form_individu_Affecte_Enfant.pas' {FAffecte_Enfant},
  u_common_func in '..\Main\u_common_func.pas',
  u_gedcom_var in '..\Gedcom\u_gedcom_var.pas',
  u_form_Union_events_notes in '..\Unions\u_form_Union_events_notes.pas' {FUnionEventsNotes},
  u_form_repertoire in '..\Divers\u_form_repertoire.pas' {FRepertoire},
  u_form_individu_Saisie_Rapide in '..\Individus\u_form_individu_Saisie_Rapide.pas' {FIndividuSaisieRapide},
  u_Form_Liste_Nouveaux_Indi in '..\Individus\u_Form_Liste_Nouveaux_Indi.pas' {FListeNouveauxIndi},
  u_form_individu_par_prenom in '..\Individus\u_form_individu_par_prenom.pas' {FIndividuPrenom},
  u_form_graph_paintbox in '..\Graph\u_form_graph_paintbox.pas' {FGraphPaintBox},
  u_form_graph_miniature in '..\Graph\u_form_graph_miniature.pas' {FGraphMiniature},
  u_common_graph_const in '..\Graph\u_common_graph_const.pas',
  u_common_graph_func in '..\Graph\u_common_graph_func.pas',
  u_common_graph_type in '..\Graph\u_common_graph_type.pas',
  u_common_graph_var in '..\Graph\u_common_graph_var.pas',
  u_objet_graph_TPlotList in '..\Graph\u_objet_graph_TPlotList.pas',
  u_objet_graph_TGraph in '..\Graph\u_objet_graph_TGraph.pas',
  u_objet_graph_TPlot in '..\Graph\u_objet_graph_TPlot.pas',
  u_objet_graph_TChantier in '..\Graph\u_objet_graph_TChantier.pas',
  u_objet_graph_TVueList in '..\Graph\u_objet_graph_TVueList.pas',
  u_objet_graph_TVue in '..\Graph\u_objet_graph_TVue.pas',
  u_objet_graph_TViewer in '..\Graph\u_objet_graph_TViewer.pas',
  u_objet_TMulot in '..\Divers\u_objet_TMulot.pas',
  u_objet_TGraphRoue in '..\Graph\u_objet_TGraphRoue.pas',
  u_objet_TGraphArbre in '..\Graph\u_objet_TGraphArbre.pas',
  u_form_graph_config_roue in '..\Graph\u_form_graph_config_roue.pas' {FGraphConfigRoue},
  u_form_graph_config_hierarchie in '..\Graph\u_form_graph_config_hierarchie.pas' {FGraphConfigHierarchie},
  u_form_No_Dossier in '..\Main\u_form_No_Dossier.pas' {FNoDossier},
  u_Form_Contributions in '..\Divers\u_Form_Contributions.pas' {FContributions},
  u_form_arbre in '..\Arbre\u_form_arbre.pas' {FArbre},
  u_form_individu in '..\Individus\u_form_individu.pas' {FIndividu},
  u_form_individu_identite in '..\Individus\u_form_individu_identite.pas' {FIndividuIdentite},
  u_form_individu_Union in '..\Individus\u_form_individu_Union.pas' {FIndividuUnion},
  u_form_individu_Domiciles in '..\Individus\u_form_individu_Domiciles.pas' {FIndividuDomiciles},
  u_rm in '..\Graph\u_rm.pas' {rm: TDataModule},
  u_form_confirm_add_to_favoris in '..\Divers\u_form_confirm_add_to_favoris.pas' {FConfirmAddToFavoris},
  u_form_individu_edit_event_life in '..\Individus\u_form_individu_edit_event_life.pas' {FIndividuEditEventLife},
  u_form_edit_dossier in '..\Divers\u_form_edit_dossier.pas' {FEditDossier},
  u_form_Occupe in '..\Divers\u_form_Occupe.pas' {FOccupe},
  u_form_Ville_Ajout in '..\Divers\u_form_Ville_Ajout.pas' {FVilleAjout},
  u_form_Actes_Affectation in '..\Divers\u_form_Actes_Affectation.pas' {FActesAffectation},
  Unit1 in '..\ZeLook\Unit1.pas' {SuperForm1},
  u_form_postit in '..\Divers\u_form_postit.pas' {FPostit},
  u_form_msg in '..\Divers\u_form_msg.pas' {FMsg},
  u_form_edit_context in '..\Context\u_form_edit_context.pas' {FEditContext},
  u_objet_TContext in '..\Context\u_objet_TContext.pas',
  u_form_TAG_Gedcom in '..\Divers\u_form_TAG_Gedcom.pas' {FTAGGedcom},
  u_form_export_table_2_textfile in '..\Context\u_form_export_table_2_textfile.pas' {FExportTable2TextFile},
  u_form_Import_textfile_2_table in '..\Context\u_form_Import_textfile_2_table.pas' {FImportTextFile2Table},
  u_form_edit_raccourcis in '..\Context\u_form_edit_raccourcis.pas' {FEditRaccourcis},
  u_form_edit_ref_prefixes in '..\Context\u_form_edit_ref_prefixes.pas' {FEditRefPrefixes},
  u_form_edit_ref_particules in '..\Context\u_form_edit_ref_particules.pas' {FEditRefParticules},
  u_form_TriEvent in '..\Divers\u_form_TriEvent.pas' {FTriEvent},
  u_objet_TCoherenceDate in '..\Individus\u_objet_TCoherenceDate.pas',
  u_Form_Verif_Event in '..\Divers\u_Form_Verif_Event.pas' {FVerifEvent},
  u_form_individu_connector in '..\Individus\u_form_individu_connector.pas' {FIndividuConnector},
  u_form_OpenSources in '..\Divers\u_form_OpenSources.pas' {FOpenSources},
  u_form_export_geneanet in '..\Gedcom\u_form_export_geneanet.pas' {FExportGeneanet},
  u_form_edit_ref_token_date in '..\Gedcom\u_form_edit_ref_token_date.pas' {FEditRefTokenDate},
  u_gedcom_const in '..\Gedcom\u_gedcom_const.pas',
  u_form_param_reports in '..\Editions\u_form_param_reports.pas' {FParamReports},
  u_form_ask_name_files_to_export_report in '..\Editions\u_form_ask_name_files_to_export_report.pas' {FAskNameFilesToExportReport},
  u_form_Pays in '..\Divers\u_form_Pays.pas' {FPays: TSuperForm},
  u_form_select_database in '..\Divers\u_form_select_database.pas' {FSelectDatabase: TSuperForm},
  u_form_Restore in '..\Divers\u_form_Restore.pas' {FRestore: TSuperForm},
  u_Form_Liste_Deces_Ville in '..\Divers\u_Form_Liste_Deces_Ville.pas' {FDecesParVille: TSuperForm},
  hh in '..\Main\hh.pas',
  hh_funcs in '..\Main\hh_funcs.pas',
  u_form_language in '..\Divers\u_form_language.pas' {FLanguage: TSuperForm},
  u_form_Web in '..\Divers\u_form_Web.pas' {FWeb: TSuperForm},
  u_form_biblio_Multimedia_Edit in '..\Divers\u_form_biblio_Multimedia_Edit.pas' {FBiblio_Multimedia_Edit: TSuperForm},
  u_Form_Liste_Unions in '..\Divers\u_Form_Liste_Unions.pas' {FListeUnions: TSuperForm},
  u_Form_Posthumes in '..\Individus\u_Form_Posthumes.pas' {FPosthumes: TSuperForm},
  u_form_calendriers in '..\Calendrier\u_form_calendriers.pas' {FCalendriers: TSuperForm},
  u_form_calendriers_func in '..\Calendrier\u_form_calendriers_func.pas',
  u_form_calendriers_gregorien in '..\Calendrier\u_form_calendriers_gregorien.pas',
  u_form_Modif_Favoris in '..\Divers\u_form_Modif_Favoris.pas' {FModifFavoris: TSuperForm},
  u_form_calendriers_infos in '..\Calendrier\u_form_calendriers_infos.pas' {FCalendriers_infos: TSuperForm},
  u_Form_About in '..\Divers\u_Form_About.pas' {FAbout},
  u_Form_Liste_Naiss_Ville in '..\Divers\u_Form_Liste_Naiss_Ville.pas' {FNaissanceParVille: TSuperForm},
  u_Form_Orphelins in '..\Individus\u_Form_Orphelins.pas' {FOrphelins: TSuperForm},
  u_Form_Individu_Sur_Favoris in '..\Individus\u_Form_Individu_Sur_Favoris.pas' {FIndividusSurFavoris: TSuperForm},
  u_form_individu_observations in '..\Individus\u_form_individu_observations.pas' {FIndividuObservations: TSuperForm},
  u_form_individu_photos_et_docs in '..\Individus\u_form_individu_photos_et_docs.pas' {FIndividuPhotosEtDocs: TSuperForm},
  u_form_list_villes_Doublons in '..\Divers\u_form_list_villes_Doublons.pas' {FListeVillesDoublons: TSuperForm},
  u_Form_SansVilles in '..\Individus\u_Form_SansVilles.pas' {FSansVilles: TSuperForm},
  u_Form_Bibliotheque_Multimedia in '..\Multimedia\u_Form_Bibliotheque_Multimedia.pas' {FBibliothequeMultimedia: TSuperForm},
  u_form_Evements_Ajout in '..\Divers\u_form_Evements_Ajout.pas' {FEvenement_Ajout: TSuperForm},
  u_Form_Agent in '..\Divers\u_Form_Agent.pas' {FAgent: TSuperForm},
  u_Form_InverseInsee in '..\Divers\u_Form_InverseInsee.pas' {FInverseInsee: TSuperForm},
  u_Form_Compte_Favoris in '..\Divers\u_Form_Compte_Favoris.pas' {FCompteFavoris: TSuperForm},
  u_Form_Infos in '..\Divers\u_Form_Infos.pas' {FInfos: TSuperForm},
  u_Form_Maj_Internet in '..\Divers\u_Form_Maj_Internet.pas' {FMajInternet: TSuperForm},
  u_Form_Liste_Doublons in '..\Divers\u_Form_Liste_Doublons.pas' {FListeDoublons: TSuperForm},
  U_Form_Cartographie in '..\Cartographie\U_Form_Cartographie.pas' {FCartoGraphie},
  u_form_edit_ref_religions in '..\Context\u_form_edit_ref_religions.pas' {FEditRefReligions: TSuperForm},
  u_Form_Compte_Villes in '..\Divers\u_Form_Compte_Villes.pas' {FCompteVilles: TSuperForm},
  u_form_individu_Actes in '..\Individus\u_form_individu_Actes.pas' {FIndividuActes: TSuperForm},
  u_form_Ville_Favoris in '..\Divers\u_form_Ville_Favoris.pas' {FVillesFavoris: TSuperForm},
  u_form_biblio_Sources in '..\Evenements\u_form_biblio_Sources.pas' {FBiblio_Sources: TSuperForm},
  u_form_Biblio_Documents in '..\Evenements\u_form_Biblio_Documents.pas' {FBiblio_Documents: TSuperForm},
  u_form_coherence in '..\Individus\u_form_coherence.pas' {FCoherence: TSuperForm},
  U_Microsoft_Agent in '..\Main\U_Microsoft_Agent.pas',
  u_Form_About_Suite in '..\Divers\u_Form_About_Suite.pas' {FAboutSuite: TSuperForm};

{$R *.RES}

begin
  Application.Initialize;
  Application.Title := 'Ancestrologie';
  Application.CreateForm(Tdm, dm);
  Application.CreateForm(TFMain, FMain);
  Application.Run;
end.

