unit U_Form_Main;

interface

uses
  Windows, Messages, SysUtils, Forms, Classes, IBStoredProc, DB,
  IBCustomDataSet, IBQuery, Dialogs, IBDatabase, dxCntner, dxEditor,
  dxEdLib, StdCtrls, u_comp_TGoodBtn, URLLink, jpeg, Graphics, ExtCtrls,
  Controls, Buttons, registry, ComCtrls, IBServices, compSuperForm;
{
, Graphics, Controls, Forms, Dialogs,
StdCtrls, IBDatabase, Db, dxTL, dxTLClms, dxCntner, IBCustomDataSet,
IBQuery, IBStoredProc, Buttons, ExtCtrls, jpeg, u_comp_TGoodBtn,
dxEditor, dxEdLib, URLLink, ComCtrls, registry  }

type
  TFMain = class(TSuperForm)
    Panel1: TPanel;
    Panel15: TPanel;
    SpeedButton2: TSpeedButton;
    Label10: TLabel;
    sdfsf: TSpeedButton;
    Panel2: TPanel;
    Panel3: TPanel;
    Image2: TImage;
    lb1: TLabel;
    Label1: TLabel;
    sbBase: TSpeedButton;
    Image1: TImage;
    OpenDialog: TOpenDialog;
    btnRestaurer: TGoodBtn;
    btnQuitter: TGoodBtn;
    Edit1: TdxEdit;
    urlLink: TURLLink;
    lbVersion: TLabel;
    Memo1: TRichEdit;
    IBRestoreService: TIBRestoreService;
    procedure sbBaseClick(Sender: TObject);
    procedure Panel15MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure sdfsfClick(Sender: TObject);
    procedure urlLinkClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure btnRestaurerClick(Sender: TObject);
    procedure btnQuitterClick(Sender: TObject);
    procedure SuperFormRefreshControls(Sender: TObject);
    procedure SuperFormShowFirstTime(Sender: TObject);
  private
    fDataBase: string;

    function GetVersion: string;
    //          function GetClefUnique(NameGenerator: string): integer;
              { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  FMain: TFMain;

implementation

uses
  u_objet_TCut, u_form_msg, ShellAPI;

{$R *.DFM}

function MyMessageDlg(const Msg: string; DlgType: TMsgDlgType; Buttons: TMsgDlgButtons; HelpCtx: Longint): Word;
var
  aFMsg: TFMsg;
begin
  aFMsg := TFMsg.create(nil);
  try
    aFMsg.lbMsg.Caption := Msg;
    aFMsg.Buttons := Buttons;
    aFMsg.DlgType := DlgType;
    result := aFMsg.ShowModal;
  finally
    aFMsg.Free;
  end;
end;

procedure GotoThisURL(URL: string);
var
  tmp, para: string;

const nbr_extension = 4;
  extension: array[0..nbr_extension - 1] of string = ('.HTM', '.HTML', '.SHTML', '.SHTM');

  function FindBrowser: string;
  var c: byte;
    hkey1, hkey2: hkey;
    typ, taille: integer;
    tmp: array[0..1024] of char;
    tmpstr: string;
    procedure Arrange;
    var u: word;
    begin
      tmpstr := strpas(tmp);
      u := 1;
      repeat
        if tmpstr[u] <> '%' then inc(u) else delete(tmpstr, u, 2);
      until u >= length(tmpstr);
      RegCloseKey(hkey2);
      FindBrowser := tmpstr;
    end;
  begin
    c := 0;
    repeat
      if regopenkeyex(hkey_classes_root, pchar(extension[c]), 0, key_all_access, hkey1) = 0 then
        begin
          if regqueryvalueex(hkey1, nil, nil, @typ, nil, @taille) = error_success then
            begin
              regqueryvalueex(hkey1, nil, nil, nil, @tmp, @taille);
              if tmp <> '' then
                if regopenkeyex(hkey_classes_root, pchar(tmp + '\shell\open\command'), 0, key_all_access, hkey2) = error_success then
                  begin
                    if regqueryvalueex(hkey2, nil, nil, @typ, nil, @taille) = error_success then
                      begin
                        regqueryvalueex(hkey2, nil, nil, nil, @tmp, @taille);
                        if tmp <> '' then
                          begin
                            Arrange;
                            Exit;
                          end;
                      end;
                    regclosekey(hkey2);
                  end;
              if regopenkeyex(hkey1, 'shell\open\command', 0, key_all_access, hkey2) = error_success then
                begin
                  if regqueryvalueex(hkey2, nil, nil, @typ, nil, @taille) = error_success then
                    begin
                      regqueryvalueex(hkey2, nil, nil, nil, @tmp, @taille);
                      if tmp <> '' then
                        begin
                          Arrange;
                          Exit;
                        end;
                    end;
                end;
            end;
          regclosekey(hkey1);
        end;
      inc(c);
    until c = nbr_extension;
    FindBrowser := '';
  end;

  function BrowserPath: string;
  var tmp: string;
    c: word;
  begin
    tmp := findbrowser;
    if tmp <> '' then
      begin
        tmp := uppercase(tmp);
        c := length(tmp) + 1;
        repeat
          dec(c);
          para := copy(tmp, c - 3, 4);
        until (para = '.EXE') or (para = '.BAT') or (para = '.COM');
        if c < length(tmp) then
          begin
            para := trim(copy(tmp, c + 1, length(tmp) - (c)));
            while (para <> '') and (para[1] = '"') do delete(para, 1, 1);
            delete(tmp, c + 1, length(tmp) - (c));
          end else para := '';
        if tmp[1] = '"' then delete(tmp, 1, 1);
      end;
    BrowserPath := tmp;
  end;

begin
  tmp := BrowserPath;
  if tmp <> '' then
    begin
      shellexecute(application.handle, nil, pchar(tmp), pchar(para + ' ' + Url), nil, SW_SHOWNORMAL);
    end;
end;

procedure TFMain.sbBaseClick(Sender: TObject);
begin
  if OpenDialog.execute then Edit1.text := opendialog.filename;

  doRefreshControls;
end;

procedure TFMain.Panel15MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFMain.sdfsfClick(Sender: TObject);
begin
  close;
end;

procedure TFMain.urlLinkClick(Sender: TObject);
begin
  GotoThisURL('www.ancestrologie.com');
end;

procedure TFMain.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = VK_ESCAPE then Close;
end;

procedure TFMain.FormCreate(Sender: TObject);
var
  fIni: TRegIniFile;
  fKeyRegistry: string;
  fBackup: string;
  FileNameGBK, PathNameGBK: string;
begin
  try
    Memo1.Clear;
    if FileExists(ExtractFilePath(Application.ExeName) + 'RESTAURE BASE.RTF') then
      begin
        Memo1.lines.loadFromFile(ExtractFilePath(Application.ExeName) + 'RESTAURE BASE.RTF');
      end;
  except
  end;
  lbVersion.Caption := '[Build ' + GetVersion + ']';

  fKeyRegistry := '\SOFTWARE\Ancestro2001\';

  fIni := TRegIniFile.create;
  try
    fIni.RootKey := HKEY_CURRENT_USER;

    if fIni.OpenKey(fKeyRegistry, false) then
      begin
        //La base de donne
        fBackup := fIni.ReadString('Path', 'PathFileNameBdd', '');
        fDataBase := fBackup;

        FileNameGBK := ExtractFileName(fBackup);
        FileNameGBK := ChangeFileExt(FileNameGBK, '.GBK');
        PathNameGBK := ExtractFilePath(fBackup) + 'Backup\';

        if FileExists(PathNameGBK + FileNameGBK)
          then Edit1.Text := PathNameGBK + FileNameGBK
        else Edit1.Text := '';


      end;
  finally
    fIni.Free;
  end;
end;

function TFMain.GetVersion: string;
var
  Wnd: DWord;
  theSize: DWord;
  verBuf: pointer;
  FI: PVSFixedFileInfo;
  fNoMineur: string;
  fNoMajeur: string;
  fNoSousVersion: string;
  fNoConstruction: string;
begin
  fNoMineur := '0';
  fNoMajeur := '0';
  fNoSousVersion := '0';
  fNoConstruction := '0';
  theSize := getFileVersionInfoSize(PChar(application.exename), Wnd);

  if theSize <> 0 then
    begin
      GetMem(verBuf, theSize);
      try
        if GetFileVersionInfo(PChar(application.exename), Wnd, theSize, VerBuf) then
          begin
            if VerQueryValue(VerBuf, '\', Pointer(FI), theSize) then
              begin
                fNoMineur := inttostr(FI.dwProductVersionMS shr 16);
                fNoMajeur := inttostr((FI.dwProductVersionMS shl 16) shr 16);
                fNoSousVersion := inttostr(FI.dwProductVersionLS shr 16);
                fNoConstruction := inttostr((FI.dwProductVersionLS shl 16) shr 16);
              end;
          end;
      finally
        FreeMem(VerBuf);
      end;
    end;

  result := fNoMineur + '.' + fNoMajeur + '.' + fNoSousVersion + '.' + fNoConstruction;
end;

procedure TFMain.btnRestaurerClick(Sender: TObject);

var
  Save_Cursor: TCursor;
  ibRestore: TIBRestoreService;

  cp: integer;
begin
  if not FileExists(Edit1.Text) then
    begin
      MyMessageDlg('Le fichier backup, n''existe pas  l''endroit spcifi.'#13#10#13#10, mtInformation, [mbOK], 0);
      exit;
    end;

  btnRestaurer.Enabled := False;

  Screen.Cursor := crHourglass;

  ibRestore := TIBRestoreService.Create(Self);
  Application.ProcessMessages;
  Memo1.Clear;

  with IBRestore do

    begin
      LoginPrompt := False;
      Params.Add('user_name=SYSDBA');
      Params.Add('password=masterkey');
      Active := True;

      try
        Verbose := True;
        Options := [Replace, UseAllSpace];
        PageBuffers := 32000;
        PageSize := 4096;
        DatabaseName.Add(fDataBase);

        BackupFile.Add(Edit1.Text);

        Memo1.Clear;
        ServiceStart;
        cp := 0;

        while not Eof do
          begin
            Memo1.Lines.Append(GetNextLine);
            inc(cp);

            if cp > 5 then
              begin
                Application.ProcessMessages;
                Application.ProcessMessages;
                cp := 0;
              end;
          end;


        Screen.Cursor := Save_Cursor;

        MyMessageDlg('La restauration de la base s''est bien passe.'#13#10#13#10, mtInformation, [mbOK], 0);

      finally
        Active := False;
      end;
    end;
  Screen.Cursor := Save_Cursor;

  ibRestore.Free;
end;

procedure TFMain.btnQuitterClick(Sender: TObject);
begin
  close;
end;

procedure TFMain.SuperFormRefreshControls(Sender: TObject);
begin
  btnRestaurer.enabled := FileExists(Edit1.Text);
end;

procedure TFMain.SuperFormShowFirstTime(Sender: TObject);
begin
  doRefreshControls;
end;

end.

