{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_Union_events_notes;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, StdCtrls, dxCntner, dxEditor,
  dxExEdtr, dxEdLib, dxDBELib, u_comp_TYLanguage;

type
  TFUnionEventsNotes = class(TSuperForm)
    edMemo: TdxDBMemo;
    Language: TYLanguage;
    procedure edMemoKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SuperFormCreate(Sender: TObject);
  private
    fFormIndividuUnion: TForm;
    procedure SetFormIndividuUnion(const Value: TForm);
  public
    property FormIndividuUnion: TForm read fFormIndividuUnion write SetFormIndividuUnion;
    procedure DoRefresh(Mode: boolean);
  end;

implementation

uses u_dm, u_form_individu_Union, u_form_Union_events_details,
  u_form_individu, u_common_const, u_common_var;

{$R *.DFM}

{ TFIndividuIdentiteEventsSources }

procedure TFUnionEventsNotes.DoRefresh(Mode: boolean);
begin
  edMemo.enabled := mode;
end;

procedure TFUnionEventsNotes.SetFormIndividuUnion(const Value: TForm);
//var
     //PtrForm: TFIndividuEvents;
begin
  fFormIndividuUnion := Value;
  //  if Value <> nil then PtrForm := TFIndividuEvents(Value) else PtrForm := nil;

    //edMemo.DataSource := PtrForm.dsEve;
end;

procedure TFUnionEventsNotes.edMemoKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  //     TFIndividu(TFIndividuUnion(fFormIndividuUnion).FormIndividu).TestIfHelp(Key);
end;

procedure TFUnionEventsNotes.SuperFormCreate(Sender: TObject);
begin
  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;
end;

end.
