{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_Union_events_sources;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, StdCtrls, dxCntner, dxEditor, DB,
  dxExEdtr, dxEdLib, dxDBELib, u_comp_TYLanguage, u_comp_TGoodBtn;

type
  TFUnionEventsSources = class(TSuperForm)
    edMemo: TdxDBMemo;
    Language: TYLanguage;
    procedure SuperFormCreate(Sender: TObject);
    procedure edMemoKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    fFormIndividuUnion: TForm;
    procedure SetFormIndividuUnion(const Value: TForm);

  public
    property FormIndividuUnion: TForm read fFormIndividuUnion write SetFormIndividuUnion;
    procedure DoRefresh(Mode: boolean);
  end;

implementation

uses u_form_individu,
  u_dm,
  u_form_individu_Union, u_common_const, u_common_var;

{$R *.DFM}

{ TFIndividuIdentiteEventsSources }

procedure TFUnionEventsSources.DoRefresh(Mode: boolean);
begin
  edMemo.enabled := mode;
end;

procedure TFUnionEventsSources.SetFormIndividuUnion(const Value: TForm);
var
  PtrForm: TFIndividuUnion;
begin
  fFormIndividuUnion := Value;

  if Value <> nil then PtrForm := TFIndividuUnion(Value) else PtrForm := nil;

  edMemo.DataSource := PtrForm.dsEve;
end;


procedure TFUnionEventsSources.SuperFormCreate(Sender: TObject);
begin
  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  fFormIndividuUnion := nil;
end;

procedure TFUnionEventsSources.edMemoKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  //     TFIndividu(TFIndividuUnion(fFormIndividuUnion).FormIndividu).TestIfHelp(Key);
end;

end.
