unit u_form_msg;

interface

uses
     Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
     CompSuperForm, ExtCtrls, GraphicEx, StdCtrls, TFlatSpeedButtonUnit,
     Buttons, u_comp_TGoodBtn;

type
     TFMsg = class(TSuperForm)
          Panel1: TPanel;
          Panel2: TPanel;
          lbMsg: TLabel;
          Image1: TImage;
          Panel15: TPanel;
          SpeedButton2: TSpeedButton;
          lbTitre: TLabel;
    btn1: TGoodBtn;
    btn2: TGoodBtn;
    btn3: TGoodBtn;
          procedure SuperFormShowFirstTime(Sender: TObject);
          procedure Panel15MouseDown(Sender: TObject; Button: TMouseButton;
               Shift: TShiftState; X, Y: Integer);
          procedure SuperFormKeyDown(Sender: TObject; var Key: Word;
               Shift: TShiftState);
     private
          fButtons: TMsgDlgButtons;
          fDlgType: TMsgDlgType;

     public
          property Buttons: TMsgDlgButtons read fButtons write fButtons;
          property DlgType: TMsgDlgType read fDlgType write fDlgType;
     end;



implementation

{$R *.DFM}

procedure TFMsg.SuperFormShowFirstTime(Sender: TObject);
var
     k, p: integer;

     procedure PutInBtn(numBtn: integer; aText: string; aResult: word);
     begin
          case numBtn of

               1: begin
                         btn1.Caption := aText;
                         btn1.ModalResult := aResult;
                         btn1.visible := true;
                    end;
               2: begin
                         btn2.Caption := aText;
                         btn2.ModalResult := aResult;
                         btn2.visible := true;
                    end;
               3: begin
                         btn3.Caption := aText;
                         btn3.ModalResult := aResult;
                         btn3.visible := true;
                    end;
          end;
     end;

begin
     btn1.visible := false;
     btn2.visible := false;
     btn3.visible := false;

     k := 0;
     if (mbYes in fButtons) then inc(k);
     if (mbNo in fButtons) then inc(k);
     if (mbOk in fButtons) then inc(k);
     if (mbCancel in fButtons) then inc(k);
     if (mbIgnore in fButtons) then inc(k);

     if (k > 0) and (k <= 3) then
          begin
               p := 3 - k; //numro du btn de dpart (-1)


               //          for m := 1 to k do
                 //        begin

               if (mbYes in fButtons) then
                    begin
                         inc(p);
                         putInBtn(p, 'Oui', mrYes);
                         fButtons := fButtons - [mbYes];
                    end;

               if (mbNo in fButtons) then
                    begin
                         inc(p);
                         putInBtn(p, 'Non', mrNo);
                         fButtons := fButtons - [mbNo];
                    end;

               if (mbOk in fButtons) then
                    begin
                         inc(p);
                         putInBtn(p, 'Ok', mrOk);
                         fButtons := fButtons - [mbOk];
                    end;

               if (mbCancel in fButtons) then
                    begin
                         inc(p);
                         putInBtn(p, 'Annuler', mrCancel);
                         fButtons := fButtons - [mbCancel];
                    end;

               if (mbIgnore in fButtons) then
                    begin
                         inc(p);
                         putInBtn(p, 'Ignorer', mrIgnore);
                         fButtons := fButtons - [mbIgnore];
                    end;
          end;

     case fDlgType of

          mtWarning: lbTitre.Caption := 'Attention';
          mtError: lbTitre.Caption := 'Erreur';
          mtInformation: lbTitre.Caption := 'Information';
          mtConfirmation: lbTitre.Caption := 'Confirmation';
     else
          lbTitre.Caption := '';
     end;

     //  lbTitre

       {

       k := 0;
       for n := Low(fButtons) to High(fButtons) do inc(k);

       if k > 0 then
       begin
            p := 3 - k; //numro du btn de dpart (-1)
            for B := Low(fButtons) to High(fButtons) do
            begin
                 inc(p);

                 //texte et retour du bouton :
                 case B of
                      mbYes: begin
                           end;
                      mbNo: begin
                                theText := 'Non';
                                theRetour := mrNo;
                           end;
                      mbOk: begin
                                theText := 'Ok';
                                theRetour := mrOk;
                           end;
                      mbCancel: begin
                                theText := 'Annuler';
                                theRetour := mrCancel;
                           end;
                      mbIgnore: begin
                                theText := 'Ignorer';
                                theRetour := mrIgnore;
                           end;
                 else
                      begin
                           theText := '';
                           theRetour := mrNone;
                      end;
                 end;

                 //affectation au bouton :
                 case p of

                      1: begin
                                btn1.Caption := theText;
                                btn1.ModalResult := theRetour;
                                btn1.visible := true;
                           end;
                      2: begin
                                btn2.Caption := theText;
                                btn2.ModalResult := theRetour;
                                btn2.visible := true;
                           end;
                      3: begin
                                btn3.Caption := theText;
                                btn3.ModalResult := theRetour;
                                btn3.visible := true;
                           end;
                 end;
            end;
       end;
       }
    // end;
end;


procedure TFMsg.Panel15MouseDown(Sender: TObject; Button: TMouseButton;
     Shift: TShiftState; X, Y: Integer);
begin
     ReleaseCapture;
     TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFMsg.SuperFormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
     if (ssAlt in Shift) and (Key = VK_F4) then Key := 0;
end;

end.
