unit u_Form_About;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, jpeg, ExtCtrls, URLLink, StdCtrls, ShellAPI, u_comp_TInfoVersion,
  DB, IBCustomDataSet, IBQuery, u_comp_TNakedSpeedButton, TFlatButtonUnit,
  GraphicEx;

type
  TFAbout = class(TForm)
    Image1: TImage;
    n1: TLabel;
    n2: TURLLink;
    lBuild: TLabel;
    InfoVersion: TInfoVersion;
    lVersionBase: TLabel;
    Timer1: TTimer;
    Label1: TLabel;
    procedure Image1Click(Sender: TObject);
    procedure n2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Dclarations prives }
    bFirst: boolean;
    bTimer: boolean;
    iInterval: integer;
    procedure DoParticipants;
  public
    bInitTimer: boolean;
    { Dclarations publiques }
  end;

var
  FAbout: TFAbout;

implementation

uses u_dm, u_Form_About_Suite;

{$R *.dfm}

procedure TFAbout.Image1Click(Sender: TObject);
begin
  if bInitTimer then Close;
end;

procedure TFAbout.n2Click(Sender: TObject);
var
  url: string;
begin
  if bInitTimer then
    begin
      url := dm.GetUrlAncestrologie;
      shellexecute(application.handle, nil, pchar(url), nil, nil, SW_SHOWNORMAL);
    end;
end;

procedure TFAbout.FormCreate(Sender: TObject);
begin

  bInitTimer := True;
  n2.Caption := dm.GetUrlSite;
  lBuild.Caption := 'Build [' + InfoVersion.Version + ']';

  if length(dm.VersionBase) > 0 then
    lVersionBase.Caption := 'Version de la base : ' + dm.VersionBase;

  Application.ProcessMessages;
end;

procedure TFAbout.DoParticipants;
var aFAboutSuite: TFAboutSuite;
begin
  if bInitTimer then
    begin
      aFAboutSuite := TFAboutSuite.create(self);
      try
        aFAboutSuite.ShowModal;
      finally
        begin
          bTimer := False;
          aFAboutSuite.Free;
        end;
      end;
    end;
end;

procedure TFAbout.Timer1Timer(Sender: TObject);
begin
  if bInitTimer then
    begin
      if bTimer = False then
        begin
          bTimer := True;

          if not bFirst then iInterval := 4000;

          Timer1.Interval := iInterval;
          iInterval := 6000;
          bFirst := true;
          DoParticipants;
        end;
    end;
end;

end.

