{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_Form_InverseInsee;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, u_comp_TBlueFlatSpeedButton, ExtCtrls, TFlatPanelUnit, Ibquery,
  StdCtrls, jpeg, TFlatSpeedButtonUnit, Buttons, u_comp_TGoodBtn,
  u_comp_TYLanguage, DynamicSkinForm;

type
  TFInverseInsee = class(TSuperForm)
    pBorder: TPanel;
    Panel7: TPanel;
    Panel9: TPanel;
    Image2: TImage;
    Panel10: TPanel;
    Panel11: TPanel;
    FlatPanel1: TFlatPanel;
    btnFermer: TGoodBtn;
    Language: TYLanguage;
    btnConvert: TGoodBtn;
    Label1: TLabel;
    spDynamicSkinForm1: TspDynamicSkinForm;
    procedure SuperFormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure pTopMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SuperFormCreate(Sender: TObject);
    procedure btnConvertClick(Sender: TObject);
  private

  public

  end;

implementation

uses u_dm, u_common_var, u_common_const, u_objet_TContext, u_form_main;

{$R *.DFM}


procedure TFInverseInsee.SuperFormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
    VK_ESCAPE: ModalResult := mrOk;
    _KEY_HELP: dm.ShowHelp(_ID_INFOS_DOSSIER);
  end;
end;

procedure TFInverseInsee.pTopMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFInverseInsee.SpeedButton1Click(Sender: TObject);
begin
  ModalResult := mrCancel;
  Close;
end;


procedure TFInverseInsee.SuperFormCreate(Sender: TObject);
begin
  label1.Caption := 'Cette action permet de remplacer le code INSEE par le Code Postal, ' +
    'pour ceux qui ont mis le code INSEE  la place du code postal. ' + #10#13 + #10#13 +
    'Attention, cette action est irreversible et ne doit tre excute qu''une seule fois.' + #10#13 +
    'Cette action peut prendre plusieurs minutes...' + #10#13 + #10#13 +
    'Il est fortemnt conseill de faire un export GEDCOM avant de lancer la conversion.';

  if _Context.Skin then
    begin
      ClientHeight := 232;
      ClientWidth := 429;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;

end;

procedure TFInverseInsee.btnConvertClick(Sender: TObject);
begin
  btnConvert.Enabled := False;
  dm.doChangeInsee;

  Close;
end;

end.
