{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_Occupe;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, GraphicEx, ExtCtrls, dxCntner, dxExEdtr, dxEdLib, ComCtrls,
  TFlatPanelUnit, u_comp_TYLanguage;

type
  TFOccupe = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Animate: TAnimate;
    FlatPanel1: TFlatPanel;
    Label1: TLabel;
    Language: TYLanguage;
    procedure FormCreate(Sender: TObject);

  public
    procedure doActive;
    procedure doDesactive;
  end;

var
  FOccupe: TFOccupe;

implementation

uses u_common_const, u_common_var;

{$R *.DFM}

{ TFOccupe }

procedure TFOccupe.doActive;
begin
  Show;
  application.processmessages;
  Animate.Active := true;
end;

procedure TFOccupe.doDesactive;
begin
  Hide;
  application.processmessages;
  Animate.Active := false;
end;

procedure TFOccupe.FormCreate(Sender: TObject);
begin
  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;
end;

end.
