{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_repertoire;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, StdCtrls, ExtCtrls, TFlatTabControlUnit, dxCntner, dxTL,
  dxDBGrid, DBCtrls, Db, IBCustomDataSet, IBQuery, dxGrClms,
  u_comp_TFlatTabControl2, TFlatPanelUnit,
  u_comp_TBlueFlatSpeedButton, Menus, Mask, dxDBCtrl,
  dxDBTLCl, dxEditor, dxEdLib, dxDBELib, TFlatButtonUnit,
  TFlatSpeedButtonUnit, dxExEdtr, RVStyle, RVScroll, RichView,
  u_objet_TIntegerList, u_comp_TGoodBtn, u_comp_TYLanguage;

type
  TFRepertoire = class(TSuperForm)
    IBQListeNom: TIBQuery;
    DSListeNom: TDataSource;
    pmGrid: TPopupMenu;
    Ouvrirlafiche1: TMenuItem;
    N1: TMenuItem;
    Ouvrirlafichedansunenouvellefentre1: TMenuItem;
    IBQDetail: TIBQuery;
    DSDetail: TDataSource;
    IBQPere: TIBQuery;
    DSPere: TDataSource;
    IBQMere: TIBQuery;
    DSMere: TDataSource;
    IBQEvPere: TIBQuery;
    DSEvPere: TDataSource;
    DSEvMere: TDataSource;
    IBQEvMere: TIBQuery;
    N2: TMenuItem;
    ExporterenHTML: TMenuItem;
    IBQPereCLE_FICHE: TIntegerField;
    IBQPereNOM: TIBStringField;
    IBQPerePRENOM: TIBStringField;
    IBQEvPereEV_IND_DATE_WRITEN: TIBStringField;
    IBQEvPereEV_IND_VILLE: TIBStringField;
    IBQMereCLE_FICHE: TIntegerField;
    IBQMereNOM: TIBStringField;
    IBQMerePRENOM: TIBStringField;
    IBQEvMereEV_IND_DATE_WRITEN: TIBStringField;
    IBQEvMereEV_IND_VILLE: TIBStringField;
    Panel2: TPanel;
    RVStyle: TRVStyle;
    QueryFindOneIndi: TIBQuery;
    N3: TMenuItem;
    Supprimerlafiche1: TMenuItem;
    QueryDeleteIndividu: TIBQuery;
    panTabs: TPanel;
    PaintBoxOnglet: TPaintBox;
    Panel5: TPanel;
    Panel11: TPanel;
    Panel13: TPanel;
    Panel1: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel6: TPanel;
    panDock: TPanel;
    Panel8: TPanel;
    sNom: TdxEdit;
    rbF: TdxCheckEdit;
    rbH: TdxCheckEdit;
    rbTous: TdxCheckEdit;
    fbRecherche: TGoodBtn;
    Panel12: TPanel;
    Panel7: TPanel;
    Panel10: TPanel;
    dxDBGridNom: TdxDBGrid;
    dxDBGCSexe: TdxDBGridImageColumn;
    dxDBGCNom: TdxDBGridColumn;
    dxDBPrenom: TdxDBGridColumn;
    Panel14: TPanel;
    Panel15: TPanel;
    Panel16: TPanel;
    Panel17: TPanel;
    Panel18: TPanel;
    Panel9: TPanel;
    rv: TRichView;
    SaveDialog: TSaveDialog;
    Language: TYLanguage;
    N4: TMenuItem;
    Ajouterauxfavoris: TMenuItem;
    lPere: TLabel;
    lMere: TLabel;
    dxDBNe: TdxDBGridColumn;
    dxDBDeces: TdxDBGridColumn;
    N5: TMenuItem;
    Imprimercetteliste1: TMenuItem;
    dxDBLieuNe: TdxDBGridColumn;
    N6: TMenuItem;
    mColNe: TMenuItem;
    mCola: TMenuItem;
    mColDeces: TMenuItem;
    lConjoint: TLabel;
    IBQConjoint: TIBQuery;
    DSConjoint: TDataSource;
    IBQConjointCLE_FICHE: TIntegerField;
    IBQConjointNOM: TIBStringField;
    IBQConjointPRENOM: TIBStringField;
    IBQConjointSEXE: TIntegerField;
    IBQListeNomNOM: TIBStringField;
    IBQListeNomPRENOM: TIBStringField;
    IBQListeNomSURNOM: TIBStringField;
    IBQListeNomSEXE: TIntegerField;
    IBQListeNomCLE_FICHE: TIntegerField;
    IBQListeNomCLE_PERE: TIntegerField;
    IBQListeNomCLE_MERE: TIntegerField;
    IBQListeNomKLE_DOSSIER: TIntegerField;
    IBQListeNomDATE_NAISSANCE: TIBStringField;
    IBQListeNomANNEE_DECES: TIntegerField;
    IBQListeNomCP: TIBStringField;
    IBQListeNomVILLE: TIBStringField;
    dxDBCP: TdxDBGridColumn;
    mColCode: TMenuItem;
    sPrenom: TdxEdit;
    Label1: TLabel;
    Label2: TLabel;
    procedure dxDBGridNomDblClick(Sender: TObject);
    procedure IBQListeNomAfterScroll(DataSet: TDataSet);
    procedure rgSexeClick(Sender: TObject);
    procedure rgEtatClick(Sender: TObject);
    procedure Ouvrirlafichedansunenouvellefentre1Click(Sender: TObject);
    procedure ExporterenHTMLClick(Sender: TObject);
    procedure sNomChange(Sender: TObject);
    procedure fbRechercheClick(Sender: TObject);
    procedure rbTousChange(Sender: TObject);
    procedure SuperFormCreate(Sender: TObject);
    procedure rbHChange(Sender: TObject);
    procedure rbFChange(Sender: TObject);
    procedure sNomKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SuperFormRefreshControls(Sender: TObject);
    procedure SuperFormShowFirstTime(Sender: TObject);
    procedure SuperFormDestroy(Sender: TObject);
    procedure rvJump(Sender: TObject; id: Integer);
    procedure PaintBoxOngletPaint(Sender: TObject);
    procedure PaintBoxOngletMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure dxDBGridNomChangeNode(Sender: TObject; OldNode,
      Node: TdxTreeListNode);
    procedure SuperFormKeyPress(Sender: TObject; var Key: Char);
    procedure pmGridPopup(Sender: TObject);
    procedure Supprimerlafiche1Click(Sender: TObject);
    procedure AjouterauxfavorisClick(Sender: TObject);
    procedure Imprimercetteliste1Click(Sender: TObject);
    procedure mColNeClick(Sender: TObject);
    procedure mColaClick(Sender: TObject);
    procedure mColDecesClick(Sender: TObject);
    procedure mColCodeClick(Sender: TObject);
  private
    fNumOngletSelected: integer;

    fFill: boolean;
    fCanScroll: boolean;
    fSQLChanged: boolean;

    fIndiCle: TIntegerList;
    fIndiJumpTag: TIntegerList;

    fTextesOnglets: TStringList;

    procedure doTellToOpenIndividuAndClose;
    procedure doFind;
    procedure doFillBottomInfos;
    procedure SetNumOngletSelected(index: integer);
    procedure SetTabByPositionMouse(x: integer);

  public
    procedure up_InitRepertoire(a_Lettre: string; a_Sexe, a_Mode: integer);
    procedure InitRepertoireWithFicheActive;

    procedure CloseAllQuerys;
    procedure doRefreshRepertoire;

    function GetCleFicheSelected: integer;
    function GetNomFicheSelected: string;
  end;

implementation

uses u_dm, u_form_main, u_common_func, u_common_var, u_common_const;
{$R *.DFM}
const
  _SQL_ORIGINE = 'select *  FROM PROC_LISTE_INDIVIDU(:DOSSIER, :LETTRE, :QUI, :SEXE)';

procedure TFRepertoire.up_InitRepertoire(a_Lettre: string; a_Sexe, a_Mode: integer);
var i_Tab: smallInt;
begin

  i_Tab := POS(a_Lettre, 'ABCDEFGHIJKLMNOPQRSTUVWXYZ');

  SetNumOngletSelected(i_Tab);

  fFill := true;
  try
    case a_Sexe of

      1: begin
          rbTous.checked := false;
          rbH.checked := true;
          rbF.checked := false;
        end;

      2: begin
          rbTous.checked := false;
          rbH.checked := false;
          rbF.checked := true;
        end;
      else
        begin
          rbTous.checked := true;
          rbH.checked := false;
          rbF.checked := false;
        end;
    end;

  finally
    fFill := false;
  end;

  doRefreshRepertoire;
end;

procedure TFRepertoire.doRefreshRepertoire;
var
  debut: string;
  fTryToSelectCleFiche: integer;
begin
  fCanScroll := false;
  //relancer la requette

  if fNumOngletSelected > 0
    then debut := copy('ABCDEFGHIJKLMNOPQRSTUVWXYZ', fNumOngletSelected, 1) //nom commenant par
  else debut := '*'; //tout le monde


  fTryToSelectCleFiche := -1;
  try
    if IBQListeNom.Active then
      if IBQListeNom.RecordCount > 0
        then fTryToSelectCleFiche := IBQListeNom.FieldByName('CLE_FICHE').AsInteger;
  except
  end;

  IBQDetail.Close;
  IBQDetail.Open;
  IBQPere.Close;
  IBQPere.Open;
  IBQEvPere.Close;
  IBQEvPere.Open;
  IBQMere.Close;
  IBQMere.Open;
  IBQEvMere.Close;
  IBQEvMere.Open;
  IBQConjoint.Close;
  IBQConjoint.params[0].AsInteger := dm.NumDossier;
  IBQConjoint.Open;

  //requette
  IBQListeNom.DisableControls;
  try
    IBQListeNom.Close;

    if fSQLChanged then
      begin
        IBQListeNom.SQL.Clear;
        IBQListeNom.SQL.ADD(_SQL_ORIGINE);
        fSQLChanged := False;

        dxDBGridNom.Options := dxDBGridNom.Options - [egoPreview];

        sNom.Text := '';
        sPreNom.Text := '';
      end;

    IBQListeNom.params[0].AsInteger := dm.NumDossier;
    IBQListeNom.params[1].AsString := debut;
    IBQListeNom.params[2].AsInteger := 2;
    if rbTous.checked then IBQListeNom.params[3].AsInteger := 0
    else
      if rbH.checked then IBQListeNom.params[3].AsInteger := 1
      else
        if rbF.checked then IBQListeNom.params[3].AsInteger := 2;

    IBQListeNom.Open;

    if fTryToSelectCleFiche <> -1 then
      begin
        IBQListeNom.Locate('CLE_FICHE', fTryToSelectCleFiche, []);
      end

  finally
    IBQListeNom.EnableControls;
    fCanScroll := true;
    doFillBottomInfos;
  end;
end;

procedure TFRepertoire.dxDBGridNomDblClick(Sender: TObject);
begin
  dm.FicheActive := IBQListeNomCLE_FICHE.AsInteger;
  doTellToOpenIndividuAndClose;
end;

procedure TFRepertoire.doTellToOpenIndividuAndClose;
begin
  AutoFreeOnClose := true;
  DoSendMessage(Owner, 'OPEN_FICHE_INDIVIDU_FROM_REPERTOIRE');
  Close;
end;

procedure TFRepertoire.doFillBottomInfos;
const
  crlf: string = chr(13) + chr(10);
var
  JumpTag: integer;
  s, s2, s3: string;
  sexe: integer;
begin
  rv.Clear;
  rv.FirstJumpNo := 0;
  JumpTag := 0;
  fIndiJumpTag.Clear;
  fIndiCle.Clear;

  sexe := IBQListeNomSEXE.AsInteger;

  //le nom
  s := trim(AssembleString([IBQListeNom.FieldByName('NOM').AsString,
    IBQListeNom.FieldByName('PRENOM').AsString]));

  if _Context.Nip = 1 then
    if Sexe = 1 then
      s := s + '    ---    NIP : 1-' + IBQListeNomCLE_FICHE.AsString
    else
      s := s + '    ---    NIP : 2-' + IBQListeNomCLE_FICHE.AsString;

  if s <> '' then
    begin
      case sexe of
        1: RVStyle.TextStyles.Items[2].Color := _Context.ColorHomme;
        2: RVStyle.TextStyles.Items[2].Color := _Context.ColorFemme;
        else
          RVStyle.TextStyles.Items[2].Color := clBlack;

      end;
      rv.Add(s, rvsSubheading);
      rv.AddTextFromNewLine(' ', rvsNormal);
    end;

  //N(e) le ?
  s := trim(IBQDetail.FieldByName('EV_IND_DATE_WRITEN').AsString);
  if s <> '' then
    begin
      //selon le sexe :
      case sexe of
        1: s3 := 'N le';
        2: s3 := 'Ne le';
        else
          s3 := 'N(e) le';
      end;

      s := '                 ' + s3 + ' ' + s;

      // ?
      s2 := trim(IBQDetail.FieldByName('EV_IND_VILLE').AsString);
      if s2 <> '' then s := s + ' ' + '' + ' ' + s2;

      rv.Add(s, rvsNormal);
      rv.AddTextFromNewLine(' ', rvsNormal);
    end;
  rv.AddTextFromNewLine(' ', rvsNormal);

  //le pre
  s := trim(AssembleString([IBQPereNOM.AsString, IBQPerePRENOM.AsString]));
  if (Length(s) > 0) and (_Context.Nip = 1) then s := s + '    ---    NIP : 1-' + IBQPereCLE_FICHE.AsString;

  if s <> '' then
    begin
      RVStyle.TextStyles.Items[4].Color := _Context.ColorHomme;
      rv.Add(lPere.Caption + ' ', rvsNormal);
      rv.Add(s, rvsJump1);
      fIndiJumpTag.Add(JumpTag);
      fIndiCle.Add(IBQPereCLE_FICHE.AsInteger);
      inc(JumpTag);

      rv.AddTextFromNewLine(' ', rvsNormal);

      s2 := '';
      try
        s2 := trim(IBQEvPere.FieldByName('EV_IND_DATE_WRITEN').AsString);
      except
      end;

      s3 := '';
      try
        s3 := trim(IBQEvPere.FieldByName('EV_IND_VILLE').AsString);
      except
      end;

      s := '';
      if s2 <> '' then
        begin
          s := 'N le ' + s2 + ' ';
        end;

      if s3 <> '' then
        begin
          s := s + '  ' + s3;
        end;

      if s <> '' then
        begin
          rv.Add('                 ' + s, rvsNormal);
        end;
      rv.AddTextFromNewLine(' ', rvsNormal);
    end;

  //la mre
  s := trim(AssembleString([IBQMereNOM.AsString, IBQMerePRENOM.AsString]));
  if (Length(s) > 0) and (_Context.Nip = 1) then s := s + '    ---    NIP : 2-' + IBQMereCLE_FICHE.AsString;

  if s <> '' then
    begin
      RVStyle.TextStyles.Items[5].Color := _Context.ColorFemme;
      rv.Add(lMere.Caption + ' ', rvsNormal);
      rv.Add(s, rvsJump2);
      fIndiJumpTag.Add(JumpTag);
      fIndiCle.Add(IBQMereCLE_FICHE.AsInteger);
      inc(JumpTag);

      rv.AddTextFromNewLine(' ', rvsNormal);

      s2 := '';
      try
        s2 := trim(IBQEvMere.FieldByName('EV_IND_DATE_WRITEN').AsString);
      except
      end;


      s3 := '';
      try
        s3 := trim(IBQEvMere.FieldByName('EV_IND_VILLE').AsString);
      except
      end;

      s := '';
      if s2 <> '' then
        begin
          s := 'Ne le ' + s2 + ' ';
        end;

      if s3 <> '' then
        begin
          s := s + '  ' + s3;
        end;

      if s <> '' then
        begin
          rv.Add('                 ' + s, rvsNormal);
        end;

      rv.AddTextFromNewLine(' ', rvsNormal);
    end;

  //------------------------------------------------------------------------------------------------    //les conjoints
  s := trim(AssembleString([IBQConjointNOM.AsString, IBQConjointPRENOM.AsString]));

  if (Length(s) > 0) then
    begin
      if _Context.Nip = 1 then
        if IBQConjointSEXE.AsInteger = 1 then
          s := s + '    ---    NIP : 1-' + IBQConjointCLE_FICHE.AsString
        else
          s := s + '    ---    NIP : 2-' + IBQConjointCLE_FICHE.AsString;
    end;

  if s <> '' then
    begin

      rv.Add(lConjoint.Caption + ' ', rvsNormal);

      case IBQConjointSEXE.AsInteger of
        1: rv.Add(s, rvsJump1);
        2: rv.Add(s, rvsJump2);
      end;

      rv.Cursor := crHandPoint;

      fIndiJumpTag.Add(JumpTag);
      fIndiCle.Add(IBQConjointCLE_FICHE.AsInteger);
    end;
  //------------------------------------------------------------------------------------------------

  rv.format;
  rv.Paint;
end;

procedure TFRepertoire.IBQListeNomAfterScroll(DataSet: TDataSet);
begin
  if fCanScroll then
    if IBQListeNomSEXE.AsInteger = 1 then
      panel9.Color := _Context.ColorHomme
    else
      panel9.Color := _Context.ColorFemme;

end;

procedure TFRepertoire.rgSexeClick(Sender: TObject);
begin
  doRefreshRepertoire;
end;

procedure TFRepertoire.rgEtatClick(Sender: TObject);
begin
  doRefreshRepertoire
end;

procedure TFRepertoire.Ouvrirlafichedansunenouvellefentre1Click(Sender: TObject);
begin
  OpenFicheIndividuInBox(IBQListeNomCLE_FICHE.AsInteger);
end;

procedure TFRepertoire.ExporterenHTMLClick(Sender: TObject);
var
  SavePlace: TBookmark;
begin
  if SaveDialog.Execute then
    begin
      SavePlace := nil;
      IBQListeNom.DisableControls;
      try
        SavePlace := IBQListeNom.GetBookmark;
        dxDBGridNom.SaveToHTML(SaveDialog.FileName, True);
      finally
        if SavePlace <> nil then
          begin
            IBQListeNom.GotoBookmark(SavePlace);
            IBQListeNom.FreeBookmark(SavePlace);
          end;
        IBQListeNom.EnableControls;
      end;
    end;
end;

procedure TFRepertoire.sNomChange(Sender: TObject);
begin
  doRefreshControls;
end;

procedure TFRepertoire.fbRechercheClick(Sender: TObject);
begin
  doFind;
end;

procedure TFRepertoire.doFind;
var
  fTryToSelectCleFiche: integer;
begin
  SetNumOngletSelected(0);

  IBQListeNom.DisableControls;
  try
    fTryToSelectCleFiche := -1;
    try
      if IBQListeNom.Active then
        if IBQListeNom.RecordCount > 0
          then fTryToSelectCleFiche := IBQListeNom.FieldByName('CLE_FICHE').AsInteger;
    except
    end;

    IBQListeNom.Close;

    IBQListeNom.SQL.Clear;

    IBQListeNom.SQL.Add('SELECT * FROM PROC_TROUVE_CHAINE_INDI(:DOSSIER,:NOM, :PRENOM)');

    IBQListeNom.params[0].AsInteger := dm.NumDossier;
    IBQListeNom.Params[1].AsString := sNom.Text;
    IBQListeNom.Params[2].AsString := sPreNom.Text;
    IBQListeNom.Open;

    if fTryToSelectCleFiche <> -1 then
      begin
        IBQListeNom.Locate('CLE_FICHE', fTryToSelectCleFiche, []);
      end;

    fSQLChanged := True;
  finally
    IBQListeNom.EnableControls;
  end;

  doFillBottomInfos;

  if IBQListeNom.RecordCount > 0 then
    dxDBGridNom.Options := dxDBGridNom.Options + [egoPreview]
  else
    ShowMessage('Aucun individu avec ces critres de recherche...');

end;

procedure TFRepertoire.SuperFormCreate(Sender: TObject);
var
  n: integer;
begin
  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  fTextesOnglets := TStringList.create;
  fTextesOnglets.Add('...');
  for n := 0 to 25 do fTextesOnglets.Add(chr(ord('A') + n));

  SetNumOngletSelected(0);

  mColNe.Checked := dxDBNe.Visible;
  mCola.Checked := dxDBLieuNe.Visible;
  mColDeces.Checked := dxDBDeces.Visible;
  mColCode.Checked := dxDBCP.Visible;

  fFill := false;
  fIndiCle := TIntegerList.create;
  fIndiJumpTag := TIntegerList.create;

  SaveDialog.InitialDir := _Context.PathImportExport;
end;

procedure TFRepertoire.SetNumOngletSelected(index: integer);
begin
  fNumOngletSelected := index;
  PaintBoxOnglet.Refresh;
end;

procedure TFRepertoire.rbTousChange(Sender: TObject);
begin
  if not fFill then
    begin
      fFill := true;
      try
        rbTous.checked := true;
        rbH.checked := false;
        rbF.checked := false;

      finally
        fFill := false;
      end;
      doRefreshRepertoire;
    end;
end;


procedure TFRepertoire.rbHChange(Sender: TObject);
begin
  if not fFill then
    begin
      fFill := true;
      try
        rbTous.checked := false;
        rbH.checked := true;
        rbF.checked := false;

      finally
        fFill := false;
      end;
      doRefreshRepertoire;
    end;
end;

procedure TFRepertoire.rbFChange(Sender: TObject);
begin
  if not fFill then
    begin
      fFill := true;
      try
        rbH.checked := false;
        rbTous.checked := false;
        rbF.checked := true;
      finally
        fFill := false;
      end;
      doRefreshRepertoire;
    end;
end;

procedure TFRepertoire.sNomKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key = VK_RETURN then doFind;
end;

procedure TFRepertoire.SuperFormRefreshControls(Sender: TObject);
begin
  fbRecherche.Enabled := (Length(sNom.Text) > 0) or (Length(sPreNom.Text) > 0);
end;

procedure TFRepertoire.SuperFormShowFirstTime(Sender: TObject);
begin
  doRefreshControls;
  SendFocus(sNom);
end;

procedure TFRepertoire.SuperFormDestroy(Sender: TObject);
begin
  fIndiCle.free;
  fIndiJumpTag.free;
  fTextesOnglets.free;
end;

procedure TFRepertoire.rvJump(Sender: TObject; id: Integer);
var
  k: integer;
begin
  k := fIndiJumpTag.IndexOf(id);
  if k <> -1 then
    begin
      dm.FicheActive := fIndiCle[k];
      doTellToOpenIndividuAndClose;
    end;
end;

procedure TFRepertoire.CloseAllQuerys;
begin
  IBQDetail.Close;
  IBQPere.Close;
  IBQEvPere.Close;
  IBQMere.Close;
  IBQEvMere.Close;
end;

function TFRepertoire.GetCleFicheSelected: integer;
begin
  if IBQListeNom.RecordCount > 0
    then result := IBQListeNomCLE_FICHE.AsInteger
  else result := -1;
end;

function TFRepertoire.GetNomFicheSelected: string;
begin
  if IBQListeNom.RecordCount > 0
    then result := AssembleString([IBQListeNomNOM.AsString, IBQListeNomPRENOM.AsString])
  else result := '';
end;


procedure TFRepertoire.PaintBoxOngletPaint(Sender: TObject);
begin
  PaintOnglet(PaintBoxOnglet, 27, fNumOngletSelected, 25, 18, clBlack, $00C5E8F3, $008FC6D8, fTextesOnglets);
end;

procedure TFRepertoire.PaintBoxOngletMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var p: TPoint;
begin
  p := TControl(Sender).ClientToScreen(Point(X, Y));
  p := panTabs.ScreenToClient(p);
  //  p.x := p.x - 3;

  SetTabByPositionMouse(p.x);
end;

procedure TFRepertoire.SetTabByPositionMouse(x: integer);
var k: integer;
begin
  k := (x div 21);
  if k < 0 then k := 0;
  if k > 26 then k := 26;
  if k <> fNumOngletSelected then
    begin
      SetNumOngletSelected(k);
      doRefreshRepertoire;
    end;
end;


procedure TFRepertoire.dxDBGridNomChangeNode(Sender: TObject; OldNode, Node: TdxTreeListNode);
begin
  doFillBottomInfos;
end;

procedure TFRepertoire.SuperFormKeyPress(Sender: TObject; var Key: Char);
begin
  sNom.Text := sNom.Text + Key;
  doRefreshControls;
end;

procedure TFRepertoire.InitRepertoireWithFicheActive;
var
  ok: boolean;
  s: string;
  k: integer;
begin
  ok := false;
  QueryFindOneIndi.Close;
  try
    try
      QueryFindOneIndi.ParamByName('CLE_FICHE').AsInteger := dm.FicheActive;
      QueryFindOneIndi.Open;
      QueryFindOneIndi.Last;
      QueryFindOneIndi.First;
      if QueryFindOneIndi.RecordCount = 1 then
        begin
          s := QueryFindOneIndi.FieldByName('NOM').AsString;
          if length(s) > 0 then
            begin
              s := AnsiUpperCase(s[1]);
              k := pos(s, 'ABCDEFGHIJKLMNOPQRSTUVWXYZ');
              if k > 0 then
                begin
                  SetNumOngletSelected(k);
                  doRefreshRepertoire;

                  ok := true;

                  //On locate l'individu
                  if IBQListeNom.Active then
                    begin
                      IBQListeNom.Locate('CLE_FICHE', dm.FicheActive, []);
                    end;
                end;
            end;
        end;
    except
    end;
  finally
    QueryFindOneIndi.Close;
  end;

  if ok = false then up_InitRepertoire('A', 0, 2);
end;

procedure TFRepertoire.pmGridPopup(Sender: TObject);
var
  ok: boolean;
begin
  ok := (IBQListeNom.Active) and (IBQListeNom.IsEmpty = False);

  Ajouterauxfavoris.enabled := ok;
  Ouvrirlafiche1.enabled := ok;
  Ouvrirlafichedansunenouvellefentre1.enabled := ok;
  Supprimerlafiche1.enabled := ok;
  ExporterenHTML.enabled := ok;
end;

procedure TFRepertoire.Supprimerlafiche1Click(Sender: TObject);
begin
  if MyMessageDlg('Confirmez-vous la suppression de cette fiche individu ?', mtWarning, [mbYes, mbNo], 0) = mrYes then
    begin
      try
        Application.ProcessMessages;

        QueryDeleteIndividu.Close;
        QueryDeleteIndividu.ParamByName('CLE_FICHE').AsInteger := IBQListeNom.FieldByName('CLE_FICHE').AsInteger;
        QueryDeleteIndividu.ExecSQL;
        QueryDeleteIndividu.Close;
        dm.IBT_BASE.CommitRetaining;

        Application.ProcessMessages;
        doRefreshRepertoire;

      except
      end;
    end;
end;

procedure TFRepertoire.AjouterauxfavorisClick(Sender: TObject);
begin
  fMain.MenuFavoris_AddClick(Sender);
end;

procedure TFRepertoire.Imprimercetteliste1Click(Sender: TObject);
begin
  FMain.doPrint(0);
end;

procedure TFRepertoire.mColNeClick(Sender: TObject);
begin
  mColNe.Checked := not mColNe.Checked;
  dxDBNe.Visible := mColNe.Checked;
end;

procedure TFRepertoire.mColaClick(Sender: TObject);
begin
  mCola.Checked := not mCola.Checked;
  dxDBLieuNe.Visible := mCola.Checked;
end;

procedure TFRepertoire.mColDecesClick(Sender: TObject);
begin
  mColDeces.Checked := not mColDeces.Checked;
  dxDBDeces.Visible := mColDeces.Checked;
end;

procedure TFRepertoire.mColCodeClick(Sender: TObject);
begin
  mColCode.Checked := not mColCode.Checked;
  dxDBCP.Visible := mColCode.Checked;
end;

end.

