{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_objet_TMulot;

//----------------------------------------------------------------------------------------------------------
//Comment utiliser le TMulot : TRIVIAL !!!!!!
//----------------------------------------------------------------------------------------------------------
//
//		mulot.Cursor:=crHourGlass;        <- on indique le nouveau curseur
//		try
//
//			{tout ce qu'il y a  faire}
//
//		finally
//			mulot.RollBack;		    <- l'ancien curseur revient, quelque soit les changements
//		end;
//
// note : autant d'imbrication possible
//
//----------------------------------------------------------------------------------------------------------
//Yann - Mlodie
//----------------------------------------------------------------------------------------------------------



interface

uses
  Classes,
  controls,
  u_objet_TIntegerList;


type
  TMulot = class

  private
    fLastCursorsID: TIntegerList;
    procedure SetCursor(const Value: TCursor);

  public
    property Cursor: TCursor write SetCursor;
    procedure RollBack;

    constructor Create;
    destructor Destroy; override;
  end;


implementation

uses
  forms;


{ TMulot }


constructor TMulot.Create;
begin
  fLastCursorsID := TIntegerList.create;
end;


destructor TMulot.Destroy;
begin
  fLastCursorsID.Free;
  inherited;
end;


procedure TMulot.RollBack;
var
  k: integer;
begin
  if fLastCursorsID.Count > 0 then
    begin
      //on rcupre le dernier curseur empil.
      k := fLastCursorsID.Count - 1;
      screen.Cursor := fLastCursorsID[k];
      fLastCursorsID.Delete(k);
    end;
end;

procedure TMulot.SetCursor(const Value: TCursor);
begin
  //on mmorise le curseur actuel
  fLastCursorsID.Add(screen.Cursor);

  //On indique le nouveau curseur
  screen.Cursor := Value;
end;


end.
