{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_list_report;

interface


uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, ExtCtrls, OleCtrls, SHDocVw, u_comp_TBlueFlatSpeedButton,
  StdCtrls, TFlatPanelUnit, TFlatSpeedButtonUnit, Db, ppBands, IB,
  ppCtrls, ppStrtch, ppMemo, ppDB, ppVar, ppPrnabl, ppCache, ppProd,
  ppReport, IBCustomDataSet, IBQuery, ppComm, ppRelatv, ppDBPipe, printers,
  ppViewr, ppModule, ComCtrls, daDataModule, Menus, raCodMod, Mask,
  Buttons, dxCntner, dxEditor, dxEdLib, ppEndUsr, ppTypes,
  u_comp_TNakedSpeedButton, ppClass, ppPrintr, TxtraDev, dxTL,
  TFlatSplitterUnit, dxExEdtr, u_objet_TState, u_comp_TGoodBtn,
  u_form_param_reports, u_objet_TCut, JPEG, ppJPEG, ppDBJIT, SHELLAPI,
  u_comp_TYLanguage, ppRegion, ppSubRpt, TXComp, SkinCtrls;

type
  TFListReport = class(TSuperForm)
    Panel4: TPanel;
    ppDBCousinage: TppDBPipeline;
    QCousinage: TIBQuery;
    DSCousinage: TDataSource;
    DSUnions: TDataSource;
    QUnions: TIBQuery;
    ppDBUnions: TppDBPipeline;
    ppDBEvenements: TppDBPipeline;
    QEvenements: TIBQuery;
    DSEvenements: TDataSource;
    DSStatNomPrenom: TDataSource;
    QStatNomPrenom: TIBQuery;
    ppDBStatNomPrenom: TppDBPipeline;
    ppDBFiche: TppDBPipeline;
    QFiche: TIBQuery;
    DSFiche: TDataSource;
    DSListeAlpha: TDataSource;
    QListeAlpha: TIBQuery;
    ppDBListeAlpha: TppDBPipeline;
    ppDBDesPat: TppDBPipeline;
    ppField1: TppField;
    ppField2: TppField;
    ppField3: TppField;
    ppField4: TppField;
    ppField5: TppField;
    ppField6: TppField;
    ppField7: TppField;
    ppField8: TppField;
    ppField9: TppField;
    ppDBDescendance: TppDBPipeline;
    ppDBAscendance: TppDBPipeline;
    QAscendance: TIBQuery;
    QDescendance: TIBQuery;
    QDesPat: TIBQuery;
    DSDesPat: TDataSource;
    DSAscendance: TDataSource;
    DSDescendance: TDataSource;
    popup_report: TPopupMenu;
    option_EditReport: TMenuItem;
    Nouveaurapport1: TMenuItem;
    N1: TMenuItem;
    Ajouterunrapport1: TMenuItem;
    QEvenementsDATE_EVE: TIBStringField;
    QEvenementsCP: TIBStringField;
    QEvenementsVILLE: TIBStringField;
    QEvenementsS_TYPE: TIBStringField;
    QEvenementsNOM: TIBStringField;
    QEvenementsPRENOM: TIBStringField;
    QEvenementsNOM_COMPLET: TIBStringField;
    QUnionsUNION_CLE: TIntegerField;
    QUnionsMARI_CLE: TIntegerField;
    QUnionsMARI_NOM: TIBStringField;
    QUnionsMARI_PRENOM: TIBStringField;
    QUnionsFEMME_CLE: TIntegerField;
    QUnionsFEMME_NOM: TIBStringField;
    QUnionsFEMME_PRENOM: TIBStringField;
    QUnionsVILLE: TIBStringField;
    QUnionsPAYS: TIBStringField;
    QCousinageCLE_FICHE: TIntegerField;
    QCousinageNOM: TIBStringField;
    QCousinagePRENOM: TIBStringField;
    QCousinageDATE_NAISSANCE: TIBStringField;
    QCousinageDATE_DECES: TIBStringField;
    QCousinageSEXE: TIntegerField;
    QCousinageCLE_PERE: TIntegerField;
    QCousinageCLE_MERE: TIntegerField;
    QListeAlphaNOM: TIBStringField;
    QListeAlphaPRENOM: TIBStringField;
    QListeAlphaDATE_NAISSANCE: TIBStringField;
    QListeAlphaLIEU_NAISSANCE: TIBStringField;
    QListeAlphaDATE_DECES: TIBStringField;
    QListeAlphaLIEU_DECES: TIBStringField;
    QListeAlphaSEXE: TIntegerField;
    QListeAlphaFILLIATION: TIBStringField;
    QListeAlphaLETTRE: TIBStringField;
    QStatNomPrenomCOMBIEN: TIntegerField;
    QStatNomPrenomNOM: TIBStringField;
    ppDBStatPrenoms: TppDBPipeline;
    QStatPrenoms: TIBQuery;
    IntegerField1: TIntegerField;
    IBStringField1: TIBStringField;
    dsStatPrenoms: TDataSource;
    ppDBListeAlphaBorne: TppDBPipeline;
    QListeAlphaBorne: TIBQuery;
    IBStringField2: TIBStringField;
    IBStringField3: TIBStringField;
    IBStringField4: TIBStringField;
    IBStringField5: TIBStringField;
    IBStringField6: TIBStringField;
    IBStringField7: TIBStringField;
    IntegerField2: TIntegerField;
    IBStringField8: TIBStringField;
    IBStringField9: TIBStringField;
    dsListeAlphaBorne: TDataSource;
    ppReport: TppReport;
    ppDesigner: TppDesigner;
    N2: TMenuItem;
    Configurerlimprimante1: TMenuItem;
    QAnniv: TIBQuery;
    DataSourceAnniv: TDataSource;
    ppDBAnniv: TppDBPipeline;
    QCouple: TIBQuery;
    DataSourceCouple: TDataSource;
    ppDBCouple: TppDBPipeline;
    QEnfantsCouple: TIBQuery;
    DataSourceEnfantsCouple: TDataSource;
    ppDBEnfantsCouple: TppDBPipeline;
    QEveCouple: TIBQuery;
    DataSourceEveCouple: TDataSource;
    ppDBEveCouple: TppDBPipeline;
    QAgePremiereUnion: TIBQuery;
    QLongevite: TIBQuery;
    QNbEnfantUnion: TIBQuery;
    QRecensement: TIBQuery;
    QDenombreAscendance: TIBQuery;
    QDenombreDescendance: TIBQuery;
    DataSourceAgePremiereUnion: TDataSource;
    DataSourceLongevite: TDataSource;
    DataSourceNbEnfantUnion: TDataSource;
    DataSourceRecensement: TDataSource;
    DataSourceDenombreAscendance: TDataSource;
    DataSourceDenombreDescendance: TDataSource;
    ppDBAgePremiereUnion: TppDBPipeline;
    ppDBLongevite: TppDBPipeline;
    ppDBNbEnfantUnion: TppDBPipeline;
    ppDBRecensement: TppDBPipeline;
    ppDBDenombreAscendance: TppDBPipeline;
    ppDBDenombreDescendance: TppDBPipeline;
    QEclair: TIBQuery;
    DataSourceEclair: TDataSource;
    ppDBEclair: TppDBPipeline;
    QGetNomPrenom: TIBQuery;
    QAscendanceGENERATTION: TIntegerField;
    QAscendanceSOSA: TFloatField;
    QAscendanceNOM: TIBStringField;
    QAscendanceDATE_NAISSANCE: TIBStringField;
    QAscendanceLIEU_NAISSANCE: TIBStringField;
    QAscendanceDATE_DECES: TIBStringField;
    QAscendanceLIEU_DECES: TIBStringField;
    QAscendanceSEXE: TIntegerField;
    QAscendanceAGE: TIntegerField;
    ppDBDesPatppField1: TppField;
    QListeAlphaAGE: TIntegerField;
    QListeAlphaSOSA: TFloatField;
    QUnionsDATE_UNION: TIBStringField;
    QEvenementsSEXE: TIntegerField;
    QUnionsAGE_MARI: TIntegerField;
    QUnionsAGE_FEMME: TIntegerField;
    ppDBUnionsppField11: TppField;
    ppDBUnionsppField12: TppField;
    QCousinageNOM_PERE: TIBStringField;
    QCousinagePRENOM_PERE: TIBStringField;
    QCousinageNOM_MERE: TIBStringField;
    QCousinagePRENOM_MERE: TIBStringField;
    ppDBCousinageppField9: TppField;
    ppDBCousinageppField10: TppField;
    ppDBCousinageppField11: TppField;
    ppDBCousinageppField12: TppField;
    Panel3: TPanel;
    FlatSplitter1: TFlatSplitter;
    Panel1: TPanel;
    TrackBar: TTrackBar;
    TL: TdxTreeList;
    TLColReportName: TdxTreeListColumn;
    TLColReportNum: TdxTreeListColumn;
    Panel2: TPanel;
    Label37: TLabel;
    lNom: TLabel;
    Panel6: TPanel;
    Panel7: TPanel;
    ppViewer: TppViewer;
    Panel5: TPanel;
    Label2: TLabel;
    Label1: TLabel;
    btnConfig: TNakedSpeedButton;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Label3: TLabel;
    btnPrint: TNakedSpeedButton;
    rvPrinter: TdxCheckEdit;
    rbPDF: TdxCheckEdit;
    rbRTF: TdxCheckEdit;
    rbTXT: TdxCheckEdit;
    Panel8: TPanel;
    spbPreviewFirst: TSpeedButton;
    spbPreviewPrior: TSpeedButton;
    spbPreviewNext: TSpeedButton;
    spbPreviewLast: TSpeedButton;
    spbPreviewWidth: TSpeedButton;
    spbPreview100Percent: TSpeedButton;
    spbPreviewWhole: TSpeedButton;
    mskPreviewPage: TMaskEdit;
    QAnnivNOM: TIBStringField;
    QAnnivPRENOM: TIBStringField;
    QAnnivADATE: TIBStringField;
    QAnnivANNEE: TIntegerField;
    QAnnivEV_TYPE: TIBStringField;
    QAnnivSEXE: TIntegerField;
    ppJITPVariable: TppJITPipeline;
    S_TITRE: TppField;
    S_PIED_PAGE: TppField;
    S_SEXE: TppField;
    QEveIndi: TIBQuery;
    DSEveIndi: TDataSource;
    ppDBEveIndi: TppDBPipeline;
    QMultimedia: TIBQuery;
    DSMultimedia: TDataSource;
    ppDBMultimedia: TppDBPipeline;
    I_TOUS_ENFANTS: TppField;
    I_PHOTOS: TppField;
    I_PHOTOS_INDI: TppField;
    rbHtml: TdxCheckEdit;
    ppDBFratrie: TppDBPipeline;
    DSFratrie: TDataSource;
    QFratrie: TIBQuery;
    QOnclesTantes: TIBQuery;
    DSOnclesTantes: TDataSource;
    ppDBOnclesTantes: TppDBPipeline;
    ppDBEnfants: TppDBPipeline;
    DSEnfants: TDataSource;
    QEnfants: TIBQuery;
    pRien: TPanel;
    Image2: TImage;
    Label4: TLabel;
    SaveDialog: TOpenDialog;
    OpenDialog: TOpenDialog;
    SaveDialogRTF: TSaveDialog;
    SaveDialogPDF: TSaveDialog;
    SaveDialogHTML: TSaveDialog;
    Language: TYLanguage;
    IBStatGraph: TIBQuery;
    DSStatGraph: TDataSource;
    ppDBStatGraph: TppDBPipeline;
    QDescendanceNIVEAU: TIntegerField;
    QDescendanceSOSA: TIBStringField;
    QDescendanceCLE_FICHE: TIntegerField;
    QDescendanceNOM: TIBStringField;
    QDescendanceDATE_NAISSANCE: TIBStringField;
    QDescendanceDATE_DECES: TIBStringField;
    QDescendanceSEXE: TIntegerField;
    QDescendanceCLE_PERE: TIntegerField;
    QDescendanceCLE_MERE: TIntegerField;
    QDescendanceAGE: TIntegerField;
    QDesPatNIVEAU: TIntegerField;
    QDesPatSOSA: TIBStringField;
    QDesPatCLE_FICHE: TIntegerField;
    QDesPatNOM: TIBStringField;
    QDesPatDATE_NAISSANCE: TIBStringField;
    QDesPatDATE_DECES: TIBStringField;
    QDesPatSEXE: TIntegerField;
    QDesPatCLE_PERE: TIntegerField;
    QDesPatCLE_MERE: TIntegerField;
    QDesPatAGE: TIntegerField;
    QAscendanceCP_NAISSANCE: TIBStringField;
    QAscendanceCP_DECES: TIBStringField;
    QUnionsMARI_NUM_SOSA: TFloatField;
    QUnionsFEMME_NUM_SOSA: TFloatField;
    IBQParentEnfants: TIBQuery;
    DSParentEnfants: TDataSource;
    ppDBPParentEnfants: TppDBPipeline;
    ppField10: TppField;
    ppField11: TppField;
    ppField12: TppField;
    ppField13: TppField;
    ppHeaderBand10: TppHeaderBand;
    ppShape3: TppShape;
    ppDBText1: TppDBText;
    ppDetailBand10: TppDetailBand;
    ppDBText29: TppDBText;
    ppDBText30: TppDBText;
    ppFooterBand10: TppFooterBand;
    ppSystemVariable2: TppSystemVariable;
    ppLine2: TppLine;
    ppDBText2: TppDBText;
    QAscendanceS_NOM: TStringField;
    QAscendanceCLE_FICHE: TIntegerField;
    QListeAlphaCLE_FICHE: TIntegerField;
    QListeAlphaS_NOM: TStringField;
    ExtraOptions: TExtraOptions;
    btnShowConfigBox: TspSkinButton;
    procedure SuperFormCreate(Sender: TObject);
    procedure TrackBarChange(Sender: TObject);
    procedure spbPreviewFirstClick(Sender: TObject);
    procedure spbPreviewPriorClick(Sender: TObject);
    procedure spbPreviewNextClick(Sender: TObject);
    procedure spbPreviewLastClick(Sender: TObject);
    procedure mskPreviewPageKeyPress(Sender: TObject; var Key: Char);
    procedure ppViewerPageChange(Sender: TObject);
    procedure spbPreviewWholeClick(Sender: TObject);
    procedure spbPreviewWidthClick(Sender: TObject);
    procedure spbPreview100PercentClick(Sender: TObject);
    procedure Nouveaurapport1Click(Sender: TObject);
    procedure option_EditReportClick(Sender: TObject);
    procedure ppDesignerClose(Sender: TObject; var Action: TCloseAction);
    procedure Ajouterunrapport1Click(Sender: TObject);
    procedure SuperFormRefreshControls(Sender: TObject);
    procedure SuperFormShowFirstTime(Sender: TObject);
    procedure btnPrintClick(Sender: TObject);
    procedure NakedSpeedButton2Click(Sender: TObject);
    procedure rvPrinterChange(Sender: TObject);
    procedure SuperFormDestroy(Sender: TObject);
    procedure rbPDFChange(Sender: TObject);
    procedure rbRTFChange(Sender: TObject);
    procedure rbTXTChange(Sender: TObject);
    procedure btnConfigClick(Sender: TObject);
    procedure TLChangeNode(Sender: TObject; OldNode,
      Node: TdxTreeListNode);
    procedure btnShowConfigBoxClick(Sender: TObject);
    function ppJITPVariableGetFieldValue(aFieldName: string): Variant;
    procedure rbHtmlChange(Sender: TObject);
    procedure ppDesignerShow(Sender: TObject);
    procedure QAscendanceCalcFields(DataSet: TDataSet);
    procedure QListeAlphaCalcFields(DataSet: TDataSet);
  private
    fFill: TState;
    fIDTypeReport: integer;
    fRelPathSaveReport: string;

    aFParamReports: TFParamReports;
    s_Nom: string;
    fFileName1, fFileName2, fFileName3: string;
    aFile: Text;
    fCut: TCut;
    fAddEntete: boolean;
    i_Sexe: integer;

    procedure doShowReport(TagReport: integer);
    procedure OnClickOnMenuItemReport(Sender: TObject);
    procedure PreparePopup;
    function GetDefaultFileNameReportInContext(aIDReport: integer): string;
    procedure SetDefaultFileNameReportInContext(aIDReport: integer; aFileName: string);
    function GetRelPathReport(aIDReport: integer): string;

    function GetPipeline: TppDBPipeline;
    procedure doPrepareReport(TagReport: integer);
    function GetFileNameReportForExport: boolean;
    procedure doExportReportInTextFile;
    procedure ExportATable(Q: TIBQuery; aPathFileName: string);
    procedure doTryToShowReport;
  public
    procedure doRefreshReport;

  end;

implementation

uses u_dm, u_common_func, u_common_const, raIDE, u_common_var,
  u_form_ask_name_files_to_export_report, u_form_main, u_Form_Verif_Event;

{$R *.DFM}

procedure TFListReport.doTryToShowReport;
var
  s: string;
begin
  //On rcupre le rapport dfinit dans le context
  s := ExtractFilePath(Application.exeName) + _REL_PATH_REPORT + fRelPathSaveReport + GetDefaultFileNameReportInContext(fIDTypeReport);

  if FileExists(s) then
    begin
      //on charge le rapport
      ppReport.Template.FileName := s;
      ppReport.template.LoadFromFile;
      doPrepareReport(fIDTypeReport);

      aFParamReports.cbPhotosIndi.Checked := True;
      aFParamReports.cbPhotos.Checked := True;

      doShowReport(fIDTypeReport);
    end
  else
    ppViewer.visible := false;

  doRefreshControls;
end;

procedure TFListReport.doShowReport(TagReport: integer);
var
  k1, k2, k3, k: integer;
  // Save_Cursor: TCursor;
  aFVerifEvent: TFVerifEvent;
begin

  // Save_Cursor := Screen.Cursor;

  Screen.Cursor := crHourGlass;
  //  FMain.Enabled := False;

  begin
    ppViewer.Reset;
    ppViewer.PaintBox.Repaint;

    QAscendance.Close;
    QFiche.Close;
    QDescendance.Close;
    QDesPat.Close;
    QListeAlpha.Close;
    QListeAlphaBorne.Close;
    QEvenements.Close;
    QUnions.Close;
    QCousinage.Close;
    QStatNomPrenom.Close;
    QStatPrenoms.Close;
    QAnniv.Close;
    QCouple.Close;
    QEnfantsCouple.Close;
    QEveCouple.Close;
    QAgePremiereUnion.Close;
    QLongevite.Close;
    QNbEnfantUnion.Close;
    QRecensement.Close;
    QDenombreAscendance.Close;
    QDenombreDescendance.Close;
    QEclair.Close;
    QMultimedia.Close;
    QEveIndi.Close;
    QFratrie.Close;
    QOnclesTantes.Close;
    QEnfants.Close;
    IBStatGraph.Close;
    IBQParentEnfants.Close;

    pRien.BringToFront;

    case TagReport of

      _REP_ASCENDANCE_COMPLET: begin
          s_Nom := lNom.Caption;
          s_Nom := s_Nom + ' - AC';
          Application.ProcessMessages;
          Application.ProcessMessages;
          ppViewer.Report := ppReport;
          QAscendance.Params[0].AsInteger := dm.FicheActive;
          QAscendance.Params[1].AsInteger := 0;
          QAscendance.Params[2].AsInteger := dm.NumDossier;
          QAscendance.Params[3].AsInteger := 0;
          QAscendance.Open;
          ppViewer.visible := QAscendance.RecordCount > 0;
          pRien.Visible := QAscendance.RecordCount <= 0;

          ppReport.PrintToDevices;
        end;
      _REP_ASCENDANCE_PAR_HOMMES: begin
          s_Nom := lNom.Caption;
          s_Nom := s_Nom + ' - AH';
          Application.ProcessMessages;
          Application.ProcessMessages;
          ppViewer.Report := ppReport;
          QAscendance.Params[0].AsInteger := dm.FicheActive;
          QAscendance.Params[1].AsInteger := 0;
          QAscendance.Params[2].AsInteger := dm.NumDossier;
          QAscendance.Params[3].AsInteger := 1;
          QAscendance.Open;
          ppViewer.visible := QAscendance.RecordCount > 0;
          pRien.Visible := QAscendance.RecordCount <= 0;
          ppReport.PrintToDevices;
        end;
      _REP_ASCENDANCE_PAR_FEMMES: begin
          s_Nom := lNom.Caption;
          s_Nom := s_Nom + ' - AF';
          Application.ProcessMessages;
          Application.ProcessMessages;
          ppViewer.Report := ppReport;
          QAscendance.Params[0].AsInteger := dm.FicheActive;
          QAscendance.Params[1].AsInteger := 0;
          QAscendance.Params[2].AsInteger := dm.NumDossier;
          QAscendance.Params[3].AsInteger := 2;
          QAscendance.Open;
          ppViewer.visible := QAscendance.RecordCount > 0;
          pRien.Visible := QAscendance.RecordCount <= 0;
          ppReport.PrintToDevices;
        end;
      _REP_DESCENDANCE_COMPLET: begin
          s_Nom := lNom.Caption;
          s_Nom := s_Nom + ' - DC';
          Application.ProcessMessages;
          Application.ProcessMessages;
          ppViewer.Report := ppReport;
          QDescendance.Params[0].AsInteger := dm.FicheActive;
          QDescendance.Params[1].AsInteger := 0;
          QDescendance.Params[2].AsInteger := dm.NumDossier;
          QDescendance.Open;
          ppViewer.visible := QDescendance.RecordCount > 0;
          pRien.Visible := QDescendance.RecordCount <= 0;
          ppReport.PrintToDevices;
        end;
      _REP_DESCENDANCE_PATRONYMIQUE: begin
          s_Nom := lNom.Caption;
          s_Nom := s_Nom + ' - DP';
          Application.ProcessMessages;
          Application.ProcessMessages;
          ppViewer.Report := ppReport;
          QDesPat.Params[0].AsInteger := dm.FicheActive;
          QDesPat.Params[1].AsInteger := 0;
          QDesPat.Params[2].AsInteger := dm.NumDossier;
          QDesPat.Open;
          ppViewer.visible := QDesPat.RecordCount > 0;
          pRien.Visible := QDesPat.RecordCount <= 0;
          ppReport.PrintToDevices;
        end;

      _REP_LISTE_ALPHA_TOUS: begin
          Application.ProcessMessages;
          Application.ProcessMessages;
          ppViewer.Report := ppReport;
          QListeAlpha.Params[0].AsInteger := dm.NumDossier;
          QListeAlpha.Params[1].AsInteger := 0;
          QListeAlpha.Open;
          ppViewer.visible := QListeAlpha.RecordCount > 0;
          pRien.Visible := QListeAlpha.RecordCount <= 0;
          ppReport.PrintToDevices;
        end;
      _REP_LISTE_ALPHA_HOMME: begin
          Application.ProcessMessages;
          Application.ProcessMessages;
          ppViewer.Report := ppReport;
          QListeAlpha.Params[0].AsInteger := dm.NumDossier;
          QListeAlpha.Params[1].AsInteger := 1;
          QListeAlpha.Open;
          ppViewer.visible := QListeAlpha.RecordCount > 0;
          pRien.Visible := QListeAlpha.RecordCount <= 0;
          ppReport.PrintToDevices;
        end;
      _REP_LISTE_ALPHA_FEMME: begin
          Application.ProcessMessages;
          Application.ProcessMessages;
          ppViewer.Report := ppReport;
          QListeAlpha.Params[0].AsInteger := dm.NumDossier;
          QListeAlpha.Params[1].AsInteger := 2;
          QListeAlpha.Open;
          ppViewer.visible := QListeAlpha.RecordCount > 0;
          pRien.Visible := QListeAlpha.RecordCount <= 0;
          ppReport.PrintToDevices;
        end;

      _REP_LISTE_DIVERS_UNION: begin
          Application.ProcessMessages;
          Application.ProcessMessages;
          ppViewer.Report := ppReport;
          QUnions.Params[0].AsInteger := dm.NumDossier;
          QUnions.Open;
          ppViewer.visible := QUnions.RecordCount > 0;
          pRien.Visible := QUnions.RecordCount <= 0;
          ppReport.PrintToDevices;
        end;

      _REP_LISTE_DIVERS_ECLAIR: begin

          Application.ProcessMessages;
          Application.ProcessMessages;
          ppViewer.Report := ppReport;
          QEclair.ParamByName('I_DOSSIER').AsInteger := dm.NumDossier;
          if aFParamReports.rbTrieParPatronyme.checked then k := 0 else k := 1;
          QEclair.ParamByName('I_PATRONYME_SORT').AsInteger := k;
          if aFParamReports.cbOnlySosaEclair.checked then k := 1 else k := 0;
          QEclair.ParamByName('I_SOSA').AsInteger := k;
          QEclair.ParamByName('A_VILLE').AsString := aFParamReports.edVilleEclair.Text;
          QEclair.Open;
          ppViewer.visible := QEclair.RecordCount > 0;
          pRien.Visible := QEclair.RecordCount <= 0;
          ppReport.PrintToDevices;
        end;

      _REP_LISTE_DIVERS_EVENEMENT: begin
          Application.ProcessMessages;
          Application.ProcessMessages;
          ppViewer.Report := ppReport;
          QEvenements.Params[0].AsInteger := dm.NumDossier;
          QEvenements.Open;
          ppViewer.visible := QEvenements.RecordCount > 0;
          pRien.Visible := QEvenements.RecordCount <= 0;
          ppReport.PrintToDevices;
        end;
      _REP_LISTE_DIVERS_ANNIVERSAIRE: begin
          Application.ProcessMessages;
          Application.ProcessMessages;
          ppViewer.Report := ppReport;
          QAnniv.Close;

          //Requette
          if aFParamReports.cbAnniv_Naissance.checked then k1 := 1 else k1 := 0;
          if aFParamReports.cbAnniv_Deces.checked then k2 := 1 else k2 := 0;
          if aFParamReports.cbAnniv_Mariage.checked then k3 := 1 else k3 := 0;

          QAnniv.ParamByName('A_MOIS').AsInteger := aFParamReports.PickMonth.ItemIndex + 1;
          QAnniv.ParamByName('I_DOSSIER').AsInteger := dm.NumDossier; ;
          QAnniv.ParamByName('GET_BIRT').AsInteger := k1;
          QAnniv.ParamByName('GET_DEAT').AsInteger := k2;
          QAnniv.ParamByName('GET_MARR').AsInteger := k3;

          QAnniv.Open;
          ppViewer.visible := QAnniv.RecordCount > 0;
          pRien.Visible := QAnniv.RecordCount <= 0;
          ppReport.PrintToDevices;
        end;
      _REP_LISTE_DIVERS_ENFANTS: begin
          s_Nom := lNom.Caption;
          s_Nom := s_Nom + ' - CO';
          Application.ProcessMessages;
          Application.ProcessMessages;
          ppViewer.Report := ppReport;

          if (I_SEXE = 1) then
            begin
              QEnfants.Params[0].AsInteger := dm.FicheActive;
              QEnfants.Params[1].AsInteger := 0;
            end
          else
            begin
              QEnfants.Params[0].AsInteger := 0;
              QEnfants.Params[1].AsInteger := dm.FicheActive;
            end;

          QEnfants.Params[2].AsInteger := dm.NumDossier;
          QEnfants.Open;
          ppViewer.visible := QEnfants.RecordCount > 0;
          pRien.Visible := QEnfants.RecordCount <= 0;
          ppReport.PrintToDevices;
        end;
      _REP_LISTE_DIVERS_COUSINAGE: begin
          s_Nom := lNom.Caption;
          s_Nom := s_Nom + ' - CO';

          Application.ProcessMessages;
          Application.ProcessMessages;
          ppViewer.Report := ppReport;
          QCousinage.Params[0].AsInteger := dm.FicheActive;
          QCousinage.Params[1].AsInteger := dm.NumDossier;
          QCousinage.Open;
          ppViewer.visible := QCousinage.RecordCount > 0;
          pRien.Visible := QCousinage.RecordCount <= 0;
          ppReport.PrintToDevices;
        end;
      _REP_LISTE_DIVERS_FRATRIE: begin
          s_Nom := lNom.Caption;
          s_Nom := s_Nom + ' - FR';

          Application.ProcessMessages;
          Application.ProcessMessages;
          ppViewer.Report := ppReport;
          QFratrie.Params[0].AsInteger := dm.FicheActive;
          QFratrie.Open;
          ppViewer.visible := QFratrie.RecordCount > 0;
          pRien.Visible := QFratrie.RecordCount <= 0;
          ppReport.PrintToDevices;
        end;
      _REP_LISTE_DIVERS_ONCLES_TANTES: begin
          s_Nom := lNom.Caption;
          s_Nom := s_Nom + ' - OT';
          Application.ProcessMessages;
          Application.ProcessMessages;
          ppViewer.Report := ppReport;
          QOnclesTantes.Params[0].AsInteger := dm.FicheActive;
          QOnclesTantes.Params[1].AsInteger := dm.NumDossier;
          QOnclesTantes.Params[2].AsInteger := 0;
          QOnclesTantes.Open;
          ppViewer.visible := QOnclesTantes.RecordCount > 0;
          pRien.Visible := QOnclesTantes.RecordCount <= 0;
          ppReport.PrintToDevices;
        end;
      _REP_FICHE_INDIVIDUELLE: begin
          s_Nom := lNom.Caption;
          s_Nom := s_Nom + ' - FI';
          Application.ProcessMessages;
          Application.ProcessMessages;
          ppViewer.Report := ppReport;
          aFParamReports.btnShowConfigBox.Enabled := True;

          QFiche.Close;

          if aFParamReports.cbToutDossierIndi.Checked then
            begin
              QFiche.SQL.Clear;
              QFiche.SQL.Add('select * from PROC_ETAT_TOUTES_FICHES(:I_DOSSIER)');
              QFiche.ParamByName('I_DOSSIER').AsInteger := dm.NumDossier;
            end
          else
            begin
              QFiche.SQL.Clear;
              QFiche.SQL.Add('select * from PROC_ETAT_FICHE(:CLE_FICHE)');
              QFiche.ParamByName('CLE_FICHE').AsInteger := dm.FicheActive;
            end;

          try
            QFiche.Open;
          except
            on E: Exception do
              begin
                ShowMessage('Erreur sur la requete');
              end;
          end;

          try
            QEveIndi.Open;
          except
            on E: Exception do
              begin
                ShowMessage('Erreur sur la requete');
              end;
          end;

          QMultimedia.Params[0].AsInteger := dm.FicheActive;
          QMultimedia.Params[1].AsString := 'I';
          QMultimedia.Open;
          QMultimedia.Last;
          QMultimedia.First;
          ppViewer.visible := QFiche.RecordCount > 0;
          pRien.Visible := QFiche.RecordCount <= 0;

          try
            ppReport.PrintToDevices;
          except
            on E: Exception do
              begin
                QFiche.Close;
                QEveIndi.Close;
                QMultimedia.Close;
                ShowMessage('Cette dition a gnre une erreur, verifiez les naissances et les dcs...');

                aFVerifEvent := TFVerifEvent.create(self);
                try
                  aFVerifEvent.ShowModal;
                finally
                  aFVerifEvent.Free;
                end;

              end;
          end;
        end;
      _REP_FICHE_FAMILIALE: begin
          s_Nom := lNom.Caption;
          s_Nom := s_Nom + ' - FF';
          Application.ProcessMessages;
          Application.ProcessMessages;
          ppViewer.Report := ppReport;

          aFParamReports.btnShowConfigBox.Enabled := aFParamReports.IBConjoints.FieldByName('UNION_CLEF').AsInteger > 0;
          if aFParamReports.IBConjoints.FieldByName('UNION_CLEF').AsInteger > 0 then
            begin
              QCouple.ParamByName('ACLE_UNION').AsInteger := aFParamReports.IBConjoints.FieldByName('UNION_CLEF').AsInteger;
              QCouple.Open;
              QCouple.Last;
              QCouple.First;

              QEveCouple.ParamByName('CLE_FAMILLE').AsInteger := aFParamReports.IBConjoints.FieldByName('UNION_CLEF').AsInteger;
              QEveCouple.Open;
              QEveCouple.Last;
              QEveCouple.First;

              if (aFParamReports.cbTous.Checked) and (i_Sexe = 2) then
                QEnfantsCouple.ParamByName('A_CLE_PERE').AsInteger := 0
              else
                QEnfantsCouple.ParamByName('A_CLE_PERE').AsInteger := QCouple.FieldByName('A_EPOUX_CLE').AsInteger;

              if (aFParamReports.cbTous.Checked) and (i_Sexe = 1) then
                QEnfantsCouple.ParamByName('A_CLE_MERE').AsInteger := 0
              else
                QEnfantsCouple.ParamByName('A_CLE_MERE').AsInteger := QCouple.FieldByName('A_EPOUSE_CLE').AsInteger;

              QEnfantsCouple.ParamByName('I_DOSSIER').AsInteger := dm.NumDossier;
              QEnfantsCouple.Open;

              IBQParentEnfants.ParamByName('I_DOSSIER').AsInteger := dm.NumDossier;
              IBQParentEnfants.Open;

              QMultimedia.Params[0].AsInteger := dm.FicheActive;
              QMultimedia.Params[1].AsString := 'F';
              QMultimedia.Open;
              QMultimedia.Last;
              QMultimedia.First;
            end;

          Screen.Cursor := crArrow;
          ppViewer.visible := (QCouple.RecordCount > 0);
          pRien.Visible := QCouple.RecordCount <= 0;
          ppReport.PrintToDevices;

        end;
      _REP_STAT_PATRONYME: begin
          ppViewer.visible := true;
          Application.ProcessMessages;
          Application.ProcessMessages;

          ppViewer.Report := ppReport;
          QStatNomPrenom.Params[0].AsInteger := dm.NumDossier;
          QStatNomPrenom.Open;
          pRien.Visible := QStatNomPrenom.RecordCount <= 0;
          ppReport.PrintToDevices;
        end;
      _REP_STAT_PRENOM: begin
          Application.ProcessMessages;
          Application.ProcessMessages;

          ppViewer.Report := ppReport;
          QStatPrenoms.Params[0].AsInteger := dm.NumDossier;
          QStatPrenoms.Open;
          ppViewer.visible := QStatPrenoms.RecordCount > 0;
          pRien.Visible := QStatPrenoms.RecordCount <= 0;
          ppReport.PrintToDevices;
        end;
      _REP_STAT_AGE_PREMIERE_UNION: begin
          Application.ProcessMessages;
          Application.ProcessMessages;

          ppViewer.Report := ppReport;
          QAgePremiereUnion.Params[0].AsInteger := dm.NumDossier;
          QAgePremiereUnion.Open;
          ppViewer.visible := QAgePremiereUnion.RecordCount > 0;
          pRien.Visible := QAgePremiereUnion.RecordCount <= 0;
          ppReport.PrintToDevices;
        end;
      _REP_STAT_LONGEVITE: begin
          Application.ProcessMessages;
          Application.ProcessMessages;

          ppViewer.Report := ppReport;
          QLongevite.ParamByName('A_CLE_DOSSIER').AsInteger := dm.NumDossier;
          if aFParamReports.cbLimitOnYear.checked then k := 1 else k := 0;
          QLongevite.ParamByName('LIMIT_ON_DATE').AsInteger := k;
          if aFParamReports.cbLimitOnSosa.checked then k := 1 else k := 0;
          QLongevite.ParamByName('LIMIT_ON_SOSA').AsInteger := k;
          QLongevite.ParamByName('YEAR_FROM').AsInteger := aFParamReports.edYearFrom.IntValue;
          QLongevite.ParamByName('YEAR_TO').AsInteger := aFParamReports.edYearTo.IntValue;
          QLongevite.ParamByName('INTERVAL').AsInteger := StrToInt(aFParamReports.edInterval.Text);
          QLongevite.Open;
          ppViewer.visible := QLongevite.RecordCount > 0;
          pRien.Visible := QLongevite.RecordCount <= 0;
          ppReport.PrintToDevices;
        end;
      _REP_STAT_NB_ENFANT_UNION: begin
          Application.ProcessMessages;
          Application.ProcessMessages;

          ppViewer.Report := ppReport;
          QNbEnfantUnion.ParamByName('A_CLE_DOSSIER').AsInteger := dm.NumDossier;
          if aFParamReports.cbLimitOnYear.checked then k := 1 else k := 0;
          QNbEnfantUnion.ParamByName('LIMIT_ON_DATE').AsInteger := k;
          if aFParamReports.cbLimitOnSosa.checked then k := 1 else k := 0;
          QNbEnfantUnion.ParamByName('LIMIT_ON_SOSA').AsInteger := k;
          QNbEnfantUnion.ParamByName('YEAR_FROM').AsInteger := aFParamReports.edYearFrom.IntValue;
          QNbEnfantUnion.ParamByName('YEAR_TO').AsInteger := aFParamReports.edYearTo.IntValue;
          QNbEnfantUnion.ParamByName('INTERVAL').AsInteger := StrToInt(aFParamReports.edInterval.Text);
          QNbEnfantUnion.Open;
          ppViewer.visible := QNbEnfantUnion.RecordCount > 0;
          pRien.Visible := QNbEnfantUnion.RecordCount <= 0;
          ppReport.PrintToDevices;
        end;
      _REP_STAT_RECENSEMENT: begin
          Application.ProcessMessages;
          Application.ProcessMessages;

          ppViewer.Report := ppReport;
          QRecensement.ParamByName('CLE_DOSSIER').AsInteger := dm.NumDossier;
          if aFParamReports.cbLimitOnYear.checked then k := 1 else k := 0;
          QRecensement.ParamByName('LIMIT_ON_DATE').AsInteger := k;
          if aFParamReports.cbLimitOnSosa.checked then k := 1 else k := 0;
          QRecensement.ParamByName('LIMIT_ON_SOSA').AsInteger := k;
          QRecensement.ParamByName('YEAR_FROM').AsInteger := aFParamReports.edYearFrom.IntValue;
          QRecensement.ParamByName('YEAR_TO').AsInteger := aFParamReports.edYearTo.IntValue;
          QRecensement.ParamByName('INTERVAL').AsInteger := StrToInt(aFParamReports.edInterval.Text);
          QRecensement.Open;
          ppViewer.visible := QRecensement.RecordCount > 0;
          pRien.Visible := QRecensement.RecordCount <= 0;
          ppReport.PrintToDevices;
        end;
      _REP_STAT_DENOMBREMENT_ASCENDANCE: begin
          Application.ProcessMessages;
          Application.ProcessMessages;

          ppViewer.Report := ppReport;
          QDenombreAscendance.ParamByName('A_CLE_FICHE').AsInteger := dm.FicheActive;
          QDenombreAscendance.ParamByName('A_CLE_DOSSIER').AsInteger := dm.NumDossier;
          QDenombreAscendance.Open;
          ppViewer.visible := QDenombreAscendance.RecordCount > 0;
          pRien.Visible := QDenombreAscendance.RecordCount <= 0;
          ppReport.PrintToDevices;
        end;
      _REP_STAT_DENOMBREMENT_DESCENDANCE: begin
          Application.ProcessMessages;
          Application.ProcessMessages;

          ppViewer.Report := ppReport;
          QDenombreDescendance.ParamByName('A_CLE_FICHE').AsInteger := dm.FicheActive;
          QDenombreDescendance.ParamByName('A_CLE_DOSSIER').AsInteger := dm.NumDossier;
          QDenombreDescendance.Open;
          ppViewer.visible := QDenombreDescendance.RecordCount > 0;
          pRien.Visible := QDenombreDescendance.RecordCount <= 0;
          ppReport.PrintToDevices;
        end;
      _REP_STAT_GRAPH_NAISS_DEPT: begin
          Application.ProcessMessages;
          Application.ProcessMessages;

          ppViewer.Report := ppReport;
          IBStatGraph.Params[0].AsInteger := dm.NumDossier;

          if aFParamReports.rgStats.ItemIndex = 0 then
            begin
              IBStatGraph.Params[1].AsInteger := 1;
              IBStatGraph.Params[2].AsInteger := 0;
            end
          else if aFParamReports.rgStats.ItemIndex = 1 then
            begin
              IBStatGraph.Params[1].AsInteger := 0;
              IBStatGraph.Params[2].AsInteger := 0;
            end
          else if aFParamReports.rgStats.ItemIndex = 2 then
            begin
              IBStatGraph.Params[1].AsInteger := 1;
              IBStatGraph.Params[2].AsInteger := 1;
            end
          else if aFParamReports.rgStats.ItemIndex = 3 then
            begin
              IBStatGraph.Params[1].AsInteger := 0;
              IBStatGraph.Params[2].AsInteger := 1;
            end;

          IBStatGraph.Open;
          ppViewer.visible := IBStatGraph.RecordCount > 0;
          pRien.Visible := IBStatGraph.RecordCount <= 0;
          ppReport.PrintToDevices;
        end;

    end;
  end;

  Screen.Cursor := crArrow;
  Application.ProcessMessages;
  //FMain.Enabled := True;
  Screen.Cursor := crArrow;
end;

procedure TFListReport.SuperFormCreate(Sender: TObject);
begin
  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  fIDTypeReport := -1;
  fFill := TState.create(false);
  aFParamReports := TFParamReports.create(self);
  fCut := TCut.Create;

  SaveDialogRTF.InitialDir := _Context.PathDocs;
  SaveDialogPDF.InitialDir := _Context.PathDocs;
end;

procedure TFListReport.SuperFormDestroy(Sender: TObject);
begin
  QAscendance.Close;
  QFiche.Close;
  QDescendance.Close;
  QDesPat.Close;
  QListeAlpha.Close;
  QListeAlphaBorne.Close;
  QEvenements.Close;
  QUnions.Close;
  QCousinage.Close;
  QStatNomPrenom.Close;
  QStatPrenoms.Close;
  QAnniv.Close;
  QCouple.Close;
  QEnfantsCouple.Close;
  QEveCouple.Close;
  QAgePremiereUnion.Close;
  QLongevite.Close;
  QNbEnfantUnion.Close;
  QRecensement.Close;
  QDenombreAscendance.Close;
  QDenombreDescendance.Close;
  QEclair.Close;
  QMultimedia.Close;
  QEveIndi.Close;
  QFratrie.Close;
  QOnclesTantes.Close;
  QEnfants.Close;
  IBQParentEnfants.Close;

  IBStatGraph.Close;
  fFill.Free;
  aFParamReports.Free;
  fCut.Free;
end;

procedure TFListReport.TrackBarChange(Sender: TObject);
begin
  ppViewer.ZoomPercentage := TrackBar.Position;
end;

procedure TFListReport.PreparePopup;
var
  n: integer;
  //p: tpoint;
  item: TMenuItem;
  List: TStringList;
  //aItemIsChecked: boolean;
  k: integer;
  FileNameReportInContext: string;
begin
  //Nettoyage du popup
  for n := popup_report.items.count - 1 downto 6 do popup_report.items.delete(n);

  //Construction du popup
  List := TStringList.create;
  try
    GetDirContent(ExtractFilePath(Application.exeName) + _REL_PATH_REPORT + fRelPathSaveReport, List, '*.rtm');
    k := -1;
    FileNameReportInContext := AnsiUpperCase(GetDefaultFileNameReportInContext(fIDTypeReport));
    for n := 0 to List.Count - 1 do
      if AnsiUpperCase(List[n]) = FileNameReportInContext then k := n;

    for n := 0 to List.Count - 1 do
      begin
        item := TMenuItem.create(self);
        item.caption := fRelPathSaveReport + List[n];
        // item.ImageIndex := 21;

        if (n = 0) and (k = -1) then item.checked := true
        else
          if (n = k) then item.checked := true;

        item.OnClick := OnClickOnMenuItemReport;

        popup_report.items.add(item);
      end;

    option_EditReport.enabled := (List.Count > 0);

  finally
    List.Free;
  end;
end;

procedure TFListReport.spbPreviewFirstClick(Sender: TObject);
var Save_Cursor: TCursor;
begin
  Save_Cursor := Screen.Cursor;
  Screen.Cursor := crHourglass;
  ppViewer.FirstPage;
  Screen.Cursor := Save_Cursor;
end;

procedure TFListReport.spbPreviewPriorClick(Sender: TObject);
var Save_Cursor: TCursor;
begin
  Save_Cursor := Screen.Cursor;
  Screen.Cursor := crHourglass;
  ppViewer.PriorPage;
  Screen.Cursor := Save_Cursor;
end;

procedure TFListReport.spbPreviewNextClick(Sender: TObject);
var Save_Cursor: TCursor;
begin
  Save_Cursor := Screen.Cursor;
  Screen.Cursor := crHourglass;
  ppViewer.NextPage;
  Screen.Cursor := Save_Cursor;
end;

procedure TFListReport.spbPreviewLastClick(Sender: TObject);
var Save_Cursor: TCursor;
begin
  Save_Cursor := Screen.Cursor;
  Screen.Cursor := crHourglass;
  ppViewer.LastPage;
  Screen.Cursor := Save_Cursor;
end;

procedure TFListReport.mskPreviewPageKeyPress(Sender: TObject;
  var Key: Char);

var
  liPage: Longint;
begin

  if (Key = #13) then
    begin
      liPage := StrToInt(mskPreviewPage.Text);

      ppViewer.GotoPage(liPage);
    end; {if, carriage return pressed}
end;

procedure TFListReport.ppViewerPageChange(Sender: TObject);
begin
  mskPreviewPage.Text := IntToStr(ppViewer.AbsolutePageNo);
end;

procedure TFListReport.spbPreviewWholeClick(Sender: TObject);
begin
  ppViewer.ZoomSetting := zsWholePage;
end;

procedure TFListReport.spbPreviewWidthClick(Sender: TObject);
begin
  ppViewer.ZoomSetting := zsPageWidth;
end;

procedure TFListReport.spbPreview100PercentClick(Sender: TObject);
begin
  ppViewer.ZoomSetting := zs100Percent;
end;


procedure TFListReport.OnClickOnMenuItemReport(Sender: TObject);
var
  s, p: string;
begin
  //On charge le rapport
  s := ExtractFilePath(Application.ExeName) + _REL_PATH_REPORT + TMenuItem(Sender).Caption;
  if FileExists(s) then
    begin
      p := ExtractFileName(s);
      if ansiUpperCase(p) <> AnsiUpperCase(GetDefaultFileNameReportInContext(fIDTypeReport)) then
        begin
          SetDefaultFileNameReportInContext(fIDTypeReport, p);
        end;

      ppReport.Template.FileName := s;
      ppReport.Template.LoadFromFile;
      doShowReport(fIDTypeReport);
    end;
end;


procedure TFListReport.Nouveaurapport1Click(Sender: TObject);
var
  s: string;
begin
  //On demande un nom de rapport
  s := GetRelPathReport(fIDTypeReport);
  if s <> '' then
    begin
      SaveDialog.InitialDir := ExtractFilePath(Application.ExeName) + _REL_PATH_REPORT + s;
      SaveDialog.FileName := '';
      if SaveDialog.Execute then
        begin
          if FileExists(SaveDialog.FileName) then
            begin
              MyMessageDlg('Il existe dj un rapport du mme nom !', mtWarning, [mbOK], 0);
            end
          else
            begin
              ppReport.Reset;
              ppReport.Template.New;
              ppreport.Template.FileName := SaveDialog.FileName;
              ppReport.Template.SaveToFile;

              //On relie les compos
              ppReport.DataPipeline := GetPipeline;
              ppDesigner.report := ppReport;

              //Affichage de l'diteur
              ppDesigner.ShowModal;
            end;
        end;
    end;
end;

procedure TFListReport.option_EditReportClick(Sender: TObject);
var
  n: integer;
  s: string;
  //
begin
  //On recherche l'item qui est check
  s := '';
  for n := 0 to popup_report.Items.Count - 1 do
    if popup_report.Items[n].checked then s := _REL_PATH_REPORT + popup_report.Items[n].Caption;

  s := ExtractFilePath(Application.exeName) + s;

  if FileExists(s) then
    begin
      //     ppViewer.Report := nil;
      ppReport.Reset;
      ppreport.Template.FileName := s;
      ppreport.Template.LoadFromFile;

      //On relie les compos
      ppReport.DataPipeline := GetPipeline;
      ppDesigner.report := ppReport;

      //Affichage de l'diteur
     // ppDesigner.RAPInterface := [riDialog, riNotebookTab];

      ppDesigner.Caption := 'Editeur de rapport Ancestrologie 2001';
      ppDesigner.ShowModal;
    end;
end;

procedure TFListReport.ppDesignerClose(Sender: TObject; var Action: TCloseAction);
begin
  if FileExists(ppReport.Template.FileName) then
    begin
      //est-il dans le bon rpertoire ?
      if AnsiUpperCase(SetValidPathString(ExtractFilePath(ppReport.Template.FileName))) <> AnsiUpperCase(ExtractFilePath(Application.exeName) + _REL_PATH_REPORT + fRelPathSaveReport) then
        begin
          if MyMessageDlg('Pour tre utilisable, le rapport doit tre enregistr dans la structure des rpertoires d''Ancestrologie. Souhaitez-vous que je fasse un copie de ce fichier dans le bon rpertoire ?', mtWarning, [mbYes, mbNo], 0) = mrYes then
            begin
              if CopyFile(PChar(ppReport.Template.FileName), PChar(ExtractFilePath(Application.exeName) + _REL_PATH_REPORT + fRelPathSaveReport + ExtractFileName(ppReport.Template.FileName)), true) then
                begin
                  SetDefaultFileNameReportInContext(fIDTypeReport, ExtractFileName(ppReport.Template.FileName));

                  //On rafraichit le rapport
                  doTryToShowReport;
                end;
            end;
        end
      else
        //Il est dans le bon rpertoire
        begin
          SetDefaultFileNameReportInContext(fIDTypeReport, ExtractFileName(ppReport.Template.FileName));

          //On rafraichit le rapport
          doTryToShowReport;
        end;
    end;
end;

function TFListReport.GetDefaultFileNameReportInContext(aIDReport: integer): string;
begin
  if (aIDReport >= 0) and (aIDReport <= _MAX_REP_PATH)
    then result := _Context.FileNameReport[aIDReport]
  else result := '';
end;

procedure TFListReport.SetDefaultFileNameReportInContext(aIDReport: integer; aFileName: string);
begin
  if (aIDReport >= 0) and (aIDReport <= _MAX_REP_PATH) then
    begin
      _Context.FileNameReport[aIDReport] := aFileName;
      _Context.ShouldSave := true;
    end;
end;

procedure TFListReport.Ajouterunrapport1Click(Sender: TObject);
begin
  OpenDialog.FileName := '';
  if OpenDialog.Execute then
    begin
      if AnsiUpperCase(SetValidPathString(ExtractFilePath(OpenDialog.FileName))) <> AnsiUpperCase(ExtractFilePath(Application.exeName) + _REL_PATH_REPORT + fRelPathSaveReport) then
        begin
          if CopyFile(PChar(OpenDialog.FileName), PChar(ExtractFilePath(Application.exeName) + _REL_PATH_REPORT + fRelPathSaveReport + ExtractFileName(OpenDialog.FileName)), true) then
            begin
              SetDefaultFileNameReportInContext(fIDTypeReport, ExtractFileName(OpenDialog.FileName));

              //On rafraichit le rapport
              doTryToShowReport;
            end;
        end;
    end;
end;

procedure TFListReport.SuperFormRefreshControls(Sender: TObject);
begin
  btnConfig.enabled := fIDTypeReport <> -1;
  btnPrint.enabled := fIDTypeReport <> -1;
end;

procedure TFListReport.SuperFormShowFirstTime(Sender: TObject);
begin
  btnShowConfigBox.visible := false;
  aFParamReports.PtrListReport := self;
  TL.FullExpand;
  doRefreshControls;

  lNom.Caption := '?';
  try
    try
      QGetNomPrenom.Close;
      QGetNomPrenom.ParamByName('CLE_FICHE').AsInteger := dm.FicheActive;
      QGetNomPrenom.Open;
      QGetNomPrenom.Last;
      QGetNomPrenom.First;
      if QGetNomPrenom.RecordCount = 1 then
        begin
          lNom.Caption := CoupeChaine(AssembleString([QGetNomPrenom.FieldByName('Nom').AsString, QGetNomPrenom.FieldByName('PRENOM').AsString]), lNom);
          i_Sexe := QGetNomPrenom.FieldByName('SEXE').AsInteger;
        end;
    finally
      QGetNomPrenom.Close;
    end;
  except
  end;
end;

function TFListReport.GetRelPathReport(aIDReport: integer): string;
begin
  if (aIDReport >= 0) and (aIDReport <= _MAX_REP_PATH)
    then result := _REP_PATH_REPORT[aIDReport]
  else result := '';
end;

procedure TFListReport.btnPrintClick(Sender: TObject);
var
  suite: boolean;
begin

  if rbTXT.checked = false then
    begin
      if Printer.Printers.Count = 0 then
        begin
          MyMessageDlg('Il n''y a aucune imprimante disponible.', mtError, [mbOK], 0);
        end
      else
        begin
          if rbRTF.checked then
            begin
              SaveDialogRTF.FileName := s_Nom + '.RTF';
              suite := SaveDialogRTF.Execute;
            end
          else
            if rbPDF.checked then
              begin
                SaveDialogPDF.FileName := s_Nom + '.PDF';
                suite := SaveDialogPDF.Execute;
              end
            else
              if rbHTML.checked then
                begin
                  SaveDialogHTML.FileName := s_Nom + '.HTM';
                  suite := SaveDialogHTML.Execute;
                end
              else suite := true;

          //               if MyMessageDlg('Confirmez-vous la demande d''impression du rapport ?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
          if suite then
            begin
              _FOccupe.doActive;
              try
                if rbRTF.checked then
                  begin
                    ppViewer.Report := nil;
                    ppReport.DeviceType := 'RTFFile';
                    ppReport.TextFileName := SaveDialogRTF.FileName;
                    try

                      ppReport.Print;
                      Application.ProcessMessages;
                      ShellExecute(application.Handle, nil, PChar(SaveDialogRTF.FileName), '', '', SW_SHOWNORMAL);

                      //				   shellexecute(application.handle, nil, pchar(_Context.PathWord), pchar('"' + SaveDialogRTF.FileName + '"'), nil, SW_SHOWNORMAL);
                    finally
                      ppReport.DeviceType := 'Screen';
                      ppViewer.Report := ppReport;
                    end;
                  end
                else
                  if rbPDF.checked then
                    begin
                      ppViewer.Report := nil;
                      ppReport.DeviceType := 'PDFFile';
                      ppReport.TextFileName := SaveDialogPDF.FileName;
                      try
                        ppReport.Print;
                        Application.ProcessMessages;
                        ShellExecute(application.Handle, nil, PChar(SaveDialogPDF.FileName), '', '', SW_SHOWNORMAL);
                        //				   shellexecute(application.handle, nil, pchar(_Context.PathAdobe), pchar(SaveDialogPDF.FileName), nil, SW_SHOWNORMAL);
                      finally
                        ppReport.DeviceType := 'Screen';
                        ppViewer.Report := ppReport;
                      end;
                    end
                  else
                    if rbHTML.checked then
                      begin
                        ppViewer.Report := nil;
                        //ppReport.DeviceType := 'XTMLFile';
                        ppReport.DeviceType := 'HTMLFile';
                        ppReport.TextFileName := SaveDialogHTML.FileName;
                        try
                          ppReport.Print;
                          Application.ProcessMessages;
                          //shellexecute(application.handle, nil, pchar('IEXPLORE'), pchar('"' + SaveDialogHTML.FileName + '"'), nil, SW_SHOWNORMAL);
                        finally
                          ppReport.DeviceType := 'Screen';
                          ppViewer.Report := ppReport;
                        end;
                      end
                    else
                      if rvPrinter.checked then
                        begin
                          ppViewer.Report := nil;
                          ppReport.DeviceType := 'Printer';
                          try
                            ppReport.Print;
                          finally
                            ppReport.DeviceType := 'Screen';
                            ppViewer.Report := ppReport;
                          end;
                        end;
              finally
                _FOccupe.doDesactive;
              end;
            end;
        end;
    end
  else
    begin
      //selon le type de rapport, on demande des noms de fichier pour l'extraction
      if GetFileNameReportForExport then
        begin
          doExportReportInTextFile;
        end;
    end;
end;

procedure TFListReport.NakedSpeedButton2Click(Sender: TObject);
//var
 // p: TppPrinter;
begin
  {
    p := TppPrinter.Create;
    try
      p.PrinterSetup := ppReport.PrinterSetup;
          if p.ShowSetupDialog then
    begin

    end;
    finally
          p.free;
        end;
        }
end;

procedure TFListReport.rvPrinterChange(Sender: TObject);
begin
  if not fFill.Value then
    begin
      fFill.Value := true;
      try
        rvPrinter.checked := true;
        rbPDF.checked := false;
        rbRTF.checked := false;
        rbHtml.checked := false;
        rbTXT.checked := false;
      finally
        fFill.Value := false;
      end;
    end;
end;

procedure TFListReport.rbPDFChange(Sender: TObject);
begin
  if not fFill.Value then
    begin
      fFill.Value := true;
      try
        rvPrinter.checked := false;
        rbPDF.checked := true;
        rbRTF.checked := false;
        rbHtml.checked := false;
        rbTXT.checked := false;
      finally
        fFill.Value := false;
      end;
    end;
end;

procedure TFListReport.rbRTFChange(Sender: TObject);
begin
  if not fFill.Value then
    begin
      fFill.Value := true;
      try
        rvPrinter.checked := false;
        rbPDF.checked := false;
        rbHtml.checked := false;
        rbRTF.checked := true;
        rbTXT.checked := false;
      finally
        fFill.Value := false;
      end;
    end;
end;

procedure TFListReport.rbTXTChange(Sender: TObject);
begin
  if not fFill.Value then
    begin
      fFill.Value := true;
      try
        rvPrinter.checked := false;
        rbPDF.checked := false;
        rbRTF.checked := false;
        rbHtml.checked := false;
        rbTXT.checked := true;
      finally
        fFill.Value := false;
      end;
    end;
end;

procedure TFListReport.rbHtmlChange(Sender: TObject);
begin
  if not fFill.Value then
    begin
      fFill.Value := true;
      try
        rvPrinter.checked := false;
        rbPDF.checked := false;
        rbRTF.checked := false;
        rbHtml.checked := True;
        rbTXT.checked := False;
      finally
        fFill.Value := false;
      end;
    end;
end;

procedure TFListReport.btnConfigClick(Sender: TObject);
var
  p: tpoint;
begin
  //    fIDTypeReport := TControl(Sender).Tag;
  if fIDTypeReport <> -1 then
    begin
      fRelPathSaveReport := GetRelPathReport(fIDTypeReport);
      preparePopup;

      //Ouverture du popup
      p.x := 0; p.y := 0;
      p := TControl(Sender).clienttoscreen(p);
      popup_report.popup(p.x, p.y + TControl(Sender).height);
    end;
end;

procedure TFListReport.TLChangeNode(Sender: TObject; OldNode, Node: TdxTreeListNode);
var
  k: integer;
  Item: TdxTreeListNode;
begin
  if fFill.Value = false then
    begin
      fFill.Value := true;
      try
        if TL.FocusedNode <> nil then
          begin
            Item := TL.FocusedNode;
            try
              k := StrToInt(item.Strings[1]);

              if k <> fIDTypeReport then
                begin
                  fIDTypeReport := k;
                  fRelPathSaveReport := GetRelPathReport(fIDTypeReport);
                  doRefreshControls;
                  doTryToShowReport;
                end;
            except
            end;

          end;
      finally
        fFill.Value := false;
      end;
    end;

  doRefreshControls;
end;

function TFListReport.GetPipeline: TppDBPipeline;
begin
  case fIDTypeReport of

    _REP_ASCENDANCE_COMPLET: result := ppDBAscendance;
    _REP_ASCENDANCE_PAR_HOMMES: result := ppDBAscendance;
    _REP_ASCENDANCE_PAR_FEMMES: result := ppDBAscendance;
    _REP_DESCENDANCE_COMPLET: result := ppDBDescendance;
    _REP_DESCENDANCE_PATRONYMIQUE: result := ppDBDesPat;
    _REP_LISTE_ALPHA_TOUS: result := ppDBListeAlpha;
    _REP_LISTE_ALPHA_HOMME: result := ppDBListeAlpha;
    _REP_LISTE_ALPHA_FEMME: result := ppDBListeAlpha;
    _REP_LISTE_DIVERS_UNION: result := ppDBUnions;
    _REP_LISTE_DIVERS_ECLAIR: result := ppDBEclair;
    _REP_LISTE_DIVERS_EVENEMENT: result := ppDBEvenements;
    _REP_LISTE_DIVERS_ANNIVERSAIRE: result := ppDBAnniv;
    _REP_LISTE_DIVERS_ENFANTS: result := ppDBEnfants;
    _REP_LISTE_DIVERS_FRATRIE: result := ppDBFratrie;
    _REP_LISTE_DIVERS_ONCLES_TANTES: result := ppDBOnclesTantes;
    _REP_LISTE_DIVERS_COUSINAGE: result := ppDBCousinage;
    _REP_FICHE_INDIVIDUELLE: result := ppDBFiche;
    _REP_FICHE_FAMILIALE: result := ppDBCouple;
    _REP_STAT_PATRONYME: result := ppDBStatNomPrenom;
    _REP_STAT_PRENOM: result := ppDBStatPrenoms;
    _REP_STAT_AGE_PREMIERE_UNION: result := ppDBAgePremiereUnion;
    _REP_STAT_LONGEVITE: result := ppDBLongevite;
    _REP_STAT_NB_ENFANT_UNION: result := ppDBNbEnfantUnion;
    _REP_STAT_RECENSEMENT: result := ppDBRecensement;
    _REP_STAT_DENOMBREMENT_ASCENDANCE: result := ppDBDenombreAscendance;
    _REP_STAT_DENOMBREMENT_DESCENDANCE: result := ppDBDenombreDescendance;
    _REP_STAT_GRAPH_NAISS_DEPT: result := ppDBStatGraph;

    else
      result := nil;
  end;
end;

procedure TFListReport.btnShowConfigBoxClick(Sender: TObject);
begin
  aFParamReports.Show;
end;

procedure TFListReport.doRefreshReport;
begin
  doShowReport(fIDTypeReport);
end;

procedure TFListReport.doPrepareReport(TagReport: integer);
var
  ExistConfig: boolean;
begin
  ExistConfig := true;
  ppReport.DataPipeline := GetPipeline;

  case TagReport of
    _REP_STAT_GRAPH_NAISS_DEPT: begin
        aFParamReports.Notebook.ActivePage := 'GraphStat';
        aFParamReports.Show;
      end;
    _REP_LISTE_DIVERS_ANNIVERSAIRE: begin
        aFParamReports.Notebook.ActivePage := 'Anniv';
        aFParamReports.Show;
      end;

    _REP_LISTE_DIVERS_ECLAIR: begin
        aFParamReports.Notebook.ActivePage := 'Eclair';
        aFParamReports.Show;
      end;

    _REP_FICHE_INDIVIDUELLE: begin
        aFParamReports.Notebook.ActivePage := 'FicheIndi';
        aFParamReports.Show;
      end;

    _REP_FICHE_FAMILIALE: begin
        aFParamReports.Notebook.ActivePage := 'FicheFamiliale';
        aFParamReports.Show;
        aFParamReports.IBConjoints.Close;
        aFParamReports.IBConjoints.ParamByName('NUM_DOSSIER').AsInteger := dm.NumDossier;
        aFParamReports.IBConjoints.ParamByName('CLE_FICHE').AsInteger := dm.FicheActive;
        aFParamReports.IBConjoints.Open;
      end;

    _REP_STAT_LONGEVITE,
      _REP_STAT_NB_ENFANT_UNION,
      _REP_STAT_RECENSEMENT:
      begin
        aFParamReports.Notebook.ActivePage := 'Interval';
        aFParamReports.Show;
      end;

    else
      ExistConfig := false;
  end;

  if ExistConfig = false then aFParamReports.Hide;
  btnShowConfigBox.visible := ExistConfig;

  Application.ProcessMessages;
  Application.ProcessMessages;
end;

function TFListReport.GetFileNameReportForExport: boolean;
var
  s: string;
  aFAskNameFilesToExportReport: TFAskNameFilesToExportReport;
begin
  result := false;

  //Nom du rapport
  s := '';

  if TL.FocusedNode <> nil then
    begin
      s := TL.FocusedNode.Strings[0];
    end;

  aFAskNameFilesToExportReport := TFAskNameFilesToExportReport.create(self);
  try
    //    aFAskNameFilesToExportReport.lbTitle.Caption := s;

    case fIDTypeReport of

      _REP_FICHE_FAMILIALE: begin
          //3 fichiers  demander
          aFAskNameFilesToExportReport.NbFileToAsk := 3;
          aFAskNameFilesToExportReport.lbFile1.Caption := 'Couple :';
          aFAskNameFilesToExportReport.lbFile2.Caption := 'Evnements du couple :';
          aFAskNameFilesToExportReport.lbFile3.Caption := 'Enfants du couple :';
        end;

      else
        begin
          //un seul fichier  demander
          aFAskNameFilesToExportReport.NbFileToAsk := 1;
        end;
    end;


    if aFAskNameFilesToExportReport.ShowModal = mrOk then
      begin
        fFileName1 := aFAskNameFilesToExportReport.edNameFile1.Text;
        fFileName2 := aFAskNameFilesToExportReport.edNameFile2.Text;
        fFileName3 := aFAskNameFilesToExportReport.edNameFile3.Text;


        //Enttes
        fAddEntete := aFAskNameFilesToExportReport.cbIncludeEntete.Checked;

        //Sparateur de colonne
        if aFAskNameFilesToExportReport.rbPV.checked then fCut.ParamSeparator := ';'
        else
          if aFAskNameFilesToExportReport.rbV.checked then fCut.ParamSeparator := ','
          else
            if aFAskNameFilesToExportReport.rbTab.checked then fCut.ParamSeparator := #9
            else
              if aFAskNameFilesToExportReport.rbAutre.checked then fCut.ParamSeparator := aFAskNameFilesToExportReport.edAutreSep.text;

        //Dlimiteur de chane de caractte
        //fCut.StringDelimitor := aFAskNameFilesToExportReport.edStringDelimitor.Text;


        result := true;
      end;

  finally
    aFAskNameFilesToExportReport.Free;
  end;
end;


procedure TFListReport.doExportReportInTextFile;
begin
  case fIDTypeReport of

    _REP_FICHE_FAMILIALE: begin
        ExportATable(QCouple, fFileName1);
        ExportATable(QEveCouple, fFileName2);
        ExportATable(QEnfantsCouple, fFileName3);
      end;

    else
      begin
        ExportATable(TIBQuery(TppDBPipeline(ppReport.DataPipeline).DataSource.DataSet), fFileName1);
      end;
  end;

end;

procedure TFListReport.ExportATable(Q: TIBQuery; aPathFileName: string);
var
  n: integer;
  s: string;
  ListParamName: TStringList;
begin
  //Q est ouvert
  ListParamName := TStringList.create;
  try
    fCut.Params.Clear;
    //fCut.ParamSeparator := #9;
    s := '';

    //Rcupration des champs
    for n := 0 to Q.FieldCount - 1 do
      begin
        if n > 0 then s := s + fCut.ParamSeparator;
        s := s + Q.Fields[n].FieldName;
        fCut.Params.CreateParam(Q.Fields[n].DataType, Q.Fields[n].FieldName, ptInputOutput);
        ListParamName.Add(Q.Fields[n].FieldName);
      end;

    //Maintenant, on connait les noms des paramtres
    if fCut.Params.Count > 0 then
      begin
        AssignFile(aFile, aPathFileName);
        try
          Rewrite(aFile);

          if fAddEntete then
            begin
              WriteLn(aFile, s);
            end;

          Q.First;
          while (not Q.EOF) do
            begin
              for n := 0 to ListParamName.Count - 1 do
                begin
                  s := Q.FieldByName(ListParamName[n]).AsString;
                  RemoveStrFromString(s, fCut.ParamSeparator);
                  fCut.Params[n].AsString := s;
                end;

              fCut.ParamsToStr;
              WriteLn(aFile, fCut.Line);
              Flush(aFile);

              Q.Next;
            end;

        finally
          CloseFile(aFile);
        end;
      end;

  finally
    //          fCut.Free;
    ListParamName.Free;
  end;
end;

function TFListReport.ppJITPVariableGetFieldValue(
  aFieldName: string): Variant;
var
  sNom: string;
begin

  sNom := lNom.Caption;
  if Length(sNom) > 30 then
    sNom := Copy(sNom, 0, 35) + '...';

  if aFieldName = 'I_PHOTOS' then
    if (aFParamReports.cbPhotos.Checked) then //or (aFParamReports.cbPhotosIndi.Checked) then
      result := 1
    else
      result := 0;

  if aFieldName = 'I_PHOTOS_INDI' then
    if (aFParamReports.cbPhotosIndi.Checked) then
      result := 1
    else
      result := 0;

  if aFieldName = 'I_TOUS_ENFANTS' then
    if (aFParamReports.cbTous.Checked) then
      result := 1
    else
      result := 0;

  if aFieldName = 'S_SEXE' then
    result := i_Sexe;
  if aFieldName = 'S_PIED_PAGE' then
    result := Application.Title +
      ' - Dossier : ' + dm.NomDossier +
      '  - Imprim le : ' + FormatDateTime('dddd dd mmmm yyyy', date);

  if aFieldName = 'S_TITRE' then
    begin
      case fIDTypeReport of
        _REP_ASCENDANCE_COMPLET: result := 'Ascendance complte de : ' + sNom;
        _REP_ASCENDANCE_PAR_HOMMES: result := 'Ascendance par les hommes de : ' + sNom;
        _REP_ASCENDANCE_PAR_FEMMES: result := 'Ascendance par les femmes de : ' + sNom;
        _REP_DESCENDANCE_COMPLET: result := 'Descendance complte de : ' + sNom;
        _REP_DESCENDANCE_PATRONYMIQUE: result := 'Descendance patronymique de : ' + sNom;
        _REP_LISTE_ALPHA_TOUS: result := 'Liste alphabtique complte';
        _REP_LISTE_ALPHA_HOMME: result := 'Liste alphabtique par les hommes';
        _REP_LISTE_ALPHA_FEMME: result := 'Liste alphabtique par les femmes';
        _REP_LISTE_DIVERS_UNION: result := 'Liste des unions';
        _REP_LISTE_DIVERS_ECLAIR: result := 'Liste clair';
        _REP_LISTE_DIVERS_EVENEMENT: result := 'Liste des vnements';
        _REP_LISTE_DIVERS_ANNIVERSAIRE: result := 'Liste des anniversaires';
        _REP_LISTE_DIVERS_ENFANTS: result := 'Enfants de : ' + sNom;
        _REP_LISTE_DIVERS_FRATRIE: result := 'Frres et soeurs de : ' + sNom;
        _REP_LISTE_DIVERS_ONCLES_TANTES: result := 'Oncles et tantes de : ' + sNom;
        _REP_LISTE_DIVERS_COUSINAGE: result := 'Cousins / Cousines de :' + sNom;
        _REP_FICHE_INDIVIDUELLE: result := 'Fiche individuelle de : ' + sNom;
        _REP_FICHE_FAMILIALE: result := 'Fiche familiale de : ' + sNom;
        _REP_STAT_PATRONYME: result := 'Liste des patronymes';
        _REP_STAT_PRENOM: result := 'Liste des prenoms';
        _REP_STAT_AGE_PREMIERE_UNION: result := 'Etat des ages  la premire union';
        _REP_STAT_LONGEVITE: result := 'Etat des longvits';
        _REP_STAT_NB_ENFANT_UNION: result := 'Etat du nombre d''enfants par union';
        _REP_STAT_RECENSEMENT: result := 'Etat du recensement';
        _REP_STAT_DENOMBREMENT_ASCENDANCE: result := 'Liste du dnombrement d''ascendance';
        _REP_STAT_DENOMBREMENT_DESCENDANCE: result := 'Liste du dnombrement de descendance';
        _REP_STAT_GRAPH_NAISS_DEPT:
          begin
            if aFParamReports.rgStats.ItemIndex = 0 then
              result := 'Naissances par dpartements'
            else if aFParamReports.rgStats.ItemIndex = 1 then
              result := 'Dcs par dpartements'
            else if aFParamReports.rgStats.ItemIndex = 2 then
              result := 'Naissances par pays'
            else if aFParamReports.rgStats.ItemIndex = 3 then
              result := 'Dcs par pays'
          end
        else
          result := '';
      end
    end;
end;

procedure TFListReport.ppDesignerShow(Sender: TObject);
begin
  ppDesigner.Caption := 'Editeur de rapport Ancestrologie 2001';
end;


procedure TFListReport.QAscendanceCalcFields(DataSet: TDataSet);
begin
  if _Context.Nip = 1 then
    if QAscendanceSexe.AsInteger = 1 then
      QAscendanceS_NOM.AsString := QAscendanceNom.AsString + '  ----  NIP 1-' + QAscendanceCLE_FICHE.AsString
    else
      QAscendanceS_NOM.AsString := QAscendanceNom.AsString + '  ----  NIP 2-' + QAscendanceCLE_FICHE.AsString
  else
    QAscendanceS_NOM.AsString := QAscendanceNom.AsString;
end;

procedure TFListReport.QListeAlphaCalcFields(DataSet: TDataSet);
begin

  if length(QListeAlphaPRENOM.AsString) > 0 then
    QListeAlphaS_NOM.AsString := QListeAlphaNOM.AsString + ', ' + QListeAlphaPRENOM.AsString
  else
    QListeAlphaS_NOM.AsString := QListeAlphaNOM.AsString;

  if _Context.Nip = 1 then
    if QListeAlphaSexe.AsInteger = 1 then
      QListeAlphaS_NOM.AsString := QListeAlphaS_Nom.AsString + '  ----  NIP 1-' + QListeAlphaCLE_FICHE.AsString
    else
      QListeAlphaS_NOM.AsString := QListeAlphaS_Nom.AsString + '  ----  NIP 2-' + QListeAlphaCLE_FICHE.AsString
  else
    QListeAlphaS_NOM.AsString := QListeAlphaS_Nom.AsString;
end;

end.
