{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_gedcom_var;

interface

uses
  Classes;

var
  Token_Du: TStringList;
  Token_Au: TStringList;
  Token_Avant: TStringList;
  Token_Apres: TStringList;
  Token_Entre: TStringList;
  Token_Et: TStringList;
  Token_Calculee: TStringList;
  Token_Estimee: TStringList;
  Token_Vers: TStringList;
  Token_Human_Month_01: TStringList;
  Token_Human_Month_02: TStringList;
  Token_Human_Month_03: TStringList;
  Token_Human_Month_04: TStringList;
  Token_Human_Month_05: TStringList;
  Token_Human_Month_06: TStringList;
  Token_Human_Month_07: TStringList;
  Token_Human_Month_08: TStringList;
  Token_Human_Month_09: TStringList;
  Token_Human_Month_10: TStringList;
  Token_Human_Month_11: TStringList;
  Token_Human_Month_12: TStringList;
  Separator_Human_Date: TStringList;


implementation

initialization

  Token_Du := TStringList.create;
  Token_Au := TStringList.create;
  Token_Avant := TStringList.create;
  Token_Apres := TStringList.create;
  Token_Entre := TStringList.create;
  Token_Et := TStringList.create;
  Token_Calculee := TStringList.create;
  Token_Estimee := TStringList.create;
  Token_Vers := TStringList.create;
  Token_Human_Month_01 := TStringList.create;
  Token_Human_Month_02 := TStringList.create;
  Token_Human_Month_03 := TStringList.create;
  Token_Human_Month_04 := TStringList.create;
  Token_Human_Month_05 := TStringList.create;
  Token_Human_Month_06 := TStringList.create;
  Token_Human_Month_07 := TStringList.create;
  Token_Human_Month_08 := TStringList.create;
  Token_Human_Month_09 := TStringList.create;
  Token_Human_Month_10 := TStringList.create;
  Token_Human_Month_11 := TStringList.create;
  Token_Human_Month_12 := TStringList.create;
  Separator_Human_Date := TStringList.create;


  //remplissage
  token_Du.Add('du');
  token_Du.Add('de');
  token_Du.Add('de l''an');
  token_Du.Add('de l''anne');
  token_Du.Add('de l''annee');
  token_Au.Add('au');
  token_Au.Add('');
  token_Au.Add('a');
  token_Au.Add(' l''an');
  token_Au.Add('a l''an');
  token_Au.Add(' l''anne');
  token_Au.Add('a l''anne');
  token_Apres.Add('apres');
  token_Apres.Add('aprs');
  token_Apres.Add('aprs le');
  token_Apres.Add('apres le');
  token_Apres.Add('aprs l''an');
  token_Apres.Add('apres l''an');
  token_Apres.Add('aprs l''anne');
  token_Avant.Add('avant');
  token_Avant.Add('avant le');
  token_Avant.Add('avant l''an');
  token_Avant.Add('avant l''anne');
  token_Avant.Add('avant l''annee');
  token_Entre.Add('entre');
  token_Entre.Add('entre le');
  token_Et.Add('et');
  token_Et.Add('et le');
  token_Et.Add('et l''an');
  token_Et.Add('et l''anne');
  token_Calculee.Add('calcule');
  token_Calculee.Add('cal');
  token_Estimee.Add('estime');
  token_Estimee.Add('est');
  token_Vers.Add('vers');
  token_Vers.Add('vers le');
  Separator_Human_Date.Add('/');
  Separator_Human_Date.Add('.');
  Token_Human_Month_01.Add('janvier');
  Token_Human_Month_01.Add('janv');
  Token_Human_Month_02.Add('fvrier');
  Token_Human_Month_02.Add('fevrier');
  Token_Human_Month_02.Add('fevr');
  Token_Human_Month_02.Add('fvr');
  Token_Human_Month_03.Add('mars');
  Token_Human_Month_04.Add('avril');
  Token_Human_Month_04.Add('avr');
  Token_Human_Month_05.Add('mai');
  Token_Human_Month_06.Add('juin');
  Token_Human_Month_07.Add('juillet');
  Token_Human_Month_07.Add('juil');
  Token_Human_Month_08.Add('aot');
  Token_Human_Month_08.Add('aout');
  Token_Human_Month_09.Add('septembre');
  Token_Human_Month_09.Add('sept');
  Token_Human_Month_10.Add('octobre');
  Token_Human_Month_10.Add('oct');
  Token_Human_Month_11.Add('novembre');
  Token_Human_Month_11.Add('nov');
  Token_Human_Month_12.Add('dcembre');
  Token_Human_Month_12.Add('decembre');
  Token_Human_Month_12.Add('dec');
  Token_Human_Month_12.Add('dc');

finalization

  Token_Du.free;
  Token_Au.free;
  Token_Avant.free;
  Token_Apres.free;
  Token_Entre.free;
  Token_Et.free;
  Token_Calculee.free;
  Token_Estimee.free;
  Token_Vers.free;
  Token_Human_Month_01.free;
  Token_Human_Month_02.free;
  Token_Human_Month_03.free;
  Token_Human_Month_04.free;
  Token_Human_Month_05.free;
  Token_Human_Month_06.free;
  Token_Human_Month_07.free;
  Token_Human_Month_08.free;
  Token_Human_Month_09.free;
  Token_Human_Month_10.free;
  Token_Human_Month_11.free;
  Token_Human_Month_12.free;
  Separator_Human_Date.free;


end.
