{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_common_graph_const;

interface

uses
  Controls;

const
  //Nom du rpertoire dans lequel ce trouvent les chantiers
  _RELPATH_CHANTIERS = 'Data\';

  //Rpertoires qui doivent se trouver dans le rpertoire d'un chantier
  _RELPATH_DONNEES_BRUTE = 'Donnees Brutes\';
  _RELPATH_FICHIERS_SB = 'Fichiers SB\';
  _RELPATH_GESTION_PLANS = 'Gestion Plans\';

  //Nom du fichier de config du chantier (pieux utiliss, Vues, etc...)
  _FILE_NAME_CONFIG_CHANTIER = 'config_chantier.ini';

  //Nom du fichier de sauvegarde des vues. Note : la vue courante est dans le fichier _FILE_NAME_CONFIG_CHANTIER
  _FILE_NAME_CONFIG_VUES = 'config_vues.ini';


  //Pourcentage de Zoom Min et Max
  _ZOOM_MIN = 40;
  _ZOOM_MAX = 200;

  //Nombre de mtres ajouts autour du chantier, quand on fait "Zoom Tout". (pour ne pas avoir de pieu coll sur les bords)
  _ADD_MARGE_WIDTH = 0.5; //en m

  //cart max , pour que 2 profondeurs soient considres comme gales (en m)
  _DELTA_DEPTH = 0.05;

  //Echelle par dfaut
//     _ECHELLE_PIXELS = 3300;

//reprsentation  l'cran : Combien de pixels pour faire 10 cm en X et en Y ?
//     _NB_PIXELS_X_POUR_10_CM =



  //Les curseurs
  _CURPOPUP = 5;
  _CURHAND = 6;
  _CURSOR_ZOOM_MOINS = 6;
  _CURSOR_ZOOM_PLUS = 7;
  _CURSOR_MAIN = 8;
  _CURSOR_SELECT = crDefault;

  //Nom de la dernire vue utilisateur
  _LAST_NAME_VUE = '____LAST_VUE____';


  //indices des colonnes de la grille d'affichage des pieux
  _COL_VISIBLE = 0;
  _COL_REF_CALCULE = 1;
  _COL_NOM = 2;
  _COL_REALISE_LE = 3;
  _COL_X = 4;
  _COL_Y = 5;
  _COL_ANGLE = 6;
  _COL_COTE_NGF = 7;
  _COL_MACHINE = 8;
  _COL_OPERATEUR = 9;

implementation

end.
