{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_objet_graph_TGraph;

interface

uses
  Classes, extctrls, windows, u_common_graph_type, RPrinter;

type
  TGraph = class

  public
    //rectangle d'encadrement
    REncadrementC: TFloatRect;

    constructor Create; virtual;
    procedure Prepare; virtual; abstract;
    procedure Load; virtual; abstract;

    procedure PreparePrint; virtual; abstract;
    procedure Print(rp: TReportPrinter); virtual; abstract;

    procedure CoordChantier_2_CoordViewer(coef: single); virtual; abstract;
    procedure CoordChantier_2_CoordMiniature(coef: single); virtual; abstract;

    procedure Paint(PaintBox: TPaintBox; DecalX, DecalY: integer); virtual; abstract;
    procedure PaintMiniature(PaintBox: TPaintBox; DecalX, DecalY: integer); virtual; abstract;
    function GetRectEncadrement(var R: TFloatRect): boolean; virtual; abstract;

    function GetCleIndividuAtXY(X, Y: integer): integer; virtual; abstract;
  end;


implementation

{ TGraph }


{ TGraph }

constructor TGraph.Create;
begin

end;

end.
