{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                       }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_individu_events_notes;

interface

uses
     Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
     CompSuperForm, StdCtrls, dxCntner, dxEditor,
     dxExEdtr, dxEdLib, dxDBELib;

type
     TFIndividuEventsNotes = class(TSuperForm)
          edMemo: TdxDBMemo;
     private
          fFormIndividuIdentite: TForm;
          procedure SetFormIndividuIdentite(const Value: TForm);

     public
          property FormIndividuIdentite: TForm read fFormIndividuIdentite write SetFormIndividuIdentite;
          procedure DoRefresh(Mode: boolean);
     end;

implementation

uses u_form_individu_events, u_form_individu, u_dm;

{$R *.DFM}

{ TFIndividuIdentiteEventsSources }

procedure TFIndividuEventsNotes.DoRefresh(Mode: boolean);
begin
     edMemo.enabled := mode;
end;

procedure TFIndividuEventsNotes.SetFormIndividuIdentite(const Value: TForm);
var
     PtrForm: TFIndividuEvents;
begin
     fFormIndividuIdentite := Value;
     if Value <> nil then PtrForm := TFIndividuEvents(Value) else PtrForm := nil;

     edMemo.DataSource := PtrForm.dsEve;
end;

end.
