{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestrologie                             }
{           Source Language:  Francais                                  }
{           Auteur:                        }
{           Philippe Cazaux-Moutou                                      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestrologie est un Logiciel Libre                         }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_form_rechercher;

interface


uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompSuperForm, ExtCtrls, TFlatPanelUnit, StdCtrls, Buttons,
  dxCntner, dxTL, dxDBGrid, jpeg, dxGrClms, u_comp_TBlueFlatSpeedButton,
  Db, IBCustomDataSet, IBQuery, ComCtrls, Menus, dxEditor, dxEdLib,
  dxDBCtrl, dxDBTLCl, dxExEdtr, TFlatSpeedButtonUnit, u_comp_TGoodBtn,
  GraphicEx, Mask, u_comp_TYLanguage, DynamicSkinForm, TFlatTabControlUnit,
  SkinCtrls;

type
  TFRechercher = class(TSuperForm)
    dsRecherche: TDataSource;
    IBQRecherche: TIBQuery;
    PopupMenuGrid: TPopupMenu;
    option_ExporterHTML: TMenuItem;
    N1: TMenuItem;
    option_EnVoirPlus: TMenuItem;
    IBQRechercheCLE_FICHE: TIntegerField;
    IBQRechercheNOM: TIBStringField;
    IBQRecherchePRENOM: TIBStringField;
    IBQRechercheSEXE: TIntegerField;
    IBQRechercheDATE_NAISSANCE: TIBStringField;
    IBQRechercheCP_NAISSANCE: TIBStringField;
    IBQRechercheLIEU_NAISSANCE: TIBStringField;
    IBQRecherchePAYS_NAISSANCE: TIBStringField;
    IBQRechercheDATE_DECES: TIBStringField;
    IBQRechercheCP_DECES: TIBStringField;
    IBQRechercheLIEU_DECES: TIBStringField;
    IBQRecherchePAYS_DECES: TIBStringField;
    IBQRechercheINFOS_DECES: TStringField;
    pBorder: TPanel;
    Panel5: TPanel;
    Panel16: TPanel;
    BlueFlatSpeedButton2: TBlueFlatSpeedButton;
    BlueFlatSpeedButton1: TBlueFlatSpeedButton;
    Panel2: TPanel;
    Panel8: TPanel;
    Panel9: TPanel;
    dxDBGrid1: TdxDBGrid;
    dxDBSexe: TdxDBGridImageColumn;
    dxDBNom: TdxDBGridColumn;
    dxDBPrenom: TdxDBGridColumn;
    dxDBDateNaiss: TdxDBGridColumn;
    Panel12: TPanel;
    Panel18: TPanel;
    SaveDialog: TSaveDialog;
    Panel3: TPanel;
    fpBoutons: TFlatPanel;
    lbNbIndiTrouve: TLabel;
    Panel11: TPanel;
    Panel14: TPanel;
    Image1: TImage;
    Label12: TLabel;
    Panel6: TPanel;
    Panel7: TPanel;
    Label2: TLabel;
    Image2: TImage;
    pSeparateur: TPanel;
    bsfbSelection: TGoodBtn;
    btnFermer: TGoodBtn;
    sbClear: TGoodBtn;
    sbRechercher: TGoodBtn;
    Language: TYLanguage;
    DSF: TspDynamicSkinForm;
    FlatTabControlCommentUnion: TFlatTabControl;
    Panel4: TPanel;
    pSTD: TPanel;
    Label1: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    btnAjoutMere: TFlatSpeedButton;
    FlatPanel1: TFlatPanel;
    Label7: TLabel;
    Label6: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label11: TLabel;
    Panel10: TPanel;
    Panel13: TPanel;
    Label5: TLabel;
    sECPNaissance: TdxEdit;
    sEVilleNaissance: TdxEdit;
    sEPaysNaissance: TdxEdit;
    sECPDeces: TdxEdit;
    sEVilleDeces: TdxEdit;
    sEPaysDeces: TdxEdit;
    Panel19: TPanel;
    seDateNe: TdxEdit;
    seDateDeces: TdxEdit;
    sESosa: TdxEdit;
    rbHomme: TRadioButton;
    rbFemme: TRadioButton;
    rbInconnu: TRadioButton;
    rbTous: TRadioButton;
    sENom: TdxEdit;
    sEPrenom: TdxEdit;
    FlatPanel3: TFlatPanel;
    rbNomCom: TRadioButton;
    rbNomCon: TRadioButton;
    FlatPanel2: TFlatPanel;
    rbPrenomCom: TRadioButton;
    rbPrenom: TRadioButton;
    pNotes: TPanel;
    Label10: TLabel;
    Label16: TLabel;
    sNotes: TdxEdit;
    sSouces: TdxEdit;
    procedure sbRechercherClick(Sender: TObject);
    procedure SuperFormClose(Sender: TObject; var Action: TCloseAction);
    procedure sbClearClick(Sender: TObject);
    procedure Panel11MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure SuperFormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure SpeedButton2Click(Sender: TObject);
    procedure option_ExporterHTMLClick(Sender: TObject);
    procedure option_EnVoirPlusClick(Sender: TObject);
    procedure IBQRechercheCalcFields(DataSet: TDataSet);
    procedure PopupMenuGridPopup(Sender: TObject);
    procedure dxDBGrid1DblClick(Sender: TObject);
    procedure SuperFormCreate(Sender: TObject);
    procedure bsfbSelectionClick(Sender: TObject);
    procedure FlatTabControlCommentUnionTabChanged(Sender: TObject);
  private
    fCleFicheSelected: integer;
    procedure DoRechercher;
    procedure doSelect;

  public
    //en retour (sinon -1)
    property CleFicheSelected: integer read fCleFicheSelected write fCleFicheSelected;

  end;

implementation

uses u_dm, u_form_main, u_common_func, u_common_var, u_common_const; //////////%%%%%%%%, u_form_individu;

{$R *.DFM}

procedure TFRechercher.sbRechercherClick(Sender: TObject);
begin
  //FMain.doAgent('Searching');
  DoRechercher;
  //  FMain.doAgent('Hide');
end;

procedure TFRechercher.DoRechercher;
var s_Nom, s_Prenom, s_CPNaiss, s_VilleNaissance, s_PaysNaissance,
  s_CPDeces, s_VilleDeces, s_PaysDeces, s_Sosa, s_DateNe, s_DateDeces: string;
  i_Sexe: SmallInt;
  i_Naiss, i_Deces: Integer;
  Save_Cursor: TCursor;
  OkSosa: boolean;
begin
  Save_Cursor := Screen.Cursor;
  Screen.Cursor := crHourglass;
  try

    //sbRechercher.Enabled := False;
    sbClear.Enabled := True;

    i_Sexe := 3;
    s_CPNaiss := '%';
    s_VilleNaissance := '%';
    s_PaysNaissance := '%';
    s_CPDeces := '%';
    s_VilleDeces := '%';
    s_PaysDeces := '%';
    s_Sosa := '0';
    s_DateNe := '%';
    s_DateDeces := '%';
    // i_Naiss := 0;
    // i_Deces := 0;

    i_Naiss := StrToIntDef(trim(seDateNe.Text), 0);
    i_Deces := StrToIntDef(trim(seDateDeces.Text), 0);

    if Length(seNom.Text) > 0 then
      begin
        s_Nom := seNom.Text;

        if rbNomCom.Checked then
          s_Nom := s_Nom + '%'
        else
          s_Nom := '%' + s_Nom + '%';
      end
    else
      s_Nom := '%';

    if Length(sePreNom.Text) > 0 then
      begin
        s_Prenom := sePreNom.Text;

        if rbPreNomCom.Checked then
          s_Prenom := s_Prenom + '%'
        else
          s_Prenom := '%' + s_Prenom + '%';
      end
    else
      s_Prenom := '%';

    if rbInconnu.Checked then i_Sexe := 0;
    if rbHomme.Checked then i_Sexe := 1;
    if rbFemme.Checked then i_Sexe := 2;
    if rbTous.Checked then i_Sexe := 3;

    if Length(seCPNaissance.Text) > 0 then
      s_CPNaiss := '%' + seCPNaissance.Text + '%';

    if Length(seVilleNaissance.Text) > 0 then
      s_VilleNaissance := '%' + seVilleNaissance.Text + '%';

    if Length(sePaysNaissance.Text) > 0 then
      s_PaysNaissance := '%' + sePaysNaissance.Text + '%';

    if Length(seCPDeces.Text) > 0 then
      s_CPDeces := '%' + seCPDeces.Text + '%';

    if Length(seVilleDeces.Text) > 0 then
      s_VilleDeces := '%' + seVilleDeces.Text + '%';

    if Length(sePaysDeces.Text) > 0 then
      s_PaysDeces := '%' + sePaysDeces.Text + '%';

    if Length(sESosa.Text) > 0 then
      begin
        try
          StrToFloat(sESosa.Text);
          OkSosa := true;
        except
          OkSosa := false;
        end;

        if OkSosa = false then exit;

        seNom.Text := '';
        sePreNom.Text := '';
        rbTous.Checked := True;
        seCPNaissance.Text := '';
        seVilleNaissance.Text := '';
        sePaysNaissance.Text := '';
        seCPDeces.Text := '';
        seVilleDeces.Text := '';
        sePaysDeces.Text := '';

        s_Sosa := sESosa.Text;
      end;

    if (s_Nom = '%') and
      (s_Prenom = '%') and
      (i_Sexe = 3) and
      (s_CPNaiss = '%') and
      (s_VilleNaissance = '%') and
      (s_PaysNaissance = '%') and
      (s_CPDeces = '%') and
      (s_VilleDeces = '%') and
      (s_PaysDeces = '%') and
      (s_Sosa = '0') and
      (i_Naiss = 0) and
      (i_deces = 0) then
      if MyMessageDlg('Attention, il n''y a aucun critre !' + #13#10 +
        #13#10#13#10 + 'Mettez au moins 1 critre ?',
        mtWarning, [mbOK], 0) = mrOk then
        begin
          Screen.Cursor := Save_Cursor;
          exit;
        end;
    with IBQRecherche do
      begin
        DisableControls;
        Close;

        Params[0].AsInteger := dm.NumDossier;
        Params[1].AsString := s_Nom;
        Params[2].AsString := s_Prenom;
        Params[3].AsInteger := i_Sexe;
        Params[4].AsString := s_CPNaiss;
        Params[5].AsString := s_VilleNaissance;
        Params[6].AsString := s_PaysNaissance;
        Params[7].AsString := s_CPDeces;
        Params[8].AsString := s_VilleDeces;
        Params[9].AsString := s_PaysDeces;
        Params[10].AsString := s_Sosa;
        Params[11].AsInteger := i_Naiss;
        Params[12].AsInteger := i_Deces;

        Open;
        Last;
        First;
        EnableControls;
      end;

    lbNbIndiTrouve.Caption := IntToStr(IBQRecherche.RecordCount) + ' individus trouvs...';
    bsfbSelection.Enabled := IBQRecherche.RecordCount > 0;

  finally
    Screen.Cursor := Save_Cursor;
  end;
end;

procedure TFRechercher.sbClearClick(Sender: TObject);
begin
  lbNbIndiTrouve.Caption := '';

  option_EnVoirPlus.Checked := False;
  dxDBGrid1.Options := dxDBGrid1.Options - [egoPreview];

  sbClear.Enabled := False;
  IBQRecherche.Close;

  seNom.Text := '';
  sePreNom.Text := '';
  rbTous.Checked := True;
  seCPNaissance.Text := '';
  seVilleNaissance.Text := '';
  sePaysNaissance.Text := '';
  seCPDeces.Text := '';
  seVilleDeces.Text := '';
  sePaysDeces.Text := '';
  seSosa.Text := '';
  seDateNe.Text := '';
  seDateDeces.Text := '';

  sbRechercher.Enabled := True;
  bsfbSelection.Enabled := False;
end;

procedure TFRechercher.SuperFormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  _Agent.doAgent('Hide', '', 0, 0);
  
  IBQRecherche.Close;
  IBQRecherche.Free;
end;

procedure TFRechercher.Panel11MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  TForm(Self).perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFRechercher.SuperFormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  case Key of

    VK_RETURN: DoRechercher;

    VK_ESCAPE: ModalResult := mrCancel;

  end;
end;

procedure TFRechercher.SpeedButton2Click(Sender: TObject);
begin
  ModalResult := mrCancel;
  Close;
end;

procedure TFRechercher.option_ExporterHTMLClick(Sender: TObject);
var
  SavePlace: TBookmark;
begin
  if SaveDialog.Execute then
    begin
      IBQRecherche.DisableControls;
      SavePlace := IBQRecherche.GetBookmark;
      dxDBGrid1.SaveToHTML(SaveDialog.FileName, True);

      IBQRecherche.GotoBookmark(SavePlace);
      IBQRecherche.FreeBookmark(SavePlace);

      IBQRecherche.EnableControls;
    end;
end;

procedure TFRechercher.option_EnVoirPlusClick(Sender: TObject);
begin
  option_EnVoirPlus.Checked := not option_EnVoirPlus.Checked;

  if option_EnVoirPlus.Checked then
    dxDBGrid1.Options := dxDBGrid1.Options + [egoPreview]
  else
    dxDBGrid1.Options := dxDBGrid1.Options - [egoPreview];
end;

procedure TFRechercher.IBQRechercheCalcFields(DataSet: TDataSet);
var s: string;
begin
  s := '';

  if IBQRechercheLIEU_NAISSANCE.AsString <> '' then
    s := 'N(e)  ' + IBQRechercheLIEU_NAISSANCE.AsString;

  if IBQRechercheDATE_DECES.AsString <> '' then
    if Length(s) = 0 then
      s := ' Dcd(e) : ' + IBQRechercheDATE_DECES.AsString
    else
      s := s + ' - Dcd(e) : ' + IBQRechercheDATE_DECES.AsString;

  if IBQRechercheLIEU_DECES.AsString <> '' then
    if Length(s) = 0 then
      s := ' Dcd(e)  ' + IBQRechercheLIEU_DECES.AsString
    else
      s := s + ' -  ' + IBQRechercheLIEU_DECES.AsString;

  IBQRechercheINFOS_DECES.AsString := s;

end;

procedure TFRechercher.PopupMenuGridPopup(Sender: TObject);
begin
  option_ExporterHTML.enabled := (IBQRecherche.Active) and (IBQRecherche.RecordCount > 0);
  option_EnVoirPlus.enabled := (IBQRecherche.Active) and (IBQRecherche.RecordCount > 0);
end;

procedure TFRechercher.dxDBGrid1DblClick(Sender: TObject);
begin
  doSelect;
end;

procedure TFRechercher.doSelect;
begin
  if (IBQRecherche.Active) and (IBQRecherche.RecordCount > 0) then
    begin
      fCleFicheSelected := IBQRecherche.FieldByName('CLE_FICHE').AsInteger;
      ModalResult := mrOk;
    end;
end;


procedure TFRechercher.SuperFormCreate(Sender: TObject);
begin

  _Agent.doAgent('GestureRight', 'Tapez un nom ou un prnom',
    Left +
    PBorder.Left +
    Panel16.Left +
    Panel6.Left +
    Panel7.Left +
    Panel4.Left +
    PStd.Left +
    sENom.Left + sENom.Width,
    Top +
    PBorder.Top +
    Panel16.Top +
    Panel6.Top +
    Panel7.Top +
    Panel4.Top +
    PStd.Top +
    sENom.Top + sENom.Height + 50);

  Language.RessourcesFileName := _REL_PATH_TRADUCTIONS + _FileNameTraduction;
  Language.Translate;

  pSTD.Align := AlClient;
  pNotes.Align := AlClient;

  if _Context.Skin then
    begin
      ClientHeight := 523;
      ClientWidth := 645;
    end
  else
    begin
      //SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION)
    end;

  fCleFicheSelected := -1;
  SaveDialog.InitialDir := _Context.PathImportExport;
end;

procedure TFRechercher.bsfbSelectionClick(Sender: TObject);
begin
  doSelect;
end;

procedure TFRechercher.FlatTabControlCommentUnionTabChanged(
  Sender: TObject);
begin
  case FlatTabControlCommentUnion.ActiveTab of

    0: begin
        pSTD.Show;
        pNotes.Hide;
      end;

    1: begin
        pSTD.Hide;
        pNotes.Show;
      end;
  end;
end;

end.

