unit U_Form_Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TFMain = class(TForm)
    Label1: TLabel;
    procedure FormDestroy(Sender: TObject);
  private
    { Dclarations prives }
    procedure DoAfterInit;
    procedure DoOpenBase(sBase: string);
  public
    { Dclarations publiques }
    procedure DoInit(sBase: string);
  end;

var
  FMain: TFMain;

implementation

uses U_DM;

{$R *.DFM}

procedure TFMain.FormDestroy(Sender: TObject);
begin
  dm.Free;
end;

procedure TFMain.DoInit(sBase: string);
var
  Save_Cursor: TCursor;
begin
  Save_Cursor := Screen.Cursor;
  Screen.Cursor := crHourGlass; { Affiche le curseur en forme de sablier }

  DoOpenBase(sBase);
  DoAfterInit;

  Screen.Cursor := Save_Cursor; { Revient toujours  normal }
end;

procedure TFMain.DoOpenBase(sBase: string);
begin
  dm := tdm.create(self);
  try
    dm.doOpenDatabase(sBase);
  except
    dm.Free;
  end;
end;

procedure TFMain.DoAfterInit;
begin
  Caption := dm.fNomIndi + ', ' + dm.fPrenomIndi;
  dm.fRetourDll := 'Ici on peut mettre une chaine qui sera recupr apres la fermeture de la dll';
end;
end.

